/**
 * 度数の検定
 * カイ二乗検定 ｉ×ｊ表
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 5);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop2();

	// document.getElementById("DataArea").focus();
};
// メインの計算
function mainCalc_auto2x2() {
	var i = 0;
	var j = 0;
	var k = 0;
	var ii = 0;
	var ik = 0;
	var iik = 0;
	var NN = 0; //行数
	var KK = 0; //列数

	var DData = dataremake5("DataArea");
	document.getElementById("DataArea").value = DData;
	var dd = [];
	dd = DData.split(" ");

	var strArray = [];
	var bar = "--------------------------------------\n";

	NN = countRowCol("DataArea")[0]; // 行数を取得
	KK = countRowCol("DataArea")[1]; // 列数を取得

	// var xx = new Array(KK);
	// for(i=0;i<KK;i++){
	// 	xx[i] = new Array(NN);
	// }

	// var idata = 0;
	// for(j=0;j<NN;j++){
	// 	for(i=0;i<KK;i++){
	// 		xx[i][j] = parseInt(dd[idata],10);
	// 		idata++;
	// 	}
	// }

	if (KK == -1) { //列数エラー -1
		alert("データが行列形式ではありません");
	} else if (NN !== 0) { //行数が 0 でない場合
		var xx = new Array(NN);
		for (i = 0; i < NN; i++) {
			xx[i] = new Array(KK);
		}

		var ddCount = 0;
		for (i = 0; i < NN; i++) {
			for (j = 0; j < KK; j++) {
				xx[i][j] = parseFloat(dd[ddCount]);
				ddCount++;
			}
		}

		var MI = [];
		var MA = [];
		var min0;
		var max0;
		for (j = 0; j < KK; j++) {
			min0 = xx[0][j];
			max0 = xx[0][j];
			for (i = 0; i < NN; i++) {
				if (min0 > xx[i][j]) min0 = xx[i][j];
				if (max0 < xx[i][j]) max0 = xx[i][j];
			}
			MI[j] = min0;
			MA[j] = max0;
		}

		var wA = 0;  //  wA  wB  | M1
		var wB = 0;  //  wC  wD  | M2
		var wC = 0;  //----------+---
		var wD = 0;  //  M3  M4  | NN

		var PP2 = 0; //両側確率
		var PP = 0;  //片側確率
		var P = [];

		var svA = 0; //wA～wDまでの値を保持するため
		var svB = 0;
		var svC = 0;
		var svD = 0;

		var p_value = 0.15;
		// p_value = prompt("出力する片側確率の上限を入力してください。",p_value);
		p_value = parseFloat(document.getElementById("p_value").value);

		strArray.push("片側確率 p=" + p_value + "以下を出力しました。\n\n");

		// var dat = ""; //視覚化データ
		// dat = KK + "\n";
		var diagramData = KK + "\n";

		var kekka = 0; //指定した片側確率より小さい組合せの数
		for (j = 0; j < KK - 1; j++) {
			for (jj = j + 1; jj < KK; jj++) {
				if (j == jj) continue;
				for (jk = MI[j]; jk < MA[j] + 1; jk++) {
					if (jk == MI[j]) continue;
					for (jjk = MI[jj]; jjk < MA[jj] + 1; jjk++) {
						if (jjk == MI[jj]) continue;
						for (i = 0; i < NN; i++) {
							if ((parseInt(xx[i][j], 10) < jk) && (parseInt(xx[i][jj], 10) < jjk)) wA++;
							if ((parseInt(xx[i][j], 10) < jk) && (parseInt(xx[i][jj], 10) >= jjk)) wB++;
							if ((parseInt(xx[i][j], 10) >= jk) && (parseInt(xx[i][jj], 10) < jjk)) wC++;
							if ((parseInt(xx[i][j], 10) >= jk) && (parseInt(xx[i][jj], 10) >= jjk)) wD++;
						}
						svA = wA;
						svB = wB;
						svC = wC;
						svD = wD;

						P = p_keisan(wA, wB, wC, wD);
						PP2 = P[0];
						PP = P[1];

						if (PP <= p_value) {
							kekka++;
							strArray.push("(" + kekka + ") タテ行:変数" + (j + 1) + " , ヨコ列:変数" + (jj + 1) + "\n" + bar);
							strArray.push("         " + MI[jj] + " to " + (jjk - 1) + "\t,  " + jjk + " to " + MA[jj] + "\n" + bar);
							strArray.push(MI[j] + " to " + (jk - 1) + ":\t" + svA + "\t,  " + svB + "\n");
							strArray.push(jk + " to " + MA[j] + ":\t" + svC + "\t,  " + svD + "\n" + bar);

							var M1 = svA + svB;
							var M2 = svC + svD;
							var M3 = svA + svC;
							var M4 = svB + svD;

							var Phi = Math.sqrt(Math.pow(svA * svD - svB * svC, 2) / (M1 * M2 * M3 * M4));

							// strArray.push("p="+using(PP2,1,3)+"（両側確率）\n");
							// strArray.push("p="+using(PP,1,3)+"（片側確率）\n");
							// strArray.push("Phi="+using(Phi,1,3)+"\n\n");
							strArray.push("p=" + PP2.toFixed(3) + "（両側確率）\n");
							strArray.push("p=" + PP.toFixed(3) + "（片側確率）\n");
							strArray.push("Phi=" + Phi.toFixed(3) + "\n\n");

							diagramData += (j + 1) + "," + (jj + 1) + "," + PP.toFixed(3) + "," + Phi.toFixed(3) + "\n";
						}

						wA = 0;
						wB = 0;
						wC = 0;
						wD = 0;

					}
				}
			}
		}

		// strArray.push("\n"+bar+"▽ 視覚化データ\n"+dat);
		// strArray.push("\n"+"△ ここまで\n\n");

		strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

		if (kekka === 0) {
			document.getElementById("RltArea").value = "片側確率の結果が" + p_value + "以下になるものはありません。\n";
		} else {
			// ダイアグラム出力
			document.getElementById("auto2x2DiaArea").value = diagramData;
			auto2x2DiaDraw();

			document.getElementById("RltArea").value = strArray.join("");
			strArray = null;
		}

		document.getElementById("RltArea").focus();
	}
}
/**
 * [p_keisan 直接確率計算２ｘ２の計算]
 * @param  {int} A
 * @param  {int} B
 * @param  {int} C
 * @param  {int} D
 * @return {[float, float]}  戻り値は配列 [0]両側確率 [1]片側確率
 */
function p_keisan(A, B, C, D) {
	var M1 = A + B; //  A   B  | M1
	var M2 = C + D; //  C   D  | M2
	var M3 = B + D; //---------+----
	var M4 = A + C; //  M3  M4 | NN

	var NN = A + B + C + D;

	var PP2 = 0; //両側確率
	var PP = 0;  //片側確率
	var K1 = 0;  //片側確率(計算１)
	var K2 = 0;  //片側確率(計算２)
	var wPP = []; //それぞれの場合のP値
	var KS = []; //交差 A*C-B*D

	var Dummy = 0;
	while ((M2 < M1) || (M3 < M1) || (M4 < M1)) { //M1が一番小さくなるまでABCDの値を変更する
		Dummy = A;
		A = B;
		B = Dummy;

		Dummy = A;
		A = D;
		D = Dummy;

		Dummy = A;
		A = C;
		C = Dummy;

		M1 = A + B;
		M2 = C + D;
		M3 = B + D;
		M4 = A + C;
	}

	var AA = A; //Aの値を保存しておく

	var LT = []; //logの値を代入して計算を高速化する
	var maxM = Math.max(M1, M2, M3, M4);
	for (var i = 0; i < maxM + 1; i++) {
		LT[i] = logfact(i);
	}
	LT[NN] = logfact(NN);

	var iA, iB, iC, iD;
	var myConst = LT[M1] + LT[M2] + LT[M3] + LT[M4] - LT[NN];
	for (iA = 0; iA < M1 + 1; iA++) {
		iB = M1 - iA;
		iC = M4 - iA;
		iD = M3 - iB;
		KS[iA] = iA * iD - iB * iC;
		wPP[iA] = Math.exp(myConst - LT[iA] - LT[iB] - LT[iC] - LT[iD]);
		wPP[iA] = wPP[iA] * 1000000000000000; //計算結果が16桁目に誤差がでるのを防ぐ
		wPP[iA] = Math.round(wPP[iA]);
		wPP[iA] = wPP[iA] / 1000000000000000;
	}


	for (iA = 0; iA < M1 + 1; iA++) {
		if (wPP[iA] <= wPP[AA]) {
			PP2 = PP2 + wPP[iA];
		}
		//交差で判断
		if (KS[AA] <= KS[iA]) {
			K1 = K1 + wPP[iA];
		}
		if (KS[AA] >= KS[iA]) {
			K2 = K2 + wPP[iA];
		}
	}

	if (K1 < K2) {
		PP = K1;
	} else {
		PP = K2;
	}

	if (PP2 >= 1) {
		PP2 = 1.000; //直接確率計算２ｘ２ではこの処理は行っていない
	}

	if (PP >= 1) {
		PP = 0.9999; //直接確率計算２ｘ２ではこの処理は行っていない
	}

	return [PP2, PP];
}
function auto2x2DiaDraw() {
	var i = 0;
	var j = 0;
	var jj = 0;

	var canvas = document.getElementById("DiaCanvas");
	if (!canvas || !canvas.getContext) {
		return false;
	}

	if (document.getElementById("auto2x2DiaArea").value !== "") {
		var auto2x2Data = document.getElementById("auto2x2DiaArea").value;
		var rowStr = auto2x2Data.split("\n");

		//項目数
		var KK = parseInt(rowStr[0], 10);

		var columStr = [];
		var k1 = [];
		var k2 = [];
		var p = [];
		var phi = [];

		for (i = 1; i < rowStr.length - 1; i++) {
			columStr = rowStr[i].split(",");
			k1[i] = parseInt(columStr[0], 10);        //項目１
			k2[i] = parseInt(columStr[1], 10);        //項目２
			p[i] = parseFloat(columStr[2]);          //確率
			phi[i] = parseFloat(columStr[3]);        //φ
		}

		var ctx = canvas.getContext('2d');

		//canvasを白で塗りつぶし
		ctx.beginPath();
		ctx.fillStyle = 'rgb(255,255,255)';
		ctx.fillRect(0, 0, 550, 450);

		// ダイアグラムの中心の座標
		var x1 = 275;
		var y1 = 200;

		// 項目番号0の座標
		var x2 = 275;
		var y2 = 30;

		// 項目番号の座標
		var tx = 0;
		var ty = 0;

		ctx.lineWidth = 1;

		var xx = [];
		var yy = [];

		var t = 0; //角度
		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			xx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1;
			yy[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1;
		}

		var tx = [];
		var ty = [];
		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			tx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1 - 4;
			ty[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1 + 4;
		}

		var pValue = parseFloat(document.getElementById("pValue").value);
		var phiValue = parseFloat(document.getElementById("phiValue").value);

		for (i = 1; i < rowStr.length - 1; i++) {
			if ((pValue >= p[i]) && (phiValue <= phi[i])) {
				ctx.beginPath();
				ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
				ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
				ctx.stroke();
			}
		}

		var wr = 10;
		//項目を示す○を描く（白で塗りつぶし）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.fillStyle = 'rgb(255,255,255)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.fill();
		}
		//項目を示す○を描く（線を黒く）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.strokeStyle = 'rgb(0,0,0)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.stroke();
		}

		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.font = "14px 'Times New Roman'";
		ctx.strokeStyle = 'rgb(0,0,0)';
		ctx.fillStyle = "rgb(0,0,0)";
		for (j = 0; j < KK; j++) {
			ctx.strokeText(j + 1, tx[j], ty[j]);
		}

	}

}
function saveData_auto2x2() {

	var Stream = document.getElementById("DataArea").value;
	var fineName = "auto2x2_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
