/**
 * 度数の検定
 * １×２表：母比率不等
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
//セルデータの消去
function clearCellData() {
	var result = confirm("データを消去します");
	if (result === true) {
		// 観測値のセル
		document.getElementById("cell_1").value = "";
		document.getElementById("cell_2").value = "";

		// 母比率のセル
		document.getElementById("cell2_1").value = "";
		document.getElementById("cell2_2").value = "";

		errorClearCell(2, "");
		errorClearCell(2, "2");
		document.getElementById("cell_sum").value = "";
	}
	document.getElementById("cell_1").focus();
}
//入力チェック
function checkCellData() {
	var i = 1;
	var elmCount = 2; //観測値と母比率それぞれ２つずつ
	var errorCellNum = 0;

	// 観測値のセル
	errorClearCell(2, "");
	errorCell(2, "");

	// 母比率のセル
	errorClearCell(2, "2");
	errorCell(2, "2");

	for (i = 1; i < elmCount + 1; i++) {
		if (document.getElementById("cell_" + i).value === "") {
			errorCellNum = i;
		}
	}

	if (errorCellNum == 0) {
		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell2_" + i).value === "") {
				errorCellNum = i;
			}
		}

		if (errorCellNum === 0) {
			errorClearCell(2, "");
			errorClearCell(2, "2");
			sum();
			mainCalc_futo1x2();
		} else {
			alert("すべての母比率が入力されていません (^_^)ゞ");
			document.getElementById("cell2_" + errorCellNum).focus();
		}
	} else {
		alert("すべての度数が入力されていません (^_^)ゞ");
		document.getElementById("cell_" + errorCellNum).focus();
	}
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	if (dd.length == 2 * 2) {
		copipe2('CandPArea', 'text', 'text_ratio');
	} else if (dd.length > 2 * 2) {
		crossTabulate();
		// 観測値のみ代入，母比率は空白
		copipe('CandPArea', 'text');
		document.getElementById("cell2_1").value = "";
		document.getElementById("cell2_2").value = "";
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i;
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var yoko = 2;
	var err = false;

	if (err == false) {
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) == false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < yoko + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err == false) {
			var gunAtai = new Array(yoko);
			for (i = 0; i < yoko; i++) {
				gunAtai[i] = 0;
			}

			for (i = 0; i < dd.length; i++) {
				gunAtai[dd[i] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < yoko; i++) {
				strArray.push(gunAtai[i]);
				strArray.push("\t");
			}
			strArray.push("\n");
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = "";
		alert("データ形式が正しくありません。");
	}
}
// メインの計算
function mainCalc_futo1x2() {
	var KK1 = parseInt(document.getElementById("cell_1").value, 10);
	var KK2 = parseInt(document.getElementById("cell_2").value, 10);
	var sKK1 = KK1;
	var sKK2 = KK2;

	var NN = KK1 + KK2;

	var BB1 = parseFloat(document.getElementById("cell2_1").value);
	var BB2 = parseFloat(document.getElementById("cell2_2").value);
	var BB0 = BB1 + BB2;

	var PP = 0;  //片側確率

	BB1 = BB1 / BB0;
	BB2 = BB2 / BB0;

	var sBB1 = BB1;
	var sBB2 = BB2;

	var HH1 = KK1 / NN;
	var HH2 = KK2 / NN;

	var effectSizeG = Math.abs(HH1 - BB1);

	var strArray = [];
	var rcmArray = [];

	if ((BB1 === 0) || (BB1 === 1)) {
		strArray.push("[1x2](母比率不等)\n\n");
		strArray.push("注意！\n");
		strArray.push("母比率＝0 or 1です。\n");
		strArray.push("偶然分布は生じません。\n");
		strArray.push("\n\n  _/_/_/ Analyzed by js-STAR _/_/_/");
		document.getElementById("RltArea").value = strArray.join("");
		strArray = null;
	} else {
		strArray.push("[1x2](母比率不等)\n\n");
		strArray.push("---------------------------------------------\n");
		strArray.push("観測値\t\t" + using(KK1, 5, 0) + "\t" + using(KK2, 5, 0) + "\n");
		strArray.push("観測値比率\t(" + using(HH1, 1, 4) + ") (" + using(HH2, 1, 4) + ")\n");
		strArray.push("---------------------------------------------\n");
		strArray.push("母比率\t\t" + using(BB1, 1, 4) + "\t" + using(BB2, 1, 4) + "\n");
		strArray.push("---------------------------------------------\n\n");

		if (KK1 > KK2) {
			dummy = KK1;
			KK1 = KK2;
			KK2 = dummy;

			dummy = BB1;
			BB1 = BB2;
			BB2 = dummy;
		}

		var temp;
		var R;
		if (KK1 < NN * BB1) {
			for (R = 0; R < KK1 + 1; R++) {
				temp = LogCombination(NN, R);
				PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
			}
		} else {
			for (R = KK1; R < NN + 1; R++) {
				temp = LogCombination(NN, R);
				PP = PP + Math.exp(temp + R * Math.log(BB1) + (NN - R) * Math.log(BB2));
			}
		}

		var ppStr = "";
		if (PP < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}

		strArray.push("片側確率 : p=" + PP.toFixed(4) + ppStr + "\n\n");
		strArray.push("効果量 : g=" + effectSizeG.toFixed(4) + "\n");
		strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

		//出力
		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RltArea").value += "\n\n" + strArray.join("");
		} else {
			document.getElementById("RltArea").value = strArray.join("");
		}
		strArray = null;

		//Ｒプログラム出力
		(function () {
			rcmArray.push("####### １×２表：母比率不等 #######\n");
			rcmArray.push("\n");
			rcmArray.push("# パッケージ pwr が必要\n");
			rcmArray.push("\n");
			rcmArray.push("## js-STARから入力\n");
			rcmArray.push("ds1=" + sKK1.toFixed(0) + "         # 度数１\n");
			rcmArray.push("ds2=" + sKK2.toFixed(0) + "         # 度数２\n");
			rcmArray.push("\n");
			rcmArray.push("bo1=" + sBB1.toFixed(4) + "         # 母比率１\n");
			rcmArray.push("\n");
			rcmArray.push("shinrai=0.95  # 信頼水準\n");
			rcmArray.push("## js-STARから入力おわり\n");
			rcmArray.push("\n");
			rcmArray.push("bo2=1-bo1       # 母比率２\n");
			rcmArray.push("N  = ds1+ds2    # 度数の合計\n");
			rcmArray.push("\n");
			rcmArray.push("## 作図\n");
			rcmArray.push("dosu <- c(ds1, ds2) # 観測度数\n");
			rcmArray.push("bohi <- c(bo1, bo2) # 母比率同じ\n");
			rcmArray.push("zhyo <- matrix( c(\n");
			rcmArray.push("  bohi,             # 母比率を先に\n");
			rcmArray.push("  dosu/N            # 標本比率をあとに\n");
			rcmArray.push("  ), nc=2, by=1)\n");
			rcmArray.push("rownames(zhyo) <- c(\"母比率\", \"標本比率\")\n");
			rcmArray.push("maintitle <- c(\"値１（黒）と値２（灰白）の比率\")\n");
			rcmArray.push("barplot( t(zhyo), hor=1, main=maintitle,\n");
			rcmArray.push("          las=1, cex.ax=1.5 )\n");
			rcmArray.push("\n");
			rcmArray.push("\n");
			rcmArray.push("## ここから統計分析\n");
			rcmArray.push("tx1<-c()\n");
			rcmArray.push("tx1 <- data.frame(matrix(c(\n");
			rcmArray.push("  ds1,            ds2,            # 観測度数\n");
			rcmArray.push("  round(ds1/N,4), round(ds2/N,4), # 標本比率\n");
			rcmArray.push("  bo1,            bo2             # 母比率\n");
			rcmArray.push("  ), nr=3, by=1) )\n");
			rcmArray.push("rownames(tx1) <- c(\"度 数\", \"標本比率 \",\"母比率\")\n");
			rcmArray.push("colnames(tx1) <- c(\"値１\",\"      値２\")\n");
			rcmArray.push("\n");
			rcmArray.push("library( pwr )        # パワーアナリシス用\n");
			rcmArray.push("P0 <- c(bo1,   bo2  ) # 母比率同等\n");
			rcmArray.push("P1 <- c(ds1/N, ds2/N) # 標本比率\n");
			rcmArray.push("es <- ES.w1( P0, P1 ) # 効果量w\n");
			rcmArray.push("\n");
			rcmArray.push("p0  <- P0[1]\n");
			rcmArray.push("p1  <- P1[1]\n");
			rcmArray.push("ESg <- p1-p0          # 効果量g\n");
			rcmArray.push("\n");
			rcmArray.push("\n");
			rcmArray.push("# ■両側検定\n");
			rcmArray.push("kr1 <- c()\n");
			rcmArray.push("kr1 <- binom.test(\n");
			rcmArray.push("  ds1, N, al=\"two\",  # 両側\n");
			rcmArray.push("  p=bo1,             # 母比率\n");
			rcmArray.push("  conf=shinrai )     # 信頼水準\n");
			rcmArray.push("\n");
			rcmArray.push("pten  <- 0.5+0.475*sign(ESg)      # 2.5% or 97.5%\n");
			rcmArray.push("bten  <- qbinom(\n");
			rcmArray.push("  pten, size=N, prob=p0)          # 分位点\n");
			rcmArray.push("bten  <- bten+1*sign(sign(ESg)-1) # 分位点のバーを除外\n");
			rcmArray.push("power <- pbinom(\n");
			rcmArray.push("  bten, size=N, prob=p1,\n");
			rcmArray.push("  low=sign( sign(ESg)-1 )*1 )\n");
			rcmArray.push("\n");
			rcmArray.push("tr1 <- c()\n");
			rcmArray.push("tr1 <- data.frame( matrix(c(\n");
			rcmArray.push("  round(kr1$p.v, 4),\n");
			rcmArray.push("  round(ESg,     4),\n");
			rcmArray.push("  round(power,   4)\n");
			rcmArray.push("  ), nr=1, by=1) )\n");
			rcmArray.push("rownames(tr1) <- c(\"正確二項検定\")\n");
			rcmArray.push("colnames(tr1) <- c(\"  ｐ値\",\" 効果量ｇ\",\" 検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tr2 <- c()\n");
			rcmArray.push("tr2 <- data.frame(\n");
			rcmArray.push("  matrix(kr1$conf[c(1,2)], nr=1) )\n");
			rcmArray.push("rownames(tr2) <- paste(\n");
			rcmArray.push("  shinrai*100,\n");
			rcmArray.push("  \"％信頼水準\", sep=\"\")\n");
			rcmArray.push("colnames(tr2) <- c(\n");
			rcmArray.push("  \"  下限値\",\n");
			rcmArray.push("  \"  上限値\")\n");
			rcmArray.push("\n");
			rcmArray.push("# パワーアナリシス両側\n");
			rcmArray.push("kr3 <- NA\n");
			rcmArray.push("kr3 <- c(\n");
			rcmArray.push("  pwr.p.test(\n");
			rcmArray.push("  al=\"two\",\n");
			rcmArray.push("  h=es, n=N,    si=NULL, po=0.80)$si,\n");
			rcmArray.push("  NA )\n");
			rcmArray.push("\n");
			rcmArray.push("kr4 <- c()                     # 次回のＮ\n");
			rcmArray.push("pten  <- 0.500+0.475*sign(ESg) # 両側の有意領域\n");
			rcmArray.push("for(i in 5:10000){\n");
			rcmArray.push("   bten <- qbinom(pten, i, p0)\n");
			rcmArray.push("   bten <- bten+sign(sign(ESg)-1) # 有意領域\n");
			rcmArray.push("   pow  <- pbinom(bten, i, p1,    # 分位,N,ncp\n");
			rcmArray.push("             low=sign(sign(ESg)-1)\n");
			rcmArray.push("            )\n");
			rcmArray.push("    if(pow>0.80){ kr4 <- c(kr4, i) }\n");
			rcmArray.push("    }\n");
			rcmArray.push("\n");
			rcmArray.push("tr3 <- c()\n");
			rcmArray.push("tr3 <- data.frame( matrix(c(\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("  round(kr3[1], 4),\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("             N,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("          0.05,\n");
			rcmArray.push("          0.80,\n");
			rcmArray.push("  ceiling(kr4[1])\n");
			rcmArray.push("  ), nr=2, by=1) )\n");
			rcmArray.push("rownames(tr3) <- c(\" α の計算\",\" Ｎ の計算\")\n");
			rcmArray.push("colnames(tr3) <- c(\n");
			rcmArray.push("  \" 効果量ｗ\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \"  1-β\",\n");
			rcmArray.push("  \"   Ｎ\")\n");
			rcmArray.push("\n");
			rcmArray.push("# ■片側greater\n");
			rcmArray.push("kg1 <- c()\n");
			rcmArray.push("kg1 <- binom.test(\n");
			rcmArray.push("  ds1, N, al=\"g\",  # 片側ｇ\n");
			rcmArray.push("  p=bo1,           # 母比率\n");
			rcmArray.push("  conf=shinrai )      # 信頼水準\n");
			rcmArray.push("\n");
			rcmArray.push("pten  <- 0.95      # 95%点\n");
			rcmArray.push("bten  <- qbinom(\n");
			rcmArray.push("  pten, size=N, prob=p0)          # 分位点\n");
			rcmArray.push("bten  <- bten+1*sign(sign(ESg)-1) # 分位点のバーを除外\n");
			rcmArray.push("power <- pbinom(\n");
			rcmArray.push("  bten, size=N, prob=p1,\n");
			rcmArray.push("  low=sign( sign(ESg)-1 )*1+sign( sign(ESg)-1 )*(-1) )\n");
			rcmArray.push("\n");
			rcmArray.push("tg1 <- c()\n");
			rcmArray.push("tg1 <- data.frame( matrix(c(\n");
			rcmArray.push("  round(kg1$p.v, 4),\n");
			rcmArray.push("  round(ESg,     4),\n");
			rcmArray.push("  round(power,   4)\n");
			rcmArray.push("  ), nr=1, by=1) )\n");
			rcmArray.push("rownames(tg1) <- c(\"片側greater\")\n");
			rcmArray.push("colnames(tg1) <- c(\"  ｐ値\",\" 効果量ｇ\",\" 検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tg2 <- c()\n");
			rcmArray.push("tg2 <- data.frame(\n");
			rcmArray.push("  matrix(kg1$conf[c(1,2)], nr=1) )\n");
			rcmArray.push("rownames(tg2) <- paste(\n");
			rcmArray.push("  shinrai*100,\n");
			rcmArray.push("  \"％信頼水準\", sep=\"\")\n");
			rcmArray.push("colnames(tg2) <- c(\"  下限値\",\"  上限値\")\n");
			rcmArray.push("\n");
			rcmArray.push("# ■片側less\n");
			rcmArray.push("kl1 <- c()\n");
			rcmArray.push("kl1 <- binom.test(\n");
			rcmArray.push("  ds1, N, al=\"l\",  # 片側ｇ\n");
			rcmArray.push("  p=bo1,           # 母比率\n");
			rcmArray.push("  conf=shinrai )      # 信頼水準\n");
			rcmArray.push("\n");
			rcmArray.push("pten  <- 0.05      # 下側５％点\n");
			rcmArray.push("bten  <- qbinom(\n");
			rcmArray.push("  pten, size=N, prob=p0)   # 分位点\n");
			rcmArray.push("bten  <- bten+1*sign(sign(ESg)-1) # 分位点のバーを除外\n");
			rcmArray.push("power <- pbinom(\n");
			rcmArray.push("  bten, size=N, prob=p1,\n");
			rcmArray.push("  low=sign( sign(ESg)-1 )*1+sign(sign(ESg)+1) )\n");
			rcmArray.push("\n");
			rcmArray.push("tl1 <- c()\n");
			rcmArray.push("tl1 <- data.frame( matrix(c(\n");
			rcmArray.push("  round(kl1$p.v, 4),\n");
			rcmArray.push("  round(ESg,     4),\n");
			rcmArray.push("  round(power,   4)\n");
			rcmArray.push("  ), nr=1, by=1) )\n");
			rcmArray.push("rownames(tl1) <- c(\"片側less\")\n");
			rcmArray.push("colnames(tl1) <- c(\"  ｐ値\",\" 効果量ｇ\",\" 検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tl2 <- c()\n");
			rcmArray.push("tl2 <- data.frame(\n");
			rcmArray.push("  matrix(kl1$conf[c(1,2)], nr=1) )\n");
			rcmArray.push("rownames(tl2) <- paste(\n");
			rcmArray.push("  shinrai*100,\n");
			rcmArray.push("  \"％信頼水準\", sep=\"\")\n");
			rcmArray.push("colnames(tl2) <- c(\"  下限値\",\"  上限値\")\n");

			if (HH1 >= sBB1) {
				rcmArray.push("\n");
				rcmArray.push("options(digits=4)\n");
				rcmArray.push("options(scipen=5)\n");
				rcmArray.push("##################################\n");
				rcmArray.push("# 直接確率計算１×２：母比率不等 #\n");
				rcmArray.push("#   １標本における２値の比較     #\n");
				rcmArray.push("#   正確二項検定（片側 greater） #\n");
				rcmArray.push("##################################\n");
				rcmArray.push("tx1 # 度数集計表\n");
				rcmArray.push("\n");
				rcmArray.push("tg1 # 正確二項検定（対立仮説：greater）\n");
				rcmArray.push("#  p<α なら「値１の真の比率＞母比率」\n");
				rcmArray.push("# 効果量ｇ= 標本比率－母比率\n");
				rcmArray.push("\n");
				rcmArray.push("tg2 # 値１の比率の区間推定（Ｆ分布による）\n");
			} else if (HH1 < sBB1) {
				rcmArray.push("\n");
				rcmArray.push("options(digits=4)\n");
				rcmArray.push("options(scipen=5)\n");
				rcmArray.push("##################################\n");
				rcmArray.push("# 直接確率計算１×２：母比率不等 #\n");
				rcmArray.push("#   １標本における２値の比較     #\n");
				rcmArray.push("#   正確二項検定（片側 less）    #\n");
				rcmArray.push("##################################\n");
				rcmArray.push("tx1 # 度数集計表\n");
				rcmArray.push("\n");
				rcmArray.push("tl1 # 正確二項検定（対立仮説：less）\n");
				rcmArray.push("#  p<α なら「値１の真の比率＜母比率」\n");
				rcmArray.push("# 効果量ｇ= 標本比率－母比率\n");
				rcmArray.push("\n");
				rcmArray.push("tl2 # 値１の比率の区間推定（Ｆ分布による）\n");
			}
			rcmArray.push("\n");
			rcmArray.push("options(digits=4)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("##################################\n");
			rcmArray.push("# 直接確率計算１×２：母比率不等 #\n");
			rcmArray.push("#   １標本における２値の比較     #\n");
			rcmArray.push("#   正確二項検定（両側）         #\n");
			rcmArray.push("##################################\n");
			rcmArray.push("tx1 # 度数集計表\n");
			rcmArray.push("\n");
			rcmArray.push("tr1 # 正確二項検定\n");
			rcmArray.push("#  p<α なら「値１の真の比率≠母比率」\n");
			rcmArray.push("# 効果量ｇ= 標本比率－母比率\n");
			rcmArray.push("\n");
			rcmArray.push("tr2 # 値１の比率の区間推定（Ｆ分布による）\n");
			rcmArray.push("\n");
			rcmArray.push("tr3 # パワーアナリシス（対立仮説：両側）\n");
			rcmArray.push("# ■ NULL, NA が表示されたら計算不能■\n");
			rcmArray.push("# 効果量ｗの評価：大=0.5, 中=0.3, 小=0.1\n");
			rcmArray.push("# αの計算はカイ二乗検定（df=1）を想定\n");

			rcmArray.push("\n");
			rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
			rcmArray.push("\n");

			if (document.getElementById("RltAdd").checked) {
				document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
			} else {
				document.getElementById("RcmArea").value = rcmArray.join("");
			}
			rcmArray = null;
		}());	//Ｒプログラムここまで

		//グラフ描画
		(function () {
			if (document.getElementById("RltAdd").checked === false) {
				chartClear();
			}

			var parent = document.getElementById("chart");
			var childElementCount = parent.childElementCount;

			var i;
			var chartImg = document.createElement('canvas');
			chartImg.id = "ChartImg" + childElementCount;
			var ctx = document.getElementById("chart").appendChild(chartImg);

			var data = [];
			for (i = 0; i < 2; i++) {
				data[i] = [];
			}
			data[0][0] = (HH1 * 100).toFixed(4);
			data[0][1] = (sBB1 * 100).toFixed(4);
			data[1][0] = (HH2 * 100).toFixed(4);
			data[1][1] = (sBB2 * 100).toFixed(4);

			var datasetKey = [];
			for (i = 0; i < 2; i++) {
				datasetKey[i] = [];
			}
			for (i = 0; i < 2; i++) {
				datasetKey[i].label = '値' + (i + 1);
				datasetKey[i].data = data[i];
				datasetKey[i].backgroundColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
				datasetKey[i].borderColor = 'rgba(' + 128 * i + ',' + 128 * i + ',' + 128 * i + ')';
				datasetKey[i].borderWidth = 1;
			}

			var datasetData = [];
			// var dataset = [datas[0], datas[1]];
			for (i = 0; i < 2; i++) {
				datasetData[i] = datasetKey[i];
			}
			var myChart = new Chart(ctx, {
				type: 'horizontalBar',
				data: {
					labels: ['標本比率', '母比率'],
					datasets: datasetData
				},
				options: {
					title: {
						display: true,
						text: '値１（黒）と値２（灰白）の比率',
						position: 'top',
						fontSize: 12,
						fontColor: '#000000'
					},
					scales: {
						xAxes: [{
							stacked: true,
							ticks: {
								beginAtZero: true,
								min: 0,
								max: 100
							}
						}],
						yAxes: [{
							stacked: true
						}]
					},
					legend: {
						position: 'bottom'
					}
				}
			});
		}());	//グラフ描画ここまで

	}

	document.getElementById("RltArea").focus();
}
function sum() {
	var i = 1;
	var iCount = 1; // 観測値のみ合計する
	var jCount = 2;
	var elmCount = iCount * jCount;

	var wSum = 0;

	for (i = 1; i < elmCount + 1; i++) {
		if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
			wSum += parseInt(document.getElementById("cell_" + i).value);
		}
	}
	document.getElementById("cell_sum").value = wSum;
}
function saveData_1x2futo() {
	var strArray = [];

	var KK1 = parseInt(document.getElementById("cell_1").value, 10);
	var KK2 = parseInt(document.getElementById("cell_2").value, 10);

	var BB1 = parseFloat(document.getElementById("cell2_1").value);
	var BB2 = parseFloat(document.getElementById("cell2_2").value);

	strArray.push(KK1 + "\t" + KK2 + "\n");
	strArray.push(BB1 + "\t" + BB2 + "\n");

	var Stream = strArray.join("");
	var fineName = "1x2futo_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}