/**
 * クラスタ分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeClusSetting();
	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
}
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;
	var elmCount = NN * (LA + LB);

	var result = confirm("データを消去します");
	if (result == true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");
	}
}
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;
	var elmCount = NN * (LA + LB);

	var errorCellNum = 0;
	if (document.getElementById("CandPArea").value == '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum == 0) {
			errorClearCell(elmCount, "");
			mainCalc_clus();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = new Array();
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_clus() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;
	var k = 3 + LA;

	var strArray = new Array();
	var bar = "------------------------------------------------\n";
	var rcmArray = new Array();
	var rcmArray1 = new Array();
	var rcmArray2 = new Array();

	var xx = new Array(LA + LB);
	for (i = 0; i < LA + 1; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + LB; i++) {
			if (LB == 1) {
				xx[i][j] = document.getElementById("cell_" + cellId).value;
			} else {
				xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			}
			cellId++;
		}
	}

	var hensu = 0;
	for (i = 0; i < LA; i++) {
		if (document.getElementById("x" + (i + 1)).checked) {
			hensu++;
		}
	}

	//基本統計量
	var M = new Array();	//平均
	var SD = new Array();	//標準偏差
	var MA = new Array();	//最大値
	var MI = new Array();	//最小値

	strArray.push(" == Means & SDs(SD=sqrt(Vtotal/N)) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	if (LB == 1) {
		for (i = 1; i < LA + LB; i++) {
			S = 0;
			SS = 0;
			MA[i - 1] = parseFloat(xx[i][0]);
			MI[i - 1] = parseFloat(xx[i][0]);

			for (j = 0; j < NN; j++) {
				S += parseFloat(xx[i][j]);
				SS += Math.pow(parseFloat(xx[i][j]), 2);

				if (MA[i - 1] < xx[i][j]) MA[i - 1] = xx[i][j];
				if (MI[i - 1] > xx[i][j]) MI[i - 1] = xx[i][j];
			}
			M[i - 1] = S / NN;
			SD[i - 1] = Math.sqrt(SS / NN - Math.pow(M[i - 1], 2));
			strArray.push("x" + i + "\t" + using(M[i - 1], 4, 3) + "\t" + using(SD[i - 1], 4, 3) + "\t" + using(MI[i - 1], 4, 3) + "\t" + using(MA[i - 1], 4, 3) + "\n");
		}
	} else {
		for (i = 0; i < LA + LB; i++) {
			S = 0;
			SS = 0;
			MA[i] = parseFloat(xx[i][0]);
			MI[i] = parseFloat(xx[i][0]);

			for (j = 0; j < NN; j++) {
				S += parseFloat(xx[i][j]);
				SS += Math.pow(parseFloat(xx[i][j]), 2);

				if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
				if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
			}
			M[i] = S / NN;
			SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));
			strArray.push("x" + (i + 1) + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		}
	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA; i++) {
		strArray.push("x" + (i + 1) + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			//var seiinCount=1; //成員名のためのカウンタ
			for (j = 0; j < NN; j++) {
				for (i = 0; i < LA + LB; i++) {
					if (LB == 1) {
						if (i == 0) {
							rcmArray1.push("\"" + xx[i][j] + "\"");
						} else {
							rcmArray1.push(xx[i][j]);
						}
					} else {
						rcmArray1.push(xx[i][j]);
					}
					if ((i != LA + LB - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			var enterCount = 0; //改行のためのカウンタ
			if (LB == 1) {
				rcmArray.push("nam <- c(\n");
				for (j = 0; j < NN; j++) {
					rcmArray.push("\"" + xx[0][j] + "\"");
					if ((j != NN - 1)) {
						rcmArray.push(",");
						enterCount++;
						if (enterCount == 5) {
							rcmArray.push("\n");
							enterCount = 0;
						}
					}

				}
				rcmArray.push("\n )\n");
			}
			rcmArray.push("\n");

			enterCount = 0; //改行のためのカウンタ
			if (LB == 1) {
				for (i = 1; i < LA + LB; i++) {
					rcmArray.push("x" + i + " <- c(\n");
					for (j = 0; j < NN; j++) {
						rcmArray.push(" " + xx[i][j]);
						if ((j != NN - 1)) {
							rcmArray.push(",");
							enterCount++;
							if (enterCount == 5) {
								rcmArray.push("\n");
								enterCount = 0;
							}
						}
					}
					rcmArray.push("\n )\n");
					enterCount = 0;
				}
			} else {
				for (i = 0; i < LA + LB; i++) {
					rcmArray.push("x" + (i + 1) + " <- c(\n");
					for (j = 0; j < NN; j++) {
						rcmArray.push(" " + parseFloat(xx[i][j]));
						if ((j != NN - 1)) {
							rcmArray.push(",");
							enterCount++;
							if (enterCount == 5) {
								rcmArray.push("\n");
								enterCount = 0;
							}
						}
					}
					rcmArray.push("\n )\n");
					enterCount = 0;
				}
			}
			rcmArray.push("\n");

			rcmArray.push("dtab <- data.frame(\n");
			if (LB == 1) {
				rcmArray.push(" nam,\n");
			}
			for (i = 0; i < LA; i++) {
				rcmArray.push(" x" + (i + 1));
				if ((i != LA - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");
			rcmArray.push("\n");

			if (LB == 1) {
				rcmArray.push("nam <- c()\n");
			}
			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("####### クラスタ分析 #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 欠損値は事前に処理する必要あり！\n");
		rcmArray2.push("\n");
		rcmArray2.push("## 設定諸元\n");
		rcmArray2.push("label=" + LB + "   # 成員名あり（0=なし）\n");
		rcmArray2.push("hensu=" + LA + "  # 変数の個数\n");
		rcmArray2.push("\n");

		var stdiz = parseInt(document.getElementById("standard").value);
		var kyoho = document.getElementById("dist_method").value;
		var nijyo = parseInt(document.getElementById("dist_square").value);
		var clsho = document.getElementById("cluster_method").value;
		var clust = parseInt(document.getElementById("clusterNum").value);

		var element = document.getElementById("dist_method");
		for (i = 0; i < element.options.length; i++) {
			var option = element.options[i];
			if (option.selected) {
				var dist_methodText = option.text;
			}
		}
		element = document.getElementById("cluster_method");
		for (i = 0; i < element.options.length; i++) {
			var option = element.options[i];
			if (option.selected) {
				var cluster_methodText = option.text;
			}
		}
		rcmArray.push("\n");

		rcmArray2.push("stdiz=" + stdiz + "      # 標準化する（0=しない）\n");
		rcmArray2.push("kyoho=\"" + kyoho + "\"  # 距離の計算法\n");
		rcmArray2.push("nijyo=" + nijyo + "      # 二乗する（1=二乗しない）\n");
		rcmArray2.push("clsho=\"" + clsho + "\" # クラスタ化の方法\n");
		rcmArray2.push("clust=" + clust + "      # クラスタ数（2=初期値）\n");
		rcmArray2.push("\n");
		rcmArray2.push("# メニュー\n");
		rcmArray2.push("# kyoho=euc, max, manh, canb, mink\n");
		rcmArray2.push("# clsho=ward, single, complete, average, median\n");
		rcmArray2.push("\n");

		rcmArray2.push("# データセット\n");
		rcmArray2.push("saiyo <- c(");
		var commaflag = false;
		for (i = 0; i < LA; i++) {
			if (document.getElementById("x" + (i + 1)).checked) {
				if (commaflag) {
					rcmArray2.push(",");
				}
				rcmArray2.push(" " + (i + 1));
				commaflag = true;
			}
		}
		rcmArray2.push(" )\n");

		rcmArray2.push("tmp <- c()\n");
		rcmArray2.push("if(label>0) tmp <- \"成員名\"\n");
		rcmArray2.push("colnames(dtab) <- c(\n");
		rcmArray2.push("  tmp,\n");
		rcmArray2.push("  paste(\"x\", 1:hensu, sep=\"\")\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("rets <- label+saiyo           # 分析対象の列\n");
		rcmArray2.push("if(label>0) rets <- c(1,rets) # 成員ありの場合\n");
		rcmArray2.push("dset <- dtab[,rets]\n");
		rcmArray2.push("N <- nrow(dset)\n");
		rcmArray2.push("\n");

		rcmArray2.push("# 基本統計量\n");
		rcmArray2.push("cx <- length(saiyo)\n");
		rcmArray2.push("kxx <- c()\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  kxx <- c(kxx,\n");
		rcmArray2.push("    N,\n");
		rcmArray2.push("    mean(dset[ ,label+i]),\n");
		rcmArray2.push("    sd  (dset[ ,label+i]),\n");
		rcmArray2.push("    min (dset[ ,label+i]),\n");
		rcmArray2.push("    max (dset[ ,label+i]) )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("tx0 <- matrix(round(\n");
		rcmArray2.push("  kxx, 4\n");
		rcmArray2.push("  ), nc=5, by=1 )\n");
		rcmArray2.push("colnames(tx0) <- c(\n");
		rcmArray2.push("  \"  ｎ\", \n");
		rcmArray2.push("  \"     Ｍ\",\n");
		rcmArray2.push("  \"       SD\",\n");
		rcmArray2.push("  \"    min\", \n");
		rcmArray2.push("  \"  max\" )\n");
		rcmArray2.push("hensmei <- colnames(dset[,(label+1):(label+cx)])\n");
		rcmArray2.push("rownames(tx0) <- hensmei\n");

		rcmArray2.push("\n");
		rcmArray2.push("# 分析用データセット\n");
		rcmArray2.push("dx <- dset\n");
		rcmArray2.push("if(stdiz==1){                   # 標準化\n");
		rcmArray2.push("  dx[ ,(label+1):(label+cx)] <- scale(\n");
		rcmArray2.push("  dx[ ,(label+1):(label+cx)] )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx8 <- c()\n");
		rcmArray2.push("tx8 <- round(  # 変数間相関\n");
		rcmArray2.push("  cor(dx[ ,(label+1):(label+cx)]), 3)\n");

		rcmArray2.push("\n");
		rcmArray2.push("# クラスタ化\n");
		rcmArray2.push("kx2 <- hclust(dist(\n");
		rcmArray2.push("  dx[ ,(label+1):(label+cx)],\n");
		rcmArray2.push("  method=kyoho  )^nijyo,\n");
		rcmArray2.push("  method=\"ward\" )\n");

		rcmArray2.push("\n");
		rcmArray2.push("# デンドログラム\n");
		rcmArray2.push("if(label<1){ ID= 1:N }\n");
		rcmArray2.push("if(label>0){ ID= dx[,1] } # 成員名\n");
		rcmArray2.push("plot(kx2, h=-1, labels=ID,\n");
		rcmArray2.push("  xlab=\"距離＝" + dist_methodText + "\",\n");
		rcmArray2.push("  sub =\"クラスタ化の方法＝" + cluster_methodText + "\"\n");
		rcmArray2.push("  )\n");

		rcmArray2.push("\n");
		rcmArray2.push("# クラスタ比較\n");
		rcmArray2.push("rect.hclust(kx2, k=clust, bord=3)\n");
		rcmArray2.push("dx[ ,c(\"CL\")] <- factor(cutree(kx2, k=clust))\n");
		rcmArray2.push("dset[ ,c(\"CL\")] <- factor(cutree(kx2, k=clust))\n");
		rcmArray2.push("\n");
		rcmArray2.push("nn <- c()\n");
		rcmArray2.push("nn <- table( dx$CL )\n");
		rcmArray2.push("kx <- c()\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  kx <- c(kx,\n");
		rcmArray2.push("    tapply(dx[ ,label+i],dx$CL,mean),\n");
		rcmArray2.push("    tapply(dx[ ,label+i],dx$CL,sd  )\n");
		rcmArray2.push("    )\n");
		rcmArray2.push("    if(i<cx){kx <- c(kx, rep(NA,clust) ) }\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("tx3 <- matrix(round(c(\n");
		rcmArray2.push("  nn, kx\n");
		rcmArray2.push("  ), 3), nc=clust, by=1)\n");
		rcmArray2.push("\n");
		rcmArray2.push("kxz <- chisq.test(nn)\n");
		rcmArray2.push("kx4 <- c(\n");
		rcmArray2.push("  round(kxz$stat, 3),\n");
		rcmArray2.push("  round(kxz$p.va, 4)\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  kxx <- anova(lm(\n");
		rcmArray2.push("    dx[ ,label+i]~dx$CL) )\n");
		rcmArray2.push("  kxy <- bartlett.test(\n");
		rcmArray2.push("    dx[ ,label+i]~dx$CL )\n");
		rcmArray2.push("  kx4 <- c(kx4,\n");
		rcmArray2.push("    round(kxx$F[1], 3),\n");
		rcmArray2.push("    round(kxx$Pr[1],4),\n");
		rcmArray2.push("    round(kxy$stat, 3),\n");
		rcmArray2.push("    round(kxy$p.va, 4) )\n");
		rcmArray2.push("    if(i<cx){kx4 <- c(kx4, NA,NA) }\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("tx4 <- cbind(\n");
		rcmArray2.push("  tx3,\n");
		rcmArray2.push("  matrix(kx4, nc=2, by=1)\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("\n");
		rcmArray2.push("colnames(tx4) <- c(\n");
		rcmArray2.push("  paste(\"CL\",1:clust,sep=\"\"),\n");
		rcmArray2.push("  \"  Ｆ/χ2\",\n");
		rcmArray2.push("  \"   ｐ値\" )\n");
		rcmArray2.push("tmp <- \"成員数ｎ\"\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  tmp <- c(tmp,\n");
		rcmArray2.push("    paste( \n");
		rcmArray2.push("      hensmei[i],\n");
		rcmArray2.push("      \"Ｍ\",sep=\"_\" ),\n");
		rcmArray2.push("    paste( \n");
		rcmArray2.push("      hensmei[i],\n");
		rcmArray2.push("      \"SD\",sep=\"_\" )\n");
		rcmArray2.push("    )\n");
		rcmArray2.push("    if(i<cx){tmp <- c(tmp, \"\") }\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("rownames(tx4) <- tmp\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx5 <- c()\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  tx5 <- rbind(tx5,\n");
		rcmArray2.push("    round(\n");
		rcmArray2.push("      pairwise.t.test(\n");
		rcmArray2.push("        dx[ ,label+i], dx$CL,\n");
		rcmArray2.push("        p.ad=\"BH\")$p.va,\n");
		rcmArray2.push("    4),\n");
		rcmArray2.push("  if(i<cx){matrix(\n");
		rcmArray2.push("      rep(NA, clust-1),nr=1 )}\n");
		rcmArray2.push("  ) }\n");
		rcmArray2.push("colnames(tx5) <- paste(\n");
		rcmArray2.push("  \"CL\", 1:(clust-1), sep=\"\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("tmp <- c()\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("for(j in 2:clust){\n");
		rcmArray2.push("  tmp <- c(tmp,\n");
		rcmArray2.push("    paste(\n");
		rcmArray2.push("      hensmei[i],\n");
		rcmArray2.push("      paste(\"CL\",j, sep=\"\"),\n");
		rcmArray2.push("      sep=\"_\" )\n");
		rcmArray2.push("  ) }\n");
		rcmArray2.push("  if(i<cx) tmp <- c(tmp, \"\")\n");
		rcmArray2.push(" }\n");
		rcmArray2.push("rownames(tx5) <- tmp\n");

		rcmArray2.push("\n");
		rcmArray2.push("# クラスタ数によるｎの試算\n");
		rcmArray2.push("st=clust-2; if(st<2) st=2\n");
		rcmArray2.push("ed=clust+2; if(ed>N) ed=N-2\n");
		rcmArray2.push("\n");
		rcmArray2.push("kx7 <- c()\n");
		rcmArray2.push("for(i in st:ed){\n");
		rcmArray2.push("  tmp <- cutree(kx2, k=i)\n");
		rcmArray2.push("  kxx <- chisq.test(table(tmp))\n");
		rcmArray2.push("  kx7 <- c(kx7,\n");
		rcmArray2.push("    table(tmp),\n");
		rcmArray2.push("    rep(NA, ed-i),\n");
		rcmArray2.push("    round(kxx$stat, 3),\n");
		rcmArray2.push("    i-1,\n");
		rcmArray2.push("    round(kxx$p.va, 4)    \n");
		rcmArray2.push("    )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("tx7 <- matrix(kx7,nc=ed+3,by=1)\n");
		rcmArray2.push("\n");
		rcmArray2.push("colnames(tx7) <- c(\n");
		rcmArray2.push("  paste(\"CL\", 1:ed, sep=\"\"),\n");
		rcmArray2.push("  \"  χ2\",\n");
		rcmArray2.push("  \" df\",\n");
		rcmArray2.push("  \"   ｐ値\" )\n");
		rcmArray2.push("rownames(tx7) <- paste(\n");
		rcmArray2.push("  \"ｋ\",\n");
		rcmArray2.push("  st:ed, sep=\"=\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ボックスプロット用\n");
		rcmArray2.push("bx <- dset[,(label+1):(label+cx)]\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 相関行列\n");
		rcmArray2.push("rmat <- c()\n");
		rcmArray2.push("keis <- c()\n");
		rcmArray2.push("keis <- cor(bx)\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("for(j in 1:cx){\n");
		rcmArray2.push("  if(i<j){rmat <- c(rmat, keis[i,j]) }\n");
		rcmArray2.push("  else    rmat <- c(rmat, NA)\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("pval <- c()\n");
		rcmArray2.push("padj <- c()\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("for(j in 1:cx){\n");
		rcmArray2.push("  if(i<j){\n");
		rcmArray2.push("      sokan <- keis[i,j]\n");
		rcmArray2.push("      pval  <- c(pval,\n");
		rcmArray2.push("         pf(sokan^2/((1-sokan^2)/(N-2)),\n");
		rcmArray2.push("            df1=1, df2=N-1,low=0 )\n");
		rcmArray2.push("       ) }\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("padj <- p.adjust(pval, me=\"BH\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("test <- c()\n");
		rcmArray2.push("valjun=0\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("for(j in 1:cx){\n");
		rcmArray2.push("  if(i<j) { valjun=valjun+1\n");
		rcmArray2.push("            test <- c(test, pval[valjun]) }\n");
		rcmArray2.push("  else test <- c(test, NA)\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("tadj <- c()\n");
		rcmArray2.push("adjjun=0\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("for(j in 1:cx){\n");
		rcmArray2.push("  if(i<j) { adjjun=adjjun+1\n");
		rcmArray2.push("            tadj <- c(tadj, padj[adjjun]) }\n");
		rcmArray2.push("  else tadj <- c(tadj, NA)\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx8 <- c()\n");
		rcmArray2.push("tx9 <- c()\n");
		rcmArray2.push("rmat <- matrix(rmat, nc=cx, by=1)\n");
		rcmArray2.push("test <- matrix(test, nc=cx, by=1)\n");
		rcmArray2.push("tadj <- matrix(tadj, nc=cx, by=1)\n");
		rcmArray2.push("tx8  <- round(rmat, 3)\n");
		rcmArray2.push("test <- round(test, 3)\n");
		rcmArray2.push("tx9  <- round(tadj, 3)\n");
		rcmArray2.push("dimnames(tx8)  <- dimnames(keis)\n");
		rcmArray2.push("dimnames(test) <- dimnames(keis)\n");
		rcmArray2.push("dimnames(tx9 ) <- dimnames(keis)\n");
		rcmArray2.push("\n");

		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("###########################\n");
		rcmArray2.push("# クラスタ分析：\n");
		rcmArray2.push("#  " + dist_methodText + "\n");
		rcmArray2.push("#  " + cluster_methodText + "\n");
		rcmArray2.push("#  ・クラスタ数  = " + clust + "\n");

		if (stdiz == 0) {
			rcmArray2.push("#  ・変数の標準化= なし\n");
		} else if (stdiz = 1) {
			rcmArray2.push("#  ・変数の標準化= あり\n");
		}
		rcmArray2.push("###########################\n");
		rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx4 # 各クラスタのプロフィール分析\n");
		rcmArray2.push("# ｎ の有意差検定は適合度検定（χ2値）\n");
		rcmArray2.push("# Ｍ の有意差検定は分散分析（Ｆ値）\n");
		rcmArray2.push("# SD2 の同質性検定はバートレット検定（χ2値）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx5 # 平均の多重比較（プールドSDを用いたｔ検定）\n");
		rcmArray2.push("# 数値は調整後ｐ値（両側確率）\n");
		rcmArray2.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx7 # クラスタ数ｋによる成員数ｎの試算\n");
		rcmArray2.push("# ■成員数=1 があるクラスタ数では検定結果無効！\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx8 # 変数間相関\n");
		rcmArray2.push("tx9 # 相関係数の有意性検定\n");
		rcmArray2.push("# 数値はｔ検定による調整後ｐ値（両側確率）\n");
		rcmArray2.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray2.push("# windows();boxplot(bx) # 箱ひげ図\n");
		rcmArray2.push("# test                  # 相関行列の調整前ｐ値\n");
		rcmArray2.push("# dset                    # クラスタ番号付きデータセット\n");
		rcmArray2.push("# dset[order(dset[,\"CL\"]),] # クラスタ番号順の並び替え\n");

		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray2.push("\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
/**
 *
 * 参加者数のid subjNum
 * 変数の個数のid item_number
 * 成員名のid member
 *
 */
function changeClusSetting() {
	var h = 2;
	var htmArray = new Array();

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");

	// htmArray.push("<ul class=\"menubutton1\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"cellAreaScroll('clus');return false;\"><span id=\"cellAreaScrollBtn\">△短縮</a></span></li>");
	// htmArray.push("</ul>");

	// htmArray.push("</div>");

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeClusTableBranch();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeClusTableBranch();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}
	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">変数の個数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"item_number\" size=\"10\" min=\"2\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeClusTableBranch();\">");
	} else {
		htmArray.push("<select id=\"item_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'変数の個数');changeClusTableBranch();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("<table border=\"0\" class=\"codetb4\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">成員名あり：</td>");
	htmArray.push("<td class=\"codetbR\">");
	// htmArray.push("<select id=\"mumber\" name=\"i\" class=\"tySelect3\" size=\"1\" onfocus=\"setSelectNum(2);\" onchange=\"addSelectItem5(this,'成員名あり');changeClusTableBranch();\">");
	htmArray.push("<select id=\"mumber\" name=\"i\" class=\"tySelect3\" size=\"1\" onchange=\"addSelectItem5(this,'成員名あり');changeClusTableBranch();\">");
	htmArray.push("<option value=\"2\" selected>はい</option>");
	htmArray.push("<option value=\"1\">いいえ</option>");
	htmArray.push("</select>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("clus_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeClusTableBranch();
}
function changeClusTableBranch() {
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;

	if ((NN >= 10) || (LA + LB >= 8)) {
		changeClusTable_scroll();
	} else {
		changeClusTable_all();
	}
}
function changeClusTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;

	var htmArray = new Array();
	var cellId = 1;
	var cellCount = NN * (LA + LB);

	if (LA + LB >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	if (LB == 1) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("成員名");
		htmArray.push("</td>");
	}

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		if (LA + LB < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("x" + (i + 1));
		}
		htmArray.push("</td>");
	}

	var seiinCount = 0;
	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA + LB; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");

			if (LB == 1) {
				if (seiinCount == 0) {
					htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">");
				} else {
					htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
				}
				seiinCount++;
				seiinCount = seiinCount % (LA + LB);
			} else {
				htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			}
			htmArray.push("</td>");
			cellId++;
		}
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("clus_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	//setDragAndDrop();
}
function changeClusTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;
	var htmArray = new Array();
	var cellId = 1;
	var cellCount = NN * (LA + LB);

	if (LA + LB >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	if (LB == 1) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (LA + 1 < 8) {
			htmArray.push("<div>成員名</div>");
		} else {
			htmArray.push("<div style=\"width: 41px;font-size:10pt;\">成員名</div>");
		}
		htmArray.push("</td>");
	}

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (LA + LB < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("<div style=\"width: 41px;\">x" + (i + 1) + "</div>");
		}
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	var seiinCount = 0;
	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA + LB; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			if (LB == 1) {
				if (seiinCount == 0) {
					htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">");
				} else {
					htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
				}
				seiinCount++;
				seiinCount = seiinCount % (LA + LB);
			} else {
				htmArray.push("<input type=\"text\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxlength=\"3\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			}
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("clus_table").innerHTML = htmArray.join("");
	htmArray = null;

	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_Clust() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB = parseInt(document.getElementById("mumber").value) - 1;

	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + LB; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA + LB - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "Reg_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}

