/**
 * 因子分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeFactSetting();
	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		var LB = parseInt(document.getElementById("factor_number").value);
	}
	var elmCount = NN * (LA + LB);

	var result = confirm("データを消去します");
	if (result == true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");
	}
	setFocus(0);
}
function checkCellData() {
	var i = 0;
	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		var LB = parseInt(document.getElementById("factor_number").value);
	}
	var elmCount = NN * (LA + LB);

	var errorCellNum = 0;

	console.log(NN + "," + LA + "," + LB + "," + elmCount);

	if (document.getElementById("CandPArea").value == "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum == 0) {
			errorClearCell(elmCount, "");
			mainCalc_fact();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません!!!");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_fact() {
	var i = 0;
	var j = 0;
	var k = 0;

	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB;
	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		LB = parseInt(document.getElementById("factor_number").value);
	}
	var LAB = LA + LB;

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var xx = new Array(LAB);
	for (i = 0; i < LAB; i++) {
		xx[i] = new Array(NN);
	}

	switch (afterAnalysNum) {
		case 0:
			k = 3 + LA;
			break;
		case 1:
			k = 4 + LA;
			break;
		case 2:
			k = 4 + LA + LB;
			break;
		case 3:
			k = 4 + LA + LB;
			break;
		case 4:
			k = 4 + LA;
			break;
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LAB; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var hensu = 0;
	for (i = 0; i < LA; i++) {
		if (document.getElementById("x" + (i + 1)).checked) {
			hensu++;
		}
	}

	//基本統計量
	var M = [];	//平均
	var SD = [];	//標準偏差
	var MA = [];	//最大値
	var MI = [];	//最小値

	strArray.push(" == Means & SDs(SD=sqrt(Vtotal/N)) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0];
		MI[i] = xx[i][0];

		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
		}

		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));
		strArray.push((i + 1) + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA; i++) {
		strArray.push((i + 1) + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		switch (afterAnalysNum) {
			case 0:
				//クリップボード使用のためのデータ
				if (r_output == 1) {
					for (j = 0; j < NN; j++) {
						for (i = 0; i < LA; i++) {
							rcmArray1.push(xx[i][j]);
							if ((i != LA - 1)) rcmArray1.push("\t");
						}
						rcmArray1.push("\n");
					}
				}
				//直接貼り付けるのためのデータ
				if (r_output == 2) {
					for (i = 0; i < LA; i++) {
						rcmArray.push("x" + (i + 1) + " <- c(");
						for (j = 0; j < NN; j++) {
							rcmArray.push(" " + xx[i][j]);
							if ((j != NN - 1)) rcmArray.push(",");
						}
						rcmArray.push(" )\n");
					}
					rcmArray.push("\n");
					rcmArray.push("dtab <- data.frame(\n");
					for (i = 0; i < LA; i++) {
						rcmArray.push(" x" + (i + 1));
						if ((i != LA - 1)) rcmArray.push(",");
					}
					rcmArray.push("\n  )\n");
					for (i = 0; i < LA; i++) {
						rcmArray.push("x" + (i + 1) + " <- c()\n");
					}
				}

				rcmArray2.push("####### 因子分析→事後分析「なし」 #######\n");
				rcmArray2.push("\n");
				rcmArray2.push("# パッケージ psych が必要\n");
				rcmArray2.push("# パッケージ GPArotation が必要\n");
				rcmArray2.push("# 欠損値は事前に処理する必要あり！\n");
				rcmArray2.push("\n");

				var NF = parseInt(document.getElementById("factorNum").value);
				var strMe = document.getElementById("method").value;
				var strRo = document.getElementById("rotate").value;

				rcmArray2.push("# 設定データ\n");
				rcmArray2.push("N=" + NN + "      # 参加者数\n");
				rcmArray2.push("hensu=" + LA + "  # 変数（質問項目）の数\n");
				rcmArray2.push("\n");
				rcmArray2.push("NF=" + NF + "         # 因子数（初期値=2）\n");
				rcmArray2.push("Me=\"" + strMe + "\"      # Method※下記「メニュー」参照\n");
				rcmArray2.push("Ro=\"" + strRo + "\" # Rotate※下記「メニュー」参照\n");
				rcmArray2.push("\n");

				rcmArray2.push("# メニュー\n");
				rcmArray2.push("# Me=ml, wls, gls, pa\n");
				rcmArray2.push("# Ro=varimax, Varimax, promax, oblimin\n");
				rcmArray2.push("#     正規化, 非正規化\n");
				rcmArray2.push("\n");

				rcmArray2.push("# データ\n");
				rcmArray2.push("saiyo <- c(");
				var commaflag = false;
				for (i = 0; i < LA; i++) {
					if (document.getElementById("x" + (i + 1)).checked) {
						if (commaflag) {
							rcmArray2.push(",");
						}
						rcmArray2.push(" " + (i + 1));
						commaflag = true;
					}
				}
				rcmArray2.push(" )   # 採用した説明変数\n");
				rcmArray2.push("colnames(dtab) <- c(\n");
				rcmArray2.push("  paste(\"x\",1:hensu,sep=\"\")\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("dx <- data.frame(dtab[,saiyo])\n");
				rcmArray2.push("dset <- dx\n");
				rcmArray2.push("\n");

				rcmArray2.push("## 基本統計量\n");
				// rcmArray2.push("dx <- dset[ ,1:hensu]\n");
				rcmArray2.push("hk <- sapply(dx, mean)\n");
				rcmArray2.push("sd <- sapply(dx,   sd)\n");
				rcmArray2.push("n  <- c()\n");
				rcmArray2.push("mi <- c()\n");
				rcmArray2.push("ma <- c()\n");
				rcmArray2.push("cx <- ncol(dx)\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("  n  <- c(n, length(dx[,i]) )\n");
				rcmArray2.push("  mi <- c(mi,   min(dx[,i]) )\n");
				rcmArray2.push("  ma <- c(ma,   max(dx[,i]) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx0 <- c()\n");
				rcmArray2.push("tx0 <- data.frame(\n");
				rcmArray2.push("  n,\n");
				rcmArray2.push("  round(hk, 4),\n");
				rcmArray2.push("  round(sd, 4),\n");
				rcmArray2.push("  mi,\n");
				rcmArray2.push("  ma\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("colnames(tx0) <- c(\n");
				rcmArray2.push("  \"   Ｎ\",\n");
				rcmArray2.push("  \"     Mean\",\n");
				rcmArray2.push("  \"       SD\",\n");
				rcmArray2.push("  \"   Min\",\n");
				rcmArray2.push("  \"  Max\" )\n");
				rcmArray2.push("\n");

				rcmArray2.push("# 主成分プロット\n");
				rcmArray2.push("kx1 <- princomp(\n");
				rcmArray2.push("  dx,\n");
				rcmArray2.push("  cor=1 )\n");
				rcmArray2.push("screeplot(kx1,\n");
				rcmArray2.push("  pch=21, bg=3, cex=3,\n");
				rcmArray2.push("  ty=\"lines\", lwd=2,\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("ky1 <- kx1$sdev^2/sum(kx1$sdev^2)\n");
				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("  tmp <- c(tmp,\n");
				rcmArray2.push("    ky1[i],\n");
				rcmArray2.push("    sum(ky1[1:i]) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tx1 <- c()\n");
				rcmArray2.push("tx1 <- rbind(\n");
				rcmArray2.push("    matrix(kx1$sd^2, nr=1),\n");
				rcmArray2.push("    matrix(tmp,nc=cx)\n");
				rcmArray2.push("    )\n");
				rcmArray2.push("ty1 <- matrix(kx1$load, nc=cx)\n");
				rcmArray2.push("tz1 <- round(tx1, 3)\n");
				rcmArray2.push("colnames(tz1) <- c(\n");
				rcmArray2.push("  paste(\"pc\", 1:cx, sep=\"\")\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("rownames(tz1) <- c(\n");
				rcmArray2.push("  \"説明分散\",\n");
				rcmArray2.push("  \"寄与率\", \n");
				rcmArray2.push("  \"累積比率\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子分析\n");
				rcmArray2.push("library( psych )\n");
				rcmArray2.push("library( GPArotation )\n");
				rcmArray2.push("kx2 <- fa(\n");
				rcmArray2.push("  dx,\n");
				rcmArray2.push("  nf=NF,\n");
				rcmArray2.push("  fm=Me,\n");
				rcmArray2.push("  ro=Ro,\n");
				rcmArray2.push("  sc=1,\n");
				rcmArray2.push("  max.iter=300 )\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx2 <- c()\n");
				rcmArray2.push("tx2 <- data.frame(\n");
				rcmArray2.push("  round(kx2$loadings[,], 3),\n");
				rcmArray2.push("  round(kx2$communality, 3)\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("colnames(tx2) <- c(\n");
				rcmArray2.push("  paste(\"F\",1:NF,sep=\"\"),\n");
				rcmArray2.push("  \" 共通性\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("ky2 <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  ky2 <- c(ky2,\n");
				rcmArray2.push("    sum(tx2[ ,i]^2) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  tmp <- c(tmp,\n");
				rcmArray2.push("    ky2[i],\n");
				rcmArray2.push("    ky2[i]/cx,\n");
				rcmArray2.push("    sum(ky2[1:i])/cx)\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tmp <- matrix(round(\n");
				rcmArray2.push("  c(tmp,NA,NA,NA), 3\n");
				rcmArray2.push("  ), nr=3)\n");
				rcmArray2.push("rownames(tmp) <- c(\n");
				rcmArray2.push("  \"説明分散\",\n");
				rcmArray2.push("  \"寄与率\", \n");
				rcmArray2.push("  \"累積比率\" )\n");
				rcmArray2.push("colnames(tmp) <- c(\n");
				rcmArray2.push("  paste(\"F\",1:NF,sep=\"\"),\n");
				rcmArray2.push("  \" 共通性\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx3 <- c()\n");
				rcmArray2.push("tx3 <- rbind(tx2,tmp)\n");
				rcmArray2.push("\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子間相関\n");
				rcmArray2.push("tx4 <- c()\n");
				rcmArray2.push("tx4 <- NULL\n");
				rcmArray2.push("tx4 <- c(kx2$r.scores, tx4)\n");
				rcmArray2.push("tx4 <- c(kx2$Phi,      tx4)\n");
				rcmArray2.push("if(NF>1){\n");
				rcmArray2.push("  tx4 <- matrix(\n");
				rcmArray2.push("    round(tx4[1:NF^2], 4), nc=NF)\n");
				rcmArray2.push("  colnames(tx4) <- paste(\n");
				rcmArray2.push("    \"      F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("  rownames(tx4) <- paste(\n");
				rcmArray2.push("    \"F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 適合度\n");
				rcmArray2.push("st <- NF-2\n");
				rcmArray2.push("if(st<1) st=1\n");
				rcmArray2.push("ed <- NF+2\n");
				rcmArray2.push("if(ed>(cx/2)) ed=NF\n");
				rcmArray2.push("\n");
				rcmArray2.push("kai2  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("jyudo <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("pchi  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("moku  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("rmsea <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("bic   <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("tli   <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("for(i in ed:st){\n");
				rcmArray2.push("  tmp <- fa(\n");
				rcmArray2.push("    dx,\n");
				rcmArray2.push("    nf=i,\n");
				rcmArray2.push("    fm=Me,\n");
				rcmArray2.push("    ro=Ro,\n");
				rcmArray2.push("    max.iter=300 )\n");
				rcmArray2.push("  kai2  <- c(tmp$STAT,     kai2 )\n");
				rcmArray2.push("  jyudo <- c(tmp$dof ,     jyudo)\n");
				rcmArray2.push("  pchi  <- c(tmp$PVAL,     pchi )\n");
				rcmArray2.push("  moku  <- c(tmp$objective,moku ) # 目標構造\n");
				rcmArray2.push("  rmsea <- c(tmp$RMSEA[1], rmsea)\n");
				rcmArray2.push("  bic   <- c(tmp$BIC,      bic  )\n");
				rcmArray2.push("  # tli   <- c(tmp$TLI,      tli  )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx5 <- c()\n");
				rcmArray2.push("tx5 <- matrix(c(\n");
				rcmArray2.push("  round(kai2[ 1:(ed-st+1)],4),\n");
				rcmArray2.push("        jyudo[1:(ed-st+1)],\n");
				rcmArray2.push("  round(pchi[ 1:(ed-st+1)],4),\n");
				rcmArray2.push("  round(rmsea[1:(ed-st+1)],4),\n");
				rcmArray2.push("  round(bic[  1:(ed-st+1)],4)\n");
				rcmArray2.push("  # round(tli[  1:(ed-st+1)],4)\n");
				rcmArray2.push("  ), nc=5)\n");
				rcmArray2.push("colnames(tx5) <- c(\n");
				rcmArray2.push("  \"     χ2\",\n");
				rcmArray2.push("  \" df\",\n");
				rcmArray2.push("  \"   ｐ値\",\n");
				rcmArray2.push("  \"   RMSEA\",\n");
				rcmArray2.push("  \"     BIC\"\n");
				rcmArray2.push("  # \"     TLI\"\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("rownames(tx5) <- paste(\n");
				rcmArray2.push("  \"NF=\", st:ed, sep=\"\")\n");
				rcmArray2.push("\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子得点\n");
				rcmArray2.push("fsco <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  fsco <- cbind(fsco, \n");
				rcmArray2.push("        round(kx2$scores[ ,i],4) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("colnames(fsco) <- paste(\n");
				rcmArray2.push("    \"F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("dset <- cbind(dset, fsco)\n");
				rcmArray2.push("rownames(fsco) <- rownames(dset)\n");
				rcmArray2.push("\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 相関行列\n");
				rcmArray2.push("rmat <- c()\n");
				rcmArray2.push("keis <- c()\n");
				rcmArray2.push("keis <- cor(dx)\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j){rmat <- c(rmat, keis[i,j]) }\n");
				rcmArray2.push("  else    rmat <- c(rmat, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("pval <- c()\n");
				rcmArray2.push("padj <- c()\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j){\n");
				rcmArray2.push("      sokan <- keis[i,j]\n");
				rcmArray2.push("      pval  <- c(pval,\n");
				rcmArray2.push("         pf(sokan^2/((1-sokan^2)/(N-2)),\n");
				rcmArray2.push("            df1=1, df2=N-1,low=0 )\n");
				rcmArray2.push("       ) }\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("padj <- p.adjust(pval, me=\"BH\")\n");
				rcmArray2.push("\n");
				rcmArray2.push("test <- c()\n");
				rcmArray2.push("valjun=0\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j) { valjun=valjun+1\n");
				rcmArray2.push("            test <- c(test, pval[valjun]) }\n");
				rcmArray2.push("  else test <- c(test, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("tadj <- c()\n");
				rcmArray2.push("adjjun=0\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j) { adjjun=adjjun+1\n");
				rcmArray2.push("            tadj <- c(tadj, padj[adjjun]) }\n");
				rcmArray2.push("  else tadj <- c(tadj, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("rmat <- matrix(rmat, nc=cx, by=1)\n");
				rcmArray2.push("test <- matrix(test, nc=cx, by=1)\n");
				rcmArray2.push("tadj <- matrix(tadj, nc=cx, by=1)\n");
				rcmArray2.push("rmat <- round(rmat, 3)\n");
				rcmArray2.push("test <- round(test, 3)\n");
				rcmArray2.push("tadj <- round(tadj, 3)\n");
				rcmArray2.push("dimnames(rmat) <- dimnames(keis)\n");
				rcmArray2.push("dimnames(test) <- dimnames(keis)\n");
				rcmArray2.push("dimnames(tadj) <- dimnames(keis)\n");

				rcmArray2.push("\n");
				rcmArray2.push("options(digits=5)\n");
				rcmArray2.push("options(scipen=5)\n");
				rcmArray2.push("#############################\n");
				rcmArray2.push("# 因子分析→事後分析「なし」\n");

				var element = document.getElementById("method");
				for (i = 0; i < element.options.length; i++) {
					var option = element.options[i];
					if (option.selected) {
						var methodText = option.text;
					}
				}
				element = document.getElementById("rotate");
				for (i = 0; i < element.options.length; i++) {
					var option = element.options[i];
					if (option.selected) {
						var rotateText = option.text;
					}
				}
				rcmArray2.push("#  " + methodText + "\n");
				rcmArray2.push("#  " + rotateText + "\n");
				rcmArray2.push("#############################\n");
				rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
				rcmArray2.push("\n");
				rcmArray2.push("tz1 # 主成分分析\n");
				rcmArray2.push("# 下段に平行分析のオプションあり\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx3 # 回転後の因子負荷量\n");
				rcmArray2.push("# ■斜交解のときは共通性・説明分散は無意味\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx4 # 因子間相関\n");
				rcmArray2.push("# 直交解のときは参考値（因子得点相関）\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx5 # 適合度による因子数（NF）の比較検討\n");
				rcmArray2.push("\n");
				rcmArray2.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
				rcmArray2.push("# windows(); boxplot(dx, las=1) # 箱ひげ図\n");
				rcmArray2.push("# dset           # データ全体の表示\n");
				rcmArray2.push("# fsco           # 因子得点（回帰法による）の表示\n");
				rcmArray2.push("# rmat;test;tadj # 相関行列,ｐ値,調整後ｐ値(BH法)\n");
				rcmArray2.push("# fa.parallel(dx, n.iter=50, err=1) # 平行分析\n");
				rcmArray2.push("# print(kx2, di=3, cu=0, so=1) # 負荷量の大きい順の表示\n");
				rcmArray2.push("# print(kx2$Str, dig=3, cut=0, so=1) # 斜交解の因子構造（相関）\n");

				break;
			case 1:
				//クリップボード使用のためのデータ
				if (r_output == 1) {
					for (j = 0; j < NN; j++) {
						for (i = 0; i < LA + LB; i++) {
							rcmArray1.push(xx[i][j]);
							if ((i != LA + LB - 1)) rcmArray1.push("\t");
						}
						rcmArray1.push("\n");
					}
				}
				//直接貼り付けるのためのデータ
				if (r_output == 2) {
					for (i = 0; i < LA; i++) {
						rcmArray.push("x" + (i + 1) + " <- c(");
						for (j = 0; j < NN; j++) {
							rcmArray.push(" " + xx[i][j]);
							if ((j != NN - 1)) rcmArray.push(",");
						}
						rcmArray.push(" )\n");
					}
					rcmArray.push("\n");

					for (i = LA; i < LA + LB; i++) {
						if (i == LA) rcmArray.push("yoinA <- c(");
						if (i == LA + 1) rcmArray.push("yoinB <- c(");
						if (i == LA + 2) rcmArray.push("yoinC <- c(");
						for (j = 0; j < NN; j++) {
							rcmArray.push(" " + xx[i][j]);
							if ((j != NN - 1)) rcmArray.push(",");
						}
						rcmArray.push(" )\n");
					}
					rcmArray.push("\n");

					rcmArray.push("dtab <- data.frame(\n");
					for (i = 0; i < LA; i++) {
						rcmArray.push("x" + (i + 1) + ",");
					}
					switch (LB) {
						case 1:
							rcmArray.push(" yoinA");
							break;
						case 2:
							rcmArray.push(" yoinA, yoinB");
							break;
						case 3:
							rcmArray.push(" yoinA, yoinB, yoinC");
							break;
					}
					rcmArray.push("\n  )\n");
					for (i = 0; i < LA; i++) {
						rcmArray.push(" x" + (i + 1) + " <- c()\n");
					}
				}

				rcmArray2.push("####### 因子分析→事後分析「分散分析」 #######\n");
				rcmArray2.push("\n");
				rcmArray2.push("# パッケージ car が必要\n");
				rcmArray2.push("# パッケージ psych が必要\n");
				rcmArray2.push("# パッケージ GPArotation が必要\n");
				rcmArray2.push("# 欠損値は事前に処理する必要あり！\n");
				rcmArray2.push("# 各要因の水準番号はＡ，Ｂ，Ｃ順にソートしておく\n");
				rcmArray2.push("\n");
				var NF = parseInt(document.getElementById("factorNum").value);
				var strMe = document.getElementById("method").value;
				var strRo = document.getElementById("rotate").value;

				rcmArray2.push("# 設定データ\n");
				rcmArray2.push("N=" + NN + "      # 参加者数\n");
				rcmArray2.push("hensu=" + LA + "  # 変数（質問項目）の数\n");

				rcmArray2.push("\n");
				rcmArray2.push("yoinsu=" + LB + " # 事後分析の際の要因数\n");
				rcmArray2.push("NF=" + NF + "         # 因子数（初期値=2）\n");
				rcmArray2.push("Me=\"" + strMe + "\"      # Method※下記「メニュー」参照\n");
				rcmArray2.push("Ro=\"" + strRo + "\" # Rotate※下記「メニュー」参照\n");

				rcmArray2.push("\n");
				rcmArray2.push("# メニュー\n");
				rcmArray2.push("# Me=ml, wls, gls, pa\n");
				rcmArray2.push("# Ro=varimax, Varimax, promax, oblimin\n");
				rcmArray2.push("#     正規化, 非正規化\n");

				rcmArray2.push("\n");
				rcmArray2.push("# データ\n");
				rcmArray2.push("saiyo <- c(");
				var commaflag = false;
				for (i = 0; i < LA; i++) {
					if (document.getElementById("x" + (i + 1)).checked) {
						if (commaflag) {
							rcmArray2.push(",");
						}
						rcmArray2.push(" " + (i + 1));
						commaflag = true;
					}
				}
				rcmArray2.push(" )   # 採用した説明変数\n");

				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("if(yoinsu>0){ tmp <- c(tmp, \"yoinA\") }\n");
				rcmArray2.push("if(yoinsu>1){ tmp <- c(tmp, \"yoinB\") }\n");
				rcmArray2.push("if(yoinsu>2){ tmp <- c(tmp, \"yoinC\") }\n");
				rcmArray2.push("colnames(dtab) <- c(\n");
				rcmArray2.push("  paste(\"x\",1:hensu,sep=\"\"), tmp\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("dx   <- data.frame(dtab[,saiyo])\n");
				rcmArray2.push("dset <- dtab[,c(saiyo,(hensu+1):(hensu+yoinsu))]\n");
				rcmArray2.push("for(i in (hensu+1):(hensu+yoinsu)){\n");
				rcmArray2.push("    dtab[ ,i] <- factor(dtab[ ,i])}\n");
				rcmArray2.push("    if(yoinsu>0){yoinA <- dtab[,c(\"yoinA\")] }\n");
				rcmArray2.push("    if(yoinsu>1){yoinB <- dtab[,c(\"yoinB\")] }\n");
				rcmArray2.push("    if(yoinsu>2){yoinC <- dtab[,c(\"yoinC\")] }\n");
				rcmArray2.push("\n");

				rcmArray2.push("## 基本統計量\n");
				rcmArray2.push("hk <- sapply(dx, mean)\n");
				rcmArray2.push("sd <- sapply(dx,   sd)\n");
				rcmArray2.push("n  <- c()\n");
				rcmArray2.push("mi <- c()\n");
				rcmArray2.push("ma <- c()\n");

				rcmArray2.push("cx <- ncol(dx)\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("  n  <- c(n, length(dx[,i]) )\n");
				rcmArray2.push("  mi <- c(mi,   min(dx[,i]) )\n");
				rcmArray2.push("  ma <- c(ma,   max(dx[,i]) )\n");
				rcmArray2.push("  }\n");

				rcmArray2.push("tx0 <- c()\n");
				rcmArray2.push("tx0 <- data.frame(\n");
				rcmArray2.push("  n,\n");
				rcmArray2.push("  round(hk, 4),\n");
				rcmArray2.push("  round(sd, 4),\n");
				rcmArray2.push("  mi,\n");
				rcmArray2.push("  ma\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("colnames(tx0) <- c(\n");
				rcmArray2.push("  \"   Ｎ\",\n");
				rcmArray2.push("  \"     Mean\",\n");
				rcmArray2.push("  \"       SD\",\n");
				rcmArray2.push("  \"   Min\",\n");
				rcmArray2.push("  \"  Max\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 主成分プロット\n");
				rcmArray2.push("kx1 <- princomp(\n");
				rcmArray2.push("  dx,\n");
				rcmArray2.push("  cor=1 )\n");
				rcmArray2.push("screeplot(kx1,\n");
				rcmArray2.push("  pch=21, bg=3, cex=3,\n");
				rcmArray2.push("  ty=\"lines\", lwd=2,\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("ky1 <- kx1$sdev^2/sum(kx1$sdev^2)\n");
				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("  tmp <- c(tmp,\n");
				rcmArray2.push("    ky1[i],\n");
				rcmArray2.push("    sum(ky1[1:i]) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tx1 <- c()\n");
				rcmArray2.push("tx1 <- rbind(\n");
				rcmArray2.push("    matrix(kx1$sd^2, nr=1),\n");
				rcmArray2.push("    matrix(tmp,nc=cx)\n");
				rcmArray2.push("    )\n");
				rcmArray2.push("ty1 <- matrix(kx1$load, nc=cx)\n");
				rcmArray2.push("tz1 <- round(tx1, 3)\n");
				rcmArray2.push("colnames(tz1) <- c(\n");
				rcmArray2.push("  paste(\"pc\", 1:cx, sep=\"\")\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("rownames(tz1) <- c(\n");
				rcmArray2.push("  \"説明分散\",\n");
				rcmArray2.push("  \"寄与率\", \n");
				rcmArray2.push("  \"累積比率\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子分析\n");
				rcmArray2.push("library( psych )\n");
				rcmArray2.push("library( GPArotation )\n");
				rcmArray2.push("kx2 <- fa(\n");
				rcmArray2.push("  dx,\n");
				rcmArray2.push("  nf=NF,\n");
				rcmArray2.push("  fm=Me,\n");
				rcmArray2.push("  ro=Ro,\n");
				rcmArray2.push("  sc=1,\n");
				rcmArray2.push("  max.iter=300 )\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx2 <- c()\n");
				rcmArray2.push("tx2 <- data.frame(\n");
				rcmArray2.push("  round(kx2$loadings[,], 3),\n");
				rcmArray2.push("  round(kx2$communality, 3)\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("colnames(tx2) <- c(\n");
				rcmArray2.push("  paste(\"F\",1:NF,sep=\"\"),\n");
				rcmArray2.push("  \" 共通性\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("ky2 <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  ky2 <- c(ky2,\n");
				rcmArray2.push("    sum(tx2[ ,i]^2) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  tmp <- c(tmp,\n");
				rcmArray2.push("    ky2[i],\n");
				rcmArray2.push("    ky2[i]/cx,\n");
				rcmArray2.push("    sum(ky2[1:i])/cx)\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("tmp <- matrix(round(\n");
				rcmArray2.push("  c(tmp,NA,NA,NA), 3\n");
				rcmArray2.push("  ), nr=3)\n");
				rcmArray2.push("rownames(tmp) <- c(\n");
				rcmArray2.push("  \"説明分散\",\n");
				rcmArray2.push("  \"寄与率\", \n");
				rcmArray2.push("  \"累積比率\" )\n");
				rcmArray2.push("colnames(tmp) <- c(\n");
				rcmArray2.push("  paste(\"F\",1:NF,sep=\"\"),\n");
				rcmArray2.push("  \" 共通性\" )\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx3 <- c()\n");
				rcmArray2.push("tx3 <- rbind(tx2,tmp)\n");
				rcmArray2.push("\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子間相関\n");
				rcmArray2.push("tx4 <- c()\n");
				rcmArray2.push("tx4 <- NULL\n");
				rcmArray2.push("tx4 <- c(kx2$r.scores, tx4)\n");
				rcmArray2.push("tx4 <- c(kx2$Phi,      tx4)\n");
				rcmArray2.push("if(NF>1){\n");
				rcmArray2.push("  tx4 <- matrix(\n");
				rcmArray2.push("    round(tx4[1:NF^2], 4), nc=NF)\n");
				rcmArray2.push("  colnames(tx4) <- paste(\n");
				rcmArray2.push("    \"      F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("  rownames(tx4) <- paste(\n");
				rcmArray2.push("    \"F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 適合度\n");
				rcmArray2.push("st <- NF-2\n");
				rcmArray2.push("if(st<1) st=1\n");
				rcmArray2.push("ed <- NF+2\n");
				rcmArray2.push("if(ed>(cx/2)) ed=NF\n");
				rcmArray2.push("\n");
				rcmArray2.push("kai2  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("jyudo <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("pchi  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("moku  <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("rmsea <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("bic   <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("tli   <- c(NA,NA,NA,NA,NA)\n");
				rcmArray2.push("for(i in ed:st){\n");
				rcmArray2.push("  tmp <- fa(\n");
				rcmArray2.push("    dx,\n");
				rcmArray2.push("    nf=i,\n");
				rcmArray2.push("    fm=Me,\n");
				rcmArray2.push("    ro=Ro,\n");
				rcmArray2.push("    max.iter=300 )\n");
				rcmArray2.push("  kai2  <- c(tmp$STAT,     kai2 )\n");
				rcmArray2.push("  jyudo <- c(tmp$dof ,     jyudo)\n");
				rcmArray2.push("  pchi  <- c(tmp$PVAL,     pchi )\n");
				rcmArray2.push("  moku  <- c(tmp$objective,moku ) # 目標構造\n");
				rcmArray2.push("  rmsea <- c(tmp$RMSEA[1], rmsea)\n");
				rcmArray2.push("  bic   <- c(tmp$BIC,      bic  )\n");
				rcmArray2.push("  # tli   <- c(tmp$TLI,      tli  )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx5 <- c()\n");
				rcmArray2.push("tx5 <- matrix(c(\n");
				rcmArray2.push("  round(kai2[ 1:(ed-st+1)],4),\n");
				rcmArray2.push("        jyudo[1:(ed-st+1)],\n");
				rcmArray2.push("  round(pchi[ 1:(ed-st+1)],4),\n");
				rcmArray2.push("  round(rmsea[1:(ed-st+1)],4),\n");
				rcmArray2.push("  round(bic[  1:(ed-st+1)],4)\n");
				rcmArray2.push("  # round(tli[  1:(ed-st+1)],4)\n");
				rcmArray2.push("  ), nc=5)\n");
				rcmArray2.push("colnames(tx5) <- c(\n");
				rcmArray2.push("  \"     χ2\",\n");
				rcmArray2.push("  \" df\",\n");
				rcmArray2.push("  \"   ｐ値\",\n");
				rcmArray2.push("  \"   RMSEA\",\n");
				rcmArray2.push("  \"     BIC\"\n");
				rcmArray2.push("  # \"     TLI\"\n");
				rcmArray2.push("  )\n");
				rcmArray2.push("rownames(tx5) <- paste(\n");
				rcmArray2.push("  \"NF=\", st:ed, sep=\"\")\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 因子得点\n");
				rcmArray2.push("fsco <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  fsco <- cbind(fsco, \n");
				rcmArray2.push("        round(kx2$scores[ ,i],4) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("colnames(fsco) <- paste(\n");
				rcmArray2.push("    \"F\", 1:NF, sep=\"\" )\n");
				rcmArray2.push("dset <- cbind(dset, fsco)\n");
				rcmArray2.push("rownames(fsco) <- rownames(dset)\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 相関行列\n");
				rcmArray2.push("rmat <- c()\n");
				rcmArray2.push("keis <- c()\n");
				rcmArray2.push("keis <- cor(dx)\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j){rmat <- c(rmat, keis[i,j]) }\n");
				rcmArray2.push("  else    rmat <- c(rmat, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("pval <- c()\n");
				rcmArray2.push("padj <- c()\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j){\n");
				rcmArray2.push("      sokan <- keis[i,j]\n");
				rcmArray2.push("      pval  <- c(pval,\n");
				rcmArray2.push("         pf(sokan^2/((1-sokan^2)/(N-2)),\n");
				rcmArray2.push("            df1=1, df2=N-1,low=0 )\n");
				rcmArray2.push("       ) }\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("padj <- p.adjust(pval, me=\"BH\")\n");
				rcmArray2.push("\n");
				rcmArray2.push("test <- c()\n");
				rcmArray2.push("valjun=0\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j) { valjun=valjun+1\n");
				rcmArray2.push("            test <- c(test, pval[valjun]) }\n");
				rcmArray2.push("  else test <- c(test, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("tadj <- c()\n");
				rcmArray2.push("adjjun=0\n");
				rcmArray2.push("for(i in 1:cx){\n");
				rcmArray2.push("for(j in 1:cx){\n");
				rcmArray2.push("  if(i<j) { adjjun=adjjun+1\n");
				rcmArray2.push("            tadj <- c(tadj, padj[adjjun]) }\n");
				rcmArray2.push("  else tadj <- c(tadj, NA)\n");
				rcmArray2.push("} }\n");
				rcmArray2.push("\n");
				rcmArray2.push("rmat <- matrix(rmat, nc=cx, by=1)\n");
				rcmArray2.push("test <- matrix(test, nc=cx, by=1)\n");
				rcmArray2.push("tadj <- matrix(tadj, nc=cx, by=1)\n");
				rcmArray2.push("rmat <- round(rmat, 3)\n");
				rcmArray2.push("test <- round(test, 3)\n");
				rcmArray2.push("tadj <- round(tadj, 3)\n");
				rcmArray2.push("dimnames(rmat) <- dimnames(keis)\n");
				rcmArray2.push("dimnames(test) <- dimnames(keis)\n");
				rcmArray2.push("dimnames(tadj) <- dimnames(keis)\n");
				rcmArray2.push("\n");
				rcmArray2.push("# 事後分析「分散分析」\n");
				rcmArray2.push("levA=NULL\n");
				rcmArray2.push("levB=NULL\n");
				rcmArray2.push("levC=NULL\n");
				rcmArray2.push("if(yoinsu==3){\n");
				rcmArray2.push("  dc <- dset[order(dset[,c(\"yoinC\")] ), ]\n");
				rcmArray2.push("  db <-   dc[order(  dc[,c(\"yoinB\")] ), ]\n");
				rcmArray2.push("  da <-   db[order(  db[,c(\"yoinA\")] ), ]\n");
				rcmArray2.push("  nn <- as.numeric(xtabs( ~\n");
				rcmArray2.push("         da[ ,c(\"yoinC\")]+\n");
				rcmArray2.push("         da[ ,c(\"yoinB\")]+\n");
				rcmArray2.push("         da[ ,c(\"yoinA\")] ) )\n");
				rcmArray2.push("  levA <- length( table(da[ ,c(\"yoinA\")]) )\n");
				rcmArray2.push("  levB <- length( table(da[ ,c(\"yoinB\")]) )\n");
				rcmArray2.push("  levC <- length( table(da[ ,c(\"yoinC\")]) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("if(yoinsu==2){\n");
				rcmArray2.push("  db <- dset[order(dset[,c(\"yoinB\")] ), ]\n");
				rcmArray2.push("  da <-   db[order(  db[,c(\"yoinA\")] ), ]\n");
				rcmArray2.push("  nn <- as.numeric(xtabs( ~\n");
				rcmArray2.push("         da[ ,c(\"yoinB\")]+\n");
				rcmArray2.push("         da[ ,c(\"yoinA\")] ) )\n");
				rcmArray2.push("  levA <- length( table(da[ ,c(\"yoinA\")]) )\n");
				rcmArray2.push("  levB <- length( table(da[ ,c(\"yoinB\")]) )\n");
				rcmArray2.push("  }\n");
				rcmArray2.push("if(yoinsu==1){\n");
				rcmArray2.push("  da <- dset[order(dset[,c(\"yoinA\")] ), ]\n");
				rcmArray2.push("  nn <- as.numeric(xtabs( ~\n");
				rcmArray2.push("         da[ ,c(\"yoinA\")] ) )\n");
				rcmArray2.push("  levA <- length( table(da[ ,c(\"yoinA\")]) )\n");
				rcmArray2.push("  }\n");

				rcmArray2.push("\n");
				rcmArray2.push("# オプション用\n");
				for (j = 0; j < NF; j++) {
					rcmArray2.push("daF" + (j + 1) + " <- matrix(round(\n");
					rcmArray2.push("  da[ ,c(\"F" + (j + 1) + "\")],3\n");
					rcmArray2.push("  ), nr=1)\n");
					rcmArray2.push("rownames(daF" + (j + 1) + ") <- c(\"\")\n");
					rcmArray2.push("colnames(daF" + (j + 1) + ") <- rep(\"\", N)\n");
				}

				rcmArray2.push("NN <- matrix(nn,nr=1)\n");
				rcmArray2.push("rownames(NN) <- c(\"\")\n");
				rcmArray2.push("colnames(NN) <- rep(\"\", length(nn))\n");
				rcmArray2.push("\n");

				rcmArray2.push("## ANOVA\n");
				rcmArray2.push("library( car )\n");
				rcmArray2.push("jigok <- c()\n");
				rcmArray2.push("for(i in 1:NF){\n");
				rcmArray2.push("  if(yoinsu==1){\n");
				rcmArray2.push("     kx    <- aov(fsco[,i]~yoinA)\n");
				rcmArray2.push("     jigok <- c(jigok,\n");
				rcmArray2.push("       anova(kx)$F[1],  NA, NA, NA, NA, NA, NA,\n");
				rcmArray2.push("       anova(kx)$Pr[1], NA, NA, NA, NA, NA, NA )\n");
				rcmArray2.push("     }\n");
				rcmArray2.push("  if(yoinsu==2){\n");
				rcmArray2.push("     kx <- lm(fsco[,i]~yoinA*yoinB,\n");
				rcmArray2.push("             contrast=list(\n");
				rcmArray2.push("                 yoinA=contr.sum,\n");
				rcmArray2.push("                 yoinB=contr.sum ) )\n");
				rcmArray2.push("     ktmp  <- Anova(kx,ty=3,te=\"F\")\n");
				rcmArray2.push("     jigok <- c(jigok,\n");
				rcmArray2.push("       ktmp$F[2:3] , NA, ktmp$F[4], NA, NA, NA,\n");
				rcmArray2.push("       ktmp$Pr[2:3], NA, ktmp$Pr[4],NA, NA, NA )\n");
				rcmArray2.push("     }\n");
				rcmArray2.push("  if(yoinsu==3){\n");
				rcmArray2.push("     kx <- lm(fsco[,i]~yoinA*yoinB*yoinC,\n");
				rcmArray2.push("             contrast=list(\n");
				rcmArray2.push("                 yoinA=contr.sum,\n");
				rcmArray2.push("                 yoinB=contr.sum,\n");
				rcmArray2.push("                 yoinC=contr.sum ) )\n");
				rcmArray2.push("     jigok <- c(jigok,\n");
				rcmArray2.push("       Anova(kx,ty=3,te=\"F\")$F[2:8],\n");
				rcmArray2.push("       Anova(kx,ty=3,te=\"F\")$Pr[2:8] )\n");
				rcmArray2.push("     }\n");
				rcmArray2.push("  if(i<NF){ jigok <- c(jigok,\n");
				rcmArray2.push("         NA, NA, NA, NA, NA, NA, NA ) }\n");
				rcmArray2.push("  }	\n");
				rcmArray2.push("\n");
				rcmArray2.push("jigok <- round(jigok, 4)\n");
				rcmArray2.push("tx7 <- c()\n");
				rcmArray2.push("tx7 <- matrix(jigok, nc=7, by=1)\n");
				rcmArray2.push("colnames(tx7) <- c(\n");
				rcmArray2.push("  \"要因Ａ\",\"要因Ｂ\",\"要因Ｃ\",\n");
				rcmArray2.push("  \"Ａ×Ｂ\",\"Ａ×Ｃ\",\"Ｂ×Ｃ\",\n");
				rcmArray2.push("  \"AxBxC\" )\n");
				rcmArray2.push("tmp <- c()\n");
				rcmArray2.push("for(i in 1:NF){tmp <- c(tmp,\n");
				rcmArray2.push("  paste(\n");
				rcmArray2.push("    paste(\"因子\", i, sep=\"\"),\n");
				rcmArray2.push("    \"Ｆ比=\", sep=\"_\"),\n");
				rcmArray2.push("  paste(\n");
				rcmArray2.push("    paste(\"因子\", i, sep=\"\"),\n");
				rcmArray2.push("    \"ｐ値=\", sep=\"_\")\n");
				rcmArray2.push("    )\n");
				rcmArray2.push("  if(i<NF){tmp <- c(tmp, \"\") }\n");
				rcmArray2.push(" }\n");
				rcmArray2.push("rownames(tx7) <- tmp\n");
				rcmArray2.push("\n");

				rcmArray2.push("options(digits=5)\n");
				rcmArray2.push("options(scipen=5)\n");
				rcmArray2.push("################################\n");
				rcmArray2.push("# 因子分析→事後分析「分散分析」\n");

				var element = document.getElementById("method");
				for (i = 0; i < element.options.length; i++) {
					var option = element.options[i];
					if (option.selected) {
						var methodText = option.text;
					}
				}
				element = document.getElementById("rotate");
				for (i = 0; i < element.options.length; i++) {
					var option = element.options[i];
					if (option.selected) {
						var rotateText = option.text;
					}
				}
				rcmArray2.push("#  " + methodText + "\n");
				rcmArray2.push("#  " + rotateText + "\n");
				rcmArray2.push("################################\n");

				rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
				rcmArray2.push("\n");
				rcmArray2.push("tz1 # 主成分分析\n");
				rcmArray2.push("# 下段に平行分析のオプションあり\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx3 # 回転後の因子負荷量\n");
				rcmArray2.push("# ■斜交解のときは共通性・説明分散は無意味\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx4 # 因子間相関\n");
				rcmArray2.push("# 直交解のときは参考値（因子得点相関）\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx5 # 適合度による因子数（NF）の比較検討\n");
				rcmArray2.push("\n");
				rcmArray2.push("tx7 # 標準化因子得点を用いた分散分析の結果\n");
				rcmArray2.push("# 因子得点の計算は回帰法による\n");
				rcmArray2.push("\n");

				switch (LB) {
					case 1:
						rcmArray2.push("## ■■ js-STAR / Ａｓをクリック ■■\n");
						rcmArray2.push("levA # 要因Ａの水準数\n");
						rcmArray2.push("\n");
						rcmArray2.push("NN   # 各水準の参加者数を設定する際に参照する\n");
						for (j = 0; j < NF; j++) {
							rcmArray2.push("\n");
							rcmArray2.push("daF" + (j + 1) + " # 因子得点F" + (j + 1) + "：js-STAR へコピペし【代入】→【計算】\n");
						}
						break;
					case 2:
						rcmArray2.push("## ■■ js-STAR / ＡＢｓをクリック ■■\n");
						rcmArray2.push("levA # 要因Ａの水準数\n");
						rcmArray2.push("levB # 要因Ｂの水準数\n");
						rcmArray2.push("\n");
						rcmArray2.push("NN   # 各水準の参加者数を設定する際に参照する\n");
						for (j = 0; j < NF; j++) {
							rcmArray2.push("\n");
							rcmArray2.push("daF" + (j + 1) + " # 因子得点F" + (j + 1) + "：js-STAR へコピペし【代入】→【計算】\n");
						}
						break;
					case 3:
						rcmArray2.push("## ■■ js-STAR / ＡＢＣｓをクリック ■■\n");
						rcmArray2.push("levA # 要因Ａの水準数\n");
						rcmArray2.push("levB # 要因Ｂの水準数\n");
						rcmArray2.push("levC # 要因Ｃの水準数\n");
						rcmArray2.push("\n");
						rcmArray2.push("NN   # 各水準の参加者数を設定する際に参照する\n");
						for (j = 0; j < NF; j++) {
							rcmArray2.push("\n");
							rcmArray2.push("daF" + (j + 1) + " # 因子得点F" + (j + 1) + "：js-STAR へコピペし【代入】→【計算】\n");
						}
						break;
				}

				rcmArray2.push("\n");
				rcmArray2.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
				rcmArray2.push("# windows();boxplot(dx,las=1) # 箱ひげ図\n");
				rcmArray2.push("# dset           # データ全体の表示\n");
				rcmArray2.push("# fsco           # 因子得点（回帰法による）の表示\n");
				rcmArray2.push("# rmat;test;tadj # 相関行列,ｐ値,調整後ｐ値(BH法)\n");
				rcmArray2.push("# fa.parallel(dx,n.iter=50,err=1) # 平行分析\n");
				rcmArray2.push("# print(kx2,di=3,cu=0,so=1) # 負荷量の大きい順の表示\n");
				rcmArray2.push("# print(kx2$Str, dig=3, cut=0, so=1) # 斜交解の因子構造（相関）\n");

				break;
			case 2:
				break;
		}

		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray2.push("\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
/**
 *
 * 因子得点を用いた事後分析のid afterAnalys
 * 参加者数のid subjNum
 * 項目数のid item_number
 * 事後分析の要因数のid factor_number
 *
 */
function changeFactSetting() {
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");

	// htmArray.push("<ul class=\"menubutton1\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"cellAreaScroll('fact');return false;\"><span id=\"cellAreaScrollBtn\">△短縮</a></span></li>");
	// htmArray.push("</ul>");

	// htmArray.push("</div>");

	htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<table border=\"0\" class=\"codetb4\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">因子得点を用いた事後分析：</td>");
	htmArray.push("<td class=\"codetbR\">");
	htmArray.push("<select name=\"afterAnalys\" id=\"afterAnalys\" class=\"tySelect2\" size=\"1\" onchange=\"changeFactSetting2();\">");
	htmArray.push("<option value=\"0\" selected>なし</option>");
	htmArray.push("<option value=\"1\">分散分析</option>");
	htmArray.push("</select>");
	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeFactSetting2();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeFactSetting2();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}
	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">項目数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"item_number\" size=\"10\" min=\"2\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeFactSetting2();\">");
	} else {
		htmArray.push("<select id=\"item_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'項目数');changeFactSetting2();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}
	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("fact_setting").innerHTML = htmArray.join("");
	htmArray = null;
	changeFactSetting2();
}

function changeFactSetting2() {
	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var htmArray = new Array();

	htmArray.push("<table border=\"0\" class=\"codetb4\">");
	htmArray.push("<tr>");

	switch (afterAnalysNum) {
		case 0:
			break;
		case 1:
			htmArray.push("<td class=\"codetbL\">事後分析の要因数：</td>");
			htmArray.push("<td class=\"codetbR\">");

			//事後分析の要因数は１から３までと範囲が決まっているので，プルダウンメニューにする
			htmArray.push("<select name=\"i\" class=\"tySelect\" id=\"factor_number\" size=\"1\" onchange=\"changeFactTableBranch();\">");
			htmArray.push("<option value=\"1\">1</option>");
			htmArray.push("<option value=\"2\" selected>2</option>");
			htmArray.push("<option value=\"3\">3</option>");
			htmArray.push("</select>");
			break;
		case 2:
			htmArray.push("<td class=\"codetbL\">目的変数の数：</td>");
			htmArray.push("<td class=\"codetbR\">");
			htmArray.push("<select name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'目的変数の数');changeFactTableBranch();\">");
			htmArray.push("<option value=\"1\">1</option>");
			htmArray.push("<option value=\"2\" selected>2</option>");
			htmArray.push("<option value=\"3\">3</option>");
			htmArray.push("<option value=\"4\">4</option>");
			htmArray.push("<option value=\"5\">5</option>");
			htmArray.push("<option value=\"6\">6</option>");
			htmArray.push("<option value=\"7\">7</option>");
			htmArray.push("<option value=\"8\">8</option>");
			htmArray.push("<option value=\"9\">9</option>");
			htmArray.push("<option value=\"-1\">他</option>");
			htmArray.push("</select>");
			break;
		case 3:
			htmArray.push("<td class=\"codetbL\">応答変数の数：</td>");
			htmArray.push("<td class=\"codetbR\">");
			htmArray.push("<select name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'応答変数の数');changeFactTableBranch();\">");
			htmArray.push("<option value=\"1\">1</option>");
			htmArray.push("<option value=\"2\" selected>2</option>");
			htmArray.push("<option value=\"3\">3</option>");
			htmArray.push("<option value=\"4\">4</option>");
			htmArray.push("<option value=\"5\">5</option>");
			htmArray.push("<option value=\"6\">6</option>");
			htmArray.push("<option value=\"7\">7</option>");
			htmArray.push("<option value=\"8\">8</option>");
			htmArray.push("<option value=\"9\">9</option>");
			htmArray.push("<option value=\"-1\">他</option>");
			htmArray.push("</select>");
			break;
		case 4:
			htmArray.push("<td class=\"codetbL\">クラスター数：</td>");
			htmArray.push("<td class=\"codetbR\">");
			htmArray.push("<select name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"changeFactTableBranch();\">");
			htmArray.push("<option value=\"1\">1</option>");
			htmArray.push("<option value=\"2\" selected>2</option>");
			htmArray.push("<option value=\"3\">3</option>");
			htmArray.push("<option value=\"4\">4</option>");
			htmArray.push("<option value=\"5\">5</option>");
			htmArray.push("<option value=\"6\">6</option>");
			htmArray.push("<option value=\"7\">7</option>");
			htmArray.push("<option value=\"8\">8</option>");
			htmArray.push("<option value=\"9\">9</option>");
			htmArray.push("<option value=\"-1\">他</option>");
			htmArray.push("</select>");
			break;
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("fact_setting2").innerHTML = htmArray.join("");
	htmArray = null;

	changeFactTableBranch();
}
/**
 * [changeFactTableBranch 表の出力方法を分岐]
 */
function changeFactTableBranch() {
	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		var LB = parseInt(document.getElementById("factor_number").value);
	}
	if ((NN >= 10) || (LA + LB >= 8)) {
		changeFactTable_scroll();
	} else {
		changeFactTable_all();
	}
}
function changeFactTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;

	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);

	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		var LB = parseInt(document.getElementById("factor_number").value);
	}
	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + LB);

	if (LA >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		if (LA < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("x" + (i + 1));
		}
		htmArray.push("</td>");
	}

	var LBlabel = [];
	var LBradioTF = [];
	switch (afterAnalysNum) {
		case 1:
			LBlabel[0] = '要因A';
			LBlabel[1] = '要因B';
			LBlabel[2] = '要因C';
			break;
		case 2:
			for (j = 0; j < LB; j++) {
				LBlabel[j] = 'Y' + (j + 1);
				LBradioTF[j] = '';
			}
			LBradioTF[0] = 'checked';
			break;
		case 3:
			for (j = 0; j < LB; j++) {
				LBlabel[j] = 'Y' + (j + 1);
				LBradioTF[j] = '';
			}
			LBradioTF[0] = 'checked';
			break;
		case 4:
			break;
	}

	for (j = 0; j < LB; j++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		if (afterAnalysNum == 1) {
			htmArray.push("<label for=\"Y" + (j + 1) + "\">" + LBlabel[j] + "</label>");
		} else {
			htmArray.push("<input type=\"radio\" id=\"Y" + (j + 1) + "\" name=\"LBname\" value=\"" + (j + 1) + "\" " + LBradioTF[j] + "><label for=\"Y" + (j + 1) + "\">" + LBlabel[j] + "</label>");
		}
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");

			htmArray.push("</td>");
			cellId++;
		}
		for (j = 0; j < LB; j++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("fact_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function changeFactTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);

	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		var LB = parseInt(document.getElementById("factor_number").value);
	}
	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + LB);

	if (LA + LB >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (LA + LB < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("<div style=\"width: 41px;\">x" + (i + 1) + "</div>");
		}
		htmArray.push("</td>");
	}

	var LBlabel = [];
	var LBradioTF = [];
	switch (afterAnalysNum) {
		case 1:
			LBlabel[0] = '要因A';
			LBlabel[1] = '要因B';
			LBlabel[2] = '要因C';
			break;
		case 2:
			for (j = 0; j < LB; j++) {
				LBlabel[j] = 'Y' + (j + 1);
				LBradioTF[j] = '';
			}
			LBradioTF[0] = 'checked';
			break;
		case 3:
			for (j = 0; j < LB; j++) {
				LBlabel[j] = 'Y' + (j + 1);
				LBradioTF[j] = '';
			}
			LBradioTF[0] = 'checked';
			break;
		case 4:
			break;
	}

	for (j = 0; j < LB; j++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (afterAnalysNum == 1) {
			if (LA + LB < 8) {
				htmArray.push("<div>" + LBlabel[j] + "</div>");
			} else {
				htmArray.push("<div style=\"text-align: center;width: 41px;font-size: 10pt;\">" + LBlabel[j] + "</div>");
			}

		} else {
			htmArray.push("<input type=\"radio\" id=\"Y" + (j + 1) + "\" name=\"LBname\" value=\"" + (j + 1) + "\" " + LBradioTF[j] + "><label for=\"Y" + (j + 1) + "\">" + LBlabel[j] + "</label>");
		}
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");


	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		for (j = 0; j < LB; j++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	// htmArray.push("<div class=\"btnlayout3\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("fact_table").innerHTML = htmArray.join("");
	htmArray = null;

	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_Fact() {
	var i, j;

	var strArray = [];

	var afterAnalysNum = parseInt(document.getElementById("afterAnalys").value);
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("item_number").value);
	var LB;
	if ((afterAnalysNum == 0) || (afterAnalysNum == 4)) { //事後分析が「なし」と「クラスタ分析」のときは,要因がいらない
		LB = 0;
	} else {
		LB = parseInt(document.getElementById("factor_number").value);
	}
	var LAB = LA + LB;

	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LAB; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LAB - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "Reg_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}

