/**
 * 順位相関計算
 *
 *
 *
 *
 */
// F = [];
// F1 = [];
// F2 = [];
// F3 = [];
// F[(1-1)*3+0] = "39.86 8.53 5.54 4.54 4.06 3.78 3.59 3.46 3.36 3.28 3.23 3.18 3.14 3.1 3.07 3.05 3.03 3.01 2.99 2.97 2.96 2.95 2.94 2.93 2.92 2.91 2.9 2.89 2.89 2.88 2.84 2.79 2.75";
// F[(1-1)*3+1] = "161 18.51 10.13 7.71 6.61 5.99 5.59 5.32 5.12 4.96 4.84 4.75 4.67 4.6 4.54 4.49 4.45 4.41 4.38 4.35 4.32 4.3 4.28 4.26 4.24 4.22 4.21 4.2 4.18 4.17 4.08 4 3.92";
// F[(1-1)*3+2] = "4052 98.49 34.12 21.20 16.26 13.75 12.25 11.26 10.56 10.04 9.65 9.33 9.07 8.86 8.68 8.53 8.4 8.28 8.18 8.1 8.02 7.94 7.88 7.82 7.77 7.72 7.68 7.64 7.6 7.56 7.31 7.08 6.85";

window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);


	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop2();
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value !== "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}

		if (err === false) {
			mainCalc_rank();
		}
	}
}
function mainCalc_rank() {
	var i = 0;
	var j = 0;
	var k = 0;
	var AA = "A";

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var LA = countRowCol("DataArea")[1]; // 列数を取得

	var strArray = [];
	var bar = "------------------------------------------------\n";

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var idata = 0;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(dd[idata]);
			idata++;
		}
	}

	var M = [];
	var mm = [];
	var SD = [];
	var sd = [];

	var MA = [];
	var ma = [];
	var MI = [];
	var mi = [];

	// var F1 = [];
	// var F2 = [];
	// var F3 = [];

	var V = [];

	F$ = new Array(LA);
	for (i = 0; i < LA; i++) {
		F$[i] = new Array(NN);
	}

	RA = new Array(LA);
	for (i = 0; i < LA; i++) {
		RA[i] = new Array(NN);
	}

	R = new Array(LA);
	for (i = 0; i < LA; i++) {
		R[i] = new Array(NN);
	}

	pR = new Array(LA);
	for (i = 0; i < LA; i++) {
		pR[i] = new Array(NN);
	}

	strArray.push(" == Means & SDs(samples') ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("A\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	var MMI = xx[0][0];
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0]; MI[i] = xx[i][0];
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
			if (MMI > xx[i][j]) MMI = xx[i][j];
		}

		M[i] = S / NN;
		mm[i] = using(M[i], 4, 3);
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));
		sd[i] = using(SD[i], 4, 3);
		mi[i] = using(MI[i], 4, 3);
		ma[i] = using(MA[i], 4, 3);
		strArray.push((i + 1) + "\t" + mm[i] + "\t" + sd[i] + "\t" + mi[i] + "\t" + ma[i] + "\n");
	}

	// F1 = F[0+0].split(" ");
	// F2 = F[0+1].split(" ");
	// F3 = F[0+2].split(" ");

	// var NNFlag;
	// var FF1,FF2,FF3;
	// var R1,R2;
	// if(NN>20){
	// 	NNFlag = 0;
	// 	if(NN-3<30){
	// 		FF1 = F1[NN-3];
	// 		FF2 = F2[NN-3];
	// 		FF3 = F3[NN-3];
	// 	}else if(NN-3<40){
	// 		FF1 = F1[29];
	// 		FF2 = F2[29];
	// 		FF3 = F3[29];
	// 	}else if(NN-3<60){
	// 		FF1 = F1[30];
	// 		FF2 = F2[30];
	// 		FF3 = F3[30];
	// 	}else if(NN-3<120){
	// 		FF1 = F1[31];
	// 		FF2 = F2[31];
	// 		FF3 = F3[31];
	// 	}
	// 	if(NN-3>=120){
	// 		FF1 = F1[32];
	// 		FF2 = F2[32];
	// 		FF3 = F3[32];
	// 	}
	// }else{
	// 	NNFlag = 1;
	// 	R1=0.379;
	// 	R2=0.445;
	// }


	var FF1, FF2, FF3;
	var NNFlag;
	var R1, R2;
	if (NN > 20) {
		FF3 = f_tables(2, NN); //１％水準
		FF2 = f_tables(1, NN); //５％水準
		FF1 = f_tables(0, NN); //１０％水準
		NNFlag = 0;
	} else {
		NNFlag = 1;
		R1 = 0.379;
		R2 = 0.445;
	}

	for (i = 0; i < LA; i++) {
		for (k = 0; k < NN; k++) {
			RA[i][k] = 0;
		}
	}

	var CR, TA, RANK;
	for (i = 0; i < LA; i++) {
		V[i] = 0;
		for (j = 1; j < NN + 1; j++) {
			CR = MMI - 1;
			for (k = 0; k < NN; k++) {
				if (RA[i][k] <= 0) {
					if (CR < xx[i][k]) {
						CR = xx[i][k];
					}
				}
			}
			TA = 0;
			for (k = 0; k < NN; k++) {
				if (CR == xx[i][k]) {
					TA = TA + 1;
				}
			}
			if (TA == 1) RANK = j;
			if (TA > 1) {
				S = 0;
				for (l = 1; l <= TA - 1; l++) {
					S = S + l;
				}
				RANK = (j * TA + S) / TA;
			}
			V[i] = V[i] + (Math.pow(TA, 3) - TA);
			for (k = 0; k < NN; k++) {
				if (CR == xx[i][k]) {
					RA[i][k] = RANK;
				}
			}
			j = j + TA - 1;
		}
	}

	var RR = 0;
	for (i = 0; i < LA - 1; i++) {
		for (j = i + 1; j < LA; j++) {
			S = 0;
			for (k = 0; k < NN; k++) {
				S = S + Math.pow((RA[i][k] - RA[j][k]), 2);
			}
			R[i][j] = (1 / 6 * (Math.pow(NN, 3) - NN) - (S + V[i] / 12 + V[j] / 12)) / Math.sqrt(1 / 6 * (Math.pow(NN, 3) - NN) - 2 * (V[i] / 12)) / Math.sqrt(1 / 6 * (Math.pow(NN, 3) - NN) - 2 * (V[j] / 12));
			pR[i][j] = using(R[i][j], 2, 3);
			RR = Math.abs(R[i][j]);
			if (RR > 0.9999) {
				F$[i][j] = "**";
			} else {
				if (NN > 20) {
					FFF = Math.pow(RR, 2) / (1 - Math.pow(RR, 2)) * (NN - 2);
					if (FFF > FF3) {
						F$[i][j] = "**";
					} else if (FFF > FF2) {
						F$[i][j] = " *";
					} else if (FFF > FF1) {
						F$[i][j] = " +";
					} else {
						F$[i][j] = "ns";
					}
				} else {
					F$[i][j] = "ns";
					if (RR >= R2) {
						F$[i][j] = "*";
					} else if (RR >= R1) {
						F$[i][j] = "+";
					}
				}
			}
		}
	}

	strArray.push(bar + "\n");
	strArray.push(" Rank Correlation Matrix (Speaman's r)\n\n");
	strArray.push("  A= " + AA);
	strArray.push(" [* p<.05,  + p<.10]\n");
	for (i = 0; i < LA - 1; i++) {
		strArray.push(bar);
		strArray.push("  Var.       r       Test\n");
		strArray.push(bar);
		for (j = i + 1; j < LA; j++) {
			strArray.push(" A" + (i + 1) + "xA" + (j + 1) + "\t");
			strArray.push(pR[i][j] + "\t" + "\t" + F$[i][j] + "\n");
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = Math.round(M[i] * 10) / 10;
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = Math.round(M[i] * 10) / 10;
			if (min_y > M[i]) min_y = Math.round(M[i] * 10) / 10;
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		// var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 1; i++) {
			datasetKey[i] = [];
		}
		for (i = 0; i < 1; i++) {
			datasetKey[i].label = 'A';
			datasetKey[i].data = data;
			datasetKey[i].backgroundColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].borderColor = chartClrAry[i % chartClrAry.length];
			datasetKey[i].pointBorderWidth = 3;
			datasetKey[i].borderWidth = 1;
			datasetKey[i].lineTension = 0;
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('A' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 1; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
function saveData_Rank() {

	var Stream = document.getElementById("DataArea").value;
	var fineName = "Rank_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
