/**
 * 分散分析
 * ABs(２要因参加者間計画)
 *
 *
 *
 */
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();

    //フォームを作成
    changeAbsSetting();
    // デフォルトのタブを選択
    ChangeTab(1, 4);

    //コピペエリアにドラッグ＆ドロップを設定
    setDragAndDrop();

};
// セルデータの消去
function clearCellData() {
    var i = 0;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);
    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            elmCount += NN[i][j];
        }
    }

    var result = confirm("データを消去します");
    if (result === true) {
        document.getElementById("factorA_name").value = "A";
        document.getElementById("factorB_name").value = "B";
        for (i = 0; i < elmCount; i++) {
            document.getElementById("cell_" + (i + 1)).value = "";
        }
        errorClearCell(elmCount, "");
    }
}
function checkCellData() {
    var i = 0;
    var j = 0;

    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var elmCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            elmCount += NN[i][j];
        }
    }

    var errorCellNum = 0;

    if (document.getElementById("CandPArea").value === '') {
        errorClearCell(elmCount, "");
        errorCell(elmCount, "");

        for (i = 0; i < elmCount; i++) {
            if (document.getElementById("cell_" + (i + 1)).value === '') {
                errorCellNum = i + 1;
            }
        }
        if (errorCellNum === 0) {
            errorClearCell(elmCount, "");
            mainCalc_ABs();
        } else {
            alert("すべての数値が入力されていません (^_^)ゞ");
            document.getElementById("cell_" + errorCellNum).focus();
        }
    } else {
        var DData = dataremake5("CandPArea");
        DData = crDel(DData);
        var dd = [];
        dd = DData.split(" ");
        if (elmCount != dd.length) {
            alert("データ数が一致しません");
        } else {
            copipe("CandPArea", "text");
            inputTextArea(document.getElementById("CandPArea"), 0);
            inputBtnTextClear(document.getElementById("inputBtn1"));
            checkCellData();
        }
    }
}
// メイン計算
function mainCalc_ABs() {
    var i = 0;
    var j = 0;
    var k = 0;
    var ii = 0;
    var jj = 0;

    AA = document.getElementById("factorA_name").value;
    LA = parseInt(document.getElementById("factorA_number").value, 10);
    BB = document.getElementById("factorB_name").value;
    LB = parseInt(document.getElementById("factorB_number").value, 10);

    AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
    if (AA === '') AA = "A";
    BB = BB.replace(/\s/g, "_"); //半角スペースを＿に変換する
    if (BB === '') BB = "B";

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var NX = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            if (NX < NN[i][j]) NX = NN[i][j];
        }
    }

    var NA = new Array(LA);
    for (i = 0; i < LA; i++) {
        NA[i] = 0;
        for (j = 0; j < LB; j++) {
            NA[i] += NN[i][j];
        }
    }

    var NB = new Array(LB);
    for (j = 0; j < LB; j++) {
        NB[j] = 0;
        for (i = 0; i < LA; i++) {
            NB[j] += NN[i][j];
        }
    }

    var NAB = new Array(LA);
    for (i = 0; i < LA; i++) {
        NAB[i] = new Array(LB);
    }
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NAB[i][j] = NN[i][j];
        }
    }

    var xx = new Array(LA);
    for (i = 0; i < LA; i++) {
        xx[i] = new Array(LB);
        for (j = 0; j < LB; j++) {
            xx[i][j] = new Array(NX);
        }
    }

    var cellId = 1;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                xx[i][j][k] = parseFloat(document.getElementById("cell_" + cellId).value);
                cellId++;
            }
        }
    }

    var M = new Array(LA);
    for (i = 0; i < LA; i++) {
        M[i] = new Array(LB);
    }
    var mm;

    var SD = new Array(LA);
    for (i = 0; i < LA; i++) {
        SD[i] = new Array(LB);
    }
    var sd;

    var AAA = [];
    var BBB = [];
    var FFA$ = [];
    var ADA = [];
    var FFB$ = [];
    var BDB = [];

    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    // 平均・標準偏差
    strArray.push("[ ABs-Type Design ]\n\n");
    strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
    strArray.push("  A= " + AA + "\n");
    strArray.push("  B= " + BB + "\n");
    strArray.push(bar);
    strArray.push("A\tB\tN\t\tMean\t\tS.D.\n");
    strArray.push(bar);

    var S = 0;
    var SS = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            S = 0;
            SS = 0;
            for (k = 0; k < NN[i][j]; k++) {
                S += xx[i][j][k];
                SS += Math.pow(xx[i][j][k], 2);
            }
            M[i][j] = S / NN[i][j];
            mm = using(M[i][j], 5, 4);
            SD[i][j] = Math.sqrt(SS / NN[i][j] - Math.pow(M[i][j], 2));
            sd = using(SD[i][j], 5, 4);
            strArray.push((i + 1) + "\t" + (j + 1) + "\t" + NN[i][j] + "\t" + mm + "\t" + sd + "\n");
        }
        if (i < LA - 1) {
            strArray.push("\n");
        } else {
            strArray.push(bar);
        }
    }

    S = 0;
    SS = 0;
    var OB = 0;
    var E = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            S = S + 1 / NN[i][j];
            OB = OB + NN[i][j];
            SS = SS + M[i][j];
            E = E + Math.pow(SD[i][j], 2) * NN[i][j];
        }
    }

    // var N = LA*LB/S;
    var N = NN[0][0];
    var DH = SS / LA / LB;

    var NhFgag = false;
    var NhCheck = NN[0][0];
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            if (NhCheck != NN[i][j]) {
                NhFgag = true;
            }
        }
    }

    if (NhFgag === true) {
        strArray.push("\nNが不揃いです。\n");
        strArray.push("Unweighted-Mean ANOVAを行います。\n");
        N = LA * LB / S;
        n = using(N, 4, 2);
        strArray.push("Nh=" + n + "(調和平均)と仮定します。\n\n");
    }

    //分散分析
    // S.V    SS    df    MS   F
    // -----------------------------------
    //  A      A    DA    MA    FA    FA$
    //  B      B    DB    MB    FB    FB$
    // AxB     AB   DI    MI    FI    FI$
    // subj    E    DE    ME
    // -----------------------------------
    // Total   T    DT

    // S.V    SS    df    MS    F     p
    // -----------------------------------
    //  A     SSa   DFa   MSa   Fa    Pa
    //  B     SSb   DFb   MSb   Fb    Pb
    // AxB    SSab  DFab  MSab  Fab   Pab
    // subj   SSe   DFe   MSe
    // -----------------------------------
    // Total  SSt   DFt

    //  主効果検定
    strArray.push("\n == Analysis of Variance ==\n\n");
    strArray.push(" A(" + LA + ") = " + AA + "\n");
    strArray.push(" B(" + LB + ") = " + BB + "\n");
    strArray.push(bar);
    strArray.push(" S.V          SS        df       MS        F\n");
    strArray.push(bar);

    var A = 0;
    for (i = 0; i < LA; i++) {
        S = 0;
        for (j = 0; j < LB; j++) {
            S = S + M[i][j];
        }
        A = A + Math.pow((S / LB - DH), 2) * N * LB;
    }

    var B = 0;
    for (j = 0; j < LB; j++) {
        S = 0;
        for (i = 0; i < LA; i++) {
            S = S + M[i][j];
        }
        B = B + Math.pow((S / LA - DH), 2) * N * LA;
    }

    var AB = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            AB = AB + Math.pow((M[i][j] - DH), 2) * N;
        }
    }

    AB = AB - A - B;
    var T = A + B + AB + E;
    var DA = LA - 1;
    var MA = A / DA;
    var DB = LB - 1;
    var MB = B / DB;
    var DI = DA * DB;
    var MI = AB / DI;
    var DE = OB - LA * LB;
    var ME = E / DE;
    var FA = MA / ME;
    var FB = MB / ME;
    var FI = MI / ME;

    var D1 = DA, D2 = DE, Fdata = FA;
    var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

    D1 = DI;
    D2 = DE;
    Fdata = FI;
    var FI$ = pValue_Match_fRatio(D1, D2, Fdata);

    // var a = using(A,12,4);
    // var da = using(DA,4,0);
    // var ma = using(MA,7,4);
    // var fa = using(FA,3,2);

    strArray.push("  A" + using(A, 12, 4) + " " + using(DA, 4, 0) + " " + using(MA, 7, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
    // strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");

    D1 = DA;
    if (FI$ != "ns") {
        for (j = 0; j < LB; j++) {
            S = 0;
            SS = 0;
            for (i = 0; i < LA; i++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            A = (SS - Math.pow(S, 2) / LA) * N;
            FF = A / DA / ME;
            Fdata = FF;
            FFA$[j] = pValue_Match_fRatio(D1, D2, Fdata);
            ADA[j] = A / DA;

            // var ss = using(A,6,4);
            // var df = using(DA,4,0);
            // var ms = using(ADA[j],7,4);
            // var ff = using(FF,3,2);

            strArray.push("(A at B" + (j + 1) + " " + using(A, 6, 4) + " " + using(DA, 4, 0) + " " + using(ADA[j], 7, 4) + " " + using(FF, 3, 2) + " " + FFA$[j] + ")\n");
            // strArray.push("(A at B"+(j+1)+" "+ss+" "+df+" "+ms+" "+ff+" "+FFA$[j]+")\n");
        }
        strArray.push(bar);
    }

    D1 = DB;
    Fdata = FB;
    var FB$ = pValue_Match_fRatio(D1, D2, Fdata);

    // var b = using(B,12,4);
    // var db = using(DB,4,0);
    // var mb = using(MB,7,4);
    // var fb = using(FB,3,2);

    strArray.push("  B" + using(B, 12, 4) + " " + using(DB, 4, 0) + " " + using(MB, 7, 4) + " " + using(FB, 3, 2) + " " + FB$ + "\n");
    // strArray.push("  B"+b+" "+db+" "+mb+" "+fb+" "+FB$+"\n");

    //単純主効果検定
    if (FI$ != "ns") {
        for (i = 0; i < LA; i++) {
            S = 0;
            SS = 0;
            for (j = 0; j < LB; j++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            B = (SS - Math.pow(S, 2) / LB) * N;
            FF = B / DB / ME;
            Fdata = FF;
            FFB$[i] = pValue_Match_fRatio(D1, D2, Fdata);
            BDB[i] = B / DB;

            // ss = using(B,6,4);
            // df = using(DB,4,0);
            // ms = using(BDB[i],7,4);
            // ff = using(FF,3,2);

            strArray.push("(B at A" + (i + 1) + " " + using(B, 6, 4) + " " + using(DB, 4, 0) + " " + using(BDB[i], 7, 4) + " " + using(FF, 3, 2) + " " + FFB$[i] + ")\n");
            // strArray.push("(B at A"+(i+1)+" "+ss+" "+df+" "+ms+" "+ff+" "+FFB$[i]+")\n");
        }
        strArray.push(bar);
    }

    // var ab = using(AB,11,4);
    // var di = using(DI,4,0);
    // var mi = using(MI,7,4);
    // var fi = using(FI,3,2);
    // var e = using(E,10,4);
    // var de = using(DE,4,0);
    // var me = using(ME,7,4);

    strArray.push(" AxB" + using(AB, 11, 4) + " " + using(DI, 4, 0) + " " + using(MI, 7, 4) + " " + using(FI, 3, 2) + " " + FI$ + "\n");
    strArray.push(" subj" + using(E, 10, 4) + " " + using(DE, 4, 0) + " " + using(ME, 7, 4) + "\n");
    strArray.push(bar);
    // strArray.push(" AxB"+ab+" "+di+" "+mi+" "+fi+" "+FI$+"\n");
    // strArray.push(" subj"+e+" "+de+" "+me+"\n");
    // strArray.push(bar);

    // var t = using(T,10,4);
    var DT = OB - 1;
    // var dt = using(DT,4,0);

    strArray.push("Total" + using(T, 10, 4) + " " + using(DT, 4, 0));
    strArray.push("   +p<.10 *p<.05 **p<.01\n\n");
    // strArray.push("Total"+t+" "+dt);
    // strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

    //効果量
    var eta2 = 0;
    var effectSizeF = 0;

    strArray.push("\n == EffectSize ==\n\n");
    strArray.push("\tpartial η2\teffectsize f\n");
    strArray.push(bar);

    eta2 = DA * FA / (DA * FA + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push("  A\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    eta2 = DB * FB / (DB * FB + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push("  B\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    eta2 = DI * FI / (DI * FI + DE);
    effectSizeF = Math.sqrt(eta2 / (1 - eta2));
    strArray.push(" AxB\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

    strArray.push(bar);
    strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

    //多重比較
    // 多重比較の出力メモ（すべての方法で）
    //  交互作用の有意性に関わらず,
    //  AとBの水準数が２より大きく,主効果が有意だった場合は出力する
    //  2013.1.15 改訂

    var checkedLsd = false;
    var checkedHsd = false;
    var checkedBonf = false;
    var checkedHolm = false;

    checkedLsd = document.getElementById("LSD").checked;
    checkedHsd = document.getElementById("HSD").checked;
    checkedBonf = document.getElementById("BONF").checked;
    checkedHolm = document.getElementById("HOLM").checked;

    //多重比較 LSD法
    if (checkedLsd) {
        var T2;
        var LSD;
        var lsdd;
        if (FI$ != "ns") {
            if (LA > 2) {
                T2 = tvalue(DE);
                me = using(ME, 6, 4);

                LSD = T2 * Math.sqrt(2 * ME / N);
                lsdd = using(LSD, 8, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(" (LSD=" + lsdd + ")\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                if (Math.abs(M[i][j] - M[ii][j]) > LSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
                            }
                        }
                        strArray.push(bar);
                    }
                }
            }
            if (LB > 2) {
                T2 = tvalue(DE);
                me = using(ME, 6, 4);

                LSD = T2 * Math.sqrt(2 * ME / N);
                lsdd = using(LSD, 8, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(" (LSD=" + lsdd + ")\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                if (Math.abs(M[i][j] - M[i][jj]) > LSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
                            }
                        }
                        strArray.push(bar);
                    }
                }
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            T2 = tvalue(DE);
            me = using(ME, 6, 4);

            LSD = T2 * Math.sqrt(2 * ME / N / LB);
            lsdd = using(LSD, 8, 4);

            strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(" (LSD=" + lsdd + ")\n");
            strArray.push(bar);
            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    if (Math.abs(AAA[i] - AAA[ii]) > LSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            T2 = tvalue(DE);
            LSD = T2 * Math.sqrt(2 * ME / N / LA);
            lsdd = using(LSD, 7, 4);

            strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(" (LSD=" + lsdd + ")\n");
            strArray.push(bar);
            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    if (Math.abs(BBB[j] - BBB[jj]) > LSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 HSD(Tukey-kramer)
    if (checkedHsd) {
        var Q2;
        var HSD;
        var hsd;
        if (FI$ != "ns") {
            if (LA > 2) {
                Q2 = st_qValue(LA, DE);
                me = using(ME, 6, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                HSD = Q2 * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j])) / Math.SQRT2;
                                hsd = using(HSD, 8, 4);

                                if (Math.abs(M[i][j] - M[ii][j]) > HSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                Q2 = st_qValue(LB, DE);
                me = using(ME, 6, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05)\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                HSD = Q2 * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj])) / Math.SQRT2;
                                hsd = using(HSD, 8, 4);

                                if (Math.abs(M[i][j] - M[i][jj]) > HSD) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            Q2 = st_qValue(LA, DE);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    HSD = Q2 * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii])) / Math.SQRT2;
                    hsd = using(HSD, 8, 4);

                    if (Math.abs(AAA[i] - AAA[ii]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            Q2 = st_qValue(LB, DE);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    HSD = Q2 * Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj])) / Math.SQRT2;
                    hsd = using(HSD, 8, 4);

                    if (Math.abs(BBB[j] - BBB[jj]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 Bonferroni法
    if (checkedBonf) {
        var kumi = 0;
        var TB = 0;
        var alpha_d = 0;

        var BONF;
        var bonf;

        if (FI$ != "ns") {
            if (LA > 2) {
                me = using(ME, 6, 4);

                kumi = kumiawase(LA, 2);
                TB = bonf_tValue(kumi, DE);
                alpha_d = using(0.05 / kumi, 2, 4);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
                        strArray.push(bar);
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                BONF = TB * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j]));
                                bonf = using(BONF, 7, 4);

                                if (Math.abs(M[i][j] - M[ii][j]) > BONF) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                me = using(ME, 6, 4);

                kumi = kumiawase(LB, 2);
                TB = bonf_tValue(kumi, DE);
                alpha_d = using(0.05 / kumi, 2, 4);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
                        strArray.push(bar);
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                BONF = TB * Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj]));
                                bonf = using(BONF, 7, 4);

                                if (Math.abs(M[i][j] - M[i][jj]) > BONF) {
                                    MC$ = " *  ";
                                } else {
                                    MC$ = "n.s.";
                                    EQ$ = "=";
                                }
                                if (MC$ == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                }
                                strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            me = using(ME, 6, 4);

            kumi = kumiawase(LA, 2);
            TB = bonf_tValue(kumi, DE);
            alpha_d = using(0.05 / kumi, 2, 4);

            strArray.push(" == Multiple Comparisons by Bonferroni ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4 + "\n"));
            }
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    BONF = TB * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
                    bonf = using(BONF, 7, 4);

                    if (Math.abs(AAA[i] - AAA[ii]) > BONF) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                }
            }
            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            kumi = kumiawase(LB, 2);
            TB = bonf_tValue(kumi, DE);
            alpha_d = using(0.05 / kumi, 2, 4);

            strArray.push(" == Multiple Comparisons by Bonferroni ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    BONF = TB * Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj]));
                    bonf = using(BONF, 7, 4);

                    if (Math.abs(BBB[j] - BBB[jj]) > BONF) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
                }
            }
            strArray.push(bar);
        }
    }

    //多重比較 Holm
    if (checkedHolm) {
        var TL = [];
        var TLN = []; //順番を保存
        var HMC$ = [];
        var alpha_d = [];

        var tlcount = 0;

        var kumi = 0;

        var temp, temp2, temp3, temp4;

        var kflag = 1; //１のとき棄却する 0だと検定終了

        if (FI$ != "ns") {
            if (LA > 2) {
                kumi = kumiawase(LA, 2);

                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        tlcount = 0;
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                TL[tlcount] = Math.abs(M[i][j] - M[ii][j]) / Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[ii][j]));
                                TLN[tlcount] = tlcount;
                                tlcount++;
                            }
                        }

                        //TL値の小さい順に並び替え（同時にTLN値も）
                        // var temp;
                        // var temp2;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TL[jk] < TL[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                }
                            }
                        }

                        //TL値を計算
                        kflag = 1; //１のとき棄却する 0だと検定終了
                        for (ik = kumi; ik > 0; ik--) {
                            if (kflag) {
                                if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                                    HMC$[ik - 1] = " *  ";
                                } else {
                                    HMC$[ik - 1] = "n.s.";
                                    kflag = 0; //検定終了 以降はすべて保留
                                }
                            } else {
                                HMC$[ik - 1] = "n.s.";
                            }
                            alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
                        }

                        //TLN値の小さい順に並び替え
                        // var temp3;
                        // var temp4;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TLN[jk] < TLN[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    temp3 = HMC$[jk];
                                    temp4 = alpha_d[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    HMC$[jk] = HMC$[jk - 1];
                                    alpha_d[jk] = alpha_d[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                    HMC$[jk - 1] = temp3;
                                    alpha_d[jk - 1] = temp4;
                                }
                            }
                        }
                        me = using(ME, 6, 4);

                        strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
                        strArray.push(" A at B" + (j + 1) + " Level\n");
                        strArray.push(" (MSe=" + me + ", * p<.05)\n");
                        strArray.push(bar);

                        tlcount = 0;
                        for (i = 0; i < LA - 1; i++) {
                            for (ii = i + 1; ii < LA; ii++) {
                                if (HMC$[tlcount] == " *  ") {
                                    if (M[i][j] > M[ii][j]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                } else {
                                    EQ$ = "=";
                                }
                                strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                                tlcount++;
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
            if (LB > 2) {
                kumi = kumiawase(LB, 2);

                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        tlcount = 0;
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                TL[tlcount] = Math.abs(M[i][j] - M[i][jj]) / Math.sqrt(ME * (1 / NAB[i][j] + 1 / NAB[i][jj]));
                                TLN[tlcount] = tlcount;
                                tlcount++;
                            }
                        }

                        //TL値の小さい順に並び替え（同時にTLN値も）
                        // var temp;
                        // var temp2;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TL[jk] < TL[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                }
                            }
                        }

                        //TL値を計算
                        kflag = 1; //１のとき棄却する 0だと検定終了
                        for (ik = kumi; ik > 0; ik--) {
                            if (kflag) {
                                if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                                    HMC$[ik - 1] = " *  ";
                                } else {
                                    HMC$[ik - 1] = "n.s.";
                                    kflag = 0; //検定終了 以降はすべて保留
                                }
                            } else {
                                HMC$[ik - 1] = "n.s.";
                            }
                            alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
                        }

                        //TLN値の小さい順に並び替え
                        // var temp3;
                        // var temp4;
                        for (ik = 0; ik < kumi; ik++) {
                            for (jk = kumi - 1; jk > 0; jk--) {
                                if (TLN[jk] < TLN[jk - 1]) {
                                    temp = TL[jk];
                                    temp2 = TLN[jk];
                                    temp3 = HMC$[jk];
                                    temp4 = alpha_d[jk];
                                    TL[jk] = TL[jk - 1];
                                    TLN[jk] = TLN[jk - 1];
                                    HMC$[jk] = HMC$[jk - 1];
                                    alpha_d[jk] = alpha_d[jk - 1];
                                    TL[jk - 1] = temp;
                                    TLN[jk - 1] = temp2;
                                    HMC$[jk - 1] = temp3;
                                    alpha_d[jk - 1] = temp4;
                                }
                            }
                        }
                        me = using(ME, 6, 4);

                        strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
                        strArray.push(" B at A" + (i + 1) + " Level\n");
                        strArray.push(" (MSe=" + me + ", * p<.05)\n");
                        strArray.push(bar);

                        tlcount = 0;
                        for (j = 0; j < LB - 1; j++) {
                            for (jj = j + 1; jj < LB; jj++) {
                                if (HMC$[tlcount] == " *  ") {
                                    if (M[i][j] > M[i][jj]) {
                                        EQ$ = ">";
                                    } else {
                                        EQ$ = "<";
                                    }
                                } else {
                                    EQ$ = "=";
                                }
                                strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                                tlcount++;
                            }
                        }
                    }
                }
                strArray.push(bar);
            }
        }
        if ((LA > 2) && (FA$ != "ns")) {
            kumi = kumiawase(LA, 2);
            me = using(ME, 6, 4);

            strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor A]\n");
            strArray.push(" A     N(Nu)       Mean\n");
            strArray.push(bar);
            for (i = 0; i < LA; i++) {
                S = 0;
                for (j = 0; j < LB; j++) {
                    S = S + M[i][j];
                }
                AAA[i] = S / LB;
                // var aaa = using(AAA[i],6,4);
                NLB = N * LB;
                // var nlb = using(NLB,6,2);
                strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
            }
            strArray.push(bar);

            tlcount = 0;
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    TL[tlcount] = Math.abs(AAA[i] - AAA[ii]) / Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
                    TLN[tlcount] = tlcount;
                    tlcount++;
                }
            }

            //TL値の小さい順に並び替え（同時にTLN値も）
            // var temp;
            // var temp2;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TL[jk] < TL[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                    }
                }
            }

            //TL値を計算
            kflag = 1; //１のとき棄却する 0だと検定終了
            for (ik = kumi; ik > 0; ik--) {
                if (kflag) {
                    if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                        HMC$[ik - 1] = " *  ";
                    } else {
                        HMC$[ik - 1] = "n.s.";
                        kflag = 0; //検定終了 以降はすべて保留
                    }
                } else {
                    HMC$[ik - 1] = "n.s.";
                }
                alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
            }

            //TLN値の小さい順に並び替え
            // var temp3;
            // var temp4;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TLN[jk] < TLN[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        temp3 = HMC$[jk];
                        temp4 = alpha_d[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        HMC$[jk] = HMC$[jk - 1];
                        alpha_d[jk] = alpha_d[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                        HMC$[jk - 1] = temp3;
                        alpha_d[jk - 1] = temp4;
                    }
                }
            }

            tlcount = 0;
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    if (HMC$[tlcount] == " *  ") {
                        if (AAA[i] > AAA[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    } else {
                        EQ$ = "=";
                    }
                    strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                    tlcount++;
                }
            }

            strArray.push(bar);
        }
        if ((LB > 2) && (FB$ != "ns")) {
            kumi = kumiawase(LB, 2);
            me = using(ME, 6, 4);

            strArray.push(" == Multiple Comparisons by Holm ==\n\n");
            strArray.push(" (MSe= " + me + ", * p<.05)\n");
            strArray.push(bar);

            strArray.push("[Main Effect of Factor B]\n");
            strArray.push(" B     N(Nu)       Mean\n");
            strArray.push(bar);
            for (j = 0; j < LB; j++) {
                S = 0;
                for (i = 0; i < LA; i++) {
                    S = S + M[i][j];
                }
                BBB[j] = S / LA;
                // var bbb = using(BBB[j],6,4);
                NLA = N * LA;
                // var nla = using(NLA,6,2);
                strArray.push(" " + (j + 1) + "\t" + using(NB[j], 4, 0) + "(" + NLA.toFixed(2) + ")\t" + using(BBB[j], 6, 4) + "\n");
            }
            strArray.push(bar);

            tlcount = 0;
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    TL[tlcount] = Math.abs(BBB[j] - BBB[jj]) / Math.sqrt(ME * (1 / NB[j] + 1 / NB[jj]));
                    TLN[tlcount] = tlcount;
                    tlcount++;
                }
            }

            //TL値の小さい順に並び替え（同時にTLN値も）
            // var temp;
            // var temp2;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TL[jk] < TL[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                    }
                }
            }

            //TL値を計算
            kflag = 1; //１のとき棄却する 0だと検定終了
            for (ik = kumi; ik > 0; ik--) {
                if (kflag) {
                    if (TL[ik - 1] >= bonf_tValue(ik, DE)) {
                        HMC$[ik - 1] = " *  ";
                    } else {
                        HMC$[ik - 1] = "n.s.";
                        kflag = 0; //検定終了 以降はすべて保留
                    }
                } else {
                    HMC$[ik - 1] = "n.s.";
                }
                alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
            }

            //TLN値の小さい順に並び替え
            // var temp3;
            // var temp4;
            for (ik = 0; ik < kumi; ik++) {
                for (jk = kumi - 1; jk > 0; jk--) {
                    if (TLN[jk] < TLN[jk - 1]) {
                        temp = TL[jk];
                        temp2 = TLN[jk];
                        temp3 = HMC$[jk];
                        temp4 = alpha_d[jk];
                        TL[jk] = TL[jk - 1];
                        TLN[jk] = TLN[jk - 1];
                        HMC$[jk] = HMC$[jk - 1];
                        alpha_d[jk] = alpha_d[jk - 1];
                        TL[jk - 1] = temp;
                        TLN[jk - 1] = temp2;
                        HMC$[jk - 1] = temp3;
                        alpha_d[jk - 1] = temp4;
                    }
                }
            }

            tlcount = 0;
            for (j = 0; j < LB - 1; j++) {
                for (jj = j + 1; jj < LB; jj++) {
                    if (HMC$[tlcount] == " *  ") {
                        if (BBB[j] > BBB[jj]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    } else {
                        EQ$ = "=";
                    }
                    strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
                    tlcount++;
                }
            }
            strArray.push(bar);
        }
    }

    strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

    //グラフの設定
    var gCheck = document.getElementById("RltArea").value;
    gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

    //出力
    document.getElementById("RltArea").value = strArray.join("");
    strArray = null;

    //Ｒプログラム出力
    (function () {
        var rcmArray = [];
        var spc = "          ";

        rcmArray.push("####### 分散分析ＡＢｓ(２要因参加者間) #######\n");
        rcmArray.push("\n");
        rcmArray.push("# パッケージ car が必要\n");
        rcmArray.push("\n");
        rcmArray.push("## js-STARの入力: ABs\n");
        rcmArray.push("levA <- " + LA + spc + "# level of A\n");
        rcmArray.push("levB <- " + LB + spc + "# level of B\n");
        rcmArray.push("n    <- c( # データ数\n");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                rcmArray.push(" " + NN[i][j]);
                if ((i != LA - 1) || (j != LB - 1)) rcmArray.push(",");
            }
            rcmArray.push("\n");
        }
        rcmArray.push(")");

        rcmArray.push("\n");
        rcmArray.push("data <- c(\n");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                for (k = 0; k < NN[i][j]; k++) {
                    rcmArray.push(" " + xx[i][j][k]);
                    if ((i != LA - 1) || (j != LB - 1) || (k != NN[i][j] - 1)) rcmArray.push(",");
                }
                if ((i != LA - 1) || (j != LB - 1)) {
                    rcmArray.push("\n");
                }
            }
        }
        rcmArray.push("\n )\n");
        rcmArray.push("## js-STARの入力おわり\n");

        rcmArray.push("\n");
        rcmArray.push("## スタック形式\n");
        rcmArray.push("A <- c()\n");
        rcmArray.push("for(i in 1:levA){\n");
        rcmArray.push("  for(j in 1:levB){\n");
        rcmArray.push("    suji <- rep(i, n[j+levB*(i-1)] )\n");
        rcmArray.push("    A    <- c( A, suji )\n");
        rcmArray.push("  }\n");
        rcmArray.push("}\n");
        rcmArray.push("B <- c()\n");
        rcmArray.push("for(i in 1:levA){\n");
        rcmArray.push("  for(j in 1:levB){\n");
        rcmArray.push("    suji <- rep(j, n[j+levB*(i-1)] )\n");
        rcmArray.push("    B    <- c( B, suji )\n");
        rcmArray.push("  }\n");
        rcmArray.push("}\n");
        rcmArray.push("\n");
        rcmArray.push("A <- factor(A)\n");
        rcmArray.push("B <- factor(B)\n");
        rcmArray.push("s <- c()\n");
        rcmArray.push("s <- gl(sum(n), 1)\n");
        rcmArray.push("ABs <- data.frame(A, B, s, data)\n");

        rcmArray.push("\n");
        rcmArray.push("## 基本統計量\n");
        rcmArray.push("tmp <- tapply(ABs$data, list(ABs$A,ABs$B), mean)\n");
        rcmArray.push("hk  <- as.numeric( t(tmp) )\n");
        rcmArray.push("tmp <- tapply(ABs$data, list(ABs$A,ABs$B), sd)\n");
        rcmArray.push("sd  <- as.numeric( t(tmp) )\n");
        rcmArray.push("tmp <- tapply(ABs$data, list(ABs$A,ABs$B), min)\n");
        rcmArray.push("mi  <- as.numeric( t(tmp) )\n");
        rcmArray.push("tmp <- tapply(ABs$data, list(ABs$A,ABs$B), max)\n");
        rcmArray.push("ma  <- as.numeric( t(tmp) )\n");
        rcmArray.push("\n");
        rcmArray.push("suji <- round(c(n,hk,sd,mi,ma), 4)\n");
        rcmArray.push("hyoj <- c()\n");
        rcmArray.push("for(L in 1:5){\n");
        rcmArray.push("for(i in 1:levA){\n");
        rcmArray.push("  if (i>1) hyoj <- c(hyoj, NA)\n");
        rcmArray.push("for(j in 1:levB){\n");
        rcmArray.push("  hyoj <- c(hyoj,\n");
        rcmArray.push("    suji[(L-1)*levA*levB+(i-1)*levB+j] )\n");
        rcmArray.push("  } } }\n");
        rcmArray.push("tx0 <- matrix(hyoj,\n");
        rcmArray.push("              nr=levA*levB+levA-1)\n");
        rcmArray.push("colnames(tx0) <- c(\n");
        rcmArray.push("  \"   ｎ\",\n");
        rcmArray.push("  \"     Mean\",\n");
        rcmArray.push("  \"       SD\",\n");
        rcmArray.push("  \"   Min\",\n");
        rcmArray.push("  \"   Max\" )\n");
        rcmArray.push("tmp <- c()\n");
        rcmArray.push("for(i in 1:levA){\n");
        rcmArray.push("  if (i>1) tmp <- c(tmp, \"\")\n");
        rcmArray.push("for(j in 1:levB){\n");
        rcmArray.push("  tmp <- c(tmp,\n");
        rcmArray.push("    paste(\n");
        rcmArray.push("      paste(\"A.\", i, sep=\"\"),\n");
        rcmArray.push("      paste(\"B.\", j, sep=\"\"),\n");
        rcmArray.push("      sep=\"_\" ) )\n");
        rcmArray.push("  }\n");
        rcmArray.push("  }\n");
        rcmArray.push("rownames(tx0) <- tmp\n");
        rcmArray.push("  \n");

        rcmArray.push("\n");
        rcmArray.push("# 作図：棒グラフ\n");
        rcmArray.push("mitsdo <- c(0:(levB-1))*10*log(1:levB) # バーの斜線密度\n");
        rcmArray.push("mitsdo <- rep( mitsdo, levA )          # Ａ水準数だけ反復\n");
        rcmArray.push("\n");
        rcmArray.push("kankak <- c( 1, rep(0, levB-1) ) # バーの間隔（左端=1, 以下=0）\n");
        rcmArray.push("kankak <- rep( kankak, levA )    # Ａ水準の数だけ反復\n");

        rcmArray.push("\n");
        rcmArray.push("bai  <- 2\n");

        rcmArray.push("shoh <- min(min(hk),0) # 最小平均か,ゼロ\n");
        rcmArray.push("dais <- max(sd)        # 最大ＳＤ\n");
        rcmArray.push("yjik <-c(shoh+dais*bai*sign(shoh),\n");
        rcmArray.push("         max(hk)+dais*bai) # ｙ軸の範囲\n");

        rcmArray.push("\n");
        rcmArray.push("antx <- barplot(              # バーの中点ｘ座標を出力するので取得\n");
        rcmArray.push("        hk,                   # 平均値のバーを描画\n");
        rcmArray.push("        yli=yjik,             # ｘ軸の範囲は指定しない！\n");
        rcmArray.push("        las=1, tck=0.02,      # ｙ軸の目盛デザイン ※ tck 変更可\n");
        rcmArray.push("        col=1,                # バーの色番号（黒） ※番号変更可\n");
        rcmArray.push("        den=mitsdo,           # バーの斜線密度   ※ mitsdo 変更可\n");
        rcmArray.push("        spa=kankak,           # バーの間隔\n");
        rcmArray.push("        names.arg=c(rep(c(");
        for (j = 0; j < LB; j++) {
            rcmArray.push("\"B" + (j + 1) + "\"");
            if (j < LB - 1) rcmArray.push(",");
        }
        rcmArray.push("),levA))," + spc + " # 棒グラフの名前 ※ 変更可\n");
        rcmArray.push("        xlab=\"\"," + spc + " # ｘ軸のラベル名 ※ 変更可\n");
        rcmArray.push("        ylab=\"\"," + spc + " # ｙ軸のラベル名 ※ 変更可\n");
        rcmArray.push("        main=c(\"SD= 不偏分散の平方根\")\n");
        rcmArray.push("        )\n");

        rcmArray.push("\n");
        rcmArray.push("arrows(                        # アロー（矢印）でアンテナを描く\n");
        rcmArray.push("       antx,hk,  antx,hk+sd*sign(hk),   # 矢印の始点座標,終点座標を指定\n");
        rcmArray.push("       lwd=1, ang=90, len=0.2  # 矢印の軸幅,矢羽の角度と長さ\n");
        rcmArray.push("       ) \n");

        rcmArray.push("\n");
        rcmArray.push("# 分散分析Type3\n");
        rcmArray.push("library( car )\n");
        rcmArray.push("kx0 <- lm(data~A*B, data=ABs,\n");
        rcmArray.push("  contrasts=list(\n");
        rcmArray.push("    A=contr.sum,\n");
        rcmArray.push("    B=contr.sum) )\n");
        rcmArray.push("kx1 <- Anova(kx0, type=3, test=\"F\")\n");
        rcmArray.push("\n");
        rcmArray.push("SSa   <- kx1$Sum[2]\n");
        rcmArray.push("SSb   <- kx1$Sum[3]\n");
        rcmArray.push("SSaxb <- kx1$Sum[4]\n");
        rcmArray.push("SSs   <- kx1$Sum[5]\n");
        rcmArray.push("DFa   <- levA-1\n");
        rcmArray.push("DFb   <- levB-1\n");
        rcmArray.push("DFaxb <- DFa*DFb\n");
        rcmArray.push("DFs   <- sum(n)-levA*levB\n");
        rcmArray.push("MSa   <- SSa/DFa\n");
        rcmArray.push("MSb   <- SSb/DFb\n");
        rcmArray.push("MSaxb <- SSaxb/DFaxb\n");
        rcmArray.push("MSs   <- SSs/DFs\n");
        rcmArray.push("\n");
        rcmArray.push("Fa   <- MSa/MSs\n");
        rcmArray.push("Fb   <- MSb/MSs\n");
        rcmArray.push("Faxb <- MSaxb/MSs\n");
        rcmArray.push("Pa   <- kx1$Pr[2]\n");
        rcmArray.push("Pb   <- kx1$Pr[3]\n");
        rcmArray.push("Paxb <- kx1$Pr[4]\n");
        rcmArray.push("\n");
        rcmArray.push("tx1 <- c()\n");
        rcmArray.push("tx1 <- matrix(round( c(\n");
        rcmArray.push("  SSa,   DFa,   MSa,   Fa,   Pa,\n");
        rcmArray.push("  SSb,   DFb,   MSb,   Fb,   Pb,\n");
        rcmArray.push("  SSaxb, DFaxb, MSaxb, Faxb, Paxb,\n");
        rcmArray.push("  SSs,   DFs,   MSs,   NA,   NA\n");
        rcmArray.push("  ), 4), nr=4, by=1)\n");
        rcmArray.push("colnames(tx1) <- c(\n");
        rcmArray.push("  \"TypeIII_SS\",\n");
        rcmArray.push("  \"  df\",\n");
        rcmArray.push("  \"       MS\",\n");
        rcmArray.push("  \"      Ｆ\",\n");
        rcmArray.push("  \"     ｐ\" )\n");
        rcmArray.push("rownames(tx1) <- c(\n");
        rcmArray.push("  \"要因Ａ\",\n");
        rcmArray.push("  \"要因Ｂ\",\n");
        rcmArray.push("  \"Ａ×Ｂ\",\n");
        rcmArray.push("  \" ｓ \" )\n");
        rcmArray.push("ty1 <- anova(kx0)                 # TypeI\n");
        rcmArray.push("ty2 <- Anova(kx0,type=2,test=\"F\") # TypeII\n");

        rcmArray.push("\n");
        rcmArray.push("# 分散の均一性\n");
        rcmArray.push("kx6 <- c()\n");
        rcmArray.push("kx6 <- leveneTest(data~A*B, data=ABs)\n");
        rcmArray.push("kx7 <- leveneTest(data~A*B, data=ABs,\n");
        rcmArray.push("  center=mean )\n");
        rcmArray.push("tx6 <- c()\n");
        rcmArray.push("tx6 <- matrix(round(c(\n");
        rcmArray.push("  kx7$F[1],\n");
        rcmArray.push("  kx7$Df[1], kx7$Df[2],\n");
        rcmArray.push("  kx7$P[1],\n");
        rcmArray.push("\n");
        rcmArray.push("  kx6$F[1],\n");
        rcmArray.push("  kx6$Df[1], kx6$Df[2], \n");
        rcmArray.push("  kx6$P[1]\n");
        rcmArray.push("  ), 4), nr=2, by=1 )\n");
        rcmArray.push("rownames(tx6) <- c(\n");
        rcmArray.push("  \"center=mean\",\n");
        rcmArray.push("  \"center=median\" )\n");
        rcmArray.push("colnames(tx6) <- c(\n");
        rcmArray.push("  \"     Ｆ\",\n");
        rcmArray.push("  \" df1\",\n");
        rcmArray.push("  \"  df2\",\n");
        rcmArray.push("  \"      ｐ\" )\n");

        rcmArray.push("\n");
        rcmArray.push("# パワーアナリシス\n");
        rcmArray.push("ESa   <- sqrt(SSa/SSs) # ES.f\n");
        rcmArray.push("ESb   <- sqrt(SSb/SSs)\n");
        rcmArray.push("ESaxb <- sqrt(SSaxb/SSs)\n");
        rcmArray.push("N   <- sum(n)\n");
        rcmArray.push("\n");
        rcmArray.push("# yoinA\n");
        rcmArray.push("NCP <- ESa^2*N  # 非心度\n");
        rcmArray.push("crF <- qf(0.05,df1=DFa,df2=DFs,low=0)\n");
        rcmArray.push("PWa <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFa,df2=DFs,ncp=NCP)\n");
        rcmArray.push("\n");
        rcmArray.push("ncpSPSS <- ESa^2*DFs\n");
        rcmArray.push("powA    <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFa,df2=DFs,ncp=ncpSPSS)\n");
        rcmArray.push("\n");
        rcmArray.push("crF <- qf(0.20,df1=DFa,df2=DFs,ncp=NCP)\n");
        rcmArray.push("ALa <- pf(crF, df1=DFa,df2=DFs,low=0)\n");
        rcmArray.push("\n");
        rcmArray.push("DFv <- NA\n");
        rcmArray.push("kos <- 0   # 出力個数\n");
        rcmArray.push("if (PWa<0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2 <- DFs+(i*0.01)\n");
        rcmArray.push("      DF2 <- min(DF2, 1000)\n");
        rcmArray.push("      ncp <- ESa^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFa,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFa,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta<0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("if (PWa>0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2  <- DFs-(i*0.01)\n");
        rcmArray.push("      DF2  <- max(DF2, 2)\n");
        rcmArray.push("      ncp <- ESa^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFa,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFa,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta>0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("NNa <- ceiling(DFv[1]+levA*levB)\n");

        rcmArray.push("\n");
        rcmArray.push("# yoinB\n");
        rcmArray.push("NCP <- ESb^2*N\n");
        rcmArray.push("crF <- qf(0.05,\n");
        rcmArray.push("  df1=DFb, df2=DFs,low=0)\n");
        rcmArray.push("PWb <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFb, df2=DFs,ncp=NCP)\n");
        rcmArray.push("\n");
        rcmArray.push("ncpSPSS <- ESb^2*DFs\n");
        rcmArray.push("powB    <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFb,df2=DFs,ncp=ncpSPSS)\n");
        rcmArray.push("\n");
        rcmArray.push("crF <- qf(0.20,df1=DFb,df2=DFs,ncp=NCP)\n");
        rcmArray.push("ALb <- pf(crF, df1=DFb,df2=DFs,low=0)\n");
        rcmArray.push("\n");
        rcmArray.push("DFv <- NA\n");
        rcmArray.push("kos <- 0\n");
        rcmArray.push("if (PWb<0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2 <- DFs+(i*0.01)\n");
        rcmArray.push("      DF2 <- min(DF2, 1000)\n");
        rcmArray.push("      ncp <- ESb^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFb,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFb,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta<0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("if (PWb>0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2  <- DFs-(i*0.01)\n");
        rcmArray.push("      DF2  <- max(DF2, 2)\n");
        rcmArray.push("      ncp <- ESb^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFb,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFb,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta>0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("NNb <- ceiling(DFv[1]+levA*levB)\n");

        rcmArray.push("\n");
        rcmArray.push("# AxB\n");
        rcmArray.push("NCP <- ESaxb^2*N  # 非心度\n");
        rcmArray.push("crF <- qf(0.05,\n");
        rcmArray.push("  df1=DFaxb, df2=DFs,low=0)\n");
        rcmArray.push("PWaxb <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFaxb, df2=DFs,ncp=NCP)\n");
        rcmArray.push("\n");
        rcmArray.push("ncpSPSS <- ESaxb^2*DFs\n");
        rcmArray.push("powAxB  <- 1-pf(crF,\n");
        rcmArray.push("  df1=DFaxb,df2=DFs,ncp=ncpSPSS)\n");
        rcmArray.push("\n");
        rcmArray.push("crF <- qf(0.20,df1=DFaxb,df2=DFs,ncp=NCP)\n");
        rcmArray.push("ALaxb <- pf(crF,df1=DFaxb,df2=DFs,low=0)\n");
        rcmArray.push("\n");
        rcmArray.push("DFv <- NA\n");
        rcmArray.push("kos <- 0\n");
        rcmArray.push("if (PWaxb<0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2 <- DFs+(i*0.01)\n");
        rcmArray.push("      DF2 <- min(DF2, 1000)\n");
        rcmArray.push("      ncp <- ESaxb^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFaxb,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFaxb,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta<0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("if (PWaxb>0.80)\n");
        rcmArray.push("  for(i in 1:100000){\n");
        rcmArray.push("    if (kos>1) i=99999\n");
        rcmArray.push("    else {\n");
        rcmArray.push("      DF2  <- DFs-(i*0.01)\n");
        rcmArray.push("      DF2  <- max(DF2, 2)\n");
        rcmArray.push("      ncp <- ESaxb^2*(DF2+levA*levB)\n");
        rcmArray.push("      crF  <- qf(0.95,df1=DFaxb,df2=DF2)\n");
        rcmArray.push("      beta <- pf(crF, df1=DFaxb,df2=DF2,ncp=ncp)\n");
        rcmArray.push("\n");
        rcmArray.push("      if (beta>0.20) kos=kos+1\n");
        rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
        rcmArray.push("  }\n");
        rcmArray.push("NNaxb <- ceiling(DFv[1]+levA*levB)\n");
        rcmArray.push("\n");
        rcmArray.push("tx2 <- c()\n");
        rcmArray.push("tx2 <- matrix(round( c(\n");
        rcmArray.push("  ESa^2/(ESa^2+1),    ESa,  PWa,  powA,\n");
        rcmArray.push("  ESb^2/(ESb^2+1),    ESb,  PWb,  powB,\n");
        rcmArray.push("  ESaxb^2/(ESaxb^2+1),ESaxb,PWaxb,powAxB\n");
        rcmArray.push("  ), 4), nr=3, by=1 )\n");
        rcmArray.push("rownames(tx2) <- c(\n");
        rcmArray.push("  \"要因Ａ\",\n");
        rcmArray.push("  \"要因Ｂ\",\n");
        rcmArray.push("  \"Ａ×Ｂ\" )\n");
        rcmArray.push("colnames(tx2) <- c(\n");
        rcmArray.push("  \"  偏η2\",\n");
        rcmArray.push("  \" 効果量ｆ\",\n");
        rcmArray.push("  \"  検出力1\",\n");
        rcmArray.push("  \"  検出力2\"  )\n");
        rcmArray.push("\n");
        rcmArray.push("tx4 <- c()\n");
        rcmArray.push("tx4 <- matrix(round(c(\n");
        rcmArray.push("  ESa,  ALa,  0.80,DFa,  DFs,\n");
        rcmArray.push("  ESb,  ALb,  0.80,DFb,  DFs,\n");
        rcmArray.push("  ESaxb,ALaxb,0.80,DFaxb,DFs\n");
        rcmArray.push("  ), 4), nr=3, by=1 )\n");
        rcmArray.push("rownames(tx4) <- c(\n");
        rcmArray.push("  \"要因Ａ\",\"要因Ｂ\",\"Ａ×Ｂ\")\n");
        rcmArray.push("colnames(tx4) <- c(\n");
        rcmArray.push("  \"効果量ｆ\",\n");
        rcmArray.push("  \"      α\",\n");
        rcmArray.push("  \"  1-β\",\n");
        rcmArray.push("  \"  df1\",\n");
        rcmArray.push("  \"  df2\" )\n");
        rcmArray.push("\n");
        rcmArray.push("tx5 <- c()\n");
        rcmArray.push("tx5 <- matrix(round(c(\n");
        rcmArray.push("  ESa,  0.05,0.80,NNa,  N,\n");
        rcmArray.push("  ESb,  0.05,0.80,NNb,  N,\n");
        rcmArray.push("  ESaxb,0.05,0.80,NNaxb,N\n");
        rcmArray.push("  ), 4), nr=3, by=1 )\n");
        rcmArray.push("rownames(tx5) <- c(\n");
        rcmArray.push("  \"要因Ａ\",\"要因Ｂ\",\"Ａ×Ｂ\")\n");
        rcmArray.push("colnames(tx5) <- c(\n");
        rcmArray.push("  \"効果量ｆ\",\n");
        rcmArray.push("  \"   α\",\n");
        rcmArray.push("  \" 1-β\",\n");
        rcmArray.push("  \" 次回総数\",\n");
        rcmArray.push("  \"今回のＮ\" )\n");

        if (FI$ != "ns") {
            rcmArray.push("\n");
            rcmArray.push("## 交互作用が有意のとき\n");
            rcmArray.push("## 単純主効果検定（多重検定）\n");
            rcmArray.push("SSsimp <- c()\n");
            rcmArray.push("MSsimp <- c()\n");
            rcmArray.push("for(j in 1:levB){\n");
            rcmArray.push("    ss <- anova(lm(data~A,\n");
            rcmArray.push("      data=subset(ABs, # A atBj\n");
            rcmArray.push("      as.numeric(ABs$B)==j)\n");
            rcmArray.push("      ))$Sum[1]\n");
            rcmArray.push("  SSsimp <- c(SSsimp, ss)\n");
            rcmArray.push("  MSsimp <- c(MSsimp, ss/DFa)\n");
            rcmArray.push("  }\n");
            rcmArray.push("for(i in 1:levA){\n");
            rcmArray.push("  ss <- anova(lm(data~B,\n");
            rcmArray.push("      data=subset(ABs, # B atAi\n");
            rcmArray.push("      as.numeric(ABs$A)==i)\n");
            rcmArray.push("      ))$Sum[1]\n");
            rcmArray.push("  SSsimp <- c(SSsimp, ss)\n");
            rcmArray.push("  MSsimp <- c(MSsimp, ss/DFb)\n");
            rcmArray.push("  }\n");
            rcmArray.push("\n");
            rcmArray.push("Fsimp <- MSsimp/MSs\n");
            rcmArray.push("DF1   <- c(rep(DFa,levB), rep(DFb,levA))\n");
            rcmArray.push("DF2   <- rep(DFs, levB+levA)\n");
            rcmArray.push("Psimp <- pf(Fsimp,df1=DF1,df2=DF2,low=0)\n");
            rcmArray.push("Psadj <- p.adjust(Psimp, me=\"BH\")\n");
            rcmArray.push("\n");
            rcmArray.push("suji <- round(c(\n");
            rcmArray.push("  SSsimp, DF1, DF2, Fsimp,\n");
            rcmArray.push("  Psimp, Psadj\n");
            rcmArray.push("  ), 4)\n");
            rcmArray.push("hyoj <- c()\n");
            rcmArray.push("for(L in 1:6){\n");
            rcmArray.push("for(i in 1:(levB+levA)){\n");
            rcmArray.push("  if (i==levB+1) hyoj <- c(hyoj, NA)\n");
            rcmArray.push("  hyoj <- c(hyoj,\n");
            rcmArray.push("    suji[(L-1)*(levB+levA)+i] )\n");
            rcmArray.push("  } }\n");
            rcmArray.push("\n");
            rcmArray.push("tx3 <- c()\n");
            rcmArray.push("tx3 <- matrix(hyoj,\n");
            rcmArray.push("              nr=levB+levA+1)\n");
            rcmArray.push("colnames(tx3) <- c(\n");
            rcmArray.push("  \"SS\",\n");
            rcmArray.push("  \" df1\",\n");
            rcmArray.push("  \" df2\",\n");
            rcmArray.push("  \"    Ｆ値\",\n");
            rcmArray.push("  \"   ｐ値\",\n");
            rcmArray.push("  \" 調整後\" )\n");
            rcmArray.push("tmp <- c()\n");
            rcmArray.push("for(j in 1:levB){\n");
            rcmArray.push("  tmp <- c(tmp,\n");
            rcmArray.push("    paste(\"A at_B\",\n");
            rcmArray.push("          j, sep=\"\") )\n");
            rcmArray.push("  }\n");
            rcmArray.push("tmp <- c(tmp, \"\")\n");
            rcmArray.push("for(i in 1:levA){\n");
            rcmArray.push("  tmp <- c(tmp,\n");
            rcmArray.push("    paste(\"B at_A\",\n");
            rcmArray.push("          i, sep=\"\") )\n");
            rcmArray.push("  }\n");
            rcmArray.push("rownames(tx3) <- tmp\n");

            if (LA > 2) {
                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        rcmArray.push("\n");
                        rcmArray.push("## A at B" + (j + 1) + " の多重比較\n");
                        rcmArray.push("AatB" + (j + 1) + " <- c()\n");
                        rcmArray.push("AatB" + (j + 1) + " <- round(pairwise.t.test(\n");
                        rcmArray.push("  subset(ABs,as.numeric(ABs$B)==" + (j + 1) + ")$data,\n");
                        rcmArray.push("  subset(ABs,as.numeric(ABs$B)==" + (j + 1) + ")$A,\n");
                        rcmArray.push("    p.ad=\"BH\")$p.va, 4)\n");
                        rcmArray.push("dimnames(AatB" + (j + 1) + ") <- list( \n");
                        rcmArray.push("  paste(\"A\",      2:levA,   sep=\"\"),\n");
                        rcmArray.push("  paste(\"   A\", 2:levA-1, sep=\"\") )\n");
                    }
                }
            }
            if (LB > 2) {
                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        rcmArray.push("\n");
                        rcmArray.push("## B at A" + (i + 1) + " の多重比較\n");
                        rcmArray.push("BatA" + (i + 1) + " <- c()\n");
                        rcmArray.push("BatA" + (i + 1) + " <- round(pairwise.t.test(\n");
                        rcmArray.push("  subset(ABs,as.numeric(ABs$A)==" + (i + 1) + ")$data,\n");
                        rcmArray.push("  subset(ABs,as.numeric(ABs$A)==" + (i + 1) + ")$B,\n");
                        rcmArray.push("    p.ad=\"BH\")$p.va, 4)\n");
                        rcmArray.push("dimnames(BatA" + (i + 1) + ") <- list( \n");
                        rcmArray.push("  paste(\"B\",      2:levB,   sep=\"\"),\n");
                        rcmArray.push("  paste(\"   B\", 2:levB-1, sep=\"\") )\n");
                    }
                }
            }
        } else {
            if (LA > 2) {
                if (FA$ != "ns") {
                    rcmArray.push("\n");
                    rcmArray.push("## 交互作用が有意でないとき主効果の多重比較\n");
                    rcmArray.push("## （要因Ａ）\n");
                    rcmArray.push("tmp <- c()\n");
                    rcmArray.push("for(i in 1:levA){\n");
                    rcmArray.push("  tmp <- c(tmp,\n");
                    rcmArray.push("    round(mean(\n");
                    rcmArray.push("    subset(ABs,as.numeric(ABs$A)==i)$data\n");
                    rcmArray.push("    ), 4)\n");
                    rcmArray.push("  ) }\n");
                    rcmArray.push("\n");
                    rcmArray.push("mainA <- c()\n");
                    rcmArray.push("mainA <- matrix(tmp,nr=1)\n");
                    rcmArray.push("rownames(mainA) <- \"平均値\"\n");
                    rcmArray.push("colnames(mainA) <- paste(\n");
                    rcmArray.push("  \"   A\", 1:levA, sep=\"\")\n");
                    rcmArray.push("\n");
                    rcmArray.push("testA <- c()\n");
                    rcmArray.push("testA <- round(\n");
                    rcmArray.push("  pairwise.t.test(\n");
                    rcmArray.push("  ABs$data, ABs$A,\n");
                    rcmArray.push("  p.ad=\"BH\" )$p.va,\n");
                    rcmArray.push("  4 )\n");
                    rcmArray.push("dimnames(testA) <- list(\n");
                    rcmArray.push("  paste(\"A\",      2:levA,   sep=\"\"),\n");
                    rcmArray.push("  paste(\"   A\", 2:levA-1, sep=\"\") )\n");
                }
            }
            if (LB > 2) {
                if (FB$ != "ns") {
                    rcmArray.push("\n");
                    rcmArray.push("## 交互作用が有意でないとき主効果の多重比較\n");
                    rcmArray.push("## （要因Ｂ）\n");
                    rcmArray.push("tmp <- c()\n");
                    rcmArray.push("for(j in 1:levB){\n");
                    rcmArray.push("  tmp <- c(tmp,\n");
                    rcmArray.push("    round(mean(\n");
                    rcmArray.push("    subset(ABs,as.numeric(ABs$B)==j)$data\n");
                    rcmArray.push("    ), 4)\n");
                    rcmArray.push("  ) }\n");
                    rcmArray.push("\n");
                    rcmArray.push("mainB <- c()\n");
                    rcmArray.push("mainB <- matrix(tmp,nr=1)\n");
                    rcmArray.push("rownames(mainB) <- \"平均値\"\n");
                    rcmArray.push("colnames(mainB) <- paste(\n");
                    rcmArray.push("  \"   B\", 1:levB, sep=\"\")\n");
                    rcmArray.push("\n");
                    rcmArray.push("testB <- c()\n");
                    rcmArray.push("testB <- round(\n");
                    rcmArray.push("  pairwise.t.test(\n");
                    rcmArray.push("  ABs$data, ABs$B,\n");
                    rcmArray.push("  p.ad=\"BH\" )$p.va,\n");
                    rcmArray.push("  4 )\n");
                    rcmArray.push("dimnames(testB) <- list(\n");
                    rcmArray.push("  paste(\"B\",      2:levB,   sep=\"\"),\n");
                    rcmArray.push("  paste(\"   B\", 2:levB-1, sep=\"\") )\n");
                }
            }
        }

        rcmArray.push("\n");
        rcmArray.push("options(digits=5)\n");
        rcmArray.push("options(scipen=5)\n");
        rcmArray.push("############################\n");
        rcmArray.push("#  分散分析 ＡＢs-design： #\n");
        rcmArray.push("#  ２要因 参加者間計画   #\n");
        rcmArray.push("############################\n");
        rcmArray.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
        rcmArray.push("\n");
        rcmArray.push("tx1 # 分散分析ＡＢｓ\n");
        rcmArray.push("\n");
        rcmArray.push("tx2 # 効果量と検出力(1-β)\n");
        rcmArray.push("# 効果量ｆ= sqrt( 偏η2/(1-偏η2) )\n");
        rcmArray.push("# 検出力1 は非心度推定= f^2*DataSize\n");
        rcmArray.push("# 検出力2 は非心度推定= f^2*DFerror\n");

        if (FI$ != "ns") {
            rcmArray.push("\n");
            rcmArray.push("tx3 # 交互作用Ａ×Ｂの単純主効果検定\n");
            rcmArray.push("# 調整後ｐ値の検定は有意水準α=0.15 推奨\n");
            rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
            rcmArray.push("# Part.η2(偏イータ２乗)= Ｆ*df1/(Ｆ*df1+df2)\n");

            if (LA > 2) {
                for (j = 0; j < LB; j++) {
                    if (FFA$[j] != "ns") {
                        rcmArray.push("\n");
                        rcmArray.push("AatB" + (j + 1) + " # A at B" + (j + 1) + " の多重比較\n");
                        rcmArray.push("    # プールドSDを用いたｔ検定の調整後ｐ値(両側確率)\n");
                        rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995) による\n");
                    }
                }
            }
            if (LB > 2) {
                for (i = 0; i < LA; i++) {
                    if (FFB$[i] != "ns") {
                        rcmArray.push("\n");
                        rcmArray.push("BatA" + (i + 1) + " # B at_A" + (i + 1) + " の多重比較\n");
                        rcmArray.push("    # プールドSDを用いたｔ検定の調整後ｐ値(両側確率)\n");
                        rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995) による\n");
                    }
                }
            }
        } else {
            if (LA > 2) {
                if (FA$ != "ns") {
                    rcmArray.push("\n");
                    rcmArray.push("mainA # 主効果Ａの多重比較（両側検定）\n");
                    rcmArray.push("testA # \n");
                    rcmArray.push("    # 数値はプールドSDを用いたｔ検定の調整後ｐ値\n");
                    rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995) による\n");
                }
            }
            if (LB > 2) {
                if (FB$ != "ns") {
                    rcmArray.push("\n");
                    rcmArray.push("mainB # 主効果Ｂの多重比較（両側検定）\n");
                    rcmArray.push("testB # \n");
                    rcmArray.push("    # 数値はプールドSDを用いたｔ検定の調整後ｐ値\n");
                    rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995) による\n");
                }
            }
        }

        rcmArray.push("\n");
        rcmArray.push("tx5 # パワーアナリシス：Ｎの計算\n");
        rcmArray.push("    # ■ NA が表示されたら計算不能\n");
        rcmArray.push("\n");
        rcmArray.push("tx6 # 分散の均一性の検定（Levene Test）\n");
        rcmArray.push("    # p<α なら分散の均一性不成立！\n");
        rcmArray.push("\n");
        rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
        rcmArray.push("# windows();boxplot(data~A*B,d=ABs,las=1) # 箱ひげ図\n");
        rcmArray.push("# tx4 # パワーアナリシス：αの計算\n");
        rcmArray.push("# sqrt(Fsimp*DF1/DF2)       # 単純主効果の効果量ｆ\n");
        rcmArray.push("# Fsimp*DF1/(Fsimp*DF1+DF2) # 単純主効果の偏η2\n");
        rcmArray.push("# print(ty2,d=8) # TypeII_SSの分散分析\n");

        rcmArray.push("\n");
        rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
        rcmArray.push("\n");

        document.getElementById("RcmArea").value = rcmArray.join("");
        rcmArray = null;
    }());	//Ｒプログラムここまで

    //グラフ描画
    (function () {
        chartClear();

        var i, j;
        var g;

        var chartImg = document.createElement('canvas');
        chartImg.id = "ChartImg0";
        var ctx = document.getElementById("chart").appendChild(chartImg);

        var graphType = document.getElementById("graphSelect").value;
        var legendName = document.getElementById("legendSelect").value;

        var data;
        var datasetKey = [];
        if (legendName === 'A') {
            data = new Array(LA);
            for (i = 0; i < LA; i++) {
                data[i] = new Array(LB);
            }
            for (i = 0; i < LA; i++) {
                for (j = 0; j < LB; j++) {
                    data[i][j] = Math.round(M[i][j] * 10) / 10;
                }
            }

            for (i = 0; i < LA + 1; i++) {
                datasetKey[i] = [];
            }
        }
        if (legendName === 'B') {
            data = new Array(LB);
            for (j = 0; j < LB; j++) {
                data[j] = new Array(LA);
            }
            for (j = 0; j < LB; j++) {
                for (i = 0; i < LA; i++) {
                    data[j][i] = Math.round(M[i][j] * 10) / 10;
                }
            }

            for (j = 0; j < LB + 1; j++) {
                datasetKey[j] = [];
            }
        }

        var max_y = M[0][0];
        var min_y = 0;
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                if (max_y < M[i][j]) max_y = Math.round(M[i][j] * 10) / 10;
                if (min_y > M[i][j]) min_y = Math.round(M[i][j] * 10) / 10;
            }
        }
        var _myMax = gCheck.match(/max:\d+/);
        if (_myMax !== null) {
            var myMax = _myMax[0].match(/\d+/);
            max_y = parseFloat(myMax, 10);
        }
        var _myMin = gCheck.match(/min:\d+/);
        if (_myMin !== null) {
            var myMin = _myMin[0].match(/\d+/);
            min_y = parseFloat(myMin, 10);
        }

        //カラーユニバーサルデザイン推奨配色セット制作委員会
        //https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
        var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

        // 複合グラフを作成する
        datasetKey[0].label = ''; //ラベルを空白にする

        var start;
        var end;
        // 折れ線グラフ
        if (graphType === 'line') {
            if (legendName === 'A') {
                start = 1;
                end = LA + 1;
            }
            if (legendName === 'B') {
                start = 1;
                end = LB + 1;
            }
            for (g = start; g < end; g++) {
                datasetKey[g].label = legendName + g;
                datasetKey[g].data = data[g - 1];
                datasetKey[g].backgroundColor = chartClrAry[(g - 1) % chartClrAry.length];
                datasetKey[g].borderColor = chartClrAry[(g - 1) % chartClrAry.length];
                datasetKey[g].pointBorderWidth = 3;
                datasetKey[g].borderWidth = 1;
                datasetKey[g].lineTension = 0;
                datasetKey[g].type = graphType; //折れ線グラフを指定				// datasetKey[i].type = 'line'; //折れ線グラフを指定
            }
        }

        // 棒グラフ
        if (graphType === 'bar') {
            if (legendName === 'A') {
                start = 0;
                end = LA;
            }
            if (legendName === 'B') {
                start = 0;
                end = LB;
            }
            for (g = start; g < end; g++) {
                datasetKey[g].label = legendName + (g + 1);
                datasetKey[g].data = data[g];
                datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length];
                datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
                datasetKey[g].pointBorderWidth = 3;
                datasetKey[g].borderWidth = 1;
                datasetKey[g].lineTension = 0;
                datasetKey[g].type = graphType; //折れ線グラフを指定
            }
        }

        var labelData = [];
        if (legendName === 'A') {
            for (j = 0; j < LB; j++) {
                labelData.push('B' + (j + 1));
            }
        }
        if (legendName === 'B') {
            for (i = 0; i < LA; i++) {
                labelData.push('A' + (i + 1));
            }
        }

        var datasetData = [];
        for (g = 0; g < end; g++) {
            datasetData[g] = datasetKey[g];
        }

        var myChart = new Chart(ctx, {
            type: 'bar', //最初に棒グラフを指定
            data: {
                labels: labelData,
                datasets: datasetData
            },
            options: {
                scales: {
                    xAxes: [{
                        maxBarThickness: 30,
                        ticks: {
                        }
                    }],
                    yAxes: [{
                        ticks: {
                            suggestedMin: min_y,
                            suggestedMax: max_y
                        }
                    }]
                },
                legend: {
                    position: 'right',
                    display: true,
                    labels: { //空白ラベルだったら表示しない
                        filter: function (items, chart) {
                            return items.text != '';
                        },
                    }
                },
                title: {
                    display: true,
                    text: 'Mean'
                }
            }
        });

        //箱ひげ図
        var addData = [];
        var myData = [];
        var arrayCol = [];

        if (legendName === 'A') {
            for (i = 0; i < LA; i++) {
                myData[i] = [];
            }

            for (j = 0; j < LB; j++) {
                for (i = 0; i < LA; i++) {
                    arrayCol = [];
                    for (k = 0; k < NN[i][j]; k++) {
                        arrayCol.push(xx[i][j][k]);
                    }
                    myData[i].push(arrayCol);
                }
            }
        }
        if (legendName === 'B') {
            for (j = 0; j < LB; j++) {
                myData[j] = [];
            }

            for (i = 0; i < LA; i++) {
                for (j = 0; j < LB; j++) {
                    arrayCol = [];
                    for (k = 0; k < NN[i][j]; k++) {
                        arrayCol.push(xx[i][j][k]);
                    }
                    myData[j].push(arrayCol);
                }
            }
        }

        chartImg = document.createElement('canvas');
        chartImg.id = "ChartImg1";
        ctx = document.getElementById("chart").appendChild(chartImg);

        if (legendName === 'A') {
            start = 0;
            end = LA;
        }
        if (legendName === 'B') {
            start = 0;
            end = LB;
        }

        datasetKey = [];
        for (g = 0; g < end; g++) {
            datasetKey[g] = [];
        }

        for (g = 0; g < end; g++) {
            datasetKey[g].label = legendName + (g + 1);
            datasetKey[g].data = myData[g];
            datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length] + '33';
            datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
            datasetKey[g].borderWidth = 1;
            datasetKey[g].outlierRadius = 3;
            datasetKey[g].itemRadius = 3;
            datasetKey[g].outlierColor = '#999999';
        }

        labelData = [];
        if (legendName === 'A') {
            for (j = 0; j < LB; j++) {
                labelData.push('B' + (j + 1));
            }
        }
        if (legendName === 'B') {
            for (i = 0; i < LA; i++) {
                labelData.push('A' + (i + 1));
            }
        }

        datasetData = [];
        for (g = 0; g < end; g++) {
            datasetData[g] = datasetKey[g];
        }

        var myChart2 = new Chart(ctx, {
            type: 'boxplot',
            data: {
                labels: labelData,
                datasets: datasetData
            },
            options: {
                responsive: true,
                scales: {
                    yAxes: [{
                        ticks: {
                            suggestedMin: min_y,
                            suggestedMax: max_y
                        }
                    }]
                },
                legend: {
                    position: 'right',
                },
                title: {
                    display: true,
                    text: 'Boxplot'
                }
            }
        });
    }());	//グラフ描画ここまで

    document.getElementById("RltArea").focus();
}
/**
 * [changeAbsSetting id="abs_setting"の書き換え]
 *
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 * 要因Bの名前 1行テキストボックスのid factorB_name
 * 要因Bの水準数1行テキストボックスのid factorB_number
 *
 */
function changeAbsSetting() {
    var htmArray = [];

    // freqdata2を使うか要検討 todo
    // htmArray.push("<div class=\"freqdata2\">");
    htmArray.push("<div class=\"tateyoko\">");
    htmArray.push("<table border=\"0\" class=\"codetb\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因A 名＿前：</td>");
    htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");

    htmArray.push("</tr>");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因A 水準数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsSetting2();\">");
    } else {
        htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 水準数');changeAbsSetting2();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("</table>");

    htmArray.push("<table border=\"0\" class=\"codetb3\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因B 名＿前：</td>");
    htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorB_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"B\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn2');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn2');\"><span id=\"cellClrBtn2\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorB_name','cellClrBtn2');\" >×</span></td>");

    htmArray.push("</tr>");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"codetbL\">要因B 水準数：</td>");
    htmArray.push("<td class=\"codetbR\">");

    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorB_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsSetting2();\">");
    } else {
        htmArray.push("<select id=\"factorB_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因B 水準数');changeAbsSetting2();\">");
        htmArray.push("<option value=\"2\" selected>2</option>");
        htmArray.push("<option value=\"3\">3</option>");
        htmArray.push("<option value=\"4\">4</option>");
        htmArray.push("<option value=\"5\">5</option>");
        htmArray.push("<option value=\"6\">6</option>");
        htmArray.push("<option value=\"7\">7</option>");
        htmArray.push("<option value=\"8\">8</option>");
        htmArray.push("<option value=\"9\">9</option>");
        htmArray.push("<option value=\"-1\">他</option>");
        htmArray.push("</select>");
    }

    htmArray.push("</td>");
    htmArray.push("</tr>");
    htmArray.push("</table>");

    htmArray.push("</div>");

    document.getElementById("abs_setting").innerHTML = htmArray.join("");
    htmArray = null;

    changeAbsSetting2();
}
function changeAbsSetting2() {
    var i = 0;
    var j = 0;
    var h = 3;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);

    var htmArray = [];

    var thisBrowser = getBrowser();
    if (thisBrowser.indexOf('ie') == -1) {
        htmArray.push("<table border=\"0\" class=\"codetb5\">");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                htmArray.push("<tr>");
                htmArray.push("<td class=\"codetbL\">A" + (i + 1) + " B" + (j + 1) + " 参加者数：</td>");
                htmArray.push("<td class=\"codetbR\">");
                htmArray.push("<input type=\"number\" class=\"text9\" id=\"A" + (i + 1) + "B" + (j + 1) + "_subjNum\"" + " size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAbsTable();\">");

                htmArray.push("</td>");
                htmArray.push("</tr>");
            }
        }
        htmArray.push("</table>");
    } else {
        htmArray.push("<table border=\"0\" class=\"codetb5\">");
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                htmArray.push("<tr>");
                htmArray.push("<td class=\"codetbL\">A" + (i + 1) + " B" + (j + 1) + " 参加者数：</td>");
                htmArray.push("<td class=\"codetbR\">");
                htmArray.push("<select id=\"A" + (i + 1) + "B" + (j + 1) + "_subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 第" + (i + 1) + "水準 要因B 第" + (j + 1) + "水準 参加者数');changeAbsTable();\">");
                htmArray.push("<option value=\"2\" selected>2</option>");

                for (h = 3; h < 31; h++) {
                    htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
                }

                htmArray.push("<option value=\"-1\">他</option>");
                htmArray.push("</select>");
                htmArray.push("</td>");
                htmArray.push("</tr>");
            }
        }
        htmArray.push("</table>");
    }

    document.getElementById("abs_setting2").innerHTML = htmArray.join("");
    htmArray = null;

    changeAbsTable();
}
function changeAbsTable() {
    var i = 0;
    var j = 0;
    var k = 0;
    var LA = parseInt(document.getElementById("factorA_number").value);
    var LB = parseInt(document.getElementById("factorB_number").value);
    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    var htmArray = [];
    var cellId = 1;
    var sCount = 1;

    var cellCount = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
            cellCount += NN[i][j];
        }
    }

    var NA = new Array(LA);
    for (i = 0; i < LA; i++) {
        NA[i] = 0;
        for (j = 0; j < LB; j++) {
            NA[i] += NN[i][j];
        }
    }

    // htmArray.push("<div class=\"freqdata3\">");
    htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
    htmArray.push("<tr>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("要因A");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("要因B");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("参加者");
    htmArray.push("</td>");
    htmArray.push("<td class=\"hyou_midashi_3d_title\">");
    htmArray.push("データ");
    htmArray.push("</td>");
    htmArray.push("</tr>");

    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                htmArray.push("<tr>");
                if ((j === 0) && (k === 0)) {
                    htmArray.push("<td ROWSPAN=\"" + NA[i] + "\" class=\"hyou_midashi_3d_title\">");
                    htmArray.push("A" + (i + 1));
                    htmArray.push("</td>");
                }
                if (k === 0) {
                    htmArray.push("<td ROWSPAN=\"" + NN[i][j] + "\" class=\"hyou_midashi_3d_title\">");
                    htmArray.push("B" + (j + 1));
                    htmArray.push("</td>");
                }

                if (k === 0) {
                    htmArray.push("<td class=\"hyou_midashi_3d_top\">");
                } else {
                    htmArray.push("<td class=\"hyou_midashi_3d\">");
                }
                htmArray.push(sCount);
                htmArray.push("</td>");

                htmArray.push("<td class=\"hyou_nyuryoku\">");
                htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
                htmArray.push("</td>");
                cellId++;
                sCount++;
                htmArray.push("</tr>");
            }
        }
    }
    htmArray.push("</table>");

    document.getElementById("abs_table").innerHTML = htmArray.join("");
    htmArray = null;
}
function saveData_ABs() {
    var i, j, k;

    var strArray = [];

    var AA = document.getElementById("factorA_name").value;
    var LA = parseInt(document.getElementById("factorA_number").value, 10);
    var BB = document.getElementById("factorB_name").value;
    var LB = parseInt(document.getElementById("factorB_number").value, 10);

    var NN = new Array(LA);
    for (i = 0; i < LA; i++) {
        NN[i] = new Array(LB);
    }

    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            NN[i][j] = parseInt(document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value, 10);
        }
    }

    //#0
    strArray.push("ABs" + "\n");
    //#1
    strArray.push("#" + "\n");
    strArray.push(AA + "\n");
    //#2
    strArray.push("#" + "\n");
    strArray.push(LA + "\n");
    //#3
    strArray.push("#" + "\n");
    strArray.push(BB + "\n");
    //#4
    strArray.push("#" + "\n");
    strArray.push(LB + "\n");
    //#5
    strArray.push("#" + "\n");
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            if (i !== LA - 1 || j !== LB - 1) {
                strArray.push(NN[i][j] + ",");
            } else {
                strArray.push(NN[i][j]);
            }
        }
    }
    strArray.push("\n");
    //#6
    strArray.push("#" + "\n");
    var x;
    var cellId = 1;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            for (k = 0; k < NN[i][j]; k++) {
                x = document.getElementById("cell_" + cellId).value;
                strArray.push(x + "\n");
                cellId++;
            }
        }
    }

    var Stream = strArray.join("");
    var fineName = "ABs_Data-" + getDate() + ".txt";

    SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ABs() {
    var readText = document.getElementById("CandPArea").value;
    var dd = [];
    dd = readText.split("#");

    if (crDel(dd[0]) === "ABs") {
        var AA = crDel(dd[1]);
        var LA = crDel(dd[2]);
        var BB = crDel(dd[3]);
        var LB = crDel(dd[4]);

        var nn_text = crDel(dd[5]);
        var _NN = [];
        _NN = nn_text.split(",");

        var NN = new Array(LA);
        for (i = 0; i < LA; i++) {
            NN[i] = new Array(LB);
        }

        var countN = 0;
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                NN[i][j] = _NN[countN];
                countN++;
            }
        }

        document.getElementById("factorA_name").value = AA;
        document.getElementById("factorA_number").value = parseInt(LA, 10);
        document.getElementById("factorB_name").value = BB;
        document.getElementById("factorB_number").value = parseInt(LB, 10);
        changeAbsSetting2();
        for (i = 0; i < LA; i++) {
            for (j = 0; j < LB; j++) {
                document.getElementById("A" + (i + 1) + "B" + (j + 1) + "_subjNum").value = parseInt(NN[i][j], 10);
            }
        }
        changeAbsTable();
        document.getElementById("CandPArea").value = delTopCR(dd[6]);
    }
}
