/**
 * 分散分析
 * As(１要因参加者間計画)<
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeAsSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		elmCount += NN[i];
	}

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var NN = [];

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		elmCount += NN[i];
	}

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_As();
			// ノンパラ
			mainCalc_kw();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_As() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = [];
	for (i = 0; i < LA; i++) {
		NA[i] = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = [];
	var mm;
	var SD = [];
	var sd;

	var MC$;
	var EQ$;

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ As-Type Design ]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("  A= " + AA + "\n");
	strArray.push(bar);
	strArray.push("A\tN\t\tMean\t\tS.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}

		M[i] = S / NN[i];
		mm = using(M[i], 5, 4);
		SD[i] = Math.sqrt(SS / NN[i] - Math.pow(M[i], 2));
		sd = using(SD[i], 5, 4);
		strArray.push((i + 1) + "\t" + NN[i] + "\t" + mm + "\t" + sd + "\n");
	}
	strArray.push(bar);

	//分散分析
	// S.V    SS    df    MS   F
	// -----------------------------------
	//  A      A    DA    MA    FA    FA$
	// subj    E    DE    ME
	// -----------------------------------
	// Total   T    DAE

	// S.V    SS    df    MS    F     p
	// -----------------------------------
	//  A     SSa   DFa   MSa   Fa    Pa
	// subj   SSe   DFe   MSe
	// -----------------------------------
	// Total  SSt   DFt

	//主効果検定
	strArray.push("\n == Analysis of Variance ==\n\n");
	strArray.push(" S.V        SS        df        MS        F\n");

	S = 0;
	var OB = 0;
	for (i = 0; i < LA; i++) {
		S = S + M[i] * NN[i];
		OB = OB + NN[i]; //度数の合計
	}
	var DH = S / OB; //大平均
	var A = 0;
	var E = 0;
	for (i = 0; i < LA; i++) {
		var MD = Math.pow(M[i] - DH, 2);
		A = A + MD * NN[i];
		E = E + Math.pow(SD[i], 2) * NN[i];
	}
	var T = A + E;
	var DA = LA - 1;
	var MA = A / DA;
	var DE = OB - LA;
	var ME = E / DE;
	var FA = MA / ME;
	var DAE = DA + DE;

	var D1 = DA;
	var D2 = DE;
	var Fdata = FA;
	var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var a = using(A,11,4);
	// var da = using(DA,4,0);
	// var ma = using(MA,8,4);
	// var fa = using(FA,3,2);
	// var e = using(E,9,4);
	// var de = using(DE,4,0);
	// var me = using(ME,8,4);
	// var t = using(T,9,4);
	// var dae = using(DAE,4,0);

	strArray.push(bar);
	strArray.push("  A" + using(A, 11, 4) + " " + using(DA, 4, 0) + " " + using(MA, 8, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
	strArray.push(" subj" + using(E, 9, 4) + " " + using(DE, 4, 0) + " " + using(ME, 8, 4) + "\n");
	strArray.push(bar);
	strArray.push("Total" + using(T, 9, 4) + " " + using(DAE, 4, 0));
	strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	// strArray.push(bar);
	// strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");
	// strArray.push(" subj"+e+" "+de+" "+me+"\n");
	// strArray.push(bar);
	// strArray.push("Total"+t+" "+dae);
	// strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	var effectSizeF = Math.sqrt(DA / DE * FA);
	strArray.push("\n == EffectSize ==\n\n");
	strArray.push("\teffectsize f\n");
	strArray.push(bar);
	strArray.push("  A\t" + effectSizeF.toFixed(4) + "\n");
	strArray.push(bar);
	strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

	//多重比較
	var checkedLsd = false;
	var checkedHsd = false;
	var checkedBonf = false;
	var checkedHolm = false;

	checkedLsd = document.getElementById("LSD").checked;
	checkedHsd = document.getElementById("HSD").checked;
	checkedBonf = document.getElementById("BONF").checked;
	checkedHolm = document.getElementById("HOLM").checked;

	//多重比較 LSD
	if (checkedLsd) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var T2 = 0;
				T2 = tvalue(D2);

				strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(bar);
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						var LSD = T2 * Math.sqrt(ME * (1 / NN[i] + 1 / NN[ii]));
						var lsd = using(LSD, 8, 4);

						if (Math.abs(M[i] - M[ii]) > LSD) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (LSD=" + lsd + ")\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 HSD(Tukey-kramer)
	if (checkedHsd) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var Q2 = 0;
				Q2 = st_qValue(LA, DE);

				strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(bar);
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						var HSD = Q2 * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii])) / Math.SQRT2;
						var hsd = using(HSD, 8, 4);

						if (Math.abs(M[i] - M[ii]) > HSD) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Bonferroni
	if (checkedBonf) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);
				var TB = 0;
				TB = bonf_tValue(kumi, DE);
				var alpha_d = 0;
				alpha_d = using(0.05 / kumi, 2, 4);

				strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05 , alpha'=" + alpha_d + ")\n");
				strArray.push(bar);
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						var BONF = TB * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
						var bonf = using(BONF, 8, 4);

						if (Math.abs(M[i] - M[ii]) > BONF) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
					}
				}
				strArray.push(bar);
			}
		}
	}

	//多重比較 Holm
	if (checkedHolm) {
		if (FA$ != "ns") {
			if (LA > 2) {
				var kumi = 0;
				kumi = kumiawase(LA, 2);

				var TL = [];
				var TLN = []; //順番を保存
				var HMC$ = [];
				var alpha_d = [];

				var tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						TL[tlcount] = Math.abs(M[i] - M[ii]) / Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
						TLN[tlcount] = tlcount;
						tlcount++;
					}
				}

				//TL値の小さい順に並び替え（同時にTLN値も）
				var temp;
				var temp2;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TL[j] < TL[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
						}
					}
				}

				//TL値を計算
				var kflag = 1; //１のとき棄却する 0だと検定終了
				for (i = kumi; i > 0; i--) {
					if (kflag) {
						if (TL[i - 1] >= bonf_tValue(i, DE)) {
							HMC$[i - 1] = " *  ";
						} else {
							HMC$[i - 1] = "n.s.";
							kflag = 0; //検定終了 以降はすべて保留
						}
					} else {
						HMC$[i - 1] = "n.s.";
					}
					alpha_d[i - 1] = using(0.05 / i, 2, 4);
				}

				//TLN値の小さい順に並び替え
				var temp3;
				var temp4;
				for (i = 0; i < kumi; i++) {
					for (j = kumi - 1; j > 0; j--) {
						if (TLN[j] < TLN[j - 1]) {
							temp = TL[j];
							temp2 = TLN[j];
							temp3 = HMC$[j];
							temp4 = alpha_d[j];
							TL[j] = TL[j - 1];
							TLN[j] = TLN[j - 1];
							HMC$[j] = HMC$[j - 1];
							alpha_d[j] = alpha_d[j - 1];
							TL[j - 1] = temp;
							TLN[j - 1] = temp2;
							HMC$[j - 1] = temp3;
							alpha_d[j - 1] = temp4;
						}
					}
				}

				strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
				strArray.push(" (MSe=" + using(ME, 8, 4) + ", * p<.05)\n");
				strArray.push(bar);
				tlcount = 0;
				for (i = 0; i < LA - 1; i++) {
					for (ii = i + 1; ii < LA; ii++) {
						if (HMC$[tlcount] == " *  ") {
							if (M[i] > M[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						} else {
							EQ$ = "=";
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
						tlcount++;
					}
				}
				strArray.push(bar);
			}
		}
	}
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("####### 分散分析Ａｓ(１要因参加者間) #######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ pwr が必要：pwr.anova.test\n");
		rcmArray.push("# パッケージ car が必要：LeveneTest\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARの入力: As\n");
		rcmArray.push("levA <- " + LA + "\n");
		rcmArray.push("n    <- c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push(NN[i]);
			if (i != LA - 1) {
				rcmArray.push(",");
			}
		}
		rcmArray.push(")\n");
		rcmArray.push("\n");
		rcmArray.push("data <- c(\n");
		for (i = 0; i < LA; i++) {
			for (j = 0; j < NN[i]; j++) {
				rcmArray.push(" " + xx[i][j]);
				if ((i != LA - 1) || (j != NN[i] - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n");
		}
		rcmArray.push(" )\n");
		rcmArray.push("## js-STARの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("## スタック形式のデータセット\n");
		rcmArray.push("A  <- rep(1:levA, n)\n");
		rcmArray.push("A  <- factor(A)\n");
		rcmArray.push("s  <- gl(sum(n), 1)\n");
		rcmArray.push("As <- data.frame(A, s, data)\n");

		rcmArray.push("\n");
		rcmArray.push("## 基本統計量\n");
		rcmArray.push("hk  <- tapply(As$data, As$A, mean)\n");
		rcmArray.push("sd  <- tapply(As$data, As$A, sd)\n");
		rcmArray.push("mi  <- tapply(As$data, As$A, min)\n");
		rcmArray.push("ma  <- tapply(As$data, As$A, max)\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 <- c()\n");
		rcmArray.push("tx1 <- data.frame( matrix(c(\n");
		rcmArray.push("  n,\n");
		rcmArray.push("  round(hk, 4),\n");
		rcmArray.push("  round(sd, 4),\n");
		rcmArray.push("  round(mi, 4),\n");
		rcmArray.push("  round(ma, 4)\n");
		rcmArray.push("  ), nr=levA) )\n");
		rcmArray.push("colnames(tx1) <- c(\n");
		rcmArray.push("  \"    n\",\n");
		rcmArray.push("  \"     Mean\",\n");
		rcmArray.push("  \"       SD\",\n");
		rcmArray.push("  \"   Min\",\n");
		rcmArray.push("  \"   Max\" )\n");
		rcmArray.push("rownames(tx1) <- c(\n");
		rcmArray.push("  paste(\"A.\", 1:levA, sep=\"\")\n");
		rcmArray.push("  )\n");

		rcmArray.push("\n");
		rcmArray.push("## 作図：バープロット\n");
		rcmArray.push("mitsdo <- c(0:(levA-1))*10*log(1:levA) # バーの斜線密度\n");
		rcmArray.push("\n");
		rcmArray.push("xjik <- c(0,   levA+1) # ｘ軸の拡幅：levA+1\n");
		rcmArray.push("bai  <- 2              # ｙ軸の拡幅倍率\n");
		rcmArray.push("shoh <- min(min(hk),0)      # 最小平均か,ゼロ\n");
		rcmArray.push("dais <- max(sd)             # 最大ＳＤ\n");
		rcmArray.push("yjik <-c(shoh+dais*bai*sign(shoh),\n");
		rcmArray.push("         max(hk)+dais*bai) # ｙ軸の範囲\n");

		rcmArray.push("\n");
		rcmArray.push("antx <- barplot(       # バー中点のｘ座標取得\n");
		rcmArray.push(" hk,                   # 平均値のバーを描画\n");
		rcmArray.push(" xli=xjik,  yli=yjik,  # ｘ・ｙ軸の範囲\n");
		rcmArray.push(" las=1, tck=0.02,      # ｙ軸の目盛デザイン\n");
		rcmArray.push(" col=1,                # バーの色番号（黒）\n");
		rcmArray.push(" den=mitsdo,           # バーの斜線密度\n");
		rcmArray.push(" names.arg=c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push("\"" + AA + (i + 1) + "\"");
			if (i < LA - 1) rcmArray.push(",");
		}
		rcmArray.push(")," + spc + " # 棒グラフの名前\n");
		rcmArray.push(" xlab=\"\",           # ｘ軸のラベル名\n");
		rcmArray.push(" ylab=\"\",           # ｙ軸のラベル名\n");
		rcmArray.push(" main=c(\"標準偏差＝不偏分散の平方根\")\n");
		rcmArray.push(" )\n");
		rcmArray.push("arrows(                # アローでアンテナを描く\n");
		rcmArray.push(" antx,hk, antx,hk+sd*sign(hk),  # 矢印の始点・終点座標\n");
		rcmArray.push(" lwd=2, ang=90          # 矢印の軸幅,矢羽の角度\n");
		rcmArray.push(" )\n");

		rcmArray.push("\n");
		rcmArray.push("## 分散分析\n");
		rcmArray.push("kx2 <- c()\n");
		rcmArray.push("kx2 <- anova(lm(data~A, data=As))\n");
		rcmArray.push("tx2 <- c()\n");
		rcmArray.push("tx2 <- matrix(round( c(\n");
		rcmArray.push("  kx2$S,kx2$D,kx2$M,kx2$F,kx2$P\n");
		rcmArray.push("  ), 4), nr=2)\n");
		rcmArray.push("colnames(tx2) <- c(\n");
		rcmArray.push("  \"       SS\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"       MS\",\n");
		rcmArray.push("  \"      Ｆ\",\n");
		rcmArray.push("  \"     ｐ\")\n");
		rcmArray.push("rownames(tx2) <- c(\"要因Ａ\",\" ｓ\")\n");
		rcmArray.push("\n");
		rcmArray.push("kx3 <- c()\n");
		rcmArray.push("kx3 <- pairwise.t.test( # 多重比較\n");
		rcmArray.push("  As$data, As$A,\n");
		rcmArray.push("  p.ad=\"BH\")\n");
		rcmArray.push("tx3 <- c()\n");
		rcmArray.push("tx3 <- round(kx3$p.v, 4)\n");
		rcmArray.push("dimnames(tx3) <- list(\n");
		rcmArray.push("  c(paste(\"A.\", 2:levA,   sep=\"\")),\n");
		rcmArray.push("  c(paste(\"   A.\", 2:levA-1, sep=\"\")) )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# 分散の均一性検定\n");
		rcmArray.push("library(car)   # リーベン検定用\n");
		rcmArray.push("kx4 <- c()\n");
		rcmArray.push("kx4 <- bartlett.test(data~A, data=As)\n");
		rcmArray.push("kx6 <- c()\n");
		rcmArray.push("kx6 <- leveneTest(data~A, data=As)\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 <- c()\n");
		rcmArray.push("tx4 <- matrix(round(c(\n");
		rcmArray.push("  kx6$F[1],\n");
		rcmArray.push("  kx6$Df[1], kx6$Df[2],\n");
		rcmArray.push("  kx6$P[1],\n");
		rcmArray.push("\n");
		rcmArray.push("  kx4$stat,\n");
		rcmArray.push("  kx4$para,\n");
		rcmArray.push("  NA,\n");
		rcmArray.push("  kx4$p.va\n");
		rcmArray.push("  ), 4), nr=2, by=1)\n");
		rcmArray.push("rownames(tx4) <- c(\n");
		rcmArray.push("  \"Levene Test  ：Ｆ \",\n");
		rcmArray.push("  \"Bartlett Test：χ2\" )\n");
		rcmArray.push("colnames(tx4) <- c(\n");
		rcmArray.push("  \"検定統計量\",\n");
		rcmArray.push("  \" df1\",\n");
		rcmArray.push("  \" df2\",\n");
		rcmArray.push("  \"   ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("## パワーアナリシス\n");
		rcmArray.push("df1 <- kx2$D[1]\n");
		rcmArray.push("df2 <- kx2$D[2]\n");
		rcmArray.push("MSa <- kx2$M[1]\n");
		rcmArray.push("MSs <- kx2$M[2]\n");
		rcmArray.push("Fa  <- kx2$F[1]\n");
		rcmArray.push("Pa  <- kx2$P[1]\n");
		rcmArray.push("\n");
		rcmArray.push("library( pwr )\n");
		rcmArray.push("es  <- sqrt(Fa*df1/df2) # ES.f\n");
		rcmArray.push("\n");
		rcmArray.push("kz1 <- pwr.anova.test( # po\n");
		rcmArray.push("  k =levA,\n");
		rcmArray.push("  n =sum(n)/levA,\n");
		rcmArray.push("  f =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL )\n");
		rcmArray.push("kz2 <- pwr.anova.test( # si\n");
		rcmArray.push("  k =levA,\n");
		rcmArray.push("  n =sum(n)/levA,\n");
		rcmArray.push("  f =es,\n");
		rcmArray.push("  si=NULL,\n");
		rcmArray.push("  po=0.8  )\n");
		rcmArray.push("kz3 <- pwr.anova.test( # ｎ\n");
		rcmArray.push("  k =levA,\n");
		rcmArray.push("  n =NULL,\n");
		rcmArray.push("  f =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.8  )\n");
		rcmArray.push("\n");
		rcmArray.push("ncpSPSS <- es^2*df2\n");
		rcmArray.push("powSPSS <- 1-pf(\n");
		rcmArray.push("  qf(0.05,df1,df2,low=0),\n");
		rcmArray.push("  df1, df2, ncp=ncpSPSS)\n");
		rcmArray.push("\n");
		rcmArray.push("tz7 <- c()\n");
		rcmArray.push("tz7 <- matrix(round(c(\n");
		rcmArray.push("  Fa, es, kz1$po, powSPSS\n");
		rcmArray.push("  ), 4), nr=1 )\n");
		rcmArray.push("rownames(tz7) <- c(\n");
		rcmArray.push("  \"要因Ａ\" )\n");
		rcmArray.push("colnames(tz7) <- c(\n");
		rcmArray.push("  \"Ｆ値\",\n");
		rcmArray.push("  \" 効果量ｆ\",\n");
		rcmArray.push("  \"  検出力1\",\n");
		rcmArray.push("  \"  検出力2\"  )\n");
		rcmArray.push("\n");
		rcmArray.push("tz8 <-c()\n");
		rcmArray.push("tz8 <- matrix(round(c(\n");
		rcmArray.push("  es,\n");
		rcmArray.push("  0.80,\n");
		rcmArray.push("  kz2$si,\n");
		rcmArray.push("  sum(n)/levA,\n");
		rcmArray.push("\n");
		rcmArray.push("  es,\n");
		rcmArray.push("  0.80,\n");
		rcmArray.push("  0.05,\n");
		rcmArray.push("  kz3$n\n");
		rcmArray.push("  ), 4), nr=2, by=1)\n");
		rcmArray.push("colnames(tz8) <- c(\n");
		rcmArray.push("  \"効果量ｆ\",\n");
		rcmArray.push("  \"  1-β\",\n");
		rcmArray.push("  \"      α\",\n");
		rcmArray.push("  \"    ｎ\"\n");
		rcmArray.push("  )\n");
		rcmArray.push("rownames(tz8) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" ｎ の計算\")\n");
		rcmArray.push("\n");
		rcmArray.push("tz9 <-c()\n");
		rcmArray.push("tz9 <- matrix(c(\n");
		rcmArray.push("   ceiling(kz3$n)*levA,\n");
		rcmArray.push("   sum(n)\n");
		rcmArray.push("   ), nr=1) # 必要総数N\n");
		rcmArray.push("rownames(tz9) <- c(\"Ｎ=n×群数\")\n");
		rcmArray.push("colnames(tz9) <- c(\n");
		rcmArray.push("  \"次回総数\",\n");
		rcmArray.push("  \"  今回のＮ\")\n");
		rcmArray.push("\n");
		rcmArray.push("# 自由度調整ＡＮＯＶＡ\n");
		rcmArray.push("kx5 <- c()\n");
		rcmArray.push("kx5 <- oneway.test(data~A, data=As)\n");
		rcmArray.push("tx5 <- c()\n");
		rcmArray.push("tx5 <- matrix(round(c(\n");
		rcmArray.push("  kx5$stat,\n");
		rcmArray.push("  kx5$para[1],\n");
		rcmArray.push("  kx5$para[2],\n");
		rcmArray.push("  kx5$p.val\n");
		rcmArray.push("  ), 4), nr=1 )\n");
		rcmArray.push("rownames(tx5) <- c(\n");
		rcmArray.push("  \"調整後Ｆ検定\" )\n");
		rcmArray.push("colnames(tx5) <- c(\n");
		rcmArray.push("  \"   Ｆ値\",\n");
		rcmArray.push("  \" df1\",\n");
		rcmArray.push("  \"    df2\",\n");
		rcmArray.push("  \"   ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("###########################\n");
		rcmArray.push("#  分散分析 Ａs-design：  #\n");
		rcmArray.push("#  １要因 参加者間計画  #\n");
		rcmArray.push("###########################\n");
		rcmArray.push("tx1 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # 分散分析表\n");
		rcmArray.push("\n");
		rcmArray.push("tz7 # 効果量ｆと検出力(1-β)\n");
		rcmArray.push("    # 効果量ｆの評価：大=0.40, 中=0.25, 小=0.10\n");
		rcmArray.push("    # Part.η2(偏イータ２乗)= f^2/(f^2+1)\n");
		rcmArray.push("    # 検出力1 は非心度推定= f^2*DataSize\n");
		rcmArray.push("    # 検出力2 は非心度推定= f^2*DFerror\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # 多重比較（プールドSDを用いたｔ検定）\n");
		rcmArray.push("# 数値は調整後のｐ値（両側確率）\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray.push("\n");
		rcmArray.push("tz8 # パワーアナリシス\n");
		rcmArray.push("tz9 # Ｎ(total sample size)の計算\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # 分散の均一性の検定\n");
		rcmArray.push("# p<α なら分散の均一性は不成立\n");
		rcmArray.push("# リーベン検定の中心値はメディアン\n");
		rcmArray.push("# バートレット検定は正規分布の確証時に参照\n");
		rcmArray.push("\n");
		rcmArray.push("tx5 # 分散の均一性が不成立のとき参照\n");
		rcmArray.push("\n");
		rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# windows();boxplot(data~A,d=As,las=1) # 箱ひげ図\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = Math.round(M[i] * 10) / 10;
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = Math.round(M[i] * 10) / 10;
			if (min_y > M[i]) min_y = Math.round(M[i] * 10) / 10;
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		datasetKey[0].label = ''; //ラベルを空白にする

		var graphType = document.getElementById("graphSelect").value;

		var start;
		var end;

		// 折れ線グラフ
		if (graphType === 'line') {
			start = 0;
			end = 2;
			datasetKey[1].label = 'A';
			datasetKey[1].data = data;
			datasetKey[1].backgroundColor = chartClrAry[0];
			datasetKey[1].borderColor = chartClrAry[0];
			datasetKey[1].pointBorderWidth = 3;
			datasetKey[1].borderWidth = 1;
			datasetKey[1].lineTension = 0;
			datasetKey[1].type = 'line'; //折れ線グラフを指定
		}

		// 棒グラフ
		if (graphType === 'bar') {
			end = 1;
			datasetKey[0].label = 'A';
			datasetKey[0].data = data;
			datasetKey[0].backgroundColor = chartClrAry[0];
			datasetKey[0].borderColor = chartClrAry[0];
			datasetKey[0].pointBorderWidth = 3;
			datasetKey[0].borderWidth = 1;
			datasetKey[0].lineTension = 0;
			datasetKey[0].type = 'bar'; //折れ線グラフを指定
		}

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('A' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < end; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];

		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN[i]; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
// 要因Aの名前 1行テキストボックスのid factorA_name
// 要因Aの水準数1行テキストボックスのid factorA_number
function changeAsSetting() {
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因名：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");

	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAsSetting2();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'水準数');changeAsSetting2();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("</div>");

	document.getElementById("as_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeAsSetting2();
}
// 要因Aの水準数セレクトのid ex.A1_subjNum,A2_subjNum
function changeAsSetting2() {
	var i = 0;
	var h = 3;
	var LA = parseInt(document.getElementById("factorA_number").value);

	var htmArray = [];

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<table border=\"0\" class=\"codetb2\">");
		for (i = 0; i < LA; i++) {
			htmArray.push("<tr>");
			htmArray.push("<td class=\"codetbL2\">水準" + (i + 1) + " 参加者数：</td>");
			htmArray.push("<td class=\"codetbR2\">");
			htmArray.push("<input type=\"number\" class=\"text9\" id=\"" + "A" + (i + 1) + "_subjNum\"" + " size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAsTable();\">");
			htmArray.push("</td>");
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");

	} else {
		htmArray.push("<table border=\"0\" class=\"codetb2\">");
		for (i = 0; i < LA; i++) {
			htmArray.push("<tr>");
			htmArray.push("<td class=\"codetbL2\">水準" + (i + 1) + " 参加者数：</td>");
			htmArray.push("<td class=\"codetbR2\">");
			htmArray.push("<select id=\"" + "A" + (i + 1) + "_subjNum\"" + "name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'第" + (i + 1) + "水準 参加者数');changeAsTable();\">");
			htmArray.push("<option value=\"2\" selected>2</option>");

			for (h = 3; h < 31; h++) {
				htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
			}

			htmArray.push("<option value=\"-1\">他</option>");
			htmArray.push("</select>");

			htmArray.push("</td>");
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	document.getElementById("as_setting2").innerHTML = htmArray.join("");
	htmArray = null;

	changeAsTable();
}
function changeAsTable() {
	var i = 0;
	var j = 0;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];

	var cellCount = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		cellCount += NN[i];
	}

	var htmArray = [];
	var cellId = 1;
	var sCount = 1;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("群");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("データ");
	htmArray.push("</td>");
	htmArray.push("</tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<tr>");
		htmArray.push("<td ROWSPAN=\"" + NN[i] + "\" class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");

		for (j = 0; j < NN[i]; j++) {
			if (j === 0) {
				htmArray.push("<td class=\"hyou_midashi_3d_top\">");
			} else {
				htmArray.push("<td class=\"hyou_midashi_3d\">");
			}
			htmArray.push(sCount);
			htmArray.push("</td>");
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
			htmArray.push("</td>");
			htmArray.push("</tr>");
			cellId++;
			sCount++;
		}
	}
	htmArray.push("</table>");

	document.getElementById("as_table").innerHTML = htmArray.join("");
	htmArray = null;
}

function mainCalc_kw() {
	var i = 0;
	var j = 0;
	var ii = 0;

	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var NN = [];

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	var N = 0; //総参加者数
	for (i = 0; i < LA; i++) {
		N = N + NN[i];
	}

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";

	var NA = [];
	for (i = 0; i < LA; i++) {
		NA[i] = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NX);
	}

	var a = [];
	for (i = 0; i < LA; i++) {
		a[i] = [];
	}

	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	var M = [];
	var SD = [];

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN[i]; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}

		M[i] = S / NN[i];
		SD[i] = Math.sqrt(SS / NN[i] - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN[i]; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var addedArray = a[0];
	for (i = 1; i < LA; i++) {
		addedArray = addedArray.concat(a[i]);
	}

	var sortedArray = addedArray.sort(compareNumbers);
	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var trankedArray = new Array(LA);
	for (i = 0; i < LA; i++) {
		trankedArray[i] = new Array(NX);
	}

	for (i = 0; i < sortedArray.length; i++) {
		for (ii = 0; ii < LA; ii++) {
			for (j = 0; j < a[ii].length; j++) {
				if (sortedArray[i] === a[ii][j]) {
					trankedArray[ii][j] = rerankedArray[i];
				}
			}
		}
	}

	var R = [];
	for (i = 0; i < LA; i++) {
		R[i] = 0;
		for (j = 0; j < NN[i]; j++) {
			R[i] = R[i] + trankedArray[i][j];
		}
	}

	var Rn = [];
	for (i = 0; i < LA; i++) {
		Rn[i] = R[i] / NN[i];
		Rn[i] = parseFloat(Rn[i].toFixed(2));
	}

	var RR = 0;
	for (i = 0; i < LA; i++) {
		RR = RR + Math.pow(R[i], 2) / NN[i];
	}

	var H = 12 / (N * (N + 1)) * RR - 3 * (N + 1);

	//同順位があった場合にHを補正
	var Rc = [];
	for (i = 0; i < sortedArray.length; i++) {
		Rc[i] = 0;
		for (j = 0; j < sortedArray.length; j++) {
			if (sortedArray[i] === sortedArray[j]) Rc[i]++;
		}
	}

	for (i = 0; i < sortedArray.length; i++) {
		if (i > 0) {
			if (sortedArray[i] === sortedArray[i - 1]) Rc[i] = 0;
		}
		if (Rc[i] === 1) Rc[i] = 0;
	}

	var rankCountedArray = [];
	rankCountedArray = Rc.filter(function (x) {
		return x !== 0;
	});

	var T = 0;
	for (i = 0; i < rankCountedArray.length; i++) {
		T = T + Math.pow(rankCountedArray[i], 3) - rankCountedArray[i];
	}

	var D = 0;
	D = 1 - T / (Math.pow(N, 3) - N);

	var H_adj = H / D; //補正されたH
	H_adj = parseFloat(H_adj.toFixed(2));

	//自由度
	var DF = LA - 1;
	//カイ二乗分布から確率を求める
	var ppStr = pValue_Match_ChiSquareValue(H_adj, DF);

	strArray.push("[クラスカル・ウォリス検定]\n\n");
	// strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("  A     N      Mean      S.D.       MAX       MIN  平均順位\n");
	strArray.push("-----------------------------------------------------------\n");
	for (i = 0; i < LA; i++) {
		strArray.push(((i + 1).format(" ", 3) + NN[i].format(" ", 6) + M[i].format(" ", 10) + SD[i].format(" ", 10) + MAX[i].format(" ", 10) + MIN[i].format(" ", 10) + Rn[i].format(" ", 10) + "\n"));
	}
	strArray.push("-----------------------------------------------------------\n");
	strArray.push('統計量H = ' + H_adj + '\n');
	strArray.push('df = ' + DF + ' , ' + ppStr + '\n');
	strArray.push("-----------------------------------------------------------\n");

	//多重比較
	// var checkedSD = false;
	var checkedSD = true;
	// checkedSD = document.getElementById("Steel-Dwass").checked;

	//多重比較 Steel-Dwass
	if (checkedSD) {
		if (ppStr != "ns") {
			if (LA > 2) {
				var _addedArray = [];
				var _rankedArray = [];
				var _countedArray = [];
				var _rerankedArray = [];
				var _trankedArray = [[], []];
				var _R = new Array(LA);
				for (i = 0; i < LA; i++) {
					_R[i] = new Array(LA);
					for (j = 0; j < LA; j++) {
						_R[i][j] = new Array(2);
					}
				}
				var _N = new Array(LA);
				for (i = 0; i < LA; i++) {
					_N[i] = new Array(LA);
				}
				var _E = new Array(LA);
				for (i = 0; i < LA; i++) {
					_E[i] = new Array(LA);
				}
				var _V = new Array(LA);
				for (i = 0; i < LA; i++) {
					_V[i] = new Array(LA);
				}
				var _R2 = [];
				var _T = new Array(LA);
				for (i = 0; i < LA; i++) {
					_T[i] = new Array(LA);
				}
				var _Q = 0;
				var MC$ = "";
				var EQ$ = "";

				strArray.push("\n == Multiple Comparisons by Steel-Dwass ==\n\n");
				strArray.push(" (* p<.05)\n");
				strArray.push("-----------------------------------------------------------\n");

				for (i = 0; i < LA - 1; i++) {
					//配列の全データ削除
					_addedArray = [];
					_rankedArray = [];
					_countedArray = [];
					_rerankedArray = [];
					_trankedArray = [[], []];
					_R2 = [];

					for (ii = i + 1; ii < LA; ii++) {
						_addedArray = a[i].concat(a[ii]);

						_sortedArray = _addedArray.sort(compareNumbers);

						for (k = 0; k < _sortedArray.length; k++) {
							_rankedArray[k] = k + 1;
						}

						for (k = 1; k < _sortedArray.length; k++) {
							if (_sortedArray[k] === _sortedArray[k - 1]) {
								_rankedArray[k] = _rankedArray[k - 1];
							}
						}

						for (k = 0; k < _rankedArray.length; k++) {
							_countedArray[k] = 0;
							for (kk = 0; kk < _rankedArray.length; kk++) {
								if (_rankedArray[k] === _rankedArray[kk]) {
									_countedArray[k]++;
								}
							}
						}

						for (k = 0; k < _rankedArray.length; k++) {
							_rerankedArray[k] = (_rankedArray[k] * 2 + _countedArray[k] - 1) / 2;
						}

						for (k = 0; k < _sortedArray.length; k++) {
							for (var j1 = 0; j1 < a[i].length; j1++) {
								if (_sortedArray[k] === a[i][j1]) {
									_trankedArray[0][j1] = _rerankedArray[k];
								}
							}
							for (var j2 = 0; j2 < a[ii].length; j2++) {
								if (_sortedArray[k] === a[ii][j2]) {
									_trankedArray[1][j2] = _rerankedArray[k];
								}
							}
						}

						for (jj = 0; jj < 2; jj++) {
							_R[i][ii][jj] = 0;
							for (k = 0; k < _trankedArray[jj].length; k++) {
								_R[i][ii][jj] = _R[i][ii][jj] + _trankedArray[jj][k];
							}
						}

						_N[i][ii] = 0;
						_N[i][ii] = NN[i] + NN[ii];

						_E[i][ii] = 0;
						_E[i][ii] = NN[i] * (_N[i][ii] + 1) / 2;

						_R2[0] = 0;
						for (k = 0; k < _trankedArray[0].length; k++) {
							_R2[0] = _R2[0] + Math.pow(_trankedArray[0][k], 2);
						}
						_R2[1] = 0;
						for (k = 0; k < _trankedArray[1].length; k++) {
							_R2[1] = _R2[1] + Math.pow(_trankedArray[1][k], 2);
						}

						_V[i][ii] = NN[i] * NN[ii] / (_N[i][ii] * (_N[i][ii] - 1)) * (_R2[0] + _R2[1] - _N[i][ii] * Math.pow(_N[i][ii] + 1, 2) / 4);
						_T[i][ii] = (_R[i][ii][0] - _E[i][ii]) / Math.sqrt(_V[i][ii]);

						console.log(_T[i][ii]);

						_Q = st_qValue(LA, 999) / Math.SQRT2;
						if (Math.abs(_T[i][ii]) > _Q) {
							MC$ = " *  ";
						} else {
							MC$ = "n.s.";
							EQ$ = "=";
						}
						if (MC$ == " *  ") {
							if (Rn[i] > Rn[ii]) {
								EQ$ = ">";
							} else {
								EQ$ = "<";
							}
						}
						strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (T=" + Math.abs(_T[i][ii]).toFixed(3) + ")\n");
					}
				}
				strArray.push("-----------------------------------------------------------\n");
			}
		}
	}
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	//出力
	document.getElementById("RltArea").value += "\n\n" + strArray.join("");

	strArray = null;

	document.getElementById("RltArea").focus();
}
function saveData_As() {
	var i, j;

	var strArray = [];

	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}

	//#0
	strArray.push("As" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#3
	strArray.push("#" + "\n");
	for (i = 0; i < LA; i++) {
		if (i !== LA - 1) {
			strArray.push(NN[i] + ",");
		} else {
			strArray.push(NN[i]);
		}
	}
	strArray.push("\n");
	//#4
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < NN[i]; j++) {
			x = document.getElementById("cell_" + cellId).value;
			strArray.push(x + "\n");
			cellId++;
		}
	}

	var Stream = strArray.join("");
	var fineName = "As_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_As() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "As") {
		var AA = crDel(dd[1]);
		var LA = crDel(dd[2]);

		var nn_text = crDel(dd[3]);
		var NN = [];
		NN = nn_text.split(",");

		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeAsSetting2();
		for (i = 0; i < LA; i++) {
			document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
		}
		changeAsTable();
		document.getElementById("CandPArea").value = delTopCR(dd[4]);
	}
}