
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 4; //群（点）の数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var str = '?var=' + _rnd;
    images[i].src = '../image/point_puma.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

//分散分析のための設定
var AA = 'A';
var LA = 2;
var BB = 'B';
var LB = 2;

var NN = new Array(LA);
for (i = 0; i < LA; i++) {
    NN[i] = new Array(LB);
}

var M = new Array(LA);
for (i = 0; i < LA; i++) {
    M[i] = new Array(LB);
}

var SD = new Array(LA);
for (i = 0; i < LA; i++) {
    SD[i] = new Array(LB);
}

function setData() {
    x = [ox + a * 2, ox + a * 8, ox + a * 2, ox + a * 8];
    y = [oy - a * 4, oy - a * 5, oy - a * 5, oy - a * 6];

    var wN = parseInt(document.getElementById('A1B1_N').value);
    NN[0][0] = wN;
    NN[0][1] = wN;
    NN[1][0] = wN;
    NN[1][1] = wN;

    M[0][0] = parseFloat((oy - y[0]) / a).toFixed(1);
    M[0][1] = parseFloat((oy - y[1]) / a).toFixed(1);
    M[1][0] = parseFloat((oy - y[2]) / a).toFixed(1);
    M[1][1] = parseFloat((oy - y[3]) / a).toFixed(1);

    var wSD = parseFloat(document.getElementById('A1B1_SD').value);
    SD[0][0] = wSD;
    SD[0][1] = wSD;
    SD[1][0] = wSD;
    SD[1][1] = wSD;
}
function DrawAxis() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillText("0", ox - 5, oy + 20);
    ctx.fillText("10", ox - 5, oy - a * 10);
    ctx.fillText("B1", ox + a * 2 + 10, oy + 20);
    ctx.fillText("B2", ox + a * 8 + 10, oy + 20);
}
function DrawLine() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    var wSD = parseFloat(document.getElementById('A1B1_SD').value);
    SD[0][0] = wSD;
    SD[0][1] = wSD;
    SD[1][0] = wSD;
    SD[1][1] = wSD;

    //線グラフを描画
    ctx.lineWidth = 3;
    ctx.strokeStyle = 'rgb(0,175,45)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(x[0], y[0]);
    ctx.lineTo(x[1], y[1]);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(x[2], y[2]);
    ctx.lineTo(x[3], y[3]);
    ctx.stroke();

    //標準偏差を描画
    ctx.lineWidth = 2;
    var temp = 1; //アンテナの上下
    if (y[0] < y[2]) {
        temp = -1;
    }
    ctx.beginPath();
    ctx.moveTo(x[0], y[0]);
    ctx.lineTo(x[0], y[0] + temp * SD[0][0] * a);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(x[0] - 10, y[0] + temp * SD[0][0] * a);
    ctx.lineTo(x[0] + 10, y[0] + temp * SD[0][0] * a);
    ctx.stroke();

    temp = 1;
    if (y[0] > y[2]) {
        temp = -1;
    }
    ctx.beginPath();
    ctx.moveTo(x[2], y[2]);
    ctx.lineTo(x[2], y[2] + temp * SD[1][0] * a);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(x[2] - 10, y[2] + temp * SD[1][0] * a);
    ctx.lineTo(x[2] + 10, y[2] + temp * SD[1][0] * a);
    ctx.stroke();

    temp = 1;
    if (y[1] < y[3]) {
        temp = -1;
    }
    ctx.beginPath();
    ctx.moveTo(x[1], y[1]);
    ctx.lineTo(x[1], y[1] + temp * SD[0][1] * a);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(x[1] - 10, y[1] + temp * SD[0][1] * a);
    ctx.lineTo(x[1] + 10, y[1] + temp * SD[0][1] * a);
    ctx.stroke();

    temp = 1;
    if (y[1] > y[3]) {
        temp = -1;
    }
    ctx.beginPath();
    ctx.moveTo(x[3], y[3]);
    ctx.lineTo(x[3], y[3] + temp * SD[1][1] * a);
    ctx.stroke();
    ctx.beginPath();
    ctx.lineTo(x[3] - 10, y[3] + temp * SD[1][1] * a);
    ctx.lineTo(x[3] + 10, y[3] + temp * SD[1][1] * a);
    ctx.stroke();
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
    }
}
function printData() {
    var wN = parseInt(document.getElementById('A1B1_N').value);

    document.getElementById('A1B2_N').innerHTML = wN;
    document.getElementById('A2B1_N').innerHTML = wN;
    document.getElementById('A2B2_N').innerHTML = wN;

    document.getElementById('A1B1_mean').innerHTML = M[0][0];
    document.getElementById('A1B2_mean').innerHTML = M[0][1];
    document.getElementById('A2B1_mean').innerHTML = M[1][0];
    document.getElementById('A2B2_mean').innerHTML = M[1][1];

    var wSD = parseFloat(document.getElementById('A1B1_SD').value);
    document.getElementById('A1B2_SD').innerHTML = wSD.toFixed(1);
    document.getElementById('A2B1_SD').innerHTML = wSD.toFixed(1);
    document.getElementById('A2B2_SD').innerHTML = wSD.toFixed(1);

}
function mainABs() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    printData();
    s_calc_abs();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
                posY >= images[i].drawOffsetY &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に、ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;


        if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    mx = images[i].drawOffsetX;
                    my = posY - images[i].drawHeight / 2;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            M[0][0] = ((oy - y[0]) / a).toFixed(1);
            M[0][1] = ((oy - y[1]) / a).toFixed(1);
            M[1][0] = ((oy - y[2]) / a).toFixed(1);
            M[1][1] = ((oy - y[3]) / a).toFixed(1);

            DrawAxis();
            DrawLine();
            DrawPoint();
            printData();

            s_calc_abs();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

}
function s_calc_abs() {
    var AAA = [];
    var BBB = [];
    var FFA$ = [];
    var ADA = [];
    var FFB$ = [];
    var BDB = [];

    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var wN = parseInt(document.getElementById('A1B1_N').value);
    NN[0][0] = wN;
    NN[0][1] = wN;
    NN[1][0] = wN;
    NN[1][1] = wN;

    M[0][0] = parseFloat(M[0][0]);
    M[0][1] = parseFloat(M[0][1]);
    M[1][0] = parseFloat(M[1][0]);
    M[1][1] = parseFloat(M[1][1]);

    var wSD = parseFloat(document.getElementById('A1B1_SD').value);
    SD[0][0] = wSD;
    SD[0][1] = wSD;
    SD[1][0] = wSD;
    SD[1][1] = wSD;

    var S = 0;
    var SS = 0;
    var OB = 0;
    var E = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            S = S + 1 / NN[i][j];
            OB = OB + NN[i][j];
            SS = SS + M[i][j];
            E = E + Math.pow(SD[i][j], 2) * NN[i][j];
        }
    }

    var N = LA * LB / S;
    var DH = SS / LA / LB;

    var NhFgag = false;
    var NhCheck = NN[0][0];
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            if (NhCheck != NN[i][j]) {
                NhFgag = true;
            }
        }
    }

    if (NhFgag === true) {
        strArray.push("\nNが不揃いです。\n");
        strArray.push("Unweighted-Mean ANOVAを行います。\n");
        n = using(N, 4, 2);
        strArray.push("Nh=" + n + "(調和平均)と仮定します。\n\n");
    }

    //  主効果検定
    strArray.push(" == Analysis of Variance ==\n\n");
    strArray.push(" A(" + LA + ") = " + AA + "\n");
    strArray.push(" B(" + LB + ") = " + BB + "\n");
    strArray.push(bar);
    strArray.push(" S.V          SS        df       MS        F\n");
    strArray.push(bar);

    var A = 0;
    for (i = 0; i < LA; i++) {
        S = 0;
        for (j = 0; j < LB; j++) {
            S = S + M[i][j];
        }
        A = A + Math.pow((S / LB - DH), 2) * N * LB;
    }

    var B = 0;
    for (j = 0; j < LB; j++) {
        S = 0;
        for (i = 0; i < LA; i++) {
            S = S + M[i][j];
        }
        B = B + Math.pow((S / LA - DH), 2) * N * LA;
    }

    var AB = 0;
    for (i = 0; i < LA; i++) {
        for (j = 0; j < LB; j++) {
            AB = AB + Math.pow((M[i][j] - DH), 2) * N;
        }
    }

    AB = AB - A - B;
    var T = A + B + AB + E;
    var DA = LA - 1;
    var MA = A / DA;
    var DB = LB - 1;
    var MB = B / DB;
    var DI = DA * DB;
    var MI = AB / DI;
    var DE = OB - LA * LB;
    var ME = E / DE;
    var FA = MA / ME;
    var FB = MB / ME;
    var FI = MI / ME;

    var D1 = DA;
    var D2 = DE;
    var Fdata = FA;
    var FA$ = pValue_Match_fRatio(DA, DE, FA);

    var D1 = DI;
    var D2 = DE;
    var Fdata = FI;
    var FI$ = pValue_Match_fRatio(DI, DE, FI);

    var a = using(A, 12, 4);
    var da = using(DA, 4, 0);
    var ma = using(MA, 7, 4);
    var fa = using(FA, 3, 2);

    strArray.push("  A" + a + " " + da + " " + ma + " " + fa + " " + FA$ + "\n");

    D1 = DA;
    if (FI$ != "ns") {
        for (j = 0; j < LB; j++) {
            S = 0;
            SS = 0;
            for (i = 0; i < LA; i++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            A = (SS - Math.pow(S, 2) / LA) * N;
            var FF = A / DA / ME;
            Fdata = FF;
            FFA$[j] = pValue_Match_fRatio(D1, D2, Fdata);
            ADA[j] = A / DA;

            var ss = using(A, 6, 4);
            var df = using(DA, 4, 0);
            var ms = using(ADA[j], 7, 4);
            var ff = using(FF, 3, 2);

            strArray.push("(A at B" + (j + 1) + " " + ss + " " + df + " " + ms + " " + ff + " " + FFA$[j] + ")\n");
        }
        strArray.push(bar);
    }

    // D1 = DB;
    // Fdata = FB;
    var FB$ = pValue_Match_fRatio(DB, DE, FB);

    var b = using(B, 12, 4);
    var db = using(DB, 4, 0);
    var mb = using(MB, 7, 4);
    var fb = using(FB, 3, 2);

    strArray.push("  B" + b + " " + db + " " + mb + " " + fb + " " + FB$ + "\n");

    //単純主効果検定
    if (FI$ != "ns") {
        for (i = 0; i < LA; i++) {
            S = 0;
            SS = 0;
            for (j = 0; j < LB; j++) {
                S += M[i][j];
                SS += Math.pow(M[i][j], 2);
            }
            B = (SS - Math.pow(S, 2) / LB) * N;
            FF = B / DB / ME;
            Fdata = FF;
            FFB$[i] = pValue_Match_fRatio(D1, D2, Fdata);
            BDB[i] = B / DB;

            ss = using(B, 6, 4);
            df = using(DB, 4, 0);
            ms = using(BDB[i], 7, 4);
            ff = using(FF, 3, 2);

            strArray.push("(B at A" + (i + 1) + " " + ss + " " + df + " " + ms + " " + ff + " " + FFB$[i] + ")\n");
        }
        strArray.push(bar);
    }

    var ab = using(AB, 11, 4);
    var di = using(DI, 4, 0);
    var mi = using(MI, 7, 4);
    var fi = using(FI, 3, 2);
    var e = using(E, 10, 4);
    var de = using(DE, 4, 0);
    var me = using(ME, 7, 4);

    strArray.push(" AxB" + ab + " " + di + " " + mi + " " + fi + " " + FI$ + "\n");
    strArray.push(" subj" + e + " " + de + " " + me + "\n");
    strArray.push(bar);

    var t = using(T, 10, 4);
    var DT = OB - 1;
    var dt = using(DT, 4, 0);

    strArray.push("Total" + t + " " + dt);
    strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

    document.getElementById("absDataArea").value = strArray.join("");
    strArray = null;
}