
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 8; //群（点）の数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var str = '?var=' + _rnd;
    images[i].src = '../image/point_puma.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

//分散分析のための設定
var AA = 'A';
var LA = 3;

var NN = new Array(LA);
var NA = new Array(LA);

var M = new Array(LA);

var SD = new Array(LA);

function setData() {
    for (var i = 0; i < PN; i++) {
        x[i] = ox + a * (i + 1.5);
        y[i] = oy - a * Math.floor(Math.random() * (9 - 1) + 1);
    }
}
function DrawAxis() {
    var i = 0;
    var j = 0;
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);

    for (i = 0; i < PN; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * (i + 1.5), oy);
        ctx.lineTo(ox + a * (i + 1.5), oy - a * 10);
        ctx.stroke();
    }

    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    for (j = 0; j < 11; j++) {
        ctx.fillText(j, ox - 5, oy - a * j + 10);
    }

    var name = ["A", "B", "C", "D", "E", "F", "G", "H"];
    for (i = 0; i < PN; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * (i + 1.5), oy);
        ctx.fillText(name[i], ox + a * (i + 1.5) + 5, oy + 20);
    }
}
function DrawLine() {
    var i;
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    var S = 0;
    var tY = 0;
    for (i = 0; i < PN; i++) {
        tY = 10 - Math.floor(y[i] / a);
        S = S + tY;
    }
    var MM = S / PN;

    var SS = 0;
    tY = 0;
    for (i = 0; i < PN; i++) {
        tY = 10 - Math.floor(y[i] / a);
        SS = SS + Math.pow(MM - tY, 2);
    }
    var SSD = Math.sqrt(SS / PN);

    //平均を描画
    ctx.lineWidth = 3;
    ctx.strokeStyle = 'rgb(255,165,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 1, oy);
    ctx.lineTo(ox + a * 1, oy - a * MM);
    ctx.moveTo(ox + a * 1, oy - a * MM);
    ctx.lineTo(ox + a * 9, oy - a * MM);
    ctx.moveTo(ox + a * 9, oy - a * MM);
    ctx.lineTo(ox + a * 9, oy);
    ctx.stroke();

    //標準偏差を描画
    ctx.lineWidth = 2;
    ctx.strokeStyle = 'rgb(255,165,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 4, oy - a * (MM + SSD));
    ctx.lineTo(ox + a * 6, oy - a * (MM + SSD));
    ctx.moveTo(ox + a * 5, oy - a * MM);
    ctx.lineTo(ox + a * 5, oy - a * (MM + SSD));
    ctx.stroke();

    //偏差を描画
    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(0,175,45)';
    ctx.setLineDash([]);
    for (i = 0; i < PN; i++) {
        ctx.beginPath();
        ctx.moveTo(ox + a * (i + 1.5), oy - a * MM);
        ctx.lineTo(ox + a * (i + 1.5), y[i]);
        ctx.stroke();
    }
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
    }
}
function printData() {
    var tY = [];
    for (i = 0; i < PN; i++) {
        tY[i] = 10 - Math.floor(y[i] / a);
    }

    var S = 0;
    for (i = 0; i < PN; i++) {
        S = S + tY[i];
    }
    var MM = S / PN;

    var name = ["A", "B", "C", "D", "E", "F", "G", "H"];
    for (i = 0; i < PN; i++) {
        document.getElementById(name[i] + '_x').innerHTML = tY[i];
        document.getElementById(name[i] + '_S').innerHTML = (tY[i] - MM).toFixed(1);
        document.getElementById(name[i] + '_SS').innerHTML = Math.pow(tY[i] - MM, 2).toFixed(1);
    }
}
function mainMean() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);

    printData();
    s_calc_mean();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
                posY >= images[i].drawOffsetY &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に、ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;


        if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    mx = images[i].drawOffsetX;
                    my = posY - images[i].drawHeight / 2;
                    my = Math.floor((my - 20) / 28) * 28 + 20;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            DrawAxis();
            DrawLine();
            DrawPoint();
            printData();

            s_calc_mean();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

}
function s_calc_mean() {
    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var S = 0;
    var tY = [];
    for (i = 0; i < PN; i++) {
        tY[i] = 10 - Math.floor(y[i] / a);
        S = S + tY[i];
    }
    var MM = S / PN;

    var SS = 0;
    for (i = 0; i < PN; i++) {
        SS = SS + Math.pow(MM - tY[i], 2);
    }
    var SSD = Math.sqrt(SS / PN);

    document.getElementById("result").value = "平均=" + MM.toFixed(2) + "  標準偏差=" + SSD.toFixed(2);
    strArray = null;
}