/**
 * ｔ検定
 * sT(参加者内)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeStSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var result = confirm("データを消去します");
	if (result === true) {
		// sAには要因名があるが，sTにはない
		// document.getElementById("factorA_name").value = "A";

		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("cell_1").focus();
}
// 入力チェック
function checkCellData() {
	var i = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var elmCount = NN * LA;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sT();
			//ノンパラ
			mainCalc_wilcoxon();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sT() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = "A";
	var LA = 2;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var M = []; //平均
	var S2 = []; //分散
	var SD = []; //標準偏差

	var D_M = 0; //水準１と水準２の差の平均
	var D_S2 = 0; //水準１と水準２の差の分散
	var D_SD = 0; //水準１と水準２の差の標準偏差

	var strArray = [];
	var bar = "------------------------------------------------\n";

	//平均・標準偏差
	strArray.push("[ 対応のあるｔ検定(paired t-Test) ]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push(bar);
	strArray.push("          N      Mean      S.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN;
		S2[i] = SS / NN - Math.pow(M[i], 2);
		SD[i] = Math.sqrt(S2[i]);

		M[i] = parseFloat(M[i].toFixed(2));
		S2[i] = parseFloat(S2[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));

		strArray.push(('水準' + (i + 1) + NN.format(" ", 6) + M[i].format(" ", 10) + SD[i].format(" ", 10) + '\n'));
	}


	S = 0;
	for (j = 0; j < NN; j++) {
		S += xx[0][j] - xx[1][j];
	}
	D_M = S / NN;

	var D = 0;
	var DD = 0;
	for (j = 0; j < NN; j++) {
		D = xx[0][j] - xx[1][j];
		DD += Math.pow(D - D_M, 2);
	}
	D_S2 = DD / NN;
	D_SD = Math.sqrt(D_S2);

	D_M = parseFloat(D_M.toFixed(2));
	D_S2 = parseFloat(D_S2.toFixed(2));
	D_SD = parseFloat(D_SD.toFixed(2));

	strArray.push(bar);
	strArray.push((' 差  ' + NN.format(" ", 6) + D_M.format(" ", 10) + D_SD.format(" ", 10) + '\n'));
	strArray.push(bar);

	//自由度
	var DF = NN - 1;
	//T値
	var T = Math.abs(D_M / (D_SD / Math.sqrt(NN - 1)));
	T = parseFloat(T.toFixed(4));
	var PP2 = t_table(DF, T);

	var ppStr = "";
	if (PP2 === 0.01) {
		ppStr = "   ** (p<.01)";
	}
	if (PP2 === 0.05) {
		ppStr = "   *  (p<.05)";
	}
	if (PP2 === 0.10) {
		ppStr = "   +  (.05<p<.10)";
	}
	if (PP2 === 1) {
		ppStr = "   ns (.10<p)";
	}

	strArray.push((' t(' + DF + ')= ' + T + ' , ' + ppStr + '\n'));
	strArray.push(bar);

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("#######　参加者内ｔ検定（対応あり）　#######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ pwr が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		for (i = 0; i < LA; i++) {
			rcmArray.push("g" + (i + 1) + " <- c(");
			for (j = 0; j < NN; j++) {
				rcmArray.push(xx[i][j]);
				if (j < NN - 1) rcmArray.push(", ");
			}
			rcmArray.push(") # 水準" + (i + 1) + "\n");
		}
		rcmArray.push("shinrai=0.95\n");
		rcmArray.push("## js-STARから入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("n1 <- length(g1)       # データ数\n");
		rcmArray.push("n2 <- length(g2)\n");
		rcmArray.push("n  <- n1\n");
		rcmArray.push("hk <- c(mean(g1), mean(g2)) # 平均\n");
		rcmArray.push("sd <- c(  sd(g1),   sd(g2)) # s.d.\n");
		rcmArray.push("mi <- c( min(g1),  min(g2))\n");
		rcmArray.push("ma <- c( max(g1),  max(g2))\n");

		rcmArray.push("\n");
		rcmArray.push("## 作図\n");
		rcmArray.push("levA <- 2                   # 水準数\n");
		rcmArray.push("suij <- rep( 1:2 )          # 水準番号\n");
		rcmArray.push("xjik <- c(1-0.3, levA+0.3)  # ｘ軸の範囲\n");
		rcmArray.push("bai=2                       # ｙ軸の拡幅倍率\n");
		// rcmArray.push("yjik <- c( min(hk)-max(sd)*bai,\n");
		// rcmArray.push("           max(hk)+max(sd)*bai )\n");
		rcmArray.push("shoh <- min(min(hk),0)      # 最小平均か,ゼロ\n");
		rcmArray.push("dais <- max(sd)             # 最大ＳＤ\n");
		rcmArray.push("yjik <-c(shoh+dais*bai*sign(shoh),\n");
		rcmArray.push("         max(hk)+dais*bai) # ｙ軸の範囲\n");
		rcmArray.push("\n");
		rcmArray.push("plot( suij, hk,                    # 描点の座標を指定\n");
		rcmArray.push("      bty=\"l\", xli=xjik, yli=yjik, # 空間枠を設定\n");
		rcmArray.push("      tck=0.03,                    # 目盛りの突起の長さ\n");
		rcmArray.push("      las=1,                       # 目盛りの数字を正立\n");
		rcmArray.push("      xlab=c(\"水準番号\"),\n");
		rcmArray.push("      ylab=c(\"平均\"),\n");
		rcmArray.push("      xaxt=\"n\",                  # ｘ軸のラベルを表示しない\n");
		rcmArray.push("      main=c(\"SD= sqrt ( 全分散／(n-1) )\")\n");
		rcmArray.push("     )\n");

		rcmArray.push("axis(side=1," + spc + "# 軸を描く場所（下）\n");
		rcmArray.push("     at = 1:" + LA + "," + spc + "# 目盛の場所\n");
		rcmArray.push("     labels = c(");
		for (i = 0; i < LA; i++) {
			rcmArray.push("\"水準" + (i + 1) + "\"");
			if (i < LA - 1) rcmArray.push(",");
		}
		rcmArray.push(")," + spc + " # 水準の名前　※ 変更可\n");
		rcmArray.push("    )\n");
		rcmArray.push("\n");

		rcmArray.push("\n");
		rcmArray.push("arrows( suij, hk, suij, hk+sd,   # SDのアンテナを先に描く\n");
		rcmArray.push("        ang=90, le=0.15        ) # 矢羽の角度と長さ\n");
		rcmArray.push("arrows( suij, hk, suij, hk-sd, ang=90, le=0.15 ) # SD下向き\n");
		rcmArray.push("lines ( suij, hk, lwd=2, col=1 ) # 描点を結ぶ（col=黒）\n");
		rcmArray.push("points( suij, hk,\n");
		rcmArray.push("        pch=21, cex=4, bg=1 )    # 描点21番,４倍,内色＝黒\n");

		rcmArray.push("\n");
		rcmArray.push("## 平均とＳＤ\n");
		rcmArray.push("tx0 <- c()\n");
		rcmArray.push("tx0 <- matrix(c(\n");
		rcmArray.push("  n1, n2, n,\n");
		rcmArray.push("  round(hk, 4),round(mean(g1-g2),4),\n");
		rcmArray.push("  round(sd, 4),round(  sd(g1-g2),4),\n");
		rcmArray.push("  round(mi, 4),round( min(g1-g2),4),\n");
		rcmArray.push("  round(ma, 4),round( max(g1-g2),4)\n");
		rcmArray.push("  ), nr=3, by=0)\n");
		rcmArray.push("rownames(tx0) <- c(\n");
		rcmArray.push("  \"水準１\",\n");
		rcmArray.push("  \"水準２\",\n");
		rcmArray.push("  \"　差　\" )\n");
		rcmArray.push("colnames(tx0) <- c(\n");
		rcmArray.push("  \"  Ｎ\",\n");
		rcmArray.push("  \"    Mean\",\n");
		rcmArray.push("  \"      SD\",\n");
		rcmArray.push("  \"    Min.\",\n");
		rcmArray.push("  \"    Max.\" )\n");

		rcmArray.push("\n");
		rcmArray.push("library( pwr ) # パワーアナリシス用\n");

		rcmArray.push("\n");
		rcmArray.push("# ■両側\n");
		rcmArray.push("H1  <- c(\"t\") # 対立仮説\n");
		rcmArray.push("\n");
		rcmArray.push("kr1 <- t.test(\n");
		rcmArray.push("  g1, g2,\n");
		rcmArray.push("  paired=1,     # 対応あり\n");
		rcmArray.push("  conf=shinrai, # 95％信頼水準\n");
		rcmArray.push("  al=H1 )\n");
		rcmArray.push("es  <- kr1$st*sqrt( 1/n ) # ■確認せよ\n");
		rcmArray.push("\n");
		rcmArray.push("kr3 <- NA\n");
		rcmArray.push("kr3 <- c(\n");
		rcmArray.push("  pwr.t.test(al=H1,\n");
		rcmArray.push("  ty=\"p\",\n");
		rcmArray.push("  n =n,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=NULL )$po, # power\n");
		rcmArray.push("  kr3 )\n");
		rcmArray.push("\n");
		rcmArray.push("kr5 <- NA\n");
		rcmArray.push("kr5 <- c(\n");
		rcmArray.push("  pwr.t.test(al=H1,\n");
		rcmArray.push("  ty=\"p\",\n");
		rcmArray.push("  n =n,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=NULL,\n");
		rcmArray.push("  po=0.80 )$si, # sig\n");
		rcmArray.push("  kr5 )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("kr4 <- NA\n");
		rcmArray.push("kr4 <- c(\n");
		rcmArray.push("  pwr.t.test(al=H1,\n");
		rcmArray.push("  ty=\"p\",\n");
		rcmArray.push("  n =NULL,\n");
		rcmArray.push("  d =es,\n");
		rcmArray.push("  si=0.05,\n");
		rcmArray.push("  po=0.80 )$n, # n\n");
		rcmArray.push("  kr4 )\n");
		rcmArray.push("\n");
		rcmArray.push("## 両側の出力用テキスト\n");
		rcmArray.push("tr1 <- c()\n");
		rcmArray.push("tr1 <- matrix(c(\n");
		rcmArray.push("  round(kr1$st,  4),\n");
		rcmArray.push("  round(kr1$pa,  2),\n");
		rcmArray.push("  round(kr1$p.v, 4),\n");
		rcmArray.push("  round(kr3[1], 3)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tr1) <- c(\"対応あり\")\n");
		rcmArray.push("colnames(tr1) <- c(\n");
		rcmArray.push("  \" 　ｔ値\",\n");
		rcmArray.push("  \"　　df\",\n");
		rcmArray.push("  \"　　ｐ値\",\n");
		rcmArray.push("  \"　検出力\")\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 <- c()\n");
		rcmArray.push("tr2 <- matrix(c(\n");
		rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
		rcmArray.push("  round(kr1$conf[c(1,2)],  4)\n");
		rcmArray.push("  ), nr=1, by=1 )\n");
		rcmArray.push("rownames(tr2) <- c(\"平均の差\")\n");
		rcmArray.push("colnames(tr2) <- c(\n");
		rcmArray.push("  \"   点推定\",\n");
		rcmArray.push("  paste(\n");
		rcmArray.push("    \"  \",\n");
		rcmArray.push("    paste(\n");
		rcmArray.push("    shinrai*100,\n");
		rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
		rcmArray.push("  sep=\"\"),\n");
		rcmArray.push("    \"   信頼上限\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tr3 <- matrix(c(    # パワーアナリシス\n");
		rcmArray.push("  round(es,     4),\n");
		rcmArray.push("  round(kr5[1], 4), # si\n");
		rcmArray.push("              0.80,\n");
		rcmArray.push("                 n,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es,     4),\n");
		rcmArray.push("              0.05,\n");
		rcmArray.push("              0.80,\n");
		rcmArray.push("  ceiling(kr4[1] )\n");
		rcmArray.push("  ), nr=2, by=1 )\n");
		rcmArray.push("rownames(tr3) <- c(\n");
		rcmArray.push("  \" α の計算\",\n");
		rcmArray.push("  \" Ｎ の計算\" )\n");
		rcmArray.push("colnames(tr3) <- c(\n");
		rcmArray.push("  \" 効果量dz\",\n");
		rcmArray.push("  \"     α\",\n");
		rcmArray.push("  \" 1-β\",\n");
		rcmArray.push("  \"   Ｎ\" )\n");

		if (M[0] - M[1] > 0) {
			rcmArray.push("\n");
			rcmArray.push("# ■片側Ｇreater\n");
			rcmArray.push("H1  <- c(\"g\") # 対立仮説\n");
			rcmArray.push("\n");
			rcmArray.push("kg1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  paired=1,     # 対応あり\n");
			rcmArray.push("  conf=shinrai, # 95％信頼水準\n");
			rcmArray.push("  al=H1 )\n");
			rcmArray.push("es  <- kg1$st*sqrt( 1/n ) # ■確認せよ\n");
			rcmArray.push("\n");
			rcmArray.push("kg3 <- NA\n");
			rcmArray.push("kg3 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =n,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po, # power\n");
			rcmArray.push("  kg3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kg5 <- NA\n");
			rcmArray.push("kg5 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =n,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si, # sig\n");
			rcmArray.push("  kg5 )\n");
			rcmArray.push("\n");
			rcmArray.push("kg4 <- NA\n");
			rcmArray.push("kg4 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n, # n\n");
			rcmArray.push("  kg4 )\n");
			rcmArray.push("\n");
			rcmArray.push("## 片側Ｇ出力用\n");
			rcmArray.push("tg1 <- c()\n");
			rcmArray.push("tg1 <- matrix(c(\n");
			rcmArray.push("  round(kg1$st,  4),\n");
			rcmArray.push("  round(kg1$pa,  2),\n");
			rcmArray.push("  round(kg1$p.v, 4),\n");
			rcmArray.push("  round(kg3[1], 3)\n");
			rcmArray.push("  ), nr=1)\n");
			rcmArray.push("rownames(tg1) <- c(\"対応あり\")\n");
			rcmArray.push("colnames(tg1) <- c(\n");
			rcmArray.push("  \" 　ｔ値\",\n");
			rcmArray.push("  \"　　df\",\n");
			rcmArray.push("  \"　　ｐ値\",\n");
			rcmArray.push("  \"　検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tg2 <- c()\n");
			rcmArray.push("tg2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kg1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1 )\n");
			rcmArray.push("rownames(tg2) <- c(\"平均の差\")\n");
			rcmArray.push("colnames(tg2) <- c(\n");
			rcmArray.push("  \"   点推定\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("    \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("tg3 <- matrix(c(    # パワーアナリシス\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("  round(kg5[1], 4), # si\n");
			rcmArray.push("              0.80,\n");
			rcmArray.push("                 n,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("              0.05,\n");
			rcmArray.push("              0.80,\n");
			rcmArray.push("  ceiling(kg4[1] )\n");
			rcmArray.push("  ), nr=2, by=1 )\n");
			rcmArray.push("rownames(tg3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" Ｎ の計算\" )\n");
			rcmArray.push("colnames(tg3) <- c(\n");
			rcmArray.push("  \" 効果量dz\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   Ｎ\" )\n");
		}

		if (M[0] - M[1] < 0) {
			rcmArray.push("\n");
			rcmArray.push("# ■片側Ｌess\n");
			rcmArray.push("H1  <- c(\"l\") # 対立仮説\n");
			rcmArray.push("\n");
			rcmArray.push("kl1 <- t.test(\n");
			rcmArray.push("  g1, g2,\n");
			rcmArray.push("  paired=1,     # 対応あり\n");
			rcmArray.push("  conf=shinrai, # 95％信頼水準\n");
			rcmArray.push("  al=H1 )\n");
			rcmArray.push("es  <- kl1$st*sqrt( 1/n ) # ■確認せよ\n");
			rcmArray.push("\n");
			rcmArray.push("kl3 <- NA\n");
			rcmArray.push("kl3 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =n,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=NULL )$po, # power\n");
			rcmArray.push("  kl3 )\n");
			rcmArray.push("\n");
			rcmArray.push("kl5 <- NA\n");
			rcmArray.push("kl5 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =n,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=NULL,\n");
			rcmArray.push("  po=0.80 )$si, # sig\n");
			rcmArray.push("  kl5 )\n");
			rcmArray.push("\n");
			rcmArray.push("kl4 <- NA\n");
			rcmArray.push("kl4 <- c(\n");
			rcmArray.push("  pwr.t.test(al=H1,\n");
			rcmArray.push("  ty=\"p\",\n");
			rcmArray.push("  n =NULL,\n");
			rcmArray.push("  d =es,\n");
			rcmArray.push("  si=0.05,\n");
			rcmArray.push("  po=0.80 )$n, # n\n");
			rcmArray.push("  kl4 )\n");
			rcmArray.push("\n");
			rcmArray.push("# 片側Ｌ出力用\n");
			rcmArray.push("tl1 <- c()\n");
			rcmArray.push("tl1 <- matrix(c(\n");
			rcmArray.push("  round(kl1$st,  4),\n");
			rcmArray.push("  round(kl1$pa,  2),\n");
			rcmArray.push("  round(kl1$p.v, 4),\n");
			rcmArray.push("  round(kl3[1], 3)\n");
			rcmArray.push("  ), nr=1)\n");
			rcmArray.push("rownames(tl1) <- c(\"対応あり\")\n");
			rcmArray.push("colnames(tl1) <- c(\n");
			rcmArray.push("  \" 　ｔ値\",\n");
			rcmArray.push("  \"　　df\",\n");
			rcmArray.push("  \"　　ｐ値\",\n");
			rcmArray.push("  \"　検出力\")\n");
			rcmArray.push("\n");
			rcmArray.push("tl2 <- c()\n");
			rcmArray.push("tl2 <- matrix(c(\n");
			rcmArray.push("  round(mean(g1)-mean(g2), 4),\n");
			rcmArray.push("  round(kl1$conf[c(1,2)],  4)\n");
			rcmArray.push("  ), nr=1, by=1 )\n");
			rcmArray.push("rownames(tl2) <- c(\"平均の差\")\n");
			rcmArray.push("colnames(tl2) <- c(\n");
			rcmArray.push("  \"   点推定\",\n");
			rcmArray.push("  paste(\n");
			rcmArray.push("    \"  \",\n");
			rcmArray.push("    paste(\n");
			rcmArray.push("    shinrai*100,\n");
			rcmArray.push("    \"％信頼下限\", sep=\"\"),\n");
			rcmArray.push("  sep=\"\"),\n");
			rcmArray.push("    \"   信頼上限\" )\n");
			rcmArray.push("\n");
			rcmArray.push("tl3 <- matrix(c(    # パワーアナリシス\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("  round(kl5[1], 4), # si\n");
			rcmArray.push("              0.80,\n");
			rcmArray.push("                 n,\n");
			rcmArray.push("\n");
			rcmArray.push("  round(es,     4),\n");
			rcmArray.push("              0.05,\n");
			rcmArray.push("              0.80,\n");
			rcmArray.push("  ceiling(kl4[1] )\n");
			rcmArray.push("  ), nr=2, by=1 )\n");
			rcmArray.push("rownames(tl3) <- c(\n");
			rcmArray.push("  \" α の計算\",\n");
			rcmArray.push("  \" Ｎ の計算\" )\n");
			rcmArray.push("colnames(tl3) <- c(\n");
			rcmArray.push("  \" 効果量dz\",\n");
			rcmArray.push("  \"     α\",\n");
			rcmArray.push("  \" 1-β\",\n");
			rcmArray.push("  \"   Ｎ\" )\n");
		}

		if (M[0] - M[1] > 0) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=5)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("###################################\n");
			rcmArray.push("# ２平均の有意差検定              #\n");
			rcmArray.push("# 　参加者内ｔ検定（片側 greater）#\n");
			rcmArray.push("# 　対立仮説：平均1－平均2＞０    #\n");
			rcmArray.push("###################################\n");
			rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
			rcmArray.push("\n");
			rcmArray.push("tg1 # ｔ検定（paired t-test）\n");
			rcmArray.push("    #  p<α なら「真の平均差＞０」\n");
			rcmArray.push("\n");
			rcmArray.push("tg2 # 平均の差の点推定と区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("tg3 # パワーアナリシス\n");
			rcmArray.push("# 効果量dz＝ 平均の差／差のSD\n");
			rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		}

		if (M[0] - M[1] < 0) {
			rcmArray.push("\n");
			rcmArray.push("options(digits=5)\n");
			rcmArray.push("options(scipen=5)\n");
			rcmArray.push("################################\n");
			rcmArray.push("# ２平均の有意差検定           #\n");
			rcmArray.push("# 　参加者内ｔ検定（片側 less）#\n");
			rcmArray.push("# 　対立仮説：平均1－平均2＜０ #\n");
			rcmArray.push("################################\n");
			rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
			rcmArray.push("\n");
			rcmArray.push("tl1 # ｔ検定（paired t-test）\n");
			rcmArray.push("    #  p<α なら「真の平均差＜０」\n");
			rcmArray.push("\n");
			rcmArray.push("tl2 # 平均の差の点推定と区間推定\n");
			rcmArray.push("\n");
			rcmArray.push("tl3 # パワーアナリシス\n");
			rcmArray.push("# 効果量dz＝ 平均の差／差のSD\n");
			rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		}

		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("################################\n");
		rcmArray.push("# ２平均の有意差検定           #\n");
		rcmArray.push("# 　参加者内ｔ検定（両側）     #\n");
		rcmArray.push("# 　対立仮説：平均1－平均2≠０ #\n");
		rcmArray.push("################################\n");
		rcmArray.push("tx0 # 基本統計量　※SDは不偏分散の平方根\n");
		rcmArray.push("\n");
		rcmArray.push("tr1 # ｔ検定（paired t-test）\n");
		rcmArray.push("    #  p<α なら「真の平均差≠０」\n");
		rcmArray.push("\n");
		rcmArray.push("tr2 # 平均の差の点推定と区間推定\n");
		rcmArray.push("\n");
		rcmArray.push("tr3 # パワーアナリシス\n");
		rcmArray.push("# 効果量dz＝ 平均の差／差のSD\n");
		rcmArray.push("# ■ NULL, NA が表示されたときは計算不能■\n");
		rcmArray.push("\n");
		rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# windows();boxplot(g1,g2,las=1) # 箱ひげ図\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (i = 0; i < LA; i++) {
			data[i] = parseFloat(M[i].toFixed(1), 10);
		}

		var max_y = M[0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			if (max_y < M[i]) max_y = parseFloat(M[i].toFixed(1), 10);
			if (min_y > M[i]) min_y = parseFloat(M[i].toFixed(1), 10);
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var datasetKey = [];
		for (i = 0; i < 2; i++) {
			datasetKey[i] = [];
		}

		// 複合グラフを作成する
		// 棒グラフ
		datasetKey[0].label = ''; //ラベルを空白にする

		// 折れ線グラフ
		datasetKey[1].label = '水準';
		datasetKey[1].data = data;
		datasetKey[1].backgroundColor = chartClrAry[0];
		datasetKey[1].borderColor = chartClrAry[0];
		datasetKey[1].pointBorderWidth = 3;
		datasetKey[1].borderWidth = 1;
		datasetKey[1].lineTension = 0;
		datasetKey[1].type = 'line'; //折れ線グラフを指定

		var labelData = [];
		for (i = 0; i < LA; i++) {
			labelData.push('水準' + (i + 1));
		}

		var datasetData = [];
		for (i = 0; i < 2; i++) {
			datasetData[i] = datasetKey[i];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];
		for (i = 0; i < LA; i++) {
			arrayCol = [];
			for (j = 0; j < NN; j++) {
				arrayCol.push(xx[i][j]);
			}
			myData.push(arrayCol);
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		var boxplotData = {
			labels: labelData,
			datasets: [{
				label: 'A',
				backgroundColor: chartClrAry[0] + '33',
				borderColor: chartClrAry[0],
				borderWidth: 1,
				padding: 10,
				outlierRadius: 3,
				itemRadius: 3,
				outlierColor: '#999999',
				data: myData
			}]
		};

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: boxplotData,
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RcmArea").focus();
}

function changeStSetting() {
	var h = 3;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");
	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeStTable();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		// htmArray.push("<select id=\"subjNum\" name=\"j\" class=\"tySelect\" size=\"1\" onfocus=\"setSelectNum(0);\" onchange=\"addSelectItem5(this,'参加者数');changeStTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 3; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">水準数：</td>");
	htmArray.push("<td class=\"codetbR\">2</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("st_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeStTable();
}
function changeStTable() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var cellId = 1;
	var cellCount = NN * LA;

	var htmArray = [];

	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("水準" + (i + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (j = 0; j < NN; j++) {
		htmArray.push("<tr>");
		if (j === 0) {
			htmArray.push("<td class=\"hyou_midashi_3d_top\">");
		} else {
			htmArray.push("<td class=\"hyou_midashi_3d\">");
		}
		htmArray.push(j + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");
	// htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("st_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
// Wilcoxon検定
function mainCalc_wilcoxon() {
	var i = 0;
	var j = 0;

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var AA = "A";
	var LA = 2;

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(NN);
	}

	var a = [[], []];
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
			a[i].push(xx[i][j]);
		}
	}

	//平均，標準偏差  ＃＃現在は出力してはいない
	var M = [];
	var SD = [];

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);
		}
		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		M[i] = parseFloat(M[i].toFixed(2));
		SD[i] = parseFloat(SD[i].toFixed(2));
	}

	//最大値，最小値
	var MAX = [];
	var MIN = [];
	for (i = 0; i < LA; i++) {
		MAX[i] = xx[i][0];
		MIN[i] = xx[i][0];
		for (j = 0; j < NN; j++) {
			if (MAX[i] < xx[i][j]) MAX[i] = xx[i][j];
			if (MIN[i] > xx[i][j]) MIN[i] = xx[i][j];
		}
	}

	var N = 0;
	N = a[0].length;

	var addedArray = a[0].concat(a[1]);

	var diffencedArray = [];
	var diffencedArray2 = [];

	for (i = 0; i < N; i++) {
		diffencedArray.push(a[0][i] - a[1][i]);
	}

	diffencedArray2 = diffencedArray.filter(function (x) {
		if (x !== 0) {
			return true;
		}
	});

	// 差が0を除いたデータ数
	var wN = diffencedArray2.length;

	var diffencedArray3 = diffencedArray2.map(function (x) {
		return Math.abs(x);
	});

	var sortedArray = diffencedArray3.sort(compareNumbers);

	var rankedArray = [];
	for (i = 0; i < sortedArray.length; i++) {
		rankedArray[i] = i + 1;
	}

	for (i = 1; i < sortedArray.length; i++) {
		if (sortedArray[i] === sortedArray[i - 1]) {
			rankedArray[i] = rankedArray[i - 1];
		}
	}

	var countedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		countedArray[i] = 0;
		for (j = 0; j < rankedArray.length; j++) {
			if (rankedArray[i] === rankedArray[j]) {
				countedArray[i]++;
			}
		}
	}

	var rerankedArray = [];
	for (i = 0; i < rankedArray.length; i++) {
		rerankedArray[i] = (rankedArray[i] * 2 + countedArray[i] - 1) / 2;
	}

	var signrankedArray = [];
	for (j = 0; j < diffencedArray2.length; j++) {
		for (i = 0; i < sortedArray.length; i++) {
			if (sortedArray[i] == Math.abs(diffencedArray2[j])) {
				signrankedArray[j] = rerankedArray[i];
			}
		}
	}

	var signrankedArray2 = [[], []];
	for (i = 0; i < diffencedArray2.length; i++) {
		if (diffencedArray2[i] > 0) {
			signrankedArray2[0].push(signrankedArray[i]);
		} else {
			signrankedArray2[1].push(signrankedArray[i]);
		}
	}

	var T1 = 0;
	var T2 = 0;
	for (i = 0; i < signrankedArray2[0].length; i++) {
		T1 = T1 + signrankedArray2[0][i];
	}
	for (i = 0; i < signrankedArray2[1].length; i++) {
		T2 = T2 + signrankedArray2[1][i];
	}

	var T = T1;
	if (T1 > T2) T = T2;

	var wM = wN * (wN + 1) / 4;
	var wSD = Math.sqrt(wN * (wN + 1) * (2 * wN + 1) / 24);
	wSD = parseFloat(wSD.toFixed(2));

	var z = Math.abs((T - wM) / wSD);
	z = Math.floor((z * 100)) / 100;

	var strArray = [];
	strArray.push("[ウィルコクソン符号順位検定]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("           N      Mean      S.D.       MAX       MIN\n");
	strArray.push("------------------------------------------------------\n");
	strArray.push(('水準１' + wN.format(" ", 6) + M[0].format(" ", 10) + SD[0].format(" ", 10) + MAX[0].format(" ", 10) + MIN[0].format(" ", 10) + "\n"));
	strArray.push(('水準２' + wN.format(" ", 6) + M[1].format(" ", 10) + SD[1].format(" ", 10) + MAX[1].format(" ", 10) + MIN[1].format(" ", 10) + "\n"));
	strArray.push("------------------------------------------------------\n\n");

	var ppStr = "";
	var PP2 = 0;

	strArray.push('データ数（差≠0）：' + wN.format(" ", 5) + '\n');
	strArray.push("-----------------------------------------\n");
	strArray.push('順位和（+）：' + T1.format(" ", 11) + '\n');
	strArray.push('順位和（-）：' + T2.format(" ", 11) + '\n');
	strArray.push('順位和：' + T.format(" ", 16) + '\n');
	strArray.push("-----------------------------------------\n");

	if (wN <= 25) {
		PP2 = W_tables(wN, T);
		if (PP2 === 9) {
			strArray.push("データ数が少ないため，計算できません\n");
		} else {
			if (PP2 === 0.01) {
				ppStr = "   ** (p<.01)";
			}
			if (PP2 === 0.05) {
				ppStr = "   *  (p<.05)";
			}
			if (PP2 === 1) {
				ppStr = "   ns (.10<p)";
			}
			strArray.push("両側検定  :" + ppStr + "\n");
		}

	} else {
		strArray.push('平均値：' + wM.format(" ", 15) + '\n');
		strArray.push('標準偏差：' + wSD.format(" ", 13) + '\n');
		strArray.push('統計量ｚ：' + z.format(" ", 13) + '\n');
		strArray.push("-----------------------------------------\n");

		PP2 = z_tables(z);
		if (PP2 < 0.01) {
			ppStr = "   ** (p<.01)";
		} else if (PP2 < 0.05) {
			ppStr = "   *  (p<.05)";
		} else if (PP2 < 0.10) {
			ppStr = "   +  (.05<p<.10)";
		} else {
			ppStr = "   ns (.10<p)";
		}
		strArray.push("両側検定  :  p=" + PP2.toFixed(4) + ppStr + "\n");
	}

	strArray.push("-----------------------------------------\n");
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/");

	// //出力
	document.getElementById("RltArea").value += strArray.join("");

	strArray = null;

	document.getElementById("RltArea").focus();
}
function saveData_sT() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = parseInt(document.getElementById("cell_" + cellId).value);
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sT_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function saveData_sT() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = 2;

	//#0
	strArray.push("sT" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");
	//#2
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA - 1) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "sT_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_sT() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "sT") {
		var NN = crDel(dd[1]);

		document.getElementById("subjNum").value = parseInt(NN, 10);
		changeStTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}
