/**
 * ユーティリティ
 * 単独集計
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得

		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}
		if (KK < 2) {
			err = true;
			alert("列数が２未満です");
		}

		if (err == false) {
			mainCalc_questionnaire();
		}
	}
}
function mainCalc_questionnaire() {
	var i = 0;
	var j = 0;

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseInt(dd[ddCount], 10);
			ddCount++;
		}
	}

	//各項目（列）の度数（0-9,10以上の数,エラーの数の全12種類）
	var counter = new Array(KK);
	for (j = 0; j < KK; j++) {
		counter[j] = new Array(12);
	}

	N = new Array(KK); //各項目の回答数
	M = new Array(KK);
	SD = new Array(KK);

	for (j = 0; j < KK; j++) {
		N[j] = 0;
	}

	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			if (isNaN(xx[i][j]) || (parseInt(xx[i][j], 10) < 0)) {
				//数字でない または 0より小さい場合は何もしない
			} else { //9より大きい値でも,最初はそのままの値を保持する（平均や分散の計算のため）
				xx[i][j] = parseInt(xx[i][j], 10);
				N[j]++;
			}
		}
	}

	var S = 0;
	var SS = 0;
	for (j = 0; j < KK; j++) {
		S = 0;
		SS = 0;
		for (i = 0; i < NN; i++) {
			if (isNaN(xx[i][j]) || (parseInt(xx[i][j], 10) < 0)) {
				//数字でない または 0より小さい場合は何もしない
			} else {
				S += xx[i][j];
				SS += Math.pow(xx[i][j], 2);
			}
		}
		M[j] = S / N[j];
		SD[j] = Math.sqrt(SS / N[j] - Math.pow(M[j], 2));
	}

	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			if (isNaN(xx[i][j]) || (parseInt(xx[i][j], 10) < 0)) { //数字でない または 0より小さい場合
				xx[i][j] = 11; //欠損値として処理
			} else {
				if (parseInt(xx[i][j], 10) > 9) { //9より大きい場合
					xx[i][j] = 10; //9より大きい値として処理
				} else { //0～9までの場合
					xx[i][j] = parseInt(xx[i][j], 10);
				}
			}
		}
	}

	for (j = 0; j < KK; j++) {
		for (k = 0; k < 12; k++) {
			counter[j][k] = 0;
		}
	}

	for (j = 0; j < KK; j++) {
		for (i = 0; i < NN; i++) {
			counter[j][xx[i][j]]++;
		}
	}

	var str = "table#：全体集計\n";
	var bar = "------------------------------------------------------\n";
	str += "回答：\t";

	for (h = 0; h < 10; h++) {
		str += h + "\t";
	}
	str += "10以上\tE\tN\tMean\tS.D.\n";

	str += bar;
	for (j = 0; j < KK; j++) {
		str += "項目" + (j + 1) + "：\t";
		for (k = 0; k < 12; k++) {
			str += counter[j][k] + "\t";
		}
		str += N[j] + "\t" + M[j].toFixed(4) + "\t" + SD[j].toFixed(4) + "\n";
	}
	str += bar;

	for (j = 0; j < KK; j++) {
		str += "\ntable#：項目" + (j + 1) + "\n";
		str += bar;
		str += "回答：\t";

		for (h = 0; h < 10; h++) {
			str += h + "\t";
		}
		str += "10以上\tE\tN\tMean\tS.D.\n";

		str += bar;
		str += "度数：\t";
		for (k = 0; k < 12; k++) {
			str += counter[j][k] + "\t";
		}
		str += N[j] + "\t" + M[j].toFixed(4) + "\t" + SD[j].toFixed(4) + "\n";
		str += "\n";
	}

	str += "\n _/_/_/ Analyzed by js-STAR _/_/_/\n";
	document.getElementById("RltArea").value = str;
}

