/**
 * 度数の検定
 * ｉ×ｊ×ｋ表(モデル選択)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	change3dSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var elmCount = iCount * jCount * kCount;

	var result = confirm("データを消去します");
	if (result === true) {
		for (var i = 1; i < elmCount + 1; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	// setFocus(0);
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	if (dd.length > iCount * jCount * kCount) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;
	var k = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 3 !== 0) {
	// 	err = true;
	// }

	if (NN === 3) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i = i + 3) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < iCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 1]) > 0) && (parseInt(dd[i + 1]) < jCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 2]) > 0) && (parseInt(dd[i + 2]) < kCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var gunAtai = new Array(iCount);
			for (i = 0; i < iCount; i++) {
				gunAtai[i] = new Array(jCount);
				for (j = 0; j < jCount; j++) {
					gunAtai[i][j] = new Array(kCount);
				}
			}

			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						gunAtai[i][j][k] = 0;
					}
				}
			}

			for (i = 0; i < dd.length; i = i + 3) {
				gunAtai[dd[i] - 1][dd[i + 1] - 1][dd[i + 2] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						strArray.push(gunAtai[i][j][k]);
						strArray.push("\t");
					}
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = '';
		alert("データ形式が正しくありません。");
	}
}
// 入力チェック
function checkCellData() {
	var i = 1;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var elmCount = iCount * jCount * kCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i < elmCount + 1; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_3d();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));

		if (isNaN(dd[elmCount - 1])) {
			alert("データを確認してください");
		} else {
			mainCalc_3d();
		}
	}
}
// メイン計算
function mainCalc_3d() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var h = 0;

	var ii = 0;
	var jj = 0;

	var TType = "kai";
	var TT = 1;
	var YY = 2;
	var NN;

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var hCount;
	var elmCount = iCount * jCount * kCount;
	var kaiData = [];

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];

	var wData = new Array(iCount);
	for (i = 0; i < iCount; i++) {
		wData[i] = new Array(jCount);
		for (j = 0; j < jCount; j++) {
			wData[i][j] = new Array(kCount);
		}
	}

	if (document.getElementById("CandPArea").value === "") {
		var cellId = 1;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					wData[i][j][k] = parseInt(document.getElementById("cell_" + cellId).value);
					cellId++;
				}
			}
		}
	} else {
		var DData = document.getElementById("CandPArea").value;
		var dd = [];
		dd = DData.split(" ");

		var idata = 0;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					wData[i][j][k] = parseInt(dd[idata]);
					idata++;
				}
			}
		}
	} // セルとテキストエリアの分岐終了

	// ixjxk();
	// var checked_ixj = document.getElementById("ixj").checked;
	// var checked_jxk = document.getElementById("jxk").checked;
	// var checked_ixk = document.getElementById("ixk").checked;

	//ixj
	// if (checked_ixj) {
	// 	for (k = 0; k < kCount; k++) {
	// 		var wkai = [];

	// 		wkai.push("kai\n ");
	// 		wkai.push(iCount + "\n ");
	// 		wkai.push(jCount + "\n");

	// 		for (i = 0; i < iCount; i++) {
	// 			for (j = 0; j < jCount; j++) {
	// 				wkai.push(" " + wData[i][j][k]);
	// 			}
	// 			wkai.push("\n");
	// 		}
	// 		kaiData[k] = wkai.join("");
	// 		wkai = null;
	// 	}
	// 	hCount = kCount;
	// }

	//jxk
	// if (checked_jxk) {
	for (i = 0; i < iCount; i++) {
		var wkai = [];

		wkai.push("kai\n ");
		wkai.push(jCount + "\n ");
		wkai.push(kCount + "\n");

		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				wkai.push(" " + wData[i][j][k]);
			}
			wkai.push("\n");
		}
		kaiData[i] = wkai.join("");
		wkai = null;
	}
	hCount = iCount;
	// }

	//ixk
	// if (checked_ixk) {
	// 	for (j = 0; j < jCount; j++) {
	// 		var wkai = [];

	// 		wkai.push("kai\n ");
	// 		wkai.push(iCount + "\n ");
	// 		wkai.push(kCount + "\n");

	// 		for (i = 0; i < iCount; i++) {
	// 			for (k = 0; k < kCount; k++) {
	// 				wkai.push(" " + wData[i][j][k]);
	// 			}
	// 			wkai.push("\n");
	// 		}
	// 		kaiData[j] = wkai.join("");
	// 		wkai = null;
	// 	}
	// 	hCount = jCount;
	// }


	// var strArray = [];
	// strArray.push("「カイニ乗検定の結果」\n（上段実測値,下段期待値）\n");
	for (h = 0; h < hCount; h++) {
		var N = 0;
		var DF = 0;

		var dd = [];
		var DData = kaiData[h];
		dd = DData.split(" ");

		TType = dd[0];
		TT = parseInt(dd[1], 10);
		YY = parseInt(dd[2], 10);
		NN = TT * YY;

		var xx = new Array(TT);
		for (i = 0; i < TT; i++) {
			xx[i] = new Array(YY);
		}

		var cellId = 1;
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				xx[i][j] = parseInt(dd[cellId + 2]);
				cellId++;
			}
		}

		var N = 0; //度数の総合計
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				N += xx[i][j];
			}
		}

		var T = new Array(YY); //列の合計
		var Y = new Array(TT); //行の合計
		for (i = 0; i < TT; i++) {
			Y[i] = 0;
			for (j = 0; j < YY; j++) {
				Y[i] += xx[i][j];
			}
		}
		for (j = 0; j < YY; j++) {
			T[j] = 0;
			for (i = 0; i < TT; i++) {
				T[j] += xx[i][j];
			}
		}

		var MC$;
		var EQ$;

		var x2 = 0;
		var DF = 0;
		var MA;
		var PHI;

		var E = new Array(TT);
		for (i = 0; i < TT; i++) {
			E[i] = new Array(YY);
		}
		var Z = new Array(TT);
		for (i = 0; i < TT; i++) {
			Z[i] = new Array(YY);
		}

		if (TT == 1) {
			for (j = 0; j < YY; j++) {
				E[0][j] = N / YY;
				x2 += Math.pow(xx[0][j] - E[0][j], 2) / E[0][j];
			}
			DF = YY - 1;
		} else {
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					E[i][j] = Y[i] * T[j] / N;
					x2 += Math.pow(xx[i][j] - E[i][j], 2) / E[i][j];
				}
			}

			//２ｘ２とのき,イェーツの補正
			if ((TT == 2) && (YY == 2)) {
				x2 = N * Math.pow(Math.abs(xx[0][0] * xx[1][1] - xx[0][1] * xx[1][0]) - N / 2, 2) / (T[0] * T[1] * Y[0] * Y[1]);
			}

			DF = (TT - 1) * (YY - 1);

			MA = TT - 1;
			if (MA > YY - 1) MA = YY - 1;

			PHI = Math.sqrt(x2 / N / MA);
		}

		var loopStr = "i=";
		// if (checked_ixj) loopStr = "k=";
		// if (checked_jxk) loopStr = "i=";
		// if (checked_ixk) loopStr = "j=";

		strArray.push("\n# " + loopStr + (h + 1) + "\n\n");
		// strArray.push("「カイ二乗検定の結果」\n（上段実測値,下段期待値）\n");
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				strArray.push("--------");
			}
			strArray.push("\n");

			for (j = 0; j < YY; j++) {
				strArray.push(xx[i][j] + "\t\t");
			}
			strArray.push("\n");
			for (j = 0; j < YY; j++) {
				strArray.push(using(E[i][j], 3, 3) + "\t");
			}
			strArray.push("\n");
		}

		var ppStr = pValue_Match_ChiSquareValue(x2, DF);

		strArray.push("\n");
		strArray.push("x2(" + DF + ")=" + using(x2, 4, 3) + "   ,  " + ppStr);

		strArray.push("\n");
		if (TT > 1) {
			if ((TT == 2) && (YY == 2)) {
				strArray.push("Phi = " + PHI.toFixed(3));
			} else {
				strArray.push("Cramer\'s V = " + PHI.toFixed(3));
			}
		}

		var MC1 = new Array(TT);
		for (i = 0; i < TT; i++) {
			MC1[i] = new Array(YY);
		}
		var MC2 = new Array(TT);
		for (i = 0; i < TT; i++) {
			MC2[i] = new Array(YY);
		}

		strArray.push("\n");
		if (ppStr != "ns") {
			if (TT == 1) {
				if (YY > 2) {
					strArray.push("==ライアンの名義水準を用いた多重比較==\n");
					strArray.push("  (有意水準 alpha = 0.05 とします)\n");
					strArray.push("----------------------------------------------------\n");
					strArray.push("セル比較\t臨界比\t\t検定\t\t名義水準\n");
					strArray.push("----------------------------------------------------\n");

					for (j = 0; j < YY; j++) {
						for (jj = j + 1; jj < YY; jj++) {
							CN = 0;
							for (l = 0; l < YY; l++) {
								if ((l == j) || (l == jj)) {
									CN = CN + 1;
								} else {
									if ((xx[0][j] > xx[0][l]) && (xx[0][jj] <= xx[0][l])) {
										CN = CN + 1;
									}
									if ((xx[0][j] < xx[0][l]) && (xx[0][jj] >= xx[0][l])) {
										CN = CN + 1;
									}
								}
							}
							NL = 0.1 / (YY * (CN - 1));
							CR = (Math.abs(xx[0][j] - xx[0][jj]) - 1) / Math.sqrt(xx[0][j] + xx[0][jj]);
							if (CR < 1.96) {
								MC$ = "ns  p>.05    ";
								EQ$ = "=";
							} else {
								if (CR > 3.62) {
									MC$ = "*   p<0.0002";
									if (xx[0][j] > xx[0][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									var wP = pValue_to_alphaDash(CR);
									if (wP >= NL) {
										// MC$ = "ns  p="+P[count];
										MC$ = "ns  p=" + wP;
										EQ$ = "=";
									}
									if (wP < NL) {
										MC$ = "*   p=" + wP;
										if (xx[0][j] > xx[0][jj]) {
											EQ$ = ">";
										} else {
											EQ$ = "<";
										}
									}
								}
							}
							strArray.push((j + 1) + " " + EQ$ + " " + (jj + 1) + " \t" + using(CR, 2, 2) + " \t" + MC$ + " \t" + using(NL, 1, 5) + "\n");
						}
					}
					strArray.push("----------------------------------------------------\n");
				}
			} else {
				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						Z[i][j] = (xx[i][j] - E[i][j]) / Math.sqrt(E[i][j]) / Math.sqrt((1 - Y[i] / N) * (1 - T[j] / N));

						if (Math.abs(Z[i][j]) > 2.5758) {
							MC1[i][j] = "  **  ";
							if (Z[i][j] > 0) {
								MC2[i][j] = "▲";
							} else {
								MC2[i][j] = "▽";
							}
						} else if (Math.abs(Z[i][j]) > 1.96) {
							MC1[i][j] = "   *  ";
							if (Z[i][j] > 0) {
								MC2[i][j] = "▲";
							} else {
								MC2[i][j] = "▽";
							}
						} else if (Math.abs(Z[i][j]) > 1.6449) {
							MC1[i][j] = "   +  ";
							MC2[i][j] = " ";
						} else {
							MC1[i][j] = "  ns  ";
							MC2[i][j] = " ";
						}
					}
				}

				strArray.push("\n");
				strArray.push("「 残差分析の結果 」\n（上段調整された残差,下段検定結果）\n");
				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						strArray.push("--------");
					}
					strArray.push("\n");
					for (j = 0; j < YY; j++) {
						strArray.push(using(Z[i][j], 3, 3) + "\t");
					}
					strArray.push("\n");
					for (j = 0; j < YY; j++) {
						strArray.push(MC1[i][j] + "\t");
					}
					strArray.push("\n");
				}

				strArray.push("\n");
				strArray.push(" +p<.10  *p<.05  **p<.01\n\n");

				strArray.push("\n");
				strArray.push("「 実測値と残差分析の結果 」\n");
				for (j = 0; j < YY; j++) {
					strArray.push("--------");
				}
				strArray.push("\n");

				for (i = 0; i < TT; i++) {
					for (j = 0; j < YY; j++) {
						strArray.push(xx[i][j] + "\t" + MC2[i][j] + "\t");
					}
					strArray.push("\n");
				}
				for (j = 0; j < YY; j++) {
					strArray.push("--------");
				}

				strArray.push("\n");
				strArray.push("（▲有意に多い,▽有意に少ない,p<.05）\n\n");
			}
		}

		//グラフ描画
		(function () {
			// // if (document.getElementById("RltAdd").checked == false) {
			// if (h == 0) {
			// 	chartClear();
			// }
			// // }

			// var chtt = "";
			// var chxr = "";
			// var chxl = "";
			// var chd = "";
			// var chds = "";
			// var chco = "000000,";//最初の色は黒

			// var chartClrAry = new Array("000000", "222222", "444444", "666666", "888888", "aaaaaa", "cccccc", "dddddd");

			// chtt = "値１（黒）～値ｊ（淡）の比率";
			// chxr = "0,0,1";
			// chxl = "1:|";
			// for (i = TT; i > 0; i--) {
			// 	chxl += "群" + i;
			// 	if (i > 1) chxl += "|";
			// }
			// chd = "t:";

			// for (j = 0; j < YY; j++) {
			// 	for (i = 0; i < TT; i++) {
			// 		chd += (xx[i][j] / Y[i]).toFixed(4);
			// 		if (i < TT - 1) chd += ",";
			// 	}
			// 	if (j < YY - 1) chd += "|";
			// }

			// chds = "0,1,0,1";

			// var wR;
			// var wC = "";
			// for (j = 1; j < YY; j++) {
			// 	wR = (parseInt("F0", 16) / (YY - 1) * j).toFixed(0); //最後の色はF0F0F0
			// 	wR = parseInt(wR, 10);
			// 	wC = wR.toString(16);
			// 	chco += wC + wC + wC;
			// 	if (j < YY - 1) chco += ",";
			// }

			// drawbarChart(chtt, chxr, chxl, chd, chds, chco);

		}());	//グラフ描画ここまで


		//グラフ描画
		(function () {
			if (h === 0) {
				chartClear();
			}

			//ixj i群：j値：k層
			var gunStr;
			var ataiStr;
			var souStr;
			// if (checked_ixj) {
			// 	gunStr = "i";
			// 	ataiStr = "j";
			// 	souStr = "k";
			// }
			//jxk i層：j群：k値
			// if (checked_jxk) {
			gunStr = "j";
			ataiStr = "k";
			souStr = "i";
			// }
			//ixk i群：j層：k値
			// if (checked_ixk) {
			// 	gunStr = "i";
			// 	ataiStr = "k";
			// 	souStr = "j";
			// }

			var i, j;
			var chartImg = document.createElement('canvas');
			chartImg.id = "ChartImg" + h;
			var ctx = document.getElementById("chart").appendChild(chartImg);

			var data = [];
			for (j = 0; j < YY; j++) {
				data[j] = [];
			}

			for (j = 0; j < YY; j++) {
				for (i = 0; i < TT; i++) {
					data[j][i] = ((xx[i][j] / Y[i]) * 100).toFixed(4);
				}
			}

			var datasetKey = [];
			for (j = 0; j < YY; j++) {
				datasetKey[j] = [];
			}
			var wC = 0;
			for (j = 0; j < YY; j++) {
				datasetKey[j].label = ataiStr + (j + 1);
				datasetKey[j].data = data[j];

				if (j === 0) {
					wC = 0; //最初の色は000000
				} else {
					wC = (parseInt("F0", 16) / (YY - 1) * j).toFixed(0); //最後の色はF0F0F0
					wC = parseInt(wC, 10);
				}
				datasetKey[j].backgroundColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';
				datasetKey[j].borderColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';

				datasetKey[j].borderWidth = 1;
			}

			var labelData = [];
			for (i = 0; i < TT; i++) {
				labelData.push(gunStr + (i + 1));
			}

			var datasetData = [];
			for (j = 0; j < YY; j++) {
				datasetData[j] = datasetKey[j];
			}

			var myChart = new Chart(ctx, {
				type: 'horizontalBar',
				data: {
					labels: labelData,
					datasets: datasetData
				},
				options: {
					title: {
						display: true,
						text: souStr + '=' + (h + 1) + '  :  ' + '各群の' + ataiStr + '1（黒）～ ' + ataiStr + YY + '（淡）の比率',
						position: 'top',
						fontSize: 12,
						fontColor: '#000000'
					},
					scales: {
						xAxes: [{
							stacked: true,
							ticks: {
								beginAtZero: true,
								min: 0,
								max: 100
							}
						}],
						yAxes: [{
							stacked: true
						}]
					},
					legend: {
						position: 'bottom'
					}
				}
			});
		}());

	} // h loop

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		//i群：j値：k層
		var gunCount;
		var gunStr;

		var ataiCount;
		var ataiStr;

		var souCount;
		var souStr;

		//ixj i群：j値：k層
		// if (checked_ixj) {
		// 	gunCount = iCount;
		// 	gunStr = "i";
		// 	gunStr2 = "ｉ";
		// 	gunStr3 = "I";

		// 	ataiCount = jCount;
		// 	ataiStr = "j";
		// 	ataiStr2 = "ｊ";
		// 	ataiStr3 = "J";

		// 	souCount = kCount;
		// 	souStr = "k";
		// 	souStr2 = "ｋ";
		// 	souStr3 = "K";
		// }
		//jxk i層：j群：k値
		// if (checked_jxk) {
		gunCount = jCount;
		gunStr = "j";
		gunStr2 = "ｊ";
		gunStr3 = "J";

		ataiCount = kCount;
		ataiStr = "k";
		ataiStr2 = "ｋ";
		ataiStr3 = "K";

		souCount = iCount;
		souStr = "i";
		souStr2 = "ｉ";
		souStr3 = "I";
		// }
		//ixk i群：j層：k値
		// if (checked_ixk) {
		// 	gunCount = iCount;
		// 	gunStr = "i";
		// 	gunStr2 = "ｉ";
		// 	gunStr3 = "I";

		// 	ataiCount = kCount;
		// 	ataiStr = "k";
		// 	ataiStr2 = "ｋ";
		// 	ataiStr3 = "K";

		// 	souCount = jCount;
		// 	souStr = "j";
		// 	souStr2 = "ｊ";
		// 	souStr3 = "J";
		// }

		rcmArray.push("######## ｉ×ｊ×ｋ表(モデル選択) #######\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		rcmArray.push("lev" + gunStr3 + " <- " + gunCount + "  # " + gunStr2 + "\n");
		rcmArray.push("lev" + ataiStr3 + " <- " + ataiCount + "  # " + ataiStr2 + "\n");
		rcmArray.push("lev" + souStr3 + " <- " + souCount + "  # " + souStr2 + "\n");

		rcmArray.push("\n");
		rcmArray.push("dosu <- c(\n");
		for (sou = 0; sou < souCount; sou++) {
			for (gun = 0; gun < gunCount; gun++) {
				for (atai = 0; atai < ataiCount; atai++) {
					// if (checked_ixj) {
					// 	rcmArray.push("  ");
					// 	rcmArray.push(wData[gun][atai][sou]);
					// }
					// if (checked_jxk) {
					rcmArray.push("  ");
					rcmArray.push(wData[sou][gun][atai]);
					// }
					// if (checked_ixk) {
					// 	rcmArray.push("  ");
					// 	rcmArray.push(wData[gun][sou][atai]);
					// }
					if ((sou == souCount - 1) && (gun == gunCount - 1) && (atai == ataiCount - 1)) {
						rcmArray.push(")");
					} else {
						rcmArray.push(",");
					}
				}
				rcmArray.push("\n");
			}
			rcmArray.push("\n");
		}

		rcmArray.push("## js-STARからの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("" + gunStr3 + "    <- gl(lev" + gunStr3 + ", lev" + ataiStr3 + ", lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + souStr3 + ")\n");
		rcmArray.push("" + ataiStr3 + "    <- gl(lev" + ataiStr3 + ",    1, lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + souStr3 + ")\n");
		rcmArray.push("" + souStr3 + "    <- gl(lev" + souStr3 + ", lev" + gunStr3 + "*lev" + ataiStr3 + ")\n");
		rcmArray.push("dset <- data.frame( " + gunStr3 + ", " + ataiStr3 + ", " + souStr3 + ", dosu)\n");
		rcmArray.push("hyo  <- xtabs(dosu~" + gunStr3 + "+" + ataiStr3 + "+" + souStr3 + ", data=dset)\n");
		rcmArray.push("\n");
		rcmArray.push("# 図を描く：各層における標本比率\n");
		rcmArray.push("bunbo <- c()\n");
		rcmArray.push("gokei <- c()\n");
		rcmArray.push("for(" + souStr + " in 1:lev" + souStr3 + ") # 層\n");
		rcmArray.push("for(" + gunStr + " in 1:lev" + gunStr3 + ") # 各群の度数を集計\n");
		rcmArray.push("  {\n");
		rcmArray.push("   ds <- c()\n");
		rcmArray.push("   for(" + ataiStr + " in 1:lev" + ataiStr3 + ")\n");
		rcmArray.push("     {\n");
		rcmArray.push("      ds <- c(ds,\n");
		rcmArray.push("        dosu[(" + souStr + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "])\n");
		rcmArray.push("     }\n");
		rcmArray.push("   bunbo <- c(bunbo, rep(sum(ds), lev" + ataiStr3 + "))\n");
		rcmArray.push("   gokei <- c(gokei, sum(ds))\n");
		rcmArray.push("  }\n");
		rcmArray.push("hyohir <- dosu/bunbo # 群別の各値の比率\n");
		rcmArray.push("\n");
		rcmArray.push("zhyo <- c()\n");
		rcmArray.push("for(" + souStr + " in lev" + souStr3 + ":1){\n");
		rcmArray.push("for(" + gunStr + " in lev" + gunStr3 + ":1){\n");
		rcmArray.push("  for(" + ataiStr + " in 1:lev" + ataiStr3 + ")\n");
		rcmArray.push("    {\n");
		rcmArray.push("     zhyo <- c(zhyo,\n");
		rcmArray.push("       hyohir[(" + souStr + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "])\n");
		rcmArray.push("    }\n");
		rcmArray.push("} }\n");
		rcmArray.push("zhyo <- matrix(zhyo, nc=lev" + ataiStr3 + ", by=1)\n");
		rcmArray.push("rownames(zhyo) <- rep(c(\n");
		rcmArray.push("  paste(\"" + gunStr2 + "\", lev" + gunStr3 + ":1, sep=\"\")\n");
		rcmArray.push("  ), time=lev" + souStr3 + ")\n");
		rcmArray.push("space <- rep(c(1, rep(0,lev" + gunStr3 + "-1)\n");
		rcmArray.push("               ), time=lev" + souStr3 + ")\n");
		rcmArray.push("xjiklabel <- c(\"上段から" + souStr2 + "１～" + souStr2 + "＃\")\n");
		rcmArray.push("maintitle <- c(\"各群の" + ataiStr2 + "１（黒）～" + ataiStr2 + "＃（灰白）の比率\")\n");
		rcmArray.push("barplot( t(zhyo), sp=space, las=1,\n");
		rcmArray.push("         hor=1,\n");
		rcmArray.push("         main=maintitle,\n");
		rcmArray.push("         cex.ax=1.5, cex.na=1.5,\n");
		rcmArray.push("         xlab=xjiklabel )\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# ここから統計分析\n");
		rcmArray.push("Mful <- glm( dosu~" + gunStr3 + "*" + ataiStr3 + "*" + souStr3 + ", \n");
		rcmArray.push("             data=dset, fa=poisson )   # ポアソン回帰\n");
		rcmArray.push("Msel <- step(Mful, k=log(sum(dosu)) ) # k= は BIC 指定\n");
		rcmArray.push("# 出力用テキスト\n");
		rcmArray.push("tx0<-c();tx1<-c();tx2<-c();tx3<-c();\n");
		rcmArray.push("         tx4<-c();tx5<-c();tx6<-c()\n");
		rcmArray.push("tx0 <- Mful$formula # 初期モデル\n");
		rcmArray.push("tx1 <- Msel$anova   # 選択ステップの要約\n");
		rcmArray.push("colnames(tx1) <- c(\"項の増減\",\" df\",\"残差増分\",\n");
		rcmArray.push("                   \" df\",\"残差逸脱度\",\"  BIC\")\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 <- Msel$formula # 選出モデル\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 <- matrix( c(Msel$null, Msel$df.null,\n");
		rcmArray.push("                 Msel$dev,  Msel$df.resid), nr=1 )\n");
		rcmArray.push("colnames(tx3) <- c(\"初期逸脱度\",\"  df\",\"    残差逸脱度\",\"  df\")\n");
		rcmArray.push("rownames(tx3) <- c(\"Deviance\")\n");
		rcmArray.push("library(car)\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 <- Anova(Msel)[,1:3]\n");
		rcmArray.push("colnames(tx4) <- c(\"χ2 値\",\" df\",\"  ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("mht  <- mantelhaen.test(hyo, cor=1) # 連続性修正は無効\n");
		rcmArray.push("tx5  <- matrix( c( round(mht$sta, 4),\n");
		rcmArray.push("                         mht$par,\n");
		rcmArray.push("                   round(mht$p.v, 4) ), nr=1)\n");
		rcmArray.push("rownames(tx5) <- c(\"\")\n");
		rcmArray.push("colnames(tx5) <- c(\"      χ2 値\",\" df\",\"  ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 <- c()\n");
		rcmArray.push("tmp <- c()\n");
		rcmArray.push(" for(" + gunStr + " in 1:lev" + gunStr3 + "){\n");
		rcmArray.push(" for(" + ataiStr + " in 1:lev" + ataiStr3 + "){\n");
		rcmArray.push("   tmp <- c(tmp,\n");
		rcmArray.push("     dosu[(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "] )\n");
		rcmArray.push("   }\n");
		rcmArray.push("   tmp <- c(tmp,\n");
		rcmArray.push("     gokei[" + gunStr + "] ) \n");
		rcmArray.push("    }\n");
		rcmArray.push("tx9 <- matrix(tmp,\n");
		rcmArray.push("   nc=lev" + ataiStr3 + "+1, by=1 ) # 第１層\n");
		rcmArray.push("colnames(tx9) <- c(\n");
		rcmArray.push("  paste(\"" + ataiStr2 + "\", 1:lev" + ataiStr3 + ", sep=\"\"),\n");
		rcmArray.push("  \"  合計\" )\n");
		rcmArray.push("rownames(tx9) <- paste(\n");
		rcmArray.push("  paste(\"" + souStr2 + "\", 1,      sep=\"\"),\n");
		rcmArray.push("  paste(\"" + gunStr2 + "\", 1:lev" + gunStr3 + ", sep=\"\"), sep=\"_\")\n");
		rcmArray.push("\n");
		rcmArray.push("for(" + souStr + " in 2:lev" + souStr3 + ") # 第２層～\n");
		rcmArray.push("  {\n");
		rcmArray.push("   tmp <- c()\n");
		rcmArray.push("   for(" + gunStr + " in 1:lev" + gunStr3 + "){\n");
		rcmArray.push("   for(" + ataiStr + " in 1:lev" + ataiStr3 + "){\n");
		rcmArray.push("     tmp <- c(tmp,\n");
		rcmArray.push("       dosu[(" + souStr + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+\n");
		rcmArray.push("            (" + gunStr + "-1)*lev" + ataiStr3 + "+\n");
		rcmArray.push("             " + ataiStr + "] )\n");
		rcmArray.push("      }\n");
		rcmArray.push("     tmp <- c(tmp,\n");
		rcmArray.push("       gokei[(" + souStr + "-1)*lev" + gunStr3 + "+" + gunStr + "] )\n");
		rcmArray.push("      }\n");
		rcmArray.push("   tmp <- matrix(c(\n");
		rcmArray.push("     rep(NA, lev" + ataiStr3 + "+1), tmp\n");
		rcmArray.push("     ), nc=lev" + ataiStr3 + "+1, by=1)\n");
		rcmArray.push("\n");
		rcmArray.push("   sounam <- c()\n");
		rcmArray.push("   gunnam <- c()\n");
		rcmArray.push("   for(" + gunStr + " in 1:lev" + gunStr3 + "){\n");
		rcmArray.push("     sounam <- c(sounam,\n");
		rcmArray.push("       paste(\"" + souStr2 + "\", " + souStr + ", sep=\"\") )\n");
		rcmArray.push("     gunnam <- c(gunnam,\n");
		rcmArray.push("       paste(\"" + gunStr2 + "\", " + gunStr + ", sep=\"\") )\n");
		rcmArray.push("      }\n");
		rcmArray.push("\n");
		rcmArray.push("   rownames(tmp) <- c(\n");
		rcmArray.push("     \"---\",\n");
		rcmArray.push("     paste(sounam,\n");
		rcmArray.push("           gunnam, sep=\"_\") )\n");
		rcmArray.push("\n");
		rcmArray.push("   tx9 <- rbind(tx9, tmp)\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("# 層併合と層別化の集計\n");
		rcmArray.push("rst0 <- c()\n");
		rcmArray.push("rst0 <- chisq.test(\n");
		rcmArray.push("  xtabs(dosu~" + gunStr3 + "+" + ataiStr3 + ", dset) )\n");
		rcmArray.push("\n");
		rcmArray.push("chis <- c()\n");
		rcmArray.push("pchi <- c()\n");
		rcmArray.push("for(" + souStr + " in 1:lev" + souStr3 + ")\n");
		rcmArray.push("  {\n");
		rcmArray.push("   rst  <- chisq.test(\n");
		rcmArray.push("     xtabs(dosu~" + gunStr3 + "+" + ataiStr3 + ",\n");
		rcmArray.push("       subset(dset,\n");
		rcmArray.push("       as.numeric(dset$" + souStr3 + ")==" + souStr + "\n");
		rcmArray.push("             ) ) )\n");
		rcmArray.push("   chis <- c(chis, rst$stat)\n");
		rcmArray.push("   pchi <- c(pchi, rst$p.va)\n");
		rcmArray.push("   }\n");
		rcmArray.push("padj <- p.adjust(pchi, \"BH\")\n");
		rcmArray.push("\n");
		rcmArray.push("DF   <- (lev" + gunStr3 + "-1)*(lev" + ataiStr3 + "-1)\n");
		rcmArray.push("\n");
		rcmArray.push("tx7 <- c()\n");
		rcmArray.push("tx7 <- matrix(c(\n");
		rcmArray.push("  round(rst0$stat, 4),\n");
		rcmArray.push("               DF,\n");
		rcmArray.push("  round(rst0$p.va, 4),\n");
		rcmArray.push("  NA\n");
		rcmArray.push("  ), nr=1, by=1 )\n");
		rcmArray.push("rownames(tx7) <- c(\n");
		rcmArray.push("  \"層併合\" )\n");
		rcmArray.push("colnames(tx7) <- c(\n");
		rcmArray.push("  \" χ2 値\",\n");
		rcmArray.push("  \" df\",\n");
		rcmArray.push("  \"    ｐ値\",\n");
		rcmArray.push("  \" 調整後ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("tx8 <- c()\n");
		rcmArray.push("tx8 <- matrix(c(\n");
		rcmArray.push("  round(chis, 4),\n");
		rcmArray.push("  rep(DF, lev" + souStr3 + "),\n");
		rcmArray.push("  round(pchi, 4),\n");
		rcmArray.push("  round(padj, 4)\n");
		rcmArray.push("  ), nc=4, by=F )\n");
		rcmArray.push("rownames(tx8) <- c(\n");
		rcmArray.push("  paste(\"層別_\", 1:lev" + souStr3 + ", sep=\"\") )\n");
		rcmArray.push("colnames(tx8) <- c(\n");
		rcmArray.push("  \"  －－\",\n");
		rcmArray.push("  \"   \",\n");
		rcmArray.push("  \"    －－\",\n");
		rcmArray.push("  \"    －－\")\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("###########################################\n");
		rcmArray.push("# ３元モデル解析ｉ×ｊ×ｋ：              #\n");
		rcmArray.push("#  ポアソン回帰モデリング                #\n");
		rcmArray.push("#  （ステップワイズ増減法, 選択基準 BIC）#\n");
		rcmArray.push("#                                         #\n");
		rcmArray.push("# ［汎用］" + gunStr2 + "群×" + ataiStr2 + "値×" + souStr2 + "層の分析          #\n");
		rcmArray.push("#   * ２群×２値でもオッズ比は計算しない  #\n");
		rcmArray.push("###########################################\n");
		rcmArray.push("tx9 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tx0 # 初期モデル（主効果・交互作用を含む）\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # モデル選択ステップの要約（選択基準 BIC）\n");
		rcmArray.push("\n");
		rcmArray.push("tx3 # 過分散判定（残差逸脱度>>df なら過分散）\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # 選出されたモデル\n");
		rcmArray.push("# ■出力が煩雑化したときは初期モデルで停止した■\n");
		rcmArray.push("# 初期モデルの選出→最適モデルは見いだされない\n");
		rcmArray.push("\n");
		rcmArray.push("# ［参考：" + souStr2 + "を層とする" + gunStr2 + "×" + ataiStr2 + "の有意差検定］\n");
		rcmArray.push("tx5 # コクラン・マンテル・ヘンツェル検定\n");
		rcmArray.push("# ■ tx2 が " + gunStr3 + ":" + ataiStr3 + " を含まないときは参照不可■\n");
		rcmArray.push("#  p<α なら" + souStr2 + "層共通に" + gunStr2 + "水準間に有意差あり！\n");
		rcmArray.push("\n");
		rcmArray.push("# 層併合・層別のカイ二乗検定（" + gunStr2 + "×" + ataiStr2 + "）\n");
		rcmArray.push("tx7;tx8 \n");
		rcmArray.push("# ■ tx2 が " + gunStr3 + ":" + souStr3 + ", " + ataiStr3 + ":" + souStr3 + " を含むなら参照注意■\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray.push("\n");
		rcmArray.push("# ○選出モデルの出力オプション\n");
		rcmArray.push("# （実行手順：上向矢印→先頭の#消去→Enter）\n");
		rcmArray.push("# summary( Msel ) # 回帰係数のワルド検定\n");
		rcmArray.push("# confint( Msel ) # 回帰係数の信頼区間推定\n");
		rcmArray.push("# tx4             # 選出モデルの尤度比検定\n");
		rcmArray.push("# step( Mful )    # AICによるモデル選択\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");

		// if (document.getElementById("RltAdd").checked) {
		// document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
		// } else {
		document.getElementById("RcmArea").value = rcmArray.join("");
		// }
		rcmArray = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
/**
 * [change3dSetting セルなどの入力フォーム部分を作成]
 */
function change3dSetting() {
	var h = 2;
	var htmArray = [];

	htmArray.push("<div class=\"tateyoko\">\n");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("ｉ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"iCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
		htmArray.push("Ｊ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"jCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
		htmArray.push("Ｋ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"kCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change3dTable();\">");
	} else {
		htmArray.push("ｉ＝<select name=\"i\" id=\"iCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'i の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｊ＝<select name=\"j\" id=\"jCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'j の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｋ＝<select name=\"k\" id=\"kCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'k の値'); change3dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("</select>");
	}

	htmArray.push("</div>");

	document.getElementById("3d_setting").innerHTML = htmArray.join("");
	htmArray = null;

	change3dTable();
}
function change3dTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	var htmArray = [];
	var cellId = 1;
	var cellCount = iCount * jCount * kCount;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("i");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｊ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｋ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("度数");
	htmArray.push("</td>");
	htmArray.push("</tr>");
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				htmArray.push("<tr>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(i + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(j + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_midashi_3d\">");
				htmArray.push(k + 1);
				htmArray.push("</td>");
				htmArray.push("<td class=\"hyou_nyuryoku\">");
				htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxl=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
				htmArray.push("</td>");
				htmArray.push("</tr>");
				cellId++;
			}
		}
	}
	htmArray.push("</table>");

	// 横線がはいるので要検討！todo
	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("3d_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_3d() {
	var i, j, k;

	var strArray = [];

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);

	//#0
	strArray.push("ixjxk" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(iCount + "," + jCount + "," + kCount + "\n");
	//#2
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				x = parseInt(document.getElementById("cell_" + cellId).value);
				strArray.push(x + "\n");
				cellId++;
			}
		}
	}

	var Stream = strArray.join("");
	var fineName = "ixjxk_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ixjxk() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "ixjxk") {
		var ijk = dd[1];
		ijk = delTopCR(ijk);
		var ijk_data = [];
		ijk_data = ijk.split(",");
		document.getElementById("iCount").value = parseInt(ijk_data[0]);
		document.getElementById("jCount").value = parseInt(ijk_data[1]);
		document.getElementById("kCount").value = parseInt(ijk_data[2]);
		change3dTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}