/**
 * 度数の検定
 * ｉ×ｊ×ｋ×Ｌ表(４元モデル解析)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	change4dSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);
	var elmCount = iCount * jCount * kCount * lCount;

	var result = confirm("データを消去します");
	if (result == true) {
		for (var i = 1; i < elmCount + 1; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	// setFocus(0);
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);
	if (dd.length > iCount * jCount * kCount * lCount) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 4 !== 0) {
	// 	err = true;
	// }

	if (NN === 4) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i = i + 4) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < iCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 1]) > 0) && (parseInt(dd[i + 1]) < jCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 2]) > 0) && (parseInt(dd[i + 2]) < kCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 3]) > 0) && (parseInt(dd[i + 3]) < lCount + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var gunAtai = new Array(iCount);
			for (i = 0; i < iCount; i++) {
				gunAtai[i] = new Array(jCount);
				for (j = 0; j < jCount; j++) {
					gunAtai[i][j] = new Array(kCount);
					for (k = 0; k < kCount; k++) {
						gunAtai[i][j][k] = new Array(lCount);
					}
				}
			}

			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						for (l = 0; l < lCount; l++) {
							gunAtai[i][j][k][l] = 0;
						}
					}
				}
			}

			for (i = 0; i < dd.length; i = i + 4) {
				gunAtai[dd[i] - 1][dd[i + 1] - 1][dd[i + 2] - 1][dd[i + 3] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < iCount; i++) {
				for (j = 0; j < jCount; j++) {
					for (k = 0; k < kCount; k++) {
						for (l = 0; l < lCount; l++) {
							strArray.push(gunAtai[i][j][k][l]);
							strArray.push("\t");
						}
					}
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			alert("データ形式が正しくありません。");
		}
	} else {
		document.getElementById("CandPArea").value = '';
		alert("データ形式が正しくありません。");
	}
}
// 入力チェック
function checkCellData() {
	var i = 1;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);
	var elmCount = iCount * jCount * kCount * lCount;

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 1; i <= elmCount; i++) {
			if (document.getElementById("cell_" + i).value === "") {
				errorCellNum = i;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_4d();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		copipe("CandPArea", "text");
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));

		if (isNaN(dd[elmCount - 1])) {
			alert("データを確認してください");
		} else {
			mainCalc_4d();
		}
	}
}
// メイン計算
function mainCalc_4d() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var h = 0;

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);
	var hCount;
	var elmCount = iCount * jCount * kCount * lCount;
	var kaiData = [];

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];

	var wData = new Array(iCount);
	for (i = 0; i < iCount; i++) {
		wData[i] = new Array(jCount);
		for (j = 0; j < jCount; j++) {
			wData[i][j] = new Array(kCount);
			for (k = 0; k < kCount; k++) {
				wData[i][j][k] = new Array(lCount);
			}
		}
	}

	if (document.getElementById("CandPArea").value === "") {
		var cellId = 1;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					for (l = 0; l < lCount; l++) {
						wData[i][j][k][l] = parseInt(document.getElementById("cell_" + cellId).value);
						cellId++;
					}
				}
			}
		}
	} else {
		var DData = document.getElementById("CandPArea").value;
		var dd = [];
		dd = DData.split(" ");

		var idata = 0;
		for (i = 0; i < iCount; i++) {
			for (j = 0; j < jCount; j++) {
				for (k = 0; k < kCount; k++) {
					for (l = 0; l < lCount; l++) {
						wData[i][j][k][l] = parseInt(dd[idata]);
						idata++;
					}
				}
			}
		}
	} // セルとテキストエリアの分岐終了

	// ixjxkxl(); //集計選択のフラッグを確認
	var checked_ixj = document.getElementById("ixj").checked;
	var checked_ixk = document.getElementById("ixk").checked;
	var checked_ixl = document.getElementById("ixl").checked;
	var checked_jxk = document.getElementById("jxk").checked;
	var checked_jxl = document.getElementById("jxl").checked;
	var checked_kxl = document.getElementById("kxl").checked;

	//Ｒプログラム出力
	//i群：j値：k層
	var gunCount;
	var gunStr;
	var gunStr2;
	var gunStr3;

	var ataiCount;
	var ataiStr;
	var ataiStr2;
	var ataiStr3;

	var sou1Count;
	var sou1Str;
	var sou1Str2;
	var sou1Str3;

	var sou2Count;
	var sou2Str;
	var sou2Str2;
	var sou2Str3;

	//ixj i群：j値：k層１：l層２
	if (checked_ixj) {
		gunCount = iCount;
		gunStr = "i"; //半角小文字
		gunStr2 = "ｉ"; //全角小文字
		gunStr3 = "I"; //半角大文字

		ataiCount = jCount;
		ataiStr = "j";
		ataiStr2 = "ｊ";
		ataiStr3 = "J";

		sou1Count = kCount;
		sou1Str = "k";
		sou1Str2 = "ｋ";
		sou1Str3 = "K";

		sou2Count = lCount;
		sou2Str = "l";
		sou2Str2 = "Ｌ";
		sou2Str3 = "L";
	}
	//ixk i群：k値：j層１：l層２
	if (checked_ixk) {
		gunCount = iCount;
		gunStr = "i";
		gunStr2 = "ｉ";
		gunStr3 = "I";

		ataiCount = kCount;
		ataiStr = "k";
		ataiStr2 = "ｋ";
		ataiStr3 = "K";

		sou1Count = jCount;
		sou1Str = "j";
		sou1Str2 = "ｊ";
		sou1Str3 = "J";

		sou2Count = lCount;
		sou2Str = "l";
		sou2Str2 = "Ｌ";
		sou2Str3 = "L";
	}
	//ixl i群：l値：j層１：k層２
	if (checked_ixl) {
		gunCount = iCount;
		gunStr = "i";
		gunStr2 = "ｉ";
		gunStr3 = "I";

		ataiCount = lCount;
		ataiStr = "l";
		ataiStr2 = "Ｌ";
		ataiStr3 = "L";

		sou1Count = jCount;
		sou1Str = "j";
		sou1Str2 = "ｊ";
		sou1Str3 = "J";

		sou2Count = kCount;
		sou2Str = "k";
		sou2Str2 = "ｋ";
		sou2Str3 = "K";
	}
	//jxk j群：k値：i層１：l層２
	if (checked_jxk) {
		gunCount = jCount;
		gunStr = "j";
		gunStr2 = "ｊ";
		gunStr3 = "J";

		ataiCount = kCount;
		ataiStr = "k";
		ataiStr2 = "ｋ";
		ataiStr3 = "K";

		sou1Count = iCount;
		sou1Str = "i";
		sou1Str2 = "ｉ";
		sou1Str3 = "I";

		sou2Count = lCount;
		sou2Str = "l";
		sou2Str2 = "Ｌ";
		sou2Str3 = "L";
	}
	//jxl j群：l値：i層１：k層２
	if (checked_jxl) {
		gunCount = jCount;
		gunStr = "j";
		gunStr2 = "ｊ";
		gunStr3 = "J";

		ataiCount = lCount;
		ataiStr = "l";
		ataiStr2 = "Ｌ";
		ataiStr3 = "L";

		sou1Count = iCount;
		sou1Str = "i";
		sou1Str2 = "ｉ";
		sou1Str3 = "I";

		sou2Count = kCount;
		sou2Str = "k";
		sou2Str2 = "ｋ";
		sou2Str3 = "K";
	}
	//kxl k群：l値：i層１：j層２
	if (checked_kxl) {
		gunCount = kCount;
		gunStr = "k";
		gunStr2 = "ｋ";
		gunStr3 = "K";

		ataiCount = lCount;
		ataiStr = "l";
		ataiStr2 = "Ｌ";
		ataiStr3 = "L";

		sou1Count = iCount;
		sou1Str = "i";
		sou1Str2 = "ｉ";
		sou1Str3 = "I";

		sou2Count = jCount;
		sou2Str = "j";
		sou2Str2 = "ｊ";
		sou2Str3 = "J";
	}

	rcmArray.push("####### ｉ×ｊ×ｋ×Ｌ表(４元モデル) #######\n");
	rcmArray.push("\n");
	rcmArray.push("## js-STARからの入力\n");
	rcmArray.push("lev" + gunStr3 + " <- " + gunCount + "  # " + gunStr2 + " 群\n");
	rcmArray.push("lev" + ataiStr3 + " <- " + ataiCount + "  # " + ataiStr2 + " 値\n");
	rcmArray.push("lev" + sou1Str3 + " <- " + sou1Count + "  # " + sou1Str2 + " 層１\n");
	rcmArray.push("lev" + sou2Str3 + " <- " + sou2Count + "  # " + sou2Str2 + " 層２\n");

	rcmArray.push("\n");
	rcmArray.push("dosu <- c(\n");

	for (sou2 = 0; sou2 < sou2Count; sou2++) {
		for (sou1 = 0; sou1 < sou1Count; sou1++) {
			for (gun = 0; gun < gunCount; gun++) {
				for (atai = 0; atai < ataiCount; atai++) {
					//ixj i群：j値：k層１：l層２
					if (checked_ixj) {
						rcmArray.push("  ");
						rcmArray.push(wData[gun][atai][sou1][sou2]);
					}
					//ixk i群：k値：j層１：l層２
					if (checked_ixk) {
						rcmArray.push("  ");
						rcmArray.push(wData[gun][sou1][atai][sou2]);
					}
					//ixl i群：l値：j層１：k層２
					if (checked_ixl) {
						rcmArray.push("  ");
						rcmArray.push(wData[gun][sou1][sou2][atai]);
					}
					//jxk j群：k値：i層１：l層２
					if (checked_jxk) {
						rcmArray.push("  ");
						rcmArray.push(wData[sou1][gun][atai][sou2]);
					}
					//jxl j群：l値：i層１：k層２
					if (checked_jxl) {
						rcmArray.push("  ");
						rcmArray.push(wData[sou1][gun][sou2][atai]);
					}
					//kxl k群：l値：i層１：j層２
					if (checked_kxl) {
						rcmArray.push("  ");
						rcmArray.push(wData[sou1][sou2][gun][atai]);
					}
					if ((sou2 == sou2Count - 1) && (sou1 == sou1Count - 1) && (gun == gunCount - 1) && (atai == ataiCount - 1)) {
						rcmArray.push(")");
					} else {
						rcmArray.push(",");
					}
				}
				rcmArray.push("\n");
			}
			rcmArray.push("\n");
		}
		rcmArray.push("\n");
	}

	rcmArray.push("## js-STARからの入力おわり\n");

	rcmArray.push("\n");
	rcmArray.push(gunStr3 + "    <- gl(lev" + gunStr3 + ",           lev" + ataiStr3 + ", lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + sou1Str3 + "*lev" + sou2Str3 + ")\n");
	rcmArray.push(ataiStr3 + "    <- gl(lev" + ataiStr3 + ",              1, lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + sou1Str3 + "*lev" + sou2Str3 + ")\n");
	rcmArray.push(sou1Str3 + "    <- gl(lev" + sou1Str3 + ", lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + sou2Str3 + ")\n");
	rcmArray.push("" + sou2Str3 + "    <- gl(lev" + sou2Str3 + ", lev" + gunStr3 + "*lev" + ataiStr3 + ",      lev" + gunStr3 + "*lev" + ataiStr3 + "*lev" + sou1Str3 + "*lev" + sou2Str3 + ")\n");
	rcmArray.push("\n");
	rcmArray.push("dset <- data.frame( " + gunStr3 + ", " + ataiStr3 + ", " + sou1Str3 + ", " + sou2Str3 + ", dosu)\n");
	rcmArray.push("hyo  <- xtabs(dosu~" + gunStr3 + "+" + ataiStr3 + "+ " + sou2Str3 + "+" + sou1Str3 + ", data=dset)\n");
	rcmArray.push("\n");
	rcmArray.push("# 図を描く：各層における標本比率\n");
	rcmArray.push("bunbo <- c()\n");
	rcmArray.push("gokei <- c()\n");
	rcmArray.push("for(" + sou1Str + " in 1:lev" + sou1Str3 + ") # 層\n");
	rcmArray.push("for(" + sou2Str + " in 1:lev" + sou2Str3 + ")\n");
	rcmArray.push("for(" + gunStr + " in 1:lev" + gunStr3 + ") # 各群の度数を集計\n");
	rcmArray.push("  {\n");
	rcmArray.push("   ds <- c()\n");
	rcmArray.push("   for(" + ataiStr + " in 1:lev" + ataiStr3 + ")\n");
	rcmArray.push("     {\n");
	rcmArray.push("      ds <- c(ds,\n");
	rcmArray.push("        dosu[(" + sou1Str + "-1)*lev" + sou2Str3 + "*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + sou2Str + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "])\n");
	rcmArray.push("     }\n");
	rcmArray.push("   bunbo <- c(bunbo, rep(sum(ds), lev" + ataiStr3 + "))\n");
	rcmArray.push("   gokei <- c(gokei, sum(ds))\n");
	rcmArray.push("  }\n");
	rcmArray.push("hyohir <- dosu/bunbo # 群別の各値の比率\n");
	rcmArray.push("\n");
	rcmArray.push("zhyo <- c()\n");
	rcmArray.push("for(" + sou1Str + " in lev" + sou1Str3 + ":1){\n");
	rcmArray.push("for(" + sou2Str + " in lev" + sou2Str3 + ":1){\n");
	rcmArray.push("for(" + gunStr + " in lev" + gunStr3 + ":1){\n");
	rcmArray.push("  for(" + ataiStr + " in 1:lev" + ataiStr3 + ")\n");
	rcmArray.push("    {\n");
	rcmArray.push("     zhyo <- c(zhyo,\n");
	rcmArray.push("       hyohir[(" + sou1Str + "-1)*lev" + sou2Str3 + "*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + sou2Str + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "])\n");
	rcmArray.push("    }\n");
	rcmArray.push("} } }\n");
	rcmArray.push("zhyo <- matrix(zhyo, nc=lev" + ataiStr3 + ", by=1)\n");
	rcmArray.push("rownames(zhyo) <- rep(c(\n");
	rcmArray.push("  paste(\"" + gunStr2 + "\", lev" + gunStr3 + ":1, sep=\"\")\n");
	rcmArray.push("  ), time=lev" + sou1Str3 + "*lev" + sou2Str3 + ")\n");
	rcmArray.push("space <- rep(c(1, rep(0,lev" + gunStr3 + "-1)\n");
	rcmArray.push("               ), time=lev" + sou1Str3 + ")\n");
	rcmArray.push("xjiklabel <- c(\"上段から " + sou1Str2 + "１/" + sou2Str2 + "１，" + sou1Str2 + "１/" + sou2Str2 + "２，．．～" + sou1Str2 + "＃/" + sou2Str2 + "＃\")\n");
	rcmArray.push("maintitle <- c(\"各群の" + ataiStr2 + "１（黒）～" + ataiStr2 + "＃（灰白）の比率\")\n");
	rcmArray.push("barplot( t(zhyo), sp=space, las=1,\n");
	rcmArray.push("         hor=1,\n");
	rcmArray.push("         main=maintitle,\n");
	rcmArray.push("         cex.ax=1.5, cex.na=1.5,\n");
	rcmArray.push("         xlab=xjiklabel )\n");
	rcmArray.push("\n");
	rcmArray.push("# ここから統計分析\n");
	rcmArray.push("Mful <- glm( dosu~" + gunStr3 + "*" + ataiStr3 + "*" + sou1Str3 + "*" + sou2Str3 + ", \n");
	rcmArray.push("             data=dset, fa=poisson )   # ポアソン回帰\n");
	rcmArray.push("Msel <- step(Mful, k=log(sum(dosu)) ) # k= は BIC 指定\n");
	rcmArray.push("\n");
	rcmArray.push("# 出力用テキスト\n");
	rcmArray.push("tx0<-c();tx1<-c();tx2<-c();tx3<-c();\n");
	rcmArray.push("         tx4<-c();tx5<-c();tx6<-c()\n");
	rcmArray.push("tx0 <- Mful$formula # 初期モデル\n");
	rcmArray.push("tx1 <- Msel$anova   # 選択ステップの要約\n");
	rcmArray.push("colnames(tx1) <- c(\"項の増減\",\" df\",\"逸脱残差\",\n");
	rcmArray.push("                   \" df\",\"残差逸脱度\",\"  BIC\")\n");
	rcmArray.push("\n");
	rcmArray.push("tx2 <- Msel$formula # 選出モデル\n");
	rcmArray.push("\n");
	rcmArray.push("tx3 <- matrix( c(Msel$null, Msel$df.null,\n");
	rcmArray.push("                 Msel$dev,  Msel$df.resid), nr=1 )\n");
	rcmArray.push("colnames(tx3) <- c(\"初期逸脱度\",\"  df\",\"    残差逸脱度\",\"  df\")\n");
	rcmArray.push("rownames(tx3) <- c(\"Deviance\")\n");
	rcmArray.push("library(car)\n");
	rcmArray.push("\n");
	rcmArray.push("tx4 <- Anova(Msel)[,1:3]\n");
	rcmArray.push("colnames(tx4) <- c(\"χ2 値\",\" df\",\"  ｐ値\")\n");
	rcmArray.push("\n");
	rcmArray.push("\n");
	rcmArray.push("tx9 <- c()\n");
	rcmArray.push("tmp <- c()\n");
	rcmArray.push(" for(" + gunStr + " in 1:lev" + gunStr3 + "){\n");
	rcmArray.push(" for(" + ataiStr + " in 1:lev" + ataiStr3 + "){\n");
	rcmArray.push("   tmp <- c(tmp,\n");
	rcmArray.push("     dosu[(" + gunStr + "-1)*lev" + ataiStr3 + "+" + ataiStr + "] )\n");
	rcmArray.push("   }\n");
	rcmArray.push("   tmp <- c(tmp,\n");
	rcmArray.push("     gokei[" + gunStr + "] ) \n");
	rcmArray.push("    }\n");
	rcmArray.push("tx9 <- matrix(tmp,\n");
	rcmArray.push("   nc=lev" + ataiStr3 + "+1, by=1 ) # 第１層\n");
	rcmArray.push("colnames(tx9) <- c(\n");
	rcmArray.push("  paste(\"" + ataiStr2 + "\", 1:lev" + ataiStr3 + ", sep=\"\"),\n");
	rcmArray.push("  \"  合計\" )\n");
	rcmArray.push("rownames(tx9) <- paste(\n");
	rcmArray.push("  paste(\n");
	rcmArray.push("    paste(\"" + sou1Str2 + "\", 1,      sep=\"\"),\n");
	rcmArray.push("    paste(\"" + sou2Str2 + "\", 1,      sep=\"\"), sep=\"/\"),\n");
	rcmArray.push("  paste(\"ｉ\", 1:lev" + gunStr3 + ", sep=\"\"), sep=\"_\")\n");
	rcmArray.push("\n");
	rcmArray.push("for(" + sou1Str + " in 1:lev" + sou1Str3 + ") # 第２層～\n");
	rcmArray.push("  {\n");
	rcmArray.push("  st <- 2-sign(k-1)\n");
	rcmArray.push("\n");
	rcmArray.push("for(" + sou2Str + " in st:lev" + sou2Str3 + ")\n");
	rcmArray.push("  {\n");
	rcmArray.push("   tmp <- c()\n");
	rcmArray.push("   for(" + gunStr + " in 1:lev" + gunStr3 + "){\n");
	rcmArray.push("   for(" + ataiStr + " in 1:lev" + ataiStr3 + "){\n");
	rcmArray.push("     tmp <- c(tmp,\n");
	rcmArray.push("       dosu[(" + sou1Str + "-1)*lev" + sou2Str3 + "*lev" + gunStr3 + "*lev" + ataiStr3 + "+\n");
	rcmArray.push("            (" + sou2Str + "-1)*lev" + gunStr3 + "*lev" + ataiStr3 + "+\n");
	rcmArray.push("            (" + gunStr + "-1)*lev" + ataiStr3 + "+\n");
	rcmArray.push("             " + ataiStr + "] )\n");
	rcmArray.push("      }\n");
	rcmArray.push("     tmp <- c(tmp,\n");
	rcmArray.push("       gokei[(" + sou1Str + "-1)*lev" + sou2Str3 + "*lev" + gunStr3 + "+\n");
	rcmArray.push("             (" + sou2Str + "-1)*lev" + gunStr3 + "+\n");
	rcmArray.push("              " + gunStr + "] )\n");
	rcmArray.push("      }\n");
	rcmArray.push("   tmp <- matrix(c(\n");
	rcmArray.push("     rep(NA, lev" + ataiStr3 + "+1), tmp\n");
	rcmArray.push("     ), nc=lev" + ataiStr3 + "+1, by=1)\n");
	rcmArray.push("\n");
	rcmArray.push("   midashi <- c(\"---\")\n");
	rcmArray.push("   for(" + gunStr + " in 1:lev" + gunStr3 + ")\n");
	rcmArray.push("     {\n");
	rcmArray.push("      midashi <- c(midashi,\n");
	rcmArray.push("        paste(\n");
	rcmArray.push("          paste(\n");
	rcmArray.push("            paste(\"" + sou1Str2 + "\", " + sou1Str + ", sep=\"\"),\n");
	rcmArray.push("            paste(\"" + sou2Str2 + "\", " + sou2Str + ", sep=\"\"),\n");
	rcmArray.push("          sep=\"/\"),\n");
	rcmArray.push("        paste(\"" + gunStr2 + "\", " + gunStr + ", sep=\"\"),\n");
	rcmArray.push("        sep=\"_\")\n");
	rcmArray.push("        )\n");
	rcmArray.push("      }\n");
	rcmArray.push("  rownames(tmp) <- midashi\n");
	rcmArray.push("\n");
	rcmArray.push("  tx9 <- rbind(tx9, tmp)\n");
	rcmArray.push("  } }\n");
	rcmArray.push("\n");
	rcmArray.push("options(digits=5)\n");
	rcmArray.push("options(scipen=5)\n");
	rcmArray.push("###########################################\n");
	rcmArray.push("# ４元モデル解析ｉ×ｊ×ｋ×Ｌ：     #\n");
	rcmArray.push("#  ポアソン回帰モデリング                #\n");
	rcmArray.push("#  （ステップワイズ増減法, 選択基準 BIC）#\n");
	rcmArray.push("#                     #\n");
	rcmArray.push("# ※度数表示は" + gunStr2 + "×" + ataiStr2 + "を " + sou1Str2 + "，" + sou2Str2 + " で層別化  #\n");
	rcmArray.push("###########################################\n");
	rcmArray.push("tx9 # 度数集計表\n");
	rcmArray.push("\n");
	rcmArray.push("tx0 # 初期モデル（主効果・交互作用を含む）\n");
	rcmArray.push("\n");
	rcmArray.push("tx1 # モデル選択ステップの要約（選択基準 BIC）\n");
	rcmArray.push("\n");
	rcmArray.push("tx3 # 過分散判定（残差逸脱度>>df なら過分散）\n");
	rcmArray.push("\n");
	rcmArray.push("tx2 # 選出されたモデル\n");
	rcmArray.push("# ■出力が煩雑化したときは初期モデルが選出された■\n");
	rcmArray.push("# 初期モデルの選出→最適モデルは見いだされない\n");
	rcmArray.push("\n");
	rcmArray.push("# ○選出モデルの出力オプション\n");
	rcmArray.push("# （表示手順：上向矢印→先頭の#消去→Enter）\n");
	rcmArray.push("# summary( Msel ) # 回帰係数のワルド検定\n");
	rcmArray.push("# confint( Msel ) # 回帰係数の信頼区間推定\n");
	rcmArray.push("# tx4             # 選出モデルの尤度比検定\n");
	rcmArray.push("# step( Mful )    # AICによるモデル選択\n");

	rcmArray.push("\n");
	rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
	rcmArray.push("\n");

	// if (document.getElementById("RltAdd").checked) {
	// document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
	// } else {
	document.getElementById("RcmArea").value = rcmArray.join("");
	// }
	rcmArray = null;
}
/**
 * [change4dSetting セルなどの入力フォーム部分を作成]
 */
function change4dSetting() {
	var h = 2;
	var htmArray = [];

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("ｉ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"iCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change4dTable();\">");
		htmArray.push("Ｊ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"jCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change4dTable();\">");
		htmArray.push("Ｋ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"kCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change4dTable();\">");
		htmArray.push("Ｌ＝");
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"lCount\" value=\"2\" size=\"3\" min=\"1\" max=\"50\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"change4dTable();\">");
		htmArray.push("</div>");
	} else {
		htmArray.push("<div class=\"tateyoko\">\n");

		htmArray.push("ｉ＝<select name=\"i\" id=\"iCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'i の値'); change4dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｊ＝<select name=\"j\" id=\"jCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'j の値'); change4dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("Ｋ＝<select name=\"k\" id=\"kCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'i の値'); change4dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");


		htmArray.push("Ｌ＝<select name=\"l\" id=\"lCount\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'l の値'); change4dTable();\">\n");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 21; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"-1\">他</option>");

		htmArray.push("</select>");
		htmArray.push("</div>");
	}

	document.getElementById("4d_setting").innerHTML = htmArray.join("");
	htmArray = null;

	change4dTable();
}
function change4dTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);

	var htmArray = [];
	var cellId = 1;
	var cellCount = iCount * jCount * kCount * lCount;

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("i");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｊ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｋ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Ｌ");
	htmArray.push("</td>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("度数");
	htmArray.push("</td>");
	htmArray.push("</tr>");
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				for (l = 0; l < lCount; l++) {
					htmArray.push("<tr>");
					htmArray.push("<td class=\"hyou_midashi_3d\">");
					htmArray.push(i + 1);
					htmArray.push("</td>");
					htmArray.push("<td class=\"hyou_midashi_3d\">");
					htmArray.push(j + 1);
					htmArray.push("</td>");
					htmArray.push("<td class=\"hyou_midashi_3d\">");
					htmArray.push(k + 1);
					htmArray.push("</td>");
					htmArray.push("<td class=\"hyou_midashi_3d\">");
					htmArray.push(l + 1);
					htmArray.push("</td>");
					htmArray.push("<td class=\"hyou_nyuryoku\">");
					htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + (cellId++) + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
					htmArray.push("</td>");
					htmArray.push("</tr>");
				}
			}
		}
	}
	htmArray.push("</table>");

	// 横線がはいるので要検討！ btnlayout3は横線なし todo
	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("4d_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_4d() {
	var i, j, k, l;

	var strArray = [];

	var iCount = parseInt(document.getElementById("iCount").value);
	var jCount = parseInt(document.getElementById("jCount").value);
	var kCount = parseInt(document.getElementById("kCount").value);
	var lCount = parseInt(document.getElementById("lCount").value);

	//#0
	strArray.push("ixjxkxl" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(iCount + "," + jCount + "," + kCount + "," + lCount + "\n");
	//#2
	strArray.push("#" + "\n");
	var cellId = 1;
	var x;
	for (i = 0; i < iCount; i++) {
		for (j = 0; j < jCount; j++) {
			for (k = 0; k < kCount; k++) {
				for (l = 0; l < lCount; l++) {
					x = parseInt(document.getElementById("cell_" + cellId).value);
					strArray.push(x + "\n");
					cellId++;
				}
			}
		}
	}

	var Stream = strArray.join("");
	var fineName = "ixjxkxl_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ixjxkxl() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "ixjxkxl") {
		var ijkl = dd[1];
		ijkl = delTopCR(ijkl);
		var ijkl_data = [];
		ijkl_data = ijkl.split(",");
		document.getElementById("iCount").value = parseInt(ijkl_data[0]);
		document.getElementById("jCount").value = parseInt(ijkl_data[1]);
		document.getElementById("kCount").value = parseInt(ijkl_data[2]);
		document.getElementById("lCount").value = parseInt(ijkl_data[3]);
		change4dTable();
		document.getElementById("CandPArea").value = delTopCR(dd[2]);
	}
}
