/**
 * 度数の検定
 * カイ二乗検定 ｉ×ｊ表
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeChisqSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
	// 入力エリアがセルとテキストエリアに切り替わるため
	// changeChisqSetting()の中でsetDragAndDrop()を呼び出している

	document.getElementById("tate").focus();
};
// データ消去の分岐
function clearDataBranch() {
	var jCount = parseInt(document.getElementById("yoko").value);
	if (jCount < 14) {
		// セルの消去
		clearCellData();
	} else {
		// テキストアリアのクリア
		DataClear();
		document.getElementById("cell_sum").value = "";
	}
}
// セルデータの消去
function clearCellData() {
	var i = 1;
	var iCount = parseInt(document.getElementById("tate").value);
	var jCount = parseInt(document.getElementById("yoko").value);
	var elmCount = iCount * jCount;

	var result = confirm("データを消去します");
	if (result === true) {
		for (i = 1; i < elmCount + 1; i++) {
			document.getElementById("cell_" + i).value = "";
		}
		errorClearCell(elmCount, "");

		document.getElementById("cell_sum").value = "";
		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
	document.getElementById("tate").focus();
}
// スタック形式ならクロス集計に分岐
function conditionalBranch() {
	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var tate = parseInt(document.getElementById("tate").value);
	var yoko = parseInt(document.getElementById("yoko").value);
	if (dd.length > tate * yoko) {
		crossTabulate();
	}
}
//スタック形式をクロス集計する
function crossTabulate() {
	var i = 0;
	var j = 0;

	var DData = dataremake5("CandPArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var tate = parseInt(document.getElementById("tate").value);
	var yoko = parseInt(document.getElementById("yoko").value);

	var err = false;

	var NN = countRowCol("CandPArea")[0]; // 行数を取得
	var KK = countRowCol("CandPArea")[1]; // 列数を取得

	// if (dd.length % 2 !== 0) {
	// 	err = true;
	// }

	if (NN === 2) {
		err = true;
	}

	if (KK === -1) { //データが行列形式でない
		err = true;
	}

	if (err === false) {
		for (i = 0; i < dd.length; i = i + 2) {
			if (isNaN(dd[i]) === false) {
				if ((parseInt(dd[i]) > 0) && (parseInt(dd[i]) < tate + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
				if ((parseInt(dd[i + 1]) > 0) && (parseInt(dd[i + 1]) < yoko + 1)) {
					err = false;
				} else {
					err = true;
					break;
				}
			}
		}

		if (err === false) {
			var gunAtai = new Array(tate);
			for (i = 0; i < tate; i++) {
				gunAtai[i] = new Array(yoko);
			}

			for (i = 0; i < tate; i++) {
				for (j = 0; j < yoko; j++) {
					gunAtai[i][j] = 0;
				}
			}

			for (i = 0; i < dd.length; i = i + 2) {
				gunAtai[dd[i] - 1][dd[i + 1] - 1]++;
			}

			var strArray = [];
			for (i = 0; i < tate; i++) {
				for (j = 0; j < yoko; j++) {
					strArray.push(gunAtai[i][j]);
					strArray.push("\t");
				}
				strArray.push("\n");
			}
			document.getElementById("CandPArea").value = strArray.join("");
		} else {
			document.getElementById("CandPArea").value = "";
			if (yoko < 14) {
				alert("データ形式が正しくありません。");
			}
		}
	} else {
		document.getElementById("CandPArea").value = '';
		if (yoko < 14) {
			alert("データ形式が正しくありません。");
		}
	}
}
// 入力チェック
function checkCellData() {
	var i = 1;
	var iCount = parseInt(document.getElementById("tate").value);
	var jCount = parseInt(document.getElementById("yoko").value);
	var elmCount = iCount * jCount;

	var errorCellNum = 0;

	if (jCount < 14) {
		if (document.getElementById("CandPArea").value === "") {
			errorClearCell(elmCount, "");
			errorCell(elmCount, "");

			for (i = 1; i < elmCount + 1; i++) {
				if (document.getElementById("cell_" + i).value === "") {
					errorCellNum = i;
				}
			}
			if (errorCellNum === 0) {
				errorClearCell(elmCount, "");
				sum();
				mainCalc_chisq_ixj();
			} else {
				alert("すべての度数が入力されていません (^_^)ゞ");
				document.getElementById("cell_" + errorCellNum).focus();
			}
		} else {
			var DData = dataremake5("CandPArea");
			DData = crDel(DData);
			var dd = [];
			dd = DData.split(" ");

			conditionalBranch();
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			sum();

			checkCellData();
		}
	} else {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (dd.length == elmCount) {
			mainCalc_chisq_ixj();
		} else {
			alert("データ数が一致しません");
			document.getElementById("DataArea").focus();
		}
	}
}
// メインの計算
function mainCalc_chisq_ixj() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var ii = 0;
	var jj = 0;

	TT = parseInt(document.getElementById("tate").value, 10);
	YY = parseInt(document.getElementById("yoko").value, 10);
	NN = TT * YY;

	var xx = new Array(TT);
	for (i = 0; i < TT; i++) {
		xx[i] = new Array(YY);
	}

	if (YY < 14) {
		var cellId = 1;
		if (document.getElementById("CandPArea").value === "") {
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					xx[i][j] = parseInt(document.getElementById("cell_" + cellId).value);
					cellId++;
				}
			}
		} else {
			var DData = document.getElementById("CandPArea").value;
			var dd = [];
			dd = DData.split(" ");

			var ddCount = 0;
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					xx[i][j] = parseFloat(dd[ddCount]);
					ddCount++;
				}
			}
		}
	} else {
		var DData = dataremake5("DataArea");
		// document.getElementById("DataArea").value = DData; //データエリアに成形データを出力
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		var ddCount = 0;
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				xx[i][j] = parseFloat(dd[ddCount]);
				ddCount++;
			}
		}
	}

	var N = 0; //度数の総合計
	for (i = 0; i < TT; i++) {
		for (j = 0; j < YY; j++) {
			N += xx[i][j];
		}
	}

	var T = new Array(YY); //列の合計
	var Y = new Array(TT); //行の合計
	for (i = 0; i < TT; i++) {
		Y[i] = 0;
		for (j = 0; j < YY; j++) {
			Y[i] += xx[i][j];
		}
	}
	for (j = 0; j < YY; j++) {
		T[j] = 0;
		for (i = 0; i < TT; i++) {
			T[j] += xx[i][j];
		}
	}

	var MC$;
	var EQ$;

	var strArray = [];

	var x2 = 0;
	var DF = 0;
	var MA;
	var PHI;

	var E = new Array(TT);
	for (i = 0; i < TT; i++) {
		E[i] = new Array(YY);
	}
	var Z = new Array(TT);
	for (i = 0; i < TT; i++) {
		Z[i] = new Array(YY);
	}

	if (TT == 1) {
		for (j = 0; j < YY; j++) {
			E[0][j] = N / YY;
			x2 += Math.pow(xx[0][j] - E[0][j], 2) / E[0][j];
		}
		DF = YY - 1;
	} else {
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				E[i][j] = Y[i] * T[j] / N;
				x2 += Math.pow(xx[i][j] - E[i][j], 2) / E[i][j];
			}
		}
		//２ｘ２とのき,イェーツの補正
		if ((TT == 2) && (YY == 2)) {
			if (document.getElementById("Yates").checked) {
				x2 = N * Math.pow(Math.abs(xx[0][0] * xx[1][1] - xx[0][1] * xx[1][0]) - N / 2, 2) / (T[0] * T[1] * Y[0] * Y[1]);
			}
		}
		DF = (TT - 1) * (YY - 1);

		MA = TT - 1;
		if (MA > YY - 1) MA = YY - 1;

		PHI = Math.sqrt(x2 / N / MA);
	}

	var zeroFlag = false;
	for (i = 0; i < TT; i++) {
		for (j = 0; j < YY; j++) {
			if (xx[i][j] === 0) zeroFlag = true;
		}
	}

	// 期待値5以下のセルの判定
	var fiveCount = 0;
	var fiveFlag = false;
	for (i = 0; i < TT; i++) {
		for (j = 0; j < YY; j++) {
			if (E[i][j] <= 5) fiveCount++;
		}
	}
	if (fiveCount / (TT * YY) > 0.2) fiveFlag = true;

	strArray.push("「カイ二乗検定の結果」\n（上段実測値,下段期待値）\n");
	for (i = 0; i < TT; i++) {
		for (j = 0; j < YY; j++) {
			strArray.push("--------");
		}
		strArray.push("\n");

		for (j = 0; j < YY; j++) {
			strArray.push(xx[i][j] + "\t\t");
		}
		strArray.push("\n");
		for (j = 0; j < YY; j++) {
			strArray.push(using(E[i][j], 3, 3) + "\t");
		}
		strArray.push("\n");
	}

	var ppStr = pValue_Match_ChiSquareValue(x2, DF);

	strArray.push("\n");
	if (zeroFlag) {
		strArray.push("実測値０のセルがあります。\n");
	}
	if (fiveFlag) {
		strArray.push("期待値５以下のセルが全セルの２０％を超えています。\n");
	}
	strArray.push("\n");

	strArray.push("x2(" + DF + ")=" + using(x2, 4, 3) + "   ,  " + ppStr);

	strArray.push("\n");
	if (TT > 1) {
		if ((TT == 2) && (YY == 2)) {
			strArray.push("Phi = " + PHI.toFixed(3));
		} else {
			strArray.push("Cramer\'s V = " + PHI.toFixed(3));
		}
	}

	var MC1 = new Array(TT);
	for (i = 0; i < TT; i++) {
		MC1[i] = new Array(YY);
	}
	var MC2 = new Array(TT);
	for (i = 0; i < TT; i++) {
		MC2[i] = new Array(YY);
	}

	strArray.push("\n");
	if (ppStr != "ns") {
		if (TT == 1) {
			if (YY > 2) {
				strArray.push("==ライアンの名義水準を用いた多重比較==\n");
				strArray.push("  (有意水準 alpha = 0.05 とします)\n");
				strArray.push("----------------------------------------------------\n");
				strArray.push("セル比較\t臨界比\t\t検定\t\t名義水準\n");
				strArray.push("----------------------------------------------------\n");

				for (j = 0; j < YY; j++) {
					for (jj = j + 1; jj < YY; jj++) {
						CN = 0;
						for (l = 0; l < YY; l++) {
							if ((l == j) || (l == jj)) {
								CN = CN + 1;
							} else {
								if ((xx[0][j] > xx[0][l]) && (xx[0][jj] <= xx[0][l])) {
									CN = CN + 1;
								}
								if ((xx[0][j] < xx[0][l]) && (xx[0][jj] >= xx[0][l])) {
									CN = CN + 1;
								}
							}
						}
						NL = 0.1 / (YY * (CN - 1));
						CR = (Math.abs(xx[0][j] - xx[0][jj]) - 1) / Math.sqrt(xx[0][j] + xx[0][jj]);
						if (CR < 1.96) {
							MC$ = "ns  p>.05    ";
							EQ$ = "=";
						} else {
							if (CR > 3.62) {
								MC$ = "*   p<0.0002";
								if (xx[0][j] > xx[0][jj]) {
									EQ$ = ">";
								} else {
									EQ$ = "<";
								}
							} else {
								var wP = pValue_to_alphaDash(CR);
								if (wP >= NL) {
									MC$ = "ns  p=" + wP;
									EQ$ = "=";
								}
								if (wP < NL) {
									MC$ = "*   p=" + wP;
									if (xx[0][j] > xx[0][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
							}
						}
						strArray.push((j + 1) + " " + EQ$ + " " + (jj + 1) + " \t" + using(CR, 2, 2) + " \t" + MC$ + " \t" + using(NL, 1, 5) + "\n");
					}
				}
				strArray.push("----------------------------------------------------\n");
			}
		} else {
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					Z[i][j] = (xx[i][j] - E[i][j]) / Math.sqrt(E[i][j]) / Math.sqrt((1 - Y[i] / N) * (1 - T[j] / N));

					if (Math.abs(Z[i][j]) > 2.5758) {
						MC1[i][j] = "  **  ";
						if (Z[i][j] > 0) {
							MC2[i][j] = "▲";
						} else {
							MC2[i][j] = "▽";
						}
					} else if (Math.abs(Z[i][j]) > 1.96) {
						MC1[i][j] = "   *  ";
						if (Z[i][j] > 0) {
							MC2[i][j] = "▲";
						} else {
							MC2[i][j] = "▽";
						}
					} else if (Math.abs(Z[i][j]) > 1.6449) {
						MC1[i][j] = "   +  ";
						MC2[i][j] = " ";
					} else {
						MC1[i][j] = "  ns  ";
						MC2[i][j] = " ";
					}
				}
			}

			strArray.push("\n");
			strArray.push("「 残差分析の結果 」\n（上段調整された残差,下段検定結果）\n");
			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					strArray.push("--------");
				}
				strArray.push("\n");
				for (j = 0; j < YY; j++) {
					strArray.push(using(Z[i][j], 3, 3) + "\t");
				}
				strArray.push("\n");
				for (j = 0; j < YY; j++) {
					strArray.push(MC1[i][j] + "\t");
				}
				strArray.push("\n");
			}

			strArray.push("\n");
			strArray.push(" +p<.10  *p<.05  **p<.01\n\n");

			strArray.push("\n");
			strArray.push("「 実測値と残差分析の結果 」\n");
			for (j = 0; j < YY; j++) {
				strArray.push("--------");
			}
			strArray.push("\n");

			for (i = 0; i < TT; i++) {
				for (j = 0; j < YY; j++) {
					strArray.push(xx[i][j] + "\t" + MC2[i][j] + "\t");
				}
				strArray.push("\n");
			}
			for (j = 0; j < YY; j++) {
				strArray.push("--------");
			}

			strArray.push("\n");
			strArray.push("（▲有意に多い,▽有意に少ない,p<.05）\n\n");
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	if (document.getElementById("RltAdd").checked) {
		document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	} else {
		document.getElementById("RltArea").value = strArray.join("");
	}
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var rcmArray = [];

		rcmArray.push("####### ｉ×ｊ表(カイ二乗検定) #######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ pwr が必要\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARからの入力\n");
		rcmArray.push("levI <- " + TT + "      # ｉの水準数\n");
		rcmArray.push("levJ <- " + YY + "      # ｊの水準数\n");
		rcmArray.push("\n");

		rcmArray.push("dosu <- c(\n");
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				rcmArray.push("  " + xx[i][j]);
				if ((i == TT - 1) && (j == YY - 1)) {
					rcmArray.push(" )\n");
				} else {
					rcmArray.push(",");
				}
			}
			rcmArray.push("\n");
		}
		rcmArray.push("## js-STARからの入力おわり\n");
		rcmArray.push("\n");

		rcmArray.push("hyo <- c()\n");
		rcmArray.push("hyo <- matrix(dosu, nr=levI, by=1)\n");
		rcmArray.push("N   <- sum( hyo )\n");
		rcmArray.push("\n");
		rcmArray.push("# 標本比率の計算\n");
		rcmArray.push("gokei <- c()\n");
		rcmArray.push("bunbo <- c()\n");
		rcmArray.push("for(i in 1:levI) # 各群の度数を集計\n");
		rcmArray.push("  {\n");
		rcmArray.push("   ds <- c()\n");
		rcmArray.push("   for(j in 1:levJ)\n");
		rcmArray.push("     {\n");
		rcmArray.push("      ds <- c(ds, dosu[(i-1)*levJ+j])\n");
		rcmArray.push("     }\n");
		rcmArray.push("   gokei <- c(gokei, sum(ds))\n");
		rcmArray.push("   bunbo <- c(bunbo, rep(sum(ds), levJ))\n");
		rcmArray.push("  }\n");
		rcmArray.push("hyohir <- dosu/bunbo # 群別の各値の比率\n");
		rcmArray.push("\n");
		rcmArray.push("tx0 <- cbind( hyo, gokei )\n");
		rcmArray.push("rownames(tx0) <- c(\n");
		rcmArray.push("  paste(\"群\", 1:levI, sep=\"\") )\n");
		rcmArray.push("colnames(tx0) <- c(\n");
		rcmArray.push("  paste(\"  値\", 1:levJ, sep=\"\"),\n");
		rcmArray.push("  \" 合計\")\n");
		rcmArray.push("\n");
		rcmArray.push("hirits <- c()\n");
		rcmArray.push("for(i in 1:levI){\n");
		rcmArray.push("for(j in 1:levJ){\n");
		rcmArray.push("  hirits <- c(hirits,\n");
		rcmArray.push("    hyohir[(i-1)*levJ+j] )\n");
		rcmArray.push("  }\n");
		rcmArray.push("  hirits <- c(hirits, 1.0000)\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 <- c()\n");
		rcmArray.push("tx1 <- matrix(\n");
		rcmArray.push("  hirits, nr=levI, by=1)\n");
		rcmArray.push("rownames(tx1) <- c(\n");
		rcmArray.push("  paste(\"群\", 1:levI, sep=\"\") )\n");
		rcmArray.push("colnames(tx1) <- c(\n");
		rcmArray.push("  paste(\"    値\", 1:levJ, sep=\"\"),\n");
		rcmArray.push("  \" 合計\")\n");

		rcmArray.push("\n");
		rcmArray.push("# 図を描く\n");
		rcmArray.push("zuhir <- c()\n");
		rcmArray.push("for(i in levI:1) # 群ｉ→群１と逆順に並べ替える\n");
		rcmArray.push("  {\n");
		rcmArray.push("   for(j in 1:levJ)\n");
		rcmArray.push("     {\n");
		rcmArray.push("      zuhir <- c(zuhir, \n");
		rcmArray.push("        hyohir[(i-1)*levJ+j] )\n");
		rcmArray.push("     }\n");
		rcmArray.push("  }\n");
		rcmArray.push("\n");
		rcmArray.push("zubar <- matrix(c(\n");
		rcmArray.push("  zuhir\n");
		rcmArray.push("  ), nc=levJ, by=1)\n");
		rcmArray.push("rownames(zubar) <- c(\n");
		rcmArray.push("  paste(\"群\", levI:1, sep=\"\") ) # 群ｉ→群１,降順に\n");
		rcmArray.push("maintitle <- c(\"値１（濃）～値ｊ（淡）の比率\")\n");
		rcmArray.push("barplot( t(zubar), hor=1, las=1,\n");
		rcmArray.push("         main=maintitle,\n");
		rcmArray.push("         cex.ax=1.5, cex.na=1.5)\n");

		rcmArray.push("\n");
		rcmArray.push("## フィッシャー正確検定\n");
		rcmArray.push("kfish <- c()\n");
		rcmArray.push("kfish <- fisher.test( hyo )\n");

		rcmArray.push("\n");
		rcmArray.push("# 多重比較２×ｊ←fisher.test\n");
		rcmArray.push("pchi <- c()\n");
		rcmArray.push("for(i in 1:(levI-1))\n");
		rcmArray.push("  {\n");
		rcmArray.push("for(k in (i+1):levI)\n");
		rcmArray.push("  {\n");
		rcmArray.push("  ds <- c()\n");
		rcmArray.push("  for(j in 1:levJ)\n");
		rcmArray.push("    {\n");
		rcmArray.push("    ds <- c(ds, dosu[(i-1)*levJ+j])\n");
		rcmArray.push("    }\n");
		rcmArray.push("  for(j in 1:levJ)\n");
		rcmArray.push("    {\n");
		rcmArray.push("    ds <- c(ds, dosu[(k-1)*levJ+j])\n");
		rcmArray.push("    }\n");
		rcmArray.push("  pchi <- c(pchi,\n");
		rcmArray.push("    fisher.test(\n");
		rcmArray.push("      matrix(ds, nr=2, by=1)\n");
		rcmArray.push("      )$p.va )\n");
		rcmArray.push("  } }\n");
		rcmArray.push("padj <- c()\n");
		rcmArray.push("padj <- p.adjust(pchi, \"BH\")\n");

		rcmArray.push("\n");
		rcmArray.push("# パワーアナリシス: ES.w2\n");
		rcmArray.push("library( pwr )\n");
		rcmArray.push("es <- c()\n");
		rcmArray.push("es <- ES.w2( hyo/N ) # 効果量w\n");
		rcmArray.push("df <- (levI-1)*(levJ-1)\n");
		rcmArray.push("\n");
		rcmArray.push("kr5 <- c()\n");
		rcmArray.push("kr5 <- pwr.chisq.test(\n");
		rcmArray.push("       w=es, \n");
		rcmArray.push("       N=N,\n");
		rcmArray.push("       df=df,\n");
		rcmArray.push("       si=0.05,\n");
		rcmArray.push("       po=NULL )\n");
		rcmArray.push("\n");
		rcmArray.push("kr6 <- NA\n");
		rcmArray.push("kr6 <- c(\n");
		rcmArray.push("  pwr.chisq.test(\n");
		rcmArray.push("  w=es, N=NULL,\n");
		rcmArray.push("  df=df, si=0.05, po=0.8)$N,\n");
		rcmArray.push("  kr6 )\n");
		rcmArray.push("\n");
		rcmArray.push("kr7 <- NA\n");
		rcmArray.push("kr7 <- c(\n");
		rcmArray.push("  pwr.chisq.test(\n");
		rcmArray.push("  w=es, N=N,\n");
		rcmArray.push("  df=df, si=NULL, po=0.8)$si,\n");
		rcmArray.push("  kr7 )\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 <- c()\n");
		rcmArray.push("tx2 <- matrix(c(\n");
		rcmArray.push("  round(kfish$p.v, 4)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tx2) <- c(\"フィッシャーの正確検定\")\n");
		rcmArray.push("colnames(tx2) <- c(\"  ｐ値\")\n");
		rcmArray.push("\n");
		rcmArray.push("# 多重比較\n");
		rcmArray.push("tx3 <- c()\n");
		rcmArray.push("tx3 <- matrix( c(\n");
		rcmArray.push("  round(pchi, 4),\n");
		rcmArray.push("  round(padj, 4)\n");
		rcmArray.push("  ), nr=(levI^2-levI)/2 )\n");
		rcmArray.push("\n");
		rcmArray.push("kochi<-c(); aite<-c()\n");
		rcmArray.push("for(i in 1:(levI-1))\n");
		rcmArray.push("  {\n");
		rcmArray.push("for(j in (i+1):levI)\n");
		rcmArray.push("    {\n");
		rcmArray.push("    kochi <- c(kochi, paste(\"群\", i, sep=\"\"))\n");
		rcmArray.push("    aite  <- c(aite,  paste(\"群\", j, sep=\"\"))\n");
		rcmArray.push("    }\n");
		rcmArray.push("  }\n");
		rcmArray.push("rownames(tx3) <- paste(\n");
		rcmArray.push("  kochi, aite, sep=\" vs \")\n");
		rcmArray.push("colnames(tx3) <- c(\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 調整後ｐ値\" )\n");
		rcmArray.push("\n");
		rcmArray.push("# パワアナ出力\n");
		rcmArray.push("tx4 <- c()\n");
		rcmArray.push("tx4 <- matrix(c(\n");
		rcmArray.push("  round(es,     4),\n");
		rcmArray.push("  round(kr7[1], 4),\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("            df,\n");
		rcmArray.push("             N,\n");
		rcmArray.push("\n");
		rcmArray.push("  round(es, 4),\n");
		rcmArray.push("          0.05,\n");
		rcmArray.push("          0.80,\n");
		rcmArray.push("            df,\n");
		rcmArray.push("  ceiling(kr6[1])\n");
		rcmArray.push("  ), nr=2, by=1)\n");
		rcmArray.push("rownames(tx4) <- c(\" α の計算\",\" Ｎ の計算\")\n");
		rcmArray.push("colnames(tx4) <- c(\"効果量ｗ\",\n");
		rcmArray.push("                   \"     α\",\n");
		rcmArray.push("                   \" 1-β\", \n");
		rcmArray.push("                   \" df\",\n");
		rcmArray.push("                   \"  Ｎ\")\n");

		rcmArray.push("\n");
		rcmArray.push("## カイ二乗検定\n");
		rcmArray.push("kchis <- c()\n");
		rcmArray.push("kchis <- chisq.test( hyo )\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 <- c()\n");
		rcmArray.push("tx9 <- kchis$exp\n");
		rcmArray.push("rownames(tx9) <- c(\n");
		rcmArray.push("  paste(\"群\", 1:levI, sep=\"\") )\n");
		rcmArray.push("colnames(tx9) <- c(\n");
		rcmArray.push("  paste(\"    値\", 1:levJ, sep=\"\") )\n");
		rcmArray.push("\n");
		rcmArray.push("tc2 <- c()\n");
		rcmArray.push("tc2 <- matrix(c(\n");
		rcmArray.push("  round(kchis$sta, 4),\n");
		rcmArray.push("  round(kchis$par, 4),\n");
		rcmArray.push("  round(kchis$p.v, 4),\n");
		rcmArray.push("  round(  kr5$w,   4),\n");
		rcmArray.push("  round(  kr5$po,  4)\n");
		rcmArray.push("  ), nr=1)\n");
		rcmArray.push("rownames(tc2) <- c(\"\")\n");
		rcmArray.push("colnames(tc2) <- c(\n");
		rcmArray.push("  \" χ2 値\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 効果量ｗ\",\n");
		rcmArray.push("  \" 検出力\")\n");
		rcmArray.push("\n");
		rcmArray.push("# 残差分析\n");
		rcmArray.push("gyouhir <- bunbo/N # 行比率\n");
		rcmArray.push("retshir <- c()     # 列比率\n");
		rcmArray.push("retsgok <- c()     # 列合計\n");
		rcmArray.push("for(j in 1:levJ)\n");
		rcmArray.push("  {\n");
		rcmArray.push("   ds <- c()\n");
		rcmArray.push("   for(i in 1:levI)\n");
		rcmArray.push("     {\n");
		rcmArray.push("      ds <- c(ds, dosu[j+(i-1)*levJ])\n");
		rcmArray.push("     }\n");
		rcmArray.push("   retsgok <- c(retsgok, sum(ds))\n");
		rcmArray.push("  }\n");
		rcmArray.push("retshir <- rep(retsgok/N, levI)\n");
		rcmArray.push("zansa   <-\n");
		rcmArray.push("  as.numeric( t(kchis$residual) )/sqrt(\n");
		rcmArray.push("  (1-gyouhir)*(1-retshir) )\n");
		rcmArray.push("\n");
		rcmArray.push("tc4 <- c()\n");
		rcmArray.push("tc4 <- matrix(\n");
		rcmArray.push("  round(zansa, 4), nr=levI, by=1)\n");
		rcmArray.push("rownames(tc4) <- paste(\"群\", 1:levI, sep=\"\")\n");
		rcmArray.push("colnames(tc4) <- paste(\"     値\", 1:levJ, sep=\"\")\n");
		rcmArray.push("\n");
		rcmArray.push("pchi <- c()\n");
		rcmArray.push("for(i in 1:(levI*levJ))\n");
		rcmArray.push("  {\n");
		rcmArray.push("   rsd  <- zansa[i]\n");
		rcmArray.push("   pchi <- c(pchi,\n");
		rcmArray.push("     pnorm(rsd,\n");
		rcmArray.push("       low=sign( (sign(rsd)-1)*(-1) )\n");
		rcmArray.push("       ) )\n");
		rcmArray.push("  }\n");
		rcmArray.push("padj <- c()\n");
		rcmArray.push("padj <- p.adjust(pchi, \"BH\")\n");
		rcmArray.push("\n");
		rcmArray.push("tc5 <- c()\n");
		rcmArray.push("tc5 <- matrix(\n");
		rcmArray.push("  round(padj, 4), nr=levI, by=1)\n");
		rcmArray.push("rownames(tc5) <- paste(\"群\", 1:levI, sep=\"\")\n");
		rcmArray.push("colnames(tc5) <- paste(\"    値\", 1:levJ, sep=\"\")\n");
		rcmArray.push("\n");
		rcmArray.push("# 多重比較\n");
		rcmArray.push("stat <- c()\n");
		rcmArray.push("jiyu <- c()\n");
		rcmArray.push("pchi <- c()\n");
		rcmArray.push("for(i in 1:(levI-1))\n");
		rcmArray.push("  {\n");
		rcmArray.push("for(k in (i+1):levI)\n");
		rcmArray.push("  {\n");
		rcmArray.push("  ds <- c()\n");
		rcmArray.push("  for(j in 1:levJ)\n");
		rcmArray.push("    {\n");
		rcmArray.push("    ds <- c(ds, dosu[(i-1)*levJ+j])\n");
		rcmArray.push("    }\n");
		rcmArray.push("  for(j in 1:levJ)\n");
		rcmArray.push("    {\n");
		rcmArray.push("    ds <- c(ds, dosu[(k-1)*levJ+j])\n");
		rcmArray.push("    }\n");
		rcmArray.push("\n");
		rcmArray.push("    kaik <- c()\n");
		rcmArray.push("    kaik <- chisq.test(matrix(ds, nr=2, by=1))\n");
		rcmArray.push("    stat <- c(stat,kaik$stat)\n");
		rcmArray.push("    jiyu <- c(jiyu,kaik$para)\n");
		rcmArray.push("    pchi <- c(pchi,\n");
		rcmArray.push("              kaik$p.va )\n");
		rcmArray.push("  } }\n");
		rcmArray.push("padj <- c()\n");
		rcmArray.push("padj <- p.adjust(pchi, \"BH\")\n");
		rcmArray.push("\n");
		rcmArray.push("tc3 <- c()\n");
		rcmArray.push("tc3 <- matrix( c(\n");
		rcmArray.push("  round(stat, 4),\n");
		rcmArray.push("  round(jiyu, 4),\n");
		rcmArray.push("  round(pchi, 4),\n");
		rcmArray.push("  round(padj, 4)\n");
		rcmArray.push("  ), nr=(levI^2-levI)/2 )\n");
		rcmArray.push("rownames(tc3) <- paste(\n");
		rcmArray.push("  kochi, aite, sep=\" vs \")\n");
		rcmArray.push("colnames(tc3) <- c(\n");
		rcmArray.push("  \"  χ2 値\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"  ｐ値\",\n");
		rcmArray.push("  \" 調整後ｐ値\" )\n");

		rcmArray.push("\n");
		rcmArray.push("options(digits=4)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("###########################\n");
		rcmArray.push("#   カイ二乗検定ｉ×ｊ：  #\n");
		rcmArray.push("#     ｉ群×ｊ値の分析    #\n");
		rcmArray.push("#     （独立性の検定）    #\n");
		rcmArray.push("###########################\n");
		rcmArray.push("tx0 # 度数集計表\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # 各群の値の比率\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 # 各セルの期待度数\n");
		rcmArray.push("# 期待度数５未満のセルがあるときは注意！\n");
		rcmArray.push("\n");
		rcmArray.push("tc2 # カイ二乗検定\n");
		rcmArray.push("#  p<α なら群間に有意差あり！\n");
		rcmArray.push("# 効果量ｗの評価：大=0.5, 中=0.3, 小=0.1\n");
		rcmArray.push("# (注)２×２表のときχ2 値は連続性修正値\n");
		rcmArray.push("\n");
		rcmArray.push("tc4 # 残差分析（調整された残差）\n");
		rcmArray.push("\n");
		rcmArray.push("tc5 # 残差の調整後有意確率（片側確率）\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray.push("\n");
		rcmArray.push("tc3 # 群の多重比較（カイ二乗検定）\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 # パワーアナリシス\n");
		rcmArray.push("# ■ NULL, NA が表示されたら計算不能■\n");
		rcmArray.push("# Ｎは総度数（total sample size）を示す\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 #［参考］\n");
		rcmArray.push("# ■ NULL は計算不能\n");
		rcmArray.push("tx3 # 多重比較（Fisher's exact test, 両側）\n");
		rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		if (document.getElementById("RltAdd").checked) {
			document.getElementById("RcmArea").value += "\n\n" + rcmArray.join("");
		} else {
			document.getElementById("RcmArea").value = rcmArray.join("");
		}
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		if (document.getElementById("RltAdd").checked === false) {
			chartClear();
		}

		var parent = document.getElementById("chart");
		var childElementCount = parent.childElementCount;

		var i, j;
		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg" + childElementCount;
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var data = [];
		for (j = 0; j < YY; j++) {
			data[j] = [];
		}

		for (j = 0; j < YY; j++) {
			for (i = 0; i < TT; i++) {
				data[j][i] = ((xx[i][j] / Y[i]) * 100).toFixed(4);
			}
		}

		var datasetKey = [];
		for (j = 0; j < YY; j++) {
			datasetKey[j] = [];
		}
		var wC = 0;
		for (j = 0; j < YY; j++) {
			datasetKey[j].label = '値' + (j + 1);
			datasetKey[j].data = data[j];

			if (j === 0) {
				wC = 0; //最初の色は000000
			} else {
				wC = (parseInt("F0", 16) / (YY - 1) * j).toFixed(0); //最後の色はF0F0F0
				wC = parseInt(wC, 10);
			}
			datasetKey[j].backgroundColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';
			datasetKey[j].borderColor = 'rgba(' + wC + ',' + wC + ',' + wC + ')';

			datasetKey[j].borderWidth = 1;
		}

		var labelData = [];
		for (i = 0; i < TT; i++) {
			labelData.push('群' + (i + 1));
		}

		var datasetData = [];
		for (j = 0; j < YY; j++) {
			datasetData[j] = datasetKey[j];
		}

		var myChart = new Chart(ctx, {
			type: 'horizontalBar',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				title: {
					display: true,
					text: '値１（黒）～値ｊ（淡）の比率',
					position: 'top',
					fontSize: 12,
					fontColor: '#000000'
				},
				scales: {
					xAxes: [{
						stacked: true,
						ticks: {
							beginAtZero: true,
							min: 0,
							max: 100
						}
					}],
					yAxes: [{
						stacked: true
					}]
				},
				legend: {
					position: 'bottom'
				}
			}
		});
	}());

	document.getElementById("RltArea").focus();
}
/**
 * 合計：セルレイアウト
 */
function sum() {
	var i = 1;
	var iCount = parseInt(document.getElementById("tate").value);
	var jCount = parseInt(document.getElementById("yoko").value);
	var elmCount = iCount * jCount;

	var wSum = 0;

	if (jCount < 14) {
		for (i = 1; i < elmCount + 1; i++) {
			if (isNaN(parseInt(document.getElementById("cell_" + i).value)) === false) {
				wSum += parseInt(document.getElementById("cell_" + i).value);
			}
		}
		document.getElementById("cell_sum").value = wSum;
	} else {
		sum2();
	}
}
/**
 * 合計：テキストレイアウト
 */
function sum2() {
	var DData = dataremake5("DataArea");
	// document.getElementById("DataArea").value = DData; //データエリアに成形データを出力
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var sum = 0;
	for (var i in dd) {
		sum += parseInt(dd[i], 10);
	}

	if (isNaN(sum)) {
		document.getElementById("cell_sum").value = "";
	} else {
		document.getElementById("cell_sum").value = sum;
	}
}
/**
 * [checkYates イエーツの修正 可能チェック]
 * ２×２ならば，イエーツの修正が可能
 */
function checkYates() {
	var iCount = parseInt(document.getElementById("tate").value);
	var jCount = parseInt(document.getElementById("yoko").value);

	if ((iCount == 2) && (jCount == 2)) {
		document.getElementById("Yates").disabled = false;
	} else {
		document.getElementById("Yates").disabled = true;
	}
}
/**
 * [changeChisqSetting セルなどの入力フォーム部分を作成]
 */
function changeChisqSetting() {
	var htmArray = [];

	htmArray.push("<div class=\"tateyoko\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("縦(行)：<input type=\"number\" class=\"text9\" id=\"tate\" size=\"10\" maxlength=\"10\"  min=\"2\"  max=\"100\" value=\"8\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeChisqTable();checkYates();\">");
		htmArray.push("×横(列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" maxlength=\"10\"  min=\"2\"  max=\"100\" value=\"12\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\" oninput=\"changeChisqTable();checkYates();\">");
	} else {
		htmArray.push("縦(行)：<select name=\"tate\" id=\"tate\" class=\"tySelect\" size=\"1\" onchange=\"changeChisqTable();checkYates();\">");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\" selected>8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\">10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\">12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("<option value=\"14\">14</option>");
		htmArray.push("<option value=\"15\">15</option>");
		htmArray.push("<option value=\"16\">16</option>");
		htmArray.push("<option value=\"17\">17</option>");
		htmArray.push("<option value=\"18\">18</option>");
		htmArray.push("<option value=\"19\">19</option>");
		htmArray.push("<option value=\"20\">20</option>");
		htmArray.push("</select>");
		htmArray.push("×横(列)：<select name=\"yoko\" id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"changeChisqTable();checkYates();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\">10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\" selected>12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</div>");

	document.getElementById("chisq_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeChisqTable();
}
function changeChisqTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var l = 0;
	var iCount = parseInt(document.getElementById("tate").value);
	var jCount = parseInt(document.getElementById("yoko").value);

	var htmArray = [];
	var cellId = 1;
	var cellCount = iCount * jCount;

	if (jCount < 14) {
		htmArray.push("<div class=\"chisqtext\">");
		for (i = 0; i < iCount; i++) {
			htmArray.push("<div id=\"chisqrow" + (i + 1) + "\" class=\"chisqrow\">");
			for (j = 0; j < jCount; j++) {
				htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" maxl=\"999\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\" onKeyUp=\"sum()\"> ");
				cellId++;
			}
			htmArray.push("</div>");
		}
		htmArray.push("</div>");

		// htmArray.push("<div id=\"n\">");
		// htmArray.push("N = <input type=\"text\" class=\"text2\" size=\"5\" maxlength=\"5\" name=\"N\" id=\"cell_sum\" readonly=\"readonly\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">");
		// htmArray.push("</div>");

		// htmArray.push("<div class=\"btnlayout3\">");
		// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
		// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"conditionalBranch();copipe('CandPArea','text');inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);sum();\"></span>");
		// htmArray.push("</div>");

		document.getElementById("chisq_table").innerHTML = htmArray.join("");
		htmArray = null;
		//document.getElementById("CandPArea").style.display = "inline";
		document.getElementById("CPdiv").style.display = "inline";

		// setDragAndDrop();
	} else {
		htmArray.push("<textarea wrap=\"off\" id=\"DataArea\" name=\"DataArea\" class=\"qa\" rows=\"15\" cols=\"60\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onkeydown=\"OutputRandNum(event);\" onkeyup=\"sum2();\"></textarea>");

		document.getElementById("chisq_table").innerHTML = htmArray.join("");
		htmArray = null;
		//document.getElementById("CandPArea").style.display = "none";
		document.getElementById("CPdiv").style.display = "none";

		// setDragAndDrop2();
	}
}
function saveData_ixj() {
	var i, j;

	var strArray = [];

	var TT = parseInt(document.getElementById("tate").value);
	var YY = parseInt(document.getElementById("yoko").value);

	var Stream;
	var x;

	//#0
	strArray.push("ixj" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(TT + "," + YY + "\n");
	//#2
	strArray.push("#" + "\n");
	if (YY < 14) {
		var cellId = 1;
		for (i = 0; i < TT; i++) {
			for (j = 0; j < YY; j++) {
				x = parseInt(document.getElementById("cell_" + cellId).value);
				if (j !== YY - 1) {
					strArray.push(x + "\t");
				} else {
					strArray.push(x);
				}
				cellId++;
			}
			if (i !== TT - 1) {
				strArray.push("\n");
			}
		}

		Stream = strArray.join("");
	} else {
		Stream = strArray.join("");
		Stream += document.getElementById("DataArea").value;
	}

	var fineName = "ixj_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_ixj() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "ixj") {
		var tateyoko = dd[1];
		tateyoko = delTopCR(tateyoko);
		var tateyoko_data = [];
		tateyoko_data = tateyoko.split(",");
		document.getElementById("tate").value = parseInt(tateyoko_data[0]);
		document.getElementById("yoko").value = parseInt(tateyoko_data[1]);
		changeChisqTable();
		if (document.getElementById("yoko").value < 14) {
			document.getElementById("CandPArea").value = delTopCR(dd[2]);
		} else {
			document.getElementById("DataArea").value = delTopCR(dd[2]);
		}
	}
}