/**
 * 相関分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 5);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop2();

};
// key_shift = false;
// document.onkeydown = function (event) {
// 	var key_event = event || window.event;
// 	key_shift = (key_event.shiftKey);
// };
function checkData() {
	var err = false;
	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {

		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK === -1) {
			err = true;
			alert("データが行列形式ではありません");
		}

		if (err == false) {
			mainCalc_corr();
		}
	}
}
function mainCalc_corr() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var strArray = [];
	bar = "--------------------------------------\n";
	var diaArray = [];
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseFloat(dd[ddCount]);
			ddCount++;
		}
	}

	var M = [];
	var SD = [];
	var MA = [];
	var MI = [];

	//基本統計量
	strArray.push(" == Means & SDs(SD=sqrt(Vtotal/N)) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (j = 0; j < KK; j++) {
		S = 0;
		SS = 0;
		MA[j] = xx[0][j];
		MI[j] = xx[0][j];

		for (i = 0; i < NN; i++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[j] < xx[i][j]) MA[j] = xx[i][j];
			if (MI[j] > xx[i][j]) MI[j] = xx[i][j];
		}

		M[j] = S / NN;
		SD[j] = Math.sqrt(SS / NN - Math.pow(M[j], 2));

		strArray.push((j + 1) + "\t" + using(M[j], 4, 3) + "\t" + using(SD[j], 4, 3) + "\t" + using(MI[j], 4, 3) + "\t" + using(MA[j], 4, 3) + "\n");
	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (j = 0; j < KK; j++) {
		strArray.push((j + 1) + "\t" + using(M[j] + SD[j], 4, 3) + "\t" + using(M[j] - SD[j], 4, 3) + "\n");
	}
	strArray.push(bar);

	var R = new Array(KK);
	for (j = 0; j < KK; j++) {
		R[j] = new Array(KK);
	}

	var FF = new Array(KK);
	for (j = 0; j < KK; j++) {
		FF[j] = new Array(KK);
	}

	var F$ = new Array(KK);
	for (j = 0; j < KK; j++) {
		F$[j] = new Array(KK);
	}

	var lineWidth = new Array(KK);
	for (j = 0; j < KK; j++) {
		lineWidth[j] = new Array(KK);
	}

	var corrStr = new Array(KK);
	for (j = 0; j < KK; j++) {
		corrStr[j] = new Array(KK);
	}

	var FF1, FF2, FF3;

	S = 0;
	for (j = 0; j < KK - 1; j++) {
		for (jj = j + 1; jj < KK; jj++) {
			S = 0;
			for (i = 0; i < NN; i++) {
				S += (xx[i][j] - M[j]) * (xx[i][jj] - M[jj]);
			}
			R[j][jj] = S / NN / SD[j] / SD[jj];
			if (R[j][jj] > 0.9999) {
				FF[j][jj] = 999.99;
			} else {
				if (Math.pow(R[j][jj], 2) == 1) {
					FF[j][jj] = 0;
				} else {
					FF[j][jj] = Math.pow(R[j][jj], 2) / (1 - Math.pow(R[j][jj], 2)) * (NN - 2);
				}
			}

			FF3 = f_tables(2, NN); //１％水準
			FF2 = f_tables(1, NN); //５％水準
			FF1 = f_tables(0, NN); //１０％水準

			if (NN > 2) {
				if (FF[j][jj] > FF3) { //１％水準
					F$[j][jj] = "**";
					if (Math.abs(R[j][jj]) >= 0.9) {
						lineWidth[j][jj] = 8;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.7) {
						lineWidth[j][jj] = 6;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.5) {
						lineWidth[j][jj] = 4;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.3) {
						lineWidth[j][jj] = 2;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
					} else {
						lineWidth[j][jj] = 1;
						corrStr[j][jj] = "";
					}
				} else if (FF[j][jj] > FF2) { //５％水準
					F$[j][jj] = " *";
					if (Math.abs(R[j][jj]) >= 0.9) {
						lineWidth[j][jj] = 8;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には非常強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.7) {
						lineWidth[j][jj] = 6;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には強い関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.5) {
						lineWidth[j][jj] = 4;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には中程度の関連があります。\n";
					} else if (Math.abs(R[j][jj]) >= 0.3) {
						lineWidth[j][jj] = 2;
						corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "には弱い関連があります。\n";
					} else {
						lineWidth[j][jj] = 1;
						corrStr[j][jj] = "";
					}
				} else if (FF[j][jj] > FF1) { //１０％水準
					F$[j][jj] = " +";
					lineWidth[j][jj] = 1;
					corrStr[j][jj] = "項目" + (j + 1) + "と項目" + (jj + 1) + "は弱く関連する可能性があります。\n";
				} else {
					F$[j][jj] = "ns";
					lineWidth[j][jj] = 0;
					corrStr[j][jj] = "";
				}
			} else {
				F$[j][jj] = "ns";
				lineWidth[j][jj] = 0;
				corrStr[j][jj] = "";
			}
		}
	}
	strArray.push("\n");
	strArray.push("\n Correlation Matrix\n");
	strArray.push("  df= 1 & " + (NN - 2) + "\n");

	var diagramData = KK + "\n";
	var wStr = "";

	strArray.push(bar);
	for (j = 0; j < KK; j++) {
		strArray.push("\tVar" + (j + 1));
	}
	strArray.push("\n");
	strArray.push(bar);

	for (j = 0; j < KK; j++) {
		strArray.push("Var" + (j + 1));
		for (jj = 0; jj < j + 1; jj++) {
			strArray.push("\t");
		}
		strArray.push("-");
		for (jj = j + 1; jj < KK; jj++) {
			strArray.push("\t" + using(R[j][jj], 2, 3) + " " + F$[j][jj]);
		}
		strArray.push("\n");
	}

	strArray.push("\nTest of Correlation\n");
	for (j = 0; j < KK - 1; j++) {
		strArray.push(bar);
		strArray.push("  Var.       r       F   Test\n");
		strArray.push(bar);
		for (jj = j + 1; jj < KK; jj++) {
			strArray.push(" Var" + (j + 1) + "xVar" + (jj + 1) + "\t");
			strArray.push(using(R[j][jj], 2, 3) + "\t" + using(FF[j][jj], 3, 2) + "\t" + F$[j][jj] + "\n");
			if (lineWidth[j][jj] != 0) {
				diagramData += (j + 1) + "," + (jj + 1) + "," + using(R[j][jj], 2, 3) + "," + lineWidth[j][jj] + "\n";
			}
			if (corrStr[j][jj] != "") {
				wStr += corrStr[j][jj];
			}
		}
	}

	strArray.push("\n" + bar + "\n" + wStr);
	// strArray.push("\n"+bar+"▽　視覚化データ\n");
	// strArray.push(diagramData);
	// strArray.push("\n"+"△　ここまで\n\n");

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	// ダイアグラム出力
	document.getElementById("corrDiaArea").value = diagramData;
	corrDiaDraw();

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	// var gResult = null;
	// if (key_shift) {
	// 	gResult = prompt("グラフの軸設定（最小値と最大値をカンマで区切る）　例： 0,100");
	// 	gResult.replace(/\s+/g, ""); //空白文字を全削除
	// }

	//出力
	// if (document.getElementById("RltAdd").checked) {
	// 	document.getElementById("RltArea").value += "\n\n" + strArray.join("");
	// } else {
	document.getElementById("RltArea").value = strArray.join("");
	// }
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (i = 0; i < NN; i++) {
				for (j = 0; j < KK; j++) {
					rcmArray1.push(xx[i][j]);
					if ((j != KK - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			for (j = 0; j < KK; j++) {
				rcmArray.push("x" + (j + 1) + " <- c(");
				for (i = 0; i < NN; i++) {
					rcmArray.push(" " + xx[i][j]);
					if ((i != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}

			rcmArray.push("\n");
			rcmArray.push("dtab <- data.frame(\n");
			for (j = 0; j < KK; j++) {
				rcmArray.push(" x" + (j + 1));
				if ((j != KK - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");
			for (j = 0; j < KK; j++) {
				rcmArray.push("x" + (j + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("#######  相関係数計算 #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 設定データ\n");
		rcmArray2.push("N=" + NN + "\n");
		rcmArray2.push("hensu=" + KK + "\n");
		rcmArray2.push("\n");
		rcmArray2.push("SOKAN=\"pearson\"  # ピアソンの積率相関係数\n");
		rcmArray2.push("\n");
		rcmArray2.push("# SOKAN=\"spearman\" #スピアマンの順位相関係数\n");
		rcmArray2.push("# SOKAN=\"kendall\"  # ケンドールの順位相関係数\n");
		rcmArray2.push("\n");

		rcmArray2.push("saiyo <- 1:hensu\n");
		rcmArray2.push("colnames(dtab) <- paste(\"x\", saiyo, sep=\"\")\n");
		rcmArray2.push("dset <- data.frame(dtab[,saiyo])\n");
		rcmArray2.push("\n");

		rcmArray2.push("## 基本統計量\n");
		rcmArray2.push("dx <- dset[ ,1:hensu]\n");
		rcmArray2.push("hk <- sapply(dx, mean)\n");
		rcmArray2.push("sd <- sapply(dx,   sd)\n");
		rcmArray2.push("n  <- c()\n");
		rcmArray2.push("mi <- c()\n");
		rcmArray2.push("ma <- c()\n");
		rcmArray2.push("for(i in 1:hensu){\n");
		rcmArray2.push("  dz <- dx[ ,i]\n");
		rcmArray2.push("  n  <- c(n,\n");
		rcmArray2.push("    length(dz[!is.na(dz)]) )\n");
		rcmArray2.push("  mi <- c(mi,min(dz,na.rm=1))\n");
		rcmArray2.push("  ma <- c(ma,max(dz,na.rm=1))\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx0 <- c()\n");
		rcmArray2.push("tx0 <- data.frame(\n");
		rcmArray2.push("  n,\n");
		rcmArray2.push("  round(hk, 4),\n");
		rcmArray2.push("  round(sd, 4),\n");
		rcmArray2.push("  mi,\n");
		rcmArray2.push("  ma\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("colnames(tx0) <- c(\n");
		rcmArray2.push("  \"   Ｎ\",\n");
		rcmArray2.push("  \"     Mean\",\n");
		rcmArray2.push("  \"       SD\",\n");
		rcmArray2.push("  \"   Min\",\n");
		rcmArray2.push("  \"  Max\" )\n");
		rcmArray2.push("\n");
		rcmArray2.push("\n");
		rcmArray2.push("# 相関行列\n");
		rcmArray2.push("keis <- c()\n");
		rcmArray2.push("pchi <- c()\n");
		rcmArray2.push("padj <- c()\n");
		rcmArray2.push("\n");
		rcmArray2.push("for(i in 1:hensu){\n");
		rcmArray2.push("for(j in 1:hensu){\n");
		rcmArray2.push("  if(i<j){\n");
		rcmArray2.push("    kent <- cor.test(\n");
		rcmArray2.push("      dx[ ,i], dx[ ,j],\n");
		rcmArray2.push("      me=SOKAN )\n");
		rcmArray2.push("    keis <- c(\n");
		rcmArray2.push("      keis, kent$esti )\n");
		rcmArray2.push("    pchi <- c(\n");
		rcmArray2.push("      pchi, kent$p.va )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("  else{ keis <- c(keis, NA)\n");
		rcmArray2.push("        pchi <- c(pchi, NA) }\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("padj <- p.adjust(pchi, me=\"BH\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("rmat <- matrix(keis, nc=hensu, by=1)\n");
		rcmArray2.push("test <- matrix(pchi, nc=hensu, by=1)\n");
		rcmArray2.push("tadj <- matrix(padj, nc=hensu, by=1)\n");
		rcmArray2.push("rmat <- round(rmat, 3)\n");
		rcmArray2.push("test <- round(test, 3)\n");
		rcmArray2.push("tadj <- round(tadj, 3)\n");
		rcmArray2.push("colnames(rmat) <- colnames(dx)\n");
		rcmArray2.push("rownames(rmat) <- colnames(dx)\n");
		rcmArray2.push("dimnames(test) <- dimnames(rmat)\n");
		rcmArray2.push("dimnames(tadj) <- dimnames(rmat)\n");

		rcmArray2.push("# spearmanオプション\n");
		rcmArray2.push("smat <- c()\n");
		rcmArray2.push("spch <- c()\n");
		rcmArray2.push("sadj <- c()\n");
		rcmArray2.push("\n");
		rcmArray2.push("for(i in 1:hensu){\n");
		rcmArray2.push("for(j in 1:hensu){\n");
		rcmArray2.push("  if(i<j){\n");
		rcmArray2.push("    kent <- cor.test(   # 検定\n");
		rcmArray2.push("      dx[ ,i], dx[ ,j],\n");
		rcmArray2.push("      me=\"spearman\" )\n");
		rcmArray2.push("    smat <- c(\n");
		rcmArray2.push("      smat, kent$esti )\n");
		rcmArray2.push("    spch <- c(\n");
		rcmArray2.push("      spch, kent$p.va )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("  else{ smat <- c(smat, NA)\n");
		rcmArray2.push("        spch <- c(spch, NA) }\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("sadj <- p.adjust(spch, me=\"BH\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("smat <- matrix(smat, nc=hensu, by=1)\n");
		rcmArray2.push("spch <- matrix(spch, nc=hensu, by=1)\n");
		rcmArray2.push("sadj <- matrix(sadj, nc=hensu, by=1)\n");
		rcmArray2.push("smat <- round(smat, 3)\n");
		rcmArray2.push("spch <- round(spch, 3)\n");
		rcmArray2.push("sadj <- round(sadj, 3)\n");
		rcmArray2.push("colnames(smat) <- colnames(dx)\n");
		rcmArray2.push("rownames(smat) <- colnames(dx)\n");
		rcmArray2.push("dimnames(spch) <- dimnames(smat)\n");
		rcmArray2.push("dimnames(sadj) <- dimnames(smat)\n");
		rcmArray2.push("\n");
		rcmArray2.push("# kendallオプション\n");
		rcmArray2.push("kmat <- c()\n");
		rcmArray2.push("kpch <- c()\n");
		rcmArray2.push("kadj <- c()\n");
		rcmArray2.push("\n");
		rcmArray2.push("for(i in 1:hensu){\n");
		rcmArray2.push("for(j in 1:hensu){\n");
		rcmArray2.push("  if(i<j){\n");
		rcmArray2.push("    kent <- cor.test(   # 検定\n");
		rcmArray2.push("      dx[ ,i], dx[ ,j],\n");
		rcmArray2.push("      me=\"kendall\" )\n");
		rcmArray2.push("    kmat <- c(\n");
		rcmArray2.push("      kmat, kent$esti )\n");
		rcmArray2.push("    kpch <- c(\n");
		rcmArray2.push("      kpch, kent$p.va )\n");
		rcmArray2.push("  }\n");
		rcmArray2.push("  else{ kmat <- c(kmat, NA)\n");
		rcmArray2.push("        kpch <- c(kpch, NA) }\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("\n");
		rcmArray2.push("kadj <- p.adjust(kpch, me=\"BH\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("kmat <- matrix(kmat, nc=hensu, by=1)\n");
		rcmArray2.push("kpch <- matrix(kpch, nc=hensu, by=1)\n");
		rcmArray2.push("kadj <- matrix(kadj, nc=hensu, by=1)\n");
		rcmArray2.push("kmat <- round(kmat, 3)\n");
		rcmArray2.push("kpch <- round(kpch, 3)\n");
		rcmArray2.push("kadj <- round(kadj, 3)\n");
		rcmArray2.push("colnames(kmat) <- colnames(dx)\n");
		rcmArray2.push("rownames(kmat) <- colnames(dx)\n");
		rcmArray2.push("dimnames(kpch) <- dimnames(kmat)\n");
		rcmArray2.push("dimnames(kadj) <- dimnames(kmat)\n");
		rcmArray2.push("\n");
		rcmArray2.push("## 散布図 ##\n");
		rcmArray2.push("for( i in (1:(hensu-1)) ){\n");
		rcmArray2.push("for( j in ((i+1):hensu) ){\n");
		rcmArray2.push("  plot( dx[,i], dset[,j],\n");
		rcmArray2.push("    pch=21, bg=3, cex=2,\n");
		rcmArray2.push("    bty=\"l\", las=1,\n");
		rcmArray2.push("    xla=colnames(dx)[i],\n");
		rcmArray2.push("    yla=colnames(dx)[j],\n");
		rcmArray2.push("    cex.lab=2\n");
		rcmArray2.push("    )\n");
		rcmArray2.push("  abline(\n");
		rcmArray2.push("    lm(dx[,j]~dx[,i]),\n");
		rcmArray2.push("    lwd=2, col=2\n");
		rcmArray2.push("    )\n");
		rcmArray2.push("  par( ask=1 )\n");
		rcmArray2.push("# ■図をクリック⇒次図\n");
		rcmArray2.push("# ■［Ｅsc］キー⇒中断\n");
		rcmArray2.push("} }\n");
		rcmArray2.push("par( ask=0 )\n");
		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("############################\n");
		rcmArray2.push("# 相関係数計算：           #\n");
		rcmArray2.push("#  ピアソンの積率相関係数 #\n");
		rcmArray2.push("############################\n");
		rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("\n");
		rcmArray2.push("rmat # 相関行列\n");
		rcmArray2.push("\n");
		rcmArray2.push("test # 無相関検定によるｐ値（両側確率）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tadj # 調整後ｐ値\n");
		rcmArray2.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray2.push("# smat;spch;sadj # スピアマン順位相関;ｐ値;調整後\n");
		rcmArray2.push("# kmat;kpch;kadj # ケンドール順位相関;ｐ値;調整後\n");
		rcmArray2.push("# windows(); boxplot(dx,las=1)  # 箱ひげ図\n");

		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray2.push("\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで


	//グラフ描画
	(function () {
		// if (document.getElementById("RltAdd").checked === false) {
		chartClear();
		// }

		var i, j, jj;

		//軸の最大値と最小値の設定
		var max = xx[0][0];
		var min = xx[0][0];
		for (i = 0; i < NN; i++) {
			for (j = 0; j < KK; j++) {
				if (max < xx[i][j]) max = xx[i][j];
				if (min > xx[i][j]) min = xx[i][j];
			}
		}

		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min = parseFloat(myMin, 10);
		}
		// if (gResult !== null) {
		// 	var _max_min = gResult.split(",");
		// 	min = _max_min[0];
		// 	max = _max_min[1];
		// }

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		// var chartClrAry = ["#ff4b00", "#fff100", "#03af7a", "#005aff", "#4dc4ff", "#ff8082", "#f6aa00", "#990099", "#804000"];
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		var titleText;

		var chartNum = 0;
		for (j = 0; j < KK - 1; j++) {
			for (jj = j + 1; jj < KK; jj++) {

				var chartImg = document.createElement('canvas');
				chartImg.id = "ChartImg" + chartNum;
				var ctx = document.getElementById("chart").appendChild(chartImg);

				var data = [];
				for (i = 0; i < NN; i++) {
					addData = { x: xx[i][j], y: xx[i][jj] };
					data.push(addData);
				}

				titleText = 'A' + (j + 1) + ':A' + (jj + 1);

				var datasetData = [{
					backgroundColor: chartClrAry[chartNum % chartClrAry.length],
					borderColor: chartClrAry[chartNum % chartClrAry.length],
					pointBorderWidth: 3,
					borderWidth: 1,
					lineTension: 0,
					data: data
				}];
				chartNum++;

				var myChart = new Chart(ctx, {
					type: 'scatter',
					data: {
						datasets: datasetData
					},
					options: {
						title: {
							display: true,
							text: titleText,
							position: 'top',
							fontSize: 12,
							fontColor: '#000000'
						},
						scales: {
							xAxes: [{
								ticks: {
									suggestedMin: min,
									suggestedMax: max
								}
							}],
							yAxes: [{
								ticks: {
									suggestedMin: min,
									suggestedMax: max
								}
							}]
						},
						legend: {
							display: false
						},
						tooltips: {
							mode: 'label'
						},
					}
				});
			}
		}
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
function corrDiaDraw() {
	var i = 0;
	var j = 0;
	var jj = 0;

	var canvas = document.getElementById("DiaCanvas");
	// var canvas = document.getElementById("corrDiaCanvas");
	if (!canvas || !canvas.getContext) {
		return false;
	}

	if (document.getElementById("corrDiaArea").value != "") {
		var diaData = document.getElementById("corrDiaArea").value;
		var rowStr = diaData.split("\n");

		//項目数
		var KK = parseInt(rowStr[0], 10);

		var columStr = [];
		var k1 = [];
		var k2 = [];
		var r = [];
		var lineWidth = [];

		for (i = 1; i < rowStr.length - 1; i++) {
			columStr = rowStr[i].split(",");
			k1[i] = parseInt(columStr[0], 10);        //項目１
			k2[i] = parseInt(columStr[1], 10);        //項目２
			r[i] = parseFloat(columStr[2]);          //相関係数
			lineWidth[i] = parseInt(columStr[3], 10); //線幅
		}

		var ctx = canvas.getContext('2d');

		//canvasを白で塗りつぶし
		ctx.beginPath();
		ctx.fillStyle = 'rgb(255,255,255)';
		ctx.fillRect(0, 0, 550, 450);

		// ダイアグラムの中心の座標
		var x1 = 275;
		var y1 = 200;

		// 項目番号0の座標
		var x2 = 275;
		var y2 = 30;

		// 項目番号の座標
		var tx = [];
		var ty = [];

		ctx.lineWidth = 1;

		var xx = [];
		var yy = [];

		var t = 0; //角度
		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			xx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1;
			yy[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1;
		}

		for (j = 0; j < KK; j++) {
			t = Math.PI / 180 * j * (360 / KK);
			tx[j] = Math.ceil((x2 - x1) * Math.cos(t) - (y2 - y1) * Math.sin(t)) + x1 - 4;
			ty[j] = Math.ceil((x2 - x1) * Math.sin(t) + (y2 - y1) * Math.cos(t)) + y1 + 4;
		}

		var diaPointNum = parseInt(document.getElementById("diaPointNum").value, 10);
		if (diaPointNum == 0) {
			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}

				if (r[i] > 0) {
					// 相関係数>0 ならば 赤
					ctx.strokeStyle = 'rgb(255,0,0)';
				} else {
					// 相関係数<=0 ならば 青
					ctx.strokeStyle = 'rgb(0,0,255)';
				}
				ctx.lineWidth = lineWidth[i];
				ctx.beginPath();
				ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
				ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
				ctx.stroke();
			}
		} else {
			// グレーで描画
			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}
				ctx.strokeStyle = 'rgb(169,169,169)';
				ctx.lineWidth = lineWidth[i];
				ctx.beginPath();
				ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
				ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
				ctx.stroke();
			}

			for (i = 1; i < rowStr.length - 1; i++) {
				// 線種 線幅=1 ならば 破線
				if (lineWidth[i] == 1) {
					ctx.setLineDash([3, 3]); //破線
				} else {
					ctx.setLineDash([]); //実線
				}

				if (r[i] > 0) {
					// 相関係数>0 ならば 赤
					if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
						ctx.strokeStyle = 'rgb(255,0,0)';
					}
				} else {
					// 相関係数<=0 ならば 青
					if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
						ctx.strokeStyle = 'rgb(0,0,255)';
					}
				}

				if (diaPointNum == k1[i] || diaPointNum == k2[i]) {
					ctx.lineWidth = lineWidth[i];
					ctx.beginPath();
					ctx.moveTo(xx[k1[i] - 1], yy[k1[i] - 1]);
					ctx.lineTo(xx[k2[i] - 1], yy[k2[i] - 1]);
					ctx.stroke();
				}
			}
		}

		var wr = 10;
		//項目を示す○を描く（白で塗りつぶし）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.fillStyle = 'rgb(255,255,255)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.fill();
		}
		//項目を示す○を描く（線を黒く）
		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.strokeStyle = 'rgb(0,0,0)';
		for (j = 0; j < KK; j++) {
			ctx.beginPath();
			ctx.arc(xx[j], yy[j], wr, 0, Math.PI * 2, false);
			ctx.stroke();
		}

		ctx.lineWidth = 1;
		ctx.setLineDash([]); //実線
		ctx.font = "14px 'Times New Roman'";
		ctx.strokeStyle = 'rgb(0,0,0)';
		ctx.fillStyle = "rgb(0,0,0)";
		for (j = 0; j < KK; j++) {
			ctx.strokeText(j + 1, tx[j], ty[j]);
		}


		if (diaPointNum != 0) {
			//項目を示す○を描く（白で塗りつぶし）
			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.fillStyle = 'rgb(0,0,0)';
			ctx.beginPath();
			ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
			ctx.fill();
			//項目を示す○を描く（線を黒く）
			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.strokeStyle = 'rgb(0,0,0)';
			ctx.beginPath();
			ctx.arc(xx[diaPointNum - 1], yy[diaPointNum - 1], wr, 0, Math.PI * 2, false);
			ctx.stroke();

			ctx.lineWidth = 1;
			ctx.setLineDash([]); //実線
			ctx.font = "14px 'Times New Roman'";
			ctx.strokeStyle = 'rgb(255,255,255)';
			ctx.fillStyle = "rgb(255,255,255)";
			ctx.strokeText(diaPointNum, tx[diaPointNum - 1], ty[diaPointNum - 1]);
		}
	}

}
function saveData_Corr() {

	var Stream = document.getElementById("DataArea").value;
	var fineName = "Corr_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
