/**
 * 回帰分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeRegSetting();
	RoutputSelect();
	RoutputArea();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var elmCount = NN * (LA + 1);

	var result = confirm("データを消去します");
	if (result == true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
}
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var elmCount = NN * (LA + 1);

	var errorCellNum = 0;
	if (document.getElementById("CandPArea").value == "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum == 0) {
			errorClearCell(elmCount, "");
			mainCalc_reg();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_reg() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var xx = new Array(LA + 1);
	for (i = 0; i < LA + 1; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + 1; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var hensu = 0;
	for (i = 0; i < LA; i++) {
		if (document.getElementById("x" + (i + 1)).checked) {
			hensu++;
		}
	}

	//基本統計量
	var M = [];	//平均
	var SD = [];	//標準偏差
	var MA = [];	//最大値
	var MI = [];	//最小値

	strArray.push(" == Means & SDs(SD=sqrt(Vtotal/N)) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA + 1; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0];
		MI[i] = xx[i][0];

		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
		}

		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		if (i == 0) {
			strArray.push("Y" + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		}

	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA + 1; i++) {
		if (i == 0) {
			strArray.push("Y" + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		}
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (j = 0; j < NN; j++) {
				for (i = 0; i < LA + 1; i++) {
					rcmArray1.push(xx[i][j]);
					if ((i != LA + 1 - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			i = 0;
			rcmArray.push("Y  <- c(");
			for (j = 0; j < NN; j++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1)) rcmArray.push(",");
			}
			rcmArray.push(" )\n");

			for (i = 1; i < LA + 1; i++) {
				rcmArray.push("x" + i + " <- c(");
				for (j = 0; j < NN; j++) {
					rcmArray.push(" " + xx[i][j]);
					if ((j != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}
			rcmArray.push("\n");

			rcmArray.push("dtab <- data.frame(\n");
			rcmArray.push(" Y,\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push(" x" + (i + 1));
				if ((i != LA - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");

			rcmArray.push("Y <- c()\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("####### 回帰分析 #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# パッケージ car が必要：vif用\n");
		rcmArray2.push("# 欠損値は事前に処理しておくこと\n");
		rcmArray2.push("\n");
		rcmArray2.push("# データセット\n");
		rcmArray2.push("hensu=" + LA + "  # 説明変数 x の数\n");
		rcmArray2.push("\n");

		rcmArray2.push("saiyo <- c(");
		var commaflag = false;
		for (i = 0; i < LA; i++) {
			if (document.getElementById("x" + (i + 1)).checked) {
				if (commaflag) {
					rcmArray2.push(",");
				}
				rcmArray2.push(" " + (i + 1));
				commaflag = true;
			}
		}
		rcmArray2.push(" )   # 採用した説明変数\n");

		var opeflag = false; //演算記号フラッグ
		rcmArray2.push("  MD <- c( \"Y~");
		for (i = 1; i < LA + 1; i++) {
			if (document.getElementById("x" + i).checked) {
				if (opeflag) {
					rcmArray2.push("+");
				}
				rcmArray2.push("x" + i);
				opeflag = true;
			}
		}
		rcmArray2.push("\" ) # 加算モデル\n");

		var opeflag = false; //演算記号フラッグ
		rcmArray2.push("# MD <- c( \"Y~");
		for (i = 1; i < LA + 1; i++) {
			if (document.getElementById("x" + i).checked) {
				if (opeflag) {
					rcmArray2.push("*");
				}
				rcmArray2.push("x" + i);
				opeflag = true;
			}
		}
		rcmArray2.push("\" ) # 交互作用モデル：オプション\n");

		rcmArray2.push("colnames(dtab) <- c(\"Y\",\n");
		rcmArray2.push("  paste(\"x\",1:hensu,sep=\"\")\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("rets <- c(1, 1+saiyo)      # 対象となる列\n");
		rcmArray2.push("dx   <- data.frame(dtab[,rets])\n");
		rcmArray2.push("\n");

		rcmArray2.push("## 基本統計量\n");
		rcmArray2.push("hk <- sapply(dx, mean)\n");
		rcmArray2.push("sd <- sapply(dx,   sd)\n");
		rcmArray2.push("n  <- c()\n");
		rcmArray2.push("mi <- c()\n");
		rcmArray2.push("ma <- c()\n");

		rcmArray2.push("cx <- ncol(dx)\n");
		rcmArray2.push("for(i in 1:cx){\n");
		rcmArray2.push("  n  <- c(n, length(dx[,i]) )\n");
		rcmArray2.push("  mi <- c(mi,   min(dx[,i]) )\n");
		rcmArray2.push("  ma <- c(ma,   max(dx[,i]) )\n");
		rcmArray2.push("  }\n");

		rcmArray2.push("tx0 <- c()\n");
		rcmArray2.push("tx0 <- matrix(round(c(\n");
		rcmArray2.push("  n,\n");
		rcmArray2.push("  hk,\n");
		rcmArray2.push("  sd,\n");
		rcmArray2.push("  mi,\n");
		rcmArray2.push("  ma\n");
		rcmArray2.push("  ), 4), nc=5 )\n");
		rcmArray2.push("colnames(tx0) <- c(\n");
		rcmArray2.push("  \"   Ｎ\",\n");
		rcmArray2.push("  \"     Mean\",\n");
		rcmArray2.push("  \"       SD\",\n");
		rcmArray2.push("  \"   Min\",\n");
		rcmArray2.push("  \"  Max\" )\n");
		rcmArray2.push("rownames(tx0) <- colnames(dx)\n");

		rcmArray2.push("\n");
		rcmArray2.push("# 散布図\n");
		rcmArray2.push("library( car )\n");
		rcmArray2.push("scatterplotMatrix(dx, dia=\"h\", smooth=0)\n");
		rcmArray2.push("\n");

		rcmArray2.push("# GLM\n");
		rcmArray2.push("Mful <- glm(MD, data=dx,\n");
		rcmArray2.push("            fa=gaussian )\n");
		rcmArray2.push("Msel <- step(Mful,\n");
		rcmArray2.push("  k=log(nrow(dx))  # BIC\n");
		rcmArray2.push("  )\n");
		rcmArray2.push("\n");

		rcmArray2.push("# 回帰診断\n");
		rcmArray2.push("windows()\n");
		rcmArray2.push("par(mfrow=c(2,2))\n");
		rcmArray2.push("plot(Msel, which=1:4)\n");
		rcmArray2.push("par(mfrow=c(1,1))\n");

		rcmArray2.push("\n");
		rcmArray2.push("# 出力用\n");
		rcmArray2.push("tx1 <- Mful$formula # 初期モデル\n");
		rcmArray2.push("tx2 <- Msel$anova   # ステップ要約\n");
		rcmArray2.push("colnames(tx2) <- c(\n");
		rcmArray2.push("  \"項の増減\",\" df\",\"残差増分\",\n");
		rcmArray2.push("  \" df\",\"残差逸脱度\",\"  BIC\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx3 <- Msel$formula # 選出モデル\n");

		rcmArray2.push("\n");
		rcmArray2.push("sx <- sapply(dx, scale)\n");
		rcmArray2.push("sx <- data.frame( sx )\n");
		rcmArray2.push("sx4 <- round( summary(\n");
		rcmArray2.push("        step( glm(MD,data=sx,fa=gaussian),\n");
		rcmArray2.push("        k=log(nrow(sx)) )\n");
		rcmArray2.push("        )$coef, 4)\n");

		rcmArray2.push("\n");
		rcmArray2.push("kx4 <- c()\n");
		rcmArray2.push("kx4 <- summary(Msel)\n");
		rcmArray2.push("tx4 <- c()\n");
		rcmArray2.push("tx4 <- round(kx4$coef, 4) # 回帰係数\n");
		rcmArray2.push("tx4 <- cbind(tx4,data.frame(sx4[,1]) )\n");
		rcmArray2.push("colnames(tx4) <- c(\n");
		rcmArray2.push("  \"偏回帰係数\",\n");
		rcmArray2.push("  \" 標準誤差\",\n");
		rcmArray2.push("  \"   ｔ値\",\n");
		rcmArray2.push("  \"   ｐ値\",\n");
		rcmArray2.push("  \"   ｓｔｂ\"\n");
		rcmArray2.push("  )\n");

		rcmArray2.push("\n");
		rcmArray2.push("library( pwr )\n");
		rcmArray2.push("# R2 <- 1-Msel$dev/Msel$null    # R-squared in GLM\n");
		rcmArray2.push("kx5 <- summary(lm(tx3,data=dx)) # lm() の実行\n");
		rcmArray2.push("\n");
		rcmArray2.push("R2   <- kx5$r.sq\n");
		rcmArray2.push("Fchi <- kx5$fsta[1]\n");
		rcmArray2.push("DF1  <- kx5$fsta[2]\n");
		rcmArray2.push("DF2  <- kx5$fsta[3]\n");
		rcmArray2.push("pchi <- pf(Fchi,df1=DF1,df2=DF2,low=0)\n");
		rcmArray2.push("tx5  <- c()\n");
		rcmArray2.push("tx5  <- matrix(round(c(\n");
		rcmArray2.push("  R2, Fchi, DF1, DF2, pchi,\n");
		rcmArray2.push("  kx5$adj.\n");
		rcmArray2.push("  ), 4), nr=1 )\n");
		rcmArray2.push("colnames(tx5) <- c(\n");
		rcmArray2.push("  \"Ｒ2\",\n");
		rcmArray2.push("  \"   Ｆ値\",\n");
		rcmArray2.push("  \" df1\",\n");
		rcmArray2.push("  \" df2\",\n");
		rcmArray2.push("  \"    ｐ値\",\n");
		rcmArray2.push("  \" adj_Ｒ2\" )\n");
		rcmArray2.push("rownames(tx5) <- c(\"\")\n");
		rcmArray2.push("\n");
		rcmArray2.push("ES  <- R2/(1-R2) # 効果量\n");
		rcmArray2.push("kx6 <- c()\n");
		rcmArray2.push("kx6 <- pwr.f2.test(\n");
		rcmArray2.push("  f2=ES,\n");
		rcmArray2.push("  u =DF1,\n");
		rcmArray2.push("  v =DF2,\n");
		rcmArray2.push("  si=0.05 )\n");
		rcmArray2.push("kx7 <- pwr.f2.test(\n");
		rcmArray2.push("  f2=ES,\n");
		rcmArray2.push("  u =DF1,\n");
		rcmArray2.push("  v =DF2,\n");
		rcmArray2.push("  si=NULL,\n");
		rcmArray2.push("  po=0.80 )\n");
		rcmArray2.push("kx8 <- pwr.f2.test(\n");
		rcmArray2.push("  f2=ES,\n");
		rcmArray2.push("  u =DF1,\n");
		rcmArray2.push("  v =NULL,\n");
		rcmArray2.push("  si=0.05,\n");
		rcmArray2.push("  po=0.80 )\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx6 <- c()\n");
		rcmArray2.push("tx6 <- matrix(c(\n");
		rcmArray2.push("  round(ES, 4),\n");
		rcmArray2.push("  round(kx6$pow, 4),\n");
		rcmArray2.push("  round(kx7$si, 4),\n");
		rcmArray2.push("  ceiling(kx8$v)+DF1+1\n");
		rcmArray2.push("  ), nr=1 )\n");
		rcmArray2.push("colnames(tx6) <- c(\n");
		rcmArray2.push("  \"効果量f2\",\n");
		rcmArray2.push("  \"  検出力\",\n");
		rcmArray2.push("  \"  今回α\",\n");
		rcmArray2.push("  \"  次回Ｎ\" )\n");
		rcmArray2.push("rownames(tx6) <- c(\"\")\n");

		rcmArray2.push("\n");
		rcmArray2.push("# 多重共線性と相関行列\n");
		rcmArray2.push("tx9 <- c()\n");
		rcmArray2.push("tx9 <- round(vif(Mful), 3)\n");
		rcmArray2.push("txx <- c()\n");
		rcmArray2.push("txx <- round(cor(dx), 3)\n");

		rcmArray2.push("\n");
		rcmArray2.push("options(digits=5)\n");
		rcmArray2.push("options(scipen=5)\n");
		rcmArray2.push("##########################\n");
		rcmArray2.push("# 回帰分析（モデル選択）\n");
		rcmArray2.push("#  ステップワイズ増減法\n");
		rcmArray2.push("#  選択基準= ＢＩＣ\n");
		rcmArray2.push("##########################\n");
		rcmArray2.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx1 # 初期モデル\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx2 # 選択ステップの要約\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx3 # 選出モデル\n");
		rcmArray2.push("# ■ Y~1 のとき選出モデルなし（→終了）\n");
		rcmArray2.push("# ■出力膨大のとき初期モデルで停止\n");

		rcmArray2.push("\n");
		rcmArray2.push("tx4 # 偏回帰係数の検定\n");
		rcmArray2.push("# 標準化偏回帰係数（ｓｔｂ）= 偏回帰係数*SDx/SDy\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx5 # モデルＲ2(決定係数)の検定\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx6 # パワーアナリシス\n");
		rcmArray2.push("# 次回Ｎは power=0.80, α=0.05 に設定時のＮ\n");
		rcmArray2.push("\n");
		rcmArray2.push("tx9 # VIF（分散拡大要因）による多重共線性の検討\n");
		rcmArray2.push("# VIF<2（推奨）, VIF<5（許容）, VIF>10（危険）\n");
		rcmArray2.push("\n");
		rcmArray2.push("\n");
		rcmArray2.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray2.push("# txx        # 相関行列\n");
		rcmArray2.push("# summary(step(Mful)) # モデル選択基準=AIC\n");
		rcmArray2.push("# windows();boxplot(dx) # 箱ひげ図\n");

		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray2.push("\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
function changeRegSetting() {
	var h = 2;
	var htmArray = [];

	// htmArray.push("<div class=\"btnlayout\">");
	// htmArray.push("<ul class=\"menubutton\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"clearCellData();\"><span>データ消去</span></a></li>");
	// htmArray.push("<li><input type=\"file\" class=\"file_input\" id=\"readFileData\" accept=\".txt,.csv\" onchange=\"readFile(this);\"><a href=\"#\" onclick=\"document.getElementById('readFileData').click();\"><span>データ読込</span></a></li>");
	// htmArray.push("</ul>");

	// htmArray.push("<ul class=\"menubutton1\">");
	// htmArray.push("<li><a href=\"#\" onclick=\"cellAreaScroll('reg');return false;\"><span id=\"cellAreaScrollBtn\">△短縮</a></span></li>");
	// htmArray.push("</ul>");
	// htmArray.push("</div>");

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"fhangeRegTableBranch();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');fhangeRegTableBranch();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">説明変数の項目数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		// EV_numver  Explanatory Variable 説明変数
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"EV_number\" size=\"10\" min=\"2\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"fhangeRegTableBranch();\">");
	} else {
		htmArray.push("<select id=\"EV_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'説明変数の項目数');fhangeRegTableBranch();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("reg_setting").innerHTML = htmArray.join("");
	htmArray = null;

	fhangeRegTableBranch();
}
function fhangeRegTableBranch() {
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数

	if ((NN >= 10) || (LA + 1 >= 8)) {
		changeRegTable_scroll();
	} else {
		changeRegTable_all();
	}
}
function changeRegTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var htmArray = new Array();
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	if (LA + 1 >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("Y");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		if (LA + 1 < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("x" + (i + 1));
		}
		htmArray.push("</td>");
	}

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA + 1; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");

			htmArray.push("</td>");
			cellId++;
		}
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// // htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell5_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("reg_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function changeRegTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	if (LA + 1 >= 8) {
		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;
		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
	if (LA + 1 < 8) {
		htmArray.push("<div>Y</div>");
	} else {
		htmArray.push("<div style=\"width: 41px;\">Y</div>");
	}
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		if (LA + 1 < 8) {
			htmArray.push("<input type=\"checkbox\" id=\"x" + (i + 1) + "\" name=\"x" + (i + 1) + "\" value=\"" + (i + 1) + "\" checked=\"true\" onclick=\"keyClick(event," + (i + 1) + ");\"><label for=\"x" + (i + 1) + "\">x" + (i + 1) + "</label>");
		} else {
			htmArray.push("<div style=\"width: 41px;\">x" + (i + 1) + "</div>");
		}
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA + 1; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	// htmArray.push("<div class=\"btnlayout4\">");
	// htmArray.push("<textarea wrap=\"off\" id=\"CandPArea\" name=\"DataArea\" class=\"inputTextAreaOff\" rows=\"1\" cols=\"30\" onfocus=\"onBgColor(this);inputTextArea(this,1);inputButton(this,'inputBtn1');\" onblur=\"offBgColor(this);\" onkeyup=\"inputButton(this,'inputBtn1');\" onmousemove=\"inputButton(this,'inputBtn1');\"></textarea>");
	// htmArray.push("<span id=\"inputBtn1\" class=\"inputBtnOn\" onclick=\"copipe('CandPArea','cell_',"+cellCount+");inputTextArea(document.getElementById('CandPArea'),0);inputBtnTextClear(this);\"></span>");
	// htmArray.push("</div>");

	document.getElementById("reg_table").innerHTML = htmArray.join("");
	htmArray = null;
	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function saveData_Reg() {
	var i, j;

	var strArray = [];

	var NN = parseInt(document.getElementById("subjNum").value, 10);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数

	var x;
	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + 1; i++) {
			x = document.getElementById("cell_" + cellId).value;
			if (i !== LA) {
				strArray.push(x + "\t");
			} else {
				strArray.push(x);
			}
			cellId++;
		}
		if (j !== NN - 1) {
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "Reg_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}

