/**
 * 回帰分析
 *
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	changeSemSetting();
	RoutputSelect();
	RoutputArea();

	// changeSemFormula();
	// changeME(); //1つ目の測定方程式の出力:Measurement_Equations
	changeSem_me_X();
	makeSemME2();
	changeSem_se_X();
	changeSem_cr_X();

	changeSem_se_F();
	changeSem_cr_F();

	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//データエリアにドラッグ＆ドロップを設定
	setDragAndDrop();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var elmCount = NN * (LA + 1);

	var result = confirm("データを消去します");
	if (result === true) {
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = '';
		}
		errorClearCell(elmCount, "");

		document.getElementById("CandPArea").value = "";
		inputTextArea(document.getElementById("CandPArea"), 0);
		inputBtnTextClear(document.getElementById("inputBtn1"));
	}
}
function checkCellData() {
	var i = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var elmCount = NN * (LA + 1);

	var errorCellNum = 0;
	if (document.getElementById("CandPArea").value == "") {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value == "") {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_sem();
		} else {
			alert("すべての度数が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_sem() {
	var i = 0;
	var j = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数

	var strArray = [];
	var bar = "------------------------------------------------\n";
	var rcmArray = [];
	var rcmArray1 = [];
	var rcmArray2 = [];

	var xx = new Array(LA + 1);
	for (i = 0; i < LA + 1; i++) {
		xx[i] = new Array(NN);
	}

	var cellId = 1;
	for (j = 0; j < NN; j++) {
		for (i = 0; i < LA + 1; i++) {
			xx[i][j] = parseFloat(document.getElementById("cell_" + cellId).value);
			cellId++;
		}
	}

	var hensu = 0;
	for (i = 0; i < LA; i++) {
		if (document.getElementById("x" + (i + 1)).checked) {
			hensu++;
		}
	}

	//基本統計量
	var M = [];	//平均
	var SD = [];	//標準偏差
	var MA = [];	//最大値
	var MI = [];	//最小値

	strArray.push(" == Means & SDs(SD=sqrt(Vtotal/N)) ==\n\n");
	strArray.push("  N= " + NN + "\n");
	strArray.push(bar);
	strArray.push("Var.\t\tMean\t\tS.D.\t\tMin.\t\tMax.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA + 1; i++) {
		S = 0;
		SS = 0;
		MA[i] = xx[i][0];
		MI[i] = xx[i][0];

		for (j = 0; j < NN; j++) {
			S += xx[i][j];
			SS += Math.pow(xx[i][j], 2);

			if (MA[i] < xx[i][j]) MA[i] = xx[i][j];
			if (MI[i] > xx[i][j]) MI[i] = xx[i][j];
		}

		M[i] = S / NN;
		SD[i] = Math.sqrt(SS / NN - Math.pow(M[i], 2));

		if (i === 0) {
			strArray.push("Y" + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i], 4, 3) + "\t" + using(SD[i], 4, 3) + "\t" + using(MI[i], 4, 3) + "\t" + using(MA[i], 4, 3) + "\n");
		}

	}
	strArray.push(bar);

	strArray.push("\n - Item Selection -\n");
	strArray.push(bar);
	strArray.push("Var.\tMean+SD\t\tMean-SD\n");
	strArray.push(bar);
	for (i = 0; i < LA + 1; i++) {
		if (i === 0) {
			strArray.push("Y" + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		} else {
			strArray.push("x" + i + "\t" + using(M[i] + SD[i], 4, 3) + "\t" + using(M[i] - SD[i], 4, 3) + "\n");
		}
	}
	strArray.push(bar);
	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var r_output = parseInt(document.getElementById("r_output").value);

		//クリップボード使用のためのデータ
		if (r_output == 1) {
			for (j = 0; j < NN; j++) {
				for (i = 0; i < LA + 1; i++) {
					rcmArray1.push(xx[i][j]);
					if ((i != LA + 1 - 1)) rcmArray1.push("\t");
				}
				rcmArray1.push("\n");
			}
		}

		//直接貼り付けるのためのデータ
		if (r_output == 2) {
			i = 0;
			rcmArray.push("Y  <- c(");
			for (j = 0; j < NN; j++) {
				rcmArray.push(" " + xx[i][j]);
				if ((j != NN - 1)) rcmArray.push(",");
			}
			rcmArray.push(" )\n");

			for (i = 1; i < LA + 1; i++) {
				rcmArray.push("x" + i + " <- c(");
				for (j = 0; j < NN; j++) {
					rcmArray.push(" " + xx[i][j]);
					if ((j != NN - 1)) rcmArray.push(",");
				}
				rcmArray.push(" )\n");
			}
			rcmArray.push("\n");

			rcmArray.push("dtab <- data.frame(\n");
			rcmArray.push(" Y,\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push(" x" + (i + 1));
				if ((i != LA - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n  )\n");

			rcmArray.push("Y <- c()\n");
			for (i = 0; i < LA; i++) {
				rcmArray.push("x" + (i + 1) + " <- c()\n");
			}
		}

		rcmArray2.push("####### 回帰分析 #######\n");
		rcmArray2.push("\n");
		rcmArray2.push("# パッケージ car が必要：vif用\n");
		rcmArray2.push("# 欠損値は事前に処理しておくこと\n");
		rcmArray2.push("\n");
		rcmArray2.push("# データセット\n");
		rcmArray2.push("hensu=" + LA + "  # 説明変数 x の数\n");
		rcmArray2.push("\n");

		rcmArray2.push("saiyo <- c(");
		var commaflag = false;
		for (i = 0; i < LA; i++) {
			if (document.getElementById("x" + (i + 1)).checked) {
				if (commaflag) {
					rcmArray2.push(",");
				}
				rcmArray2.push(" " + (i + 1));
				commaflag = true;
			}
		}
		rcmArray2.push(" )   # 採用した説明変数\n");

		var opeflag = false; //演算記号フラッグ
		rcmArray2.push("  MD <- c( \"Y~");
		for (i = 1; i < LA + 1; i++) {
			if (document.getElementById("x" + i).checked) {
				if (opeflag) {
					rcmArray2.push("+");
				}
				rcmArray2.push("x" + i);
				opeflag = true;
			}
		}
		rcmArray2.push("\" ) # 加算モデル\n");

		opeflag = false; //演算記号フラッグ
		rcmArray2.push("# MD <- c( \"Y~");
		for (i = 1; i < LA + 1; i++) {
			if (document.getElementById("x" + i).checked) {
				if (opeflag) {
					rcmArray2.push("*");
				}
				rcmArray2.push("x" + i);
				opeflag = true;
			}
		}

		rcmArray2.push("\n");
		rcmArray2.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray2.push("\n");

		if (r_output == 1) {
			document.getElementById("RcmArea").value = rcmArray1.join("");
			rcmArray1 = null;
		}
		if (r_output == 2) {
			document.getElementById("RcmArea").value = rcmArray.join("");
			rcmArray = null;
		}
		document.getElementById("RcmArea2").value = rcmArray2.join("");
		rcmArray2 = null;
	}());	//Ｒプログラムここまで

	document.getElementById("RltArea").focus();
}
function changeSemSetting() {
	var h = 2;
	var htmArray = [];

	htmArray.push("<table border=\"0\" class=\"codetb2\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">参加者数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"subjNum\" size=\"10\" min=\"2\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSemTableBranch();formulaLength_save_init();removeAllSemSE();removeAllSemCR();changeSem_se_X();changeSem_se_F();changeSem_cr_X();changeSem_cr_F();\">");
	} else {
		htmArray.push("<select id=\"subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'参加者数');changeSemTableBranch();formulaLength_save_init();removeAllSemSE();removeAllSemCR();changeSem_se_X();changeSem_se_F();changeSem_cr_X();changeSem_cr_F();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		for (h = 2; h < 10; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}
		htmArray.push("<option value=\"10\" selected>10</option>");
		for (h = 11; h < 31; h++) {
			htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
		}

		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL2\">説明変数の項目数：</td>");
	htmArray.push("<td class=\"codetbR2\">");

	if (thisBrowser.indexOf('ie') == -1) {
		// EV_numver  Explanatory Variable 説明変数
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"EV_number\" size=\"10\" min=\"2\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeSemTableBranch();changeSem_me_X();formulaLength_save_init();formulaLength_save_init();removeAllSemSE();removeAllSemCR();changeSem_se_X();changeSem_se_F();changeSem_cr_X();changeSem_cr_F();\">");
	} else {
		htmArray.push("<select id=\"EV_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'説明変数の項目数');changeSemTableBranch();changeSem_me_X();formulaLength_save_init();formulaLength_save_init();removeAllSemSE();removeAllSemCR();changeSem_se_X();changeSem_se_F();changeSem_cr_X();changeSem_cr_F();\">");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("sem_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeSemTableBranch();
}
function changeSemTableBranch() {
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数

	if ((NN >= 10) || (LA + 1 >= 8)) {
		changeSemTable_scroll();
	} else {
		changeSemTable_all();
	}
}
function changeSemTable_all() {
	var i = 0;
	var j = 0;
	var k = 0;
	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value); // EV_numver  Explanatory Variable 説明変数
	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	htmArray.push("<div id=\"cellScroll\" class=\"cellScrolloff\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_3d_title\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title\">");
		htmArray.push("x" + (i + 1));
		htmArray.push("</td>");
	}

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_3d\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
	}
	htmArray.push("</table>");
	htmArray.push("</div>");

	document.getElementById("sem_table").innerHTML = htmArray.join("");
	htmArray = null;

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
function changeSemTable_scroll() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	htmArray.push("<div id=\"tb_scroll_main\" class=\"tb_scroll_main\">");

	htmArray.push("<div id=\"divt0\" class=\"divtitle1\">");
	htmArray.push("<div id=\"div1\" class=\"div1\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku01\">");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"hyou_midashi_fact_title1\">参加者</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("<div id=\"div2\" class=\"div2\" onscroll=\"div2_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");
	htmArray.push("<tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<td class=\"hyou_midashi_fact_title2\">");
		htmArray.push("<div>x" + (i + 1) + "</div>");
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"divt1\" class=\"divtitle2\">");
	htmArray.push("<div id=\"div3\" class=\"div3_fixed\" onscroll=\"div3_onscroll();\">");

	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		htmArray.push("<td class=\"hyou_midashi_fact_title3\">");
		htmArray.push(k + 1);
		htmArray.push("</td>");
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");

	htmArray.push("<div id=\"div4\" class=\"div4_fixed\" onscroll=\"div4_onscroll();\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku0\">");

	for (k = 0; k < NN; k++) {
		htmArray.push("<tr>");
		for (i = 0; i < LA; i++) {
			htmArray.push("<td class=\"hyou_fact_nyuryoku\">");
			htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum()\">");
			htmArray.push("</td>");
			cellId++;
		}
		htmArray.push("</tr>");
	}

	htmArray.push("</table>");
	htmArray.push("</div>");
	htmArray.push("</div>");

	htmArray.push("</div>"); //tb_scroll_main

	document.getElementById("sem_table").innerHTML = htmArray.join("");
	htmArray = null;
	document.getElementById('cellAreaScrollBtn').innerHTML = '▽全体';

	//ドラッグドロップエリアを書き換えているので再セットする
	// setDragAndDrop();
}
/**
 * １つめの測定方程式の作成
 */
function changeME() { //
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var formulaLength = 1;

	htmArray.push("<div class=\"sem_formula\" name=\"formula\">f" + formulaLength + "=~ " + "</div>");
	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			if (LACount < LA) {
				htmArray.push("<input type=\"checkbox\" id=\"x_" + formulaLength + "_" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" checked=\"true\"><label for=\"x_" + formulaLength + "_" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_ME").innerHTML = htmArray.join("");
	htmArray = null;
}
var formulaLength_save = 1;
function formulaLength_save_init() {
	formulaLength_save = 1;
}
function makeSemME() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var formulaLength = document.getElementsByName("formula").length;
	if (formulaLength === formulaLength_save) {
		formulaLength_save++;
	}
	formulaLength++;

	htmArray.push("<div class=\"sem_formula\" name=\"formula\">f" + formulaLength + "=~ " + "</div>");
	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			if (LACount < LA) {
				htmArray.push("<input type=\"checkbox\" id=\"x_" + formulaLength + "_" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\"><label for=\"x_" + formulaLength + "_" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_ME");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function changeSem_me_X() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			if (LACount < LA) {
				htmArray.push("<div id=\"me_x" + (LACount + 1) + "\" class=\"me\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">x" + (LACount + 1) + "</div>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_me_x").innerHTML = htmArray.join("");
	htmArray = null;
}
function makeSemME2() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var formulaLength = document.getElementsByName("formula").length;
	if (formulaLength === formulaLength_save) {
		formulaLength_save++;
	}
	formulaLength++;

	htmArray.push("<div class=\"ME_formula\" name=\"formula\">");
	htmArray.push("<span id=\"del_ME_Formula_" + formulaLength + "\" class=\"delFormula\" onclick=\"delFormula('me'," + formulaLength + ");\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
	htmArray.push("<span class=\"me_f\"> f" + formulaLength + "　=~　" + "</span>");
	htmArray.push("<input type=\"text\" class=\"me_0\" id=\"me_0_" + formulaLength + "\" name=\"me\" onclick=\"sortXF(event);\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\" onkeydown=\"keydownHandler(event);\">");
	htmArray.push("<ul class=\"textChangeButton\">");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange2('me'," + formulaLength + ",1);return false;\"><span>▼</span></a></li>");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange2('me'," + formulaLength + ",-1);return false;\"><span>▲</span></a></li>");
	htmArray.push("</ul>");
	htmArray.push("<div>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_ME2");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function removeSemME() {
	var formulaLength = document.getElementsByName("formula").length;
	if (formulaLength > 1) {
		var parent_object = document.getElementById("sem_ME2");
		parent_object.removeChild(sem_ME2.lastChild);
	}
}
function removeAllSemME() {
	var formulaLength = document.getElementsByName("formula").length;
	var parent_object = document.getElementById("sem_ME2");
	for (var i = 0; i < formulaLength - 1; i++) {
		parent_object.removeChild(sem_ME2.lastChild);
	}
}
function changeSem_se_X() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			if (LACount < LA) {
				htmArray.push("<div id=\"se_x" + (LACount + 1) + "\" class=\"se\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">x" + (LACount + 1) + "</div>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_se_x").innerHTML = htmArray.join("");
	htmArray = null;
}
function changeSem_cr_X() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(LA / 10) + 1;
	if (LA % 10 == 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			htmArray.push("<td class=\"hyou_midashi_NF_title\">");
			if (LACount < LA) {
				htmArray.push("<div id=\"cr_x" + (LACount + 1) + "\" class=\"cr\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">x" + (LACount + 1) + "</div>");
			} else {
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_cr_x").innerHTML = htmArray.join("");
	htmArray = null;
}
function changeSem_se_F() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数
	var formulaLength = document.getElementsByName("formula").length;

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(formulaLength_save / 10) + 1;
	if (formulaLength_save % 10 === 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			if (LACount < formulaLength) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				htmArray.push("<div id=\"se_f" + (LACount + 1) + "\" class=\"se\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">f" + (LACount + 1) + "</div>");
			} else if (LACount < formulaLength_save) {
				htmArray.push("<td class=\"hyou_midashi_NF_title_delete\">");
				htmArray.push("<div id=\"se_f" + (LACount + 1) + "\" class=\"delete_f\">f" + (LACount + 1) + "</div>");
			} else {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_se_f").innerHTML = htmArray.join("");
	htmArray = null;
}
function changeSem_cr_F() {
	var i = 0;
	var j = 0;
	var k = 0;

	var NN = parseInt(document.getElementById("subjNum").value);
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数
	var formulaLength = document.getElementsByName("formula").length;

	var htmArray = [];
	var cellId = 1;
	var cellCount = NN * (LA + 1);

	var trCount = parseInt(formulaLength_save / 10) + 1;
	if (formulaLength_save % 10 === 0) trCount = trCount - 1;
	var LACount = 0;
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	for (j = 0; j < trCount; j++) {
		htmArray.push("<tr>");
		for (i = 0; i < 10; i++) {
			if (LACount < formulaLength) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				htmArray.push("<div id=\"cr_f" + (LACount + 1) + "\" class=\"cr\" draggable=\"true\" ondragstart=\"dragHandler(event);\" onmouseup=\"inputXF(event);setCursol(event);\">f" + (LACount + 1) + "</div>");
			} else if (LACount < formulaLength_save) {
				htmArray.push("<td class=\"hyou_midashi_NF_title_delete\">");
				htmArray.push("<div id=\"cr_f" + (LACount + 1) + "\" class=\"delete_f\">f" + (LACount + 1) + "</div>");
			} else {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				htmArray.push(" ");
			}
			htmArray.push("</td>");
			LACount++;
		}
		htmArray.push("</tr>");
	}
	htmArray.push("</table>");

	document.getElementById("sem_cr_f").innerHTML = htmArray.join("");
	htmArray = null;
}
function makeSemSE() {
	var i = 0;
	var j = 0;
	var k = 0;

	var htmArray = [];

	var seLength = document.getElementsByName("se").length;
	seLength++;

	htmArray.push("<div class=\"SE_formula\" name=\"SE_formula\">");
	htmArray.push("<span id=\"del_SE_Formula_" + seLength + "\" class=\"delFormula\" onclick=\"delFormula('se'," + seLength + ");\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
	htmArray.push("<input type=\"text\" class=\"se_1\" id=\"se_1_" + seLength + "\" name=\"se\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropHandler(event);\" ondragleave=\"dragleaveHandler(event);\">");
	htmArray.push("<span class=\"\"> ~ </span>");
	htmArray.push("<input type=\"text\" class=\"se_2\" id=\"se_2_" + seLength + "\" onclick=\"sortXF(event);\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\" onkeydown=\"keydownHandler(event);\">");
	htmArray.push("<ul class=\"textChangeButton\">");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('se'," + seLength + ",1);return false;\"><span>▼</span></a></li>");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('se'," + seLength + ",-1);return false;\"><span>▲</span></a></li>");
	htmArray.push("</ul>");
	htmArray.push("<div>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_SE");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function removeSemSE() {
	var seLength = document.getElementsByName("SE_formula").length;
	if (seLength > 0) {
		var parent_object = document.getElementById("sem_SE");
		parent_object.removeChild(sem_SE.lastChild);
	}
}
function removeAllSemSE() {
	var seLength = document.getElementsByName("SE_formula").length;
	var parent_object = document.getElementById("sem_SE");
	for (var i = 0; i < seLength; i++) {
		parent_object.removeChild(sem_SE.lastChild);
	}
}
function makeSemCR() {
	var i = 0;
	var j = 0;
	var k = 0;

	var htmArray = [];

	var crLength = document.getElementsByName("cr").length;
	crLength++;

	htmArray.push("<div class=\"CR_formula\" name=\"CR_formula\">");
	htmArray.push("<span id=\"del_CR_Formula_" + crLength + "\" class=\"delFormula\" onclick=\"delFormula('cr'," + crLength + ");\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
	htmArray.push("<input type=\"text\" class=\"cr_1\" id=\"cr_1_" + crLength + "\" name=\"cr\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropHandler(event);\" ondragleave=\"dragleaveHandler(event);\">");
	htmArray.push("<span class=\"\"> ~ </span>");
	htmArray.push("<input type=\"text\" class=\"cr_2\" id=\"cr_2_" + crLength + "\" onclick=\"sortXF(event);\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\" onkeydown=\"keydownHandler(event);\">");
	htmArray.push("<ul class=\"textChangeButton\">");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('cr'," + crLength + ",1);return false;\"><span>▼</span></a></li>");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange('cr'," + crLength + ",-1);return false;\"><span>▲</span></a></li>");
	htmArray.push("</ul>");
	htmArray.push("<div>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_CR");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function removeSemCR() {
	var crLength = document.getElementsByName("CR_formula").length;
	if (crLength > 0) {
		var parent_object = document.getElementById("sem_CR");
		parent_object.removeChild(sem_CR.lastChild);
	}
}
function removeAllSemCR() {
	var crLength = document.getElementsByName("CR_formula").length;
	var parent_object = document.getElementById("sem_CR");
	for (var i = 0; i < crLength; i++) {
		parent_object.removeChild(sem_CR.lastChild);
	}
}
function makeSemAAA() {
	var htmArray = [];

	var aaaLength = document.getElementsByName("aaa").length;
	aaaLength++;

	htmArray.push("<div class=\"AAA_formula\" name=\"AAA_formula\">");
	htmArray.push("<span id=\"del_AAA_Formula_" + aaaLength + "\" class=\"delFormula\" onclick=\"delFormula('aaa'," + aaaLength + ");\" onmouseover=\"delFormulaOver(this);\" onmouseout=\"delFormulaOut(this);\">×</span>");
	htmArray.push("<input type=\"text\" class=\"aaa_1\" id=\"aaa_1_" + aaaLength + "\" name=\"aaa\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\">");
	htmArray.push("<button class=\"eButton\" id=\"eButton_" + aaaLength + "\" onclick=\"equalChange(this);\">==</button>");
	htmArray.push("<input type=\"text\" class=\"aaa_2\" id=\"aaa_2_" + aaaLength + "\" ondragover=\"dragoverHandler(event);\" ondrop=\"dropPlusHandler(event);\" ondragleave=\"dragleaveHandler(event);\">");
	htmArray.push("<ul class=\"textChangeButton\">");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange2('aaa'," + aaaLength + ",1);return false;\"><span>▼</span></a></li>");
	htmArray.push("<li><a href=\"#\" onclick=\"formulaTextChange2('aaa'," + aaaLength + ",-1);return false;\"><span>▲</span></a></li>");
	htmArray.push("</ul>");
	htmArray.push("<div>");

	var div_element = document.createElement("div");
	div_element.innerHTML = htmArray.join("");
	var parent_object = document.getElementById("sem_aaa");
	parent_object.appendChild(div_element);

	htmArray = null;
}
function removeSemAAA() {
	var aaaLength = document.getElementsByName("AAA_formula").length;
	if (aaaLength > 0) {
		var parent_object = document.getElementById("sem_aaa");
		parent_object.removeChild(sem_aaa.lastChild);
	}
}
function removeAllSemAAA() {
	var aaaLength = document.getElementsByName("AAA_formula").length;
	var parent_object = document.getElementById("sem_aaa");
	for (var i = 0; i < aaaLength; i++) {
		parent_object.removeChild(sem_aaa.lastChild);
	}
}
// function aaa() {
// 	var i = 0;
// 	var j = 0;
// 	var k = 0;
// 	var NN = parseInt(document.getElementById("subjNum").value);
// 	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数
// 	var formulaLength = document.getElementsByName("formula").length;

// 	var rcmArray = [];

// 	var formulaflag = false;
// 	for (j = 0; j < formulaLength; j++) {
// 		for (i = 0; i < LA; i++) {
// 			if (document.getElementById("x_" + (j + 1) + "_" + (i + 1)).checked) {
// 				formulaflag = true;
// 				break;
// 			}
// 		}
// 		if (formulaflag) {
// 			rcmArray.push("f" + (j + 1) + " =~ ");
// 			for (i = 0; i < LA; i++) {
// 				if (document.getElementById("x_" + (j + 1) + "_" + (i + 1)).checked) {
// 					rcmArray.push("+x" + (i + 1));
// 				}
// 			}
// 			rcmArray.push("\n");
// 		}
// 		formulaflag = false;
// 	}
// 	document.getElementById("RcmArea").value = rcmArray.join("");
// 	rcmArray2 = null;
// }
// ドラッグ時のハンドラ
function dragHandler(event) {
	// ドラッグ元のテキストをDataTransferオブジェクトに保持
	var orgText = event.target.innerHTML;
	event.dataTransfer.setData("text", orgText);
}
function dragoverHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 3px #ffaaaa";
}
function dragleaveHandler(event) {
	event.preventDefault();
	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropHandler(event) {
	// デフォルト処理のキャンセル
	event.preventDefault();

	// DataTransferオブジェクトからテキストを取得してドラッグ先のテキストに代入
	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;

	var regexp = new RegExp(addText + "$"); //$は末尾指定 x1 は x11 にマッチしない
	if (orgText.match(regexp)) {
		event.target.value = "";
	} else {
		event.target.value = addText;
	}

	event.target.style.border = "solid 1px #999999";
}
// ドロップ時のハンドラ
function dropPlusHandler(event) {
	var i;
	var dd = [];
	var outputText = "";
	var addTextFlag = false;

	// デフォルト処理のキャンセル
	event.preventDefault();

	var addText = event.dataTransfer.getData("text");
	var orgText = event.target.value;
	orgText = orgText.replace(/\s+/g, "");
	orgText = orgText.replace(/\+\+*/g, "+");
	if (orgText.slice(0, 1) == "+") {
		orgText = orgText.slice(1);
	}
	dd = orgText.split("+");

	var regexp = new RegExp(addText + "$"); //$は末尾指定 x1 は x11 にマッチしない
	for (i = 0; i < dd.length; i++) {
		if (dd[i].match(regexp)) {
			addTextFlag = true;
		}
	}

	if (addTextFlag) {
		for (i = 0; i < dd.length; i++) {
			if (!dd[i].match(regexp)) {
				outputText += "+" + dd[i];
			}
		}
	} else {
		for (i = 0; i < dd.length; i++) {
			outputText += "+" + dd[i];
		}
		outputText += "+" + addText;
	}
	//複数の＋を１つに
	outputText = outputText.replace(/\+\+*/g, "+");
	//先頭の＋を削除
	if (outputText.slice(0, 1) == "+") {
		outputText = outputText.slice(1);
	}
	//末尾の＋を削除
	if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
		outputText = outputText.slice(0, outputText.length - 1);
	}
	outputText = outputText.replace(/\+/g, " + ");
	event.target.value = outputText;

	event.target.style.border = "solid 1px #999999";
}
function keydownHandler(event) {
	var key_event = event || window.event; //Firefox IE用
	var key_ctrl = (key_event.ctrlKey);

	if (event.keyCode == 13) {
		var i;
		var dd = [];
		var outputText = "";
		var wStr = "";

		var orgText = event.target.value;
		orgText = orgText.replace(/\s+/g, "");
		orgText = orgText.replace(/\+\+*/g, "+");
		if (orgText.slice(0, 1) == "+") {
			orgText = orgText.slice(1);
		}
		dd = orgText.split("+");
		for (i = 0; i < dd.length; i++) {
			wStr = ExpendXFarray(dd[i]);
			outputText += "+" + wStr;
		}
		//複数の＋を１つに
		outputText = outputText.replace(/\+\+*/g, "+");
		//先頭の＋を削除
		if (outputText.slice(0, 1) == "+") {
			outputText = outputText.slice(1);
		}
		//末尾の＋を削除
		if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
			outputText = outputText.slice(0, outputText.length - 1);
		}
		outputText = outputText.replace(/\+/g, " + ");
		event.target.value = outputText;

		if (key_ctrl) {
			sortXF(event);
		}
	}
}
function ExpendXFarray(str) {
	var i;
	var dd = str;
	var wStr = "";
	var c = [];
	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数
	var formulaLength = document.getElementsByName("formula").length;

	var xf = "";
	var regexp_x = new RegExp("^x\\d+:\\d+$");
	var regexp_f = new RegExp("^f\\d+:\\d+$");
	// var regexp_x = new RegExp("^x\\[\\d+:\\d+\\]$");
	// var regexp_f = new RegExp("^f\\[\\d+:\\d+\\]$");

	var tempStr;
	var start;
	var end;
	if (dd.match(regexp_x)) {
		tempStr = dd.slice(1, dd.length);
		c = tempStr.split(":");
		start = parseInt(c[0]);
		end = parseInt(c[1]);
		xf = "x";

		if ((start > 0) && (end < LA + 1)) {
			for (i = start; i < end + 1; i++) {
				wStr += "+" + xf + i;
			}
		} else {
			wStr = str;
		}

	} else if (dd.match(regexp_f)) {
		tempStr = dd.slice(1, dd.length);
		c = tempStr.split(":");
		start = parseInt(c[0]);
		end = parseInt(c[1]);
		xf = "f";

		if ((start > 0) && (end < formulaLength + 1)) {
			for (i = start; i < end + 1; i++) {
				wStr += "+" + xf + i;
			}
		} else {
			wStr = str;
		}

	} else {
		wStr = str;
	}

	return wStr;
}
/**
 * [inputXF xとFの入力]
 * クリックでテキストエリアにｘとFを入力する
 */
function inputXF(event) {
	//イベント処理
	var key_event = event || window.event; //Firefox IE用
	var key_ctrl = (key_event.ctrlKey);

	var $name = event.target.className;
	var count = document.getElementsByName($name).length;

	var orgText = event.target.innerHTML;

	//キーに対応した処理
	var result = "";
	if (key_ctrl) {
		result = prompt("係数を入力してください");
		if (result !== "") {
			result = result + "*";
		}
	}

	var outputText = "";
	if (document.getElementById($name + "_0_" + count) != null) { //ME部分の入力
		outputText = document.getElementById($name + "_0_" + count).value + "+" + result + orgText;
		//スペースを削除
		outputText = outputText.replace(/\s+/g, "");
		//複数の＋を１つに
		outputText = outputText.replace(/\+\+*/g, "+");
		//先頭の＋を削除
		if (outputText.slice(0, 1) == "+") {
			outputText = outputText.slice(1);
		}
		//末尾の＋を削除
		if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
			outputText = outputText.slice(0, outputText.length - 1);
		}
		outputText = outputText.replace(/\+/g, " + ");

		document.getElementById($name + "_0_" + count).value = outputText;
	} else {
		if (document.getElementById($name + "_1_" + count) != null) {
			if (document.getElementById($name + "_1_" + count).value === "") {
				document.getElementById($name + "_1_" + count).value = result + orgText;
			} else {
				outputText = document.getElementById($name + "_2_" + count).value + "+" + result + orgText;
				//スペースを削除
				outputText = outputText.replace(/\s+/g, "");
				//複数の＋を１つに
				outputText = outputText.replace(/\+\+*/g, "+");
				//先頭の＋を削除
				if (outputText.slice(0, 1) == "+") {
					outputText = outputText.slice(1);
				}
				//末尾の＋を削除
				if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
					outputText = outputText.slice(0, outputText.length - 1);
				}
				outputText = outputText.replace(/\+/g, " + ");

				document.getElementById($name + "_2_" + count).value = outputText;
			}
		}
	}
}
function equalChange(ele) {
	var id = ele.id;
	if (document.getElementById(id).innerText == "==") {
		document.getElementById(id).innerText = ":=";
	} else {
		document.getElementById(id).innerText = "==";
	}
}
function setCursol(event) {
	var $name = event.target.className;
	var count = document.getElementsByName($name).length;

	var orgText = event.target.innerHTML;

	var str;
	var result, result1, result2;
	if (document.getElementById($name + "_0_" + count) != null) { //ME部分の入力
		str = document.getElementById($name + "_0_" + count).value;

		result = 0;
		result1 = 0;
		result2 = 0;
		if (str.lastIndexOf("*") !== -1) {
			result1 = str.lastIndexOf("*");
		}
		if (str.lastIndexOf("+") !== -1) {
			result2 = str.lastIndexOf("+") + 2;
		}
		if (result1 > result2) {
			result = result1;
		} else {
			result = result2;
		}

		document.getElementById($name + "_0_" + count).focus();
		document.getElementById($name + "_0_" + count).setSelectionRange(result, result);
	} else {
		if (document.getElementById($name + "_2_" + count) != null) {
			if (document.getElementById($name + "_2_" + count).value === "") {
				str = document.getElementById($name + "_1_" + count).value;

				result = 0;
				result1 = 0;
				result2 = 0;
				if (str.lastIndexOf("*") !== -1) {
					result1 = str.lastIndexOf("*");
				}
				if (str.lastIndexOf("+") !== -1) {
					result2 = str.lastIndexOf("+") + 2;
				}
				if (result1 > result2) {
					result = result1;
				} else {
					result = result2;
				}
				document.getElementById($name + "_1_" + count).focus();
				document.getElementById($name + "_1_" + count).setSelectionRange(result, result);
			} else {
				str = document.getElementById($name + "_2_" + count).value;

				result = 0;
				result1 = 0;
				result2 = 0;
				if (str.lastIndexOf("*") !== -1) {
					result1 = str.lastIndexOf("*");
				}
				if (str.lastIndexOf("+") !== -1) {
					result2 = str.lastIndexOf("+") + 2;
				}
				if (result1 > result2) {
					result = result1;
				} else {
					result = result2;
				}

				document.getElementById($name + "_2_" + count).focus();
				document.getElementById($name + "_2_" + count).setSelectionRange(result, result);
			}
		}
	}
}
function formulaTextChange(formulaNameId, IdNumber, upDown) {
	var id = formulaNameId;
	var idNum = IdNumber;
	var num = upDown;

	if (document.getElementById(id + "_1_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_1_" + idNum).value;
		document.getElementById(id + "_1_" + idNum).value = document.getElementById(id + "_1_" + (idNum + num)).value;
		document.getElementById(id + "_1_" + (idNum + num)).value = $str;
	}
	if (document.getElementById(id + "_2_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_2_" + idNum).value;
		document.getElementById(id + "_2_" + idNum).value = document.getElementById(id + "_2_" + (idNum + num)).value;
		document.getElementById(id + "_2_" + (idNum + num)).value = $str;
	}
}
function formulaTextChange2(formulaNameId, IdNumber, upDown) {
	var id = formulaNameId;
	var idNum = IdNumber;
	var num = upDown;

	if (document.getElementById(id + "_0_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_0_" + idNum).value;
		document.getElementById(id + "_0_" + idNum).value = document.getElementById(id + "_0_" + (idNum + num)).value;
		document.getElementById(id + "_0_" + (idNum + num)).value = $str;
	}
	if (document.getElementById(id + "_1_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_1_" + idNum).value;
		document.getElementById(id + "_1_" + idNum).value = document.getElementById(id + "_1_" + (idNum + num)).value;
		document.getElementById(id + "_1_" + (idNum + num)).value = $str;
	}
	if (document.getElementById(id + "_2_" + (idNum + num)) != null) {
		$str = document.getElementById(id + "_2_" + idNum).value;
		document.getElementById(id + "_2_" + idNum).value = document.getElementById(id + "_2_" + (idNum + num)).value;
		document.getElementById(id + "_2_" + (idNum + num)).value = $str;
	}
	// ボタンの変更
	if (id === "aaa") {
		if (document.getElementById("eButton_" + (idNum + num)) != null) {
			$str = document.getElementById("eButton_" + idNum).innerText;
			document.getElementById("eButton_" + idNum).innerText = document.getElementById("eButton_" + (idNum + num)).innerText;
			document.getElementById("eButton_" + (idNum + num)).innerText = $str;
		}
	}
}
function delFormula(formulaName, IdNumber) {
	var i;
	var key_event = event || window.event; //Firefox IE用
	var key_ctrl = (key_event.ctrlKey);

	var Name = formulaName;
	var idNum = IdNumber;

	var Length = document.getElementsByName(Name).length;

	if (key_ctrl) {
		// 入力枠を削除
		switch (Name) {
			case "me":
				// 最終行のみ削除できる
				if (idNum === Length) {
					removeSemME();
					changeSem_se_F();
					changeSem_cr_F();
				}
				break;
			case "se":
				for (i = idNum + 1; i < Length + 1; i++) {
					formulaTextChange2(Name, i, -1);
				}
				removeSemSE();
				break;
			case "cr":
				for (i = idNum + 1; i < Length + 1; i++) {
					formulaTextChange2(Name, i, -1);
				}
				removeSemCR();
				break;
			case "aaa":
				for (i = idNum + 1; i < Length + 1; i++) {
					formulaTextChange2(Name, i, -1);
				}
				removeSemAAA();
				break;
			default:
				break;
		}
	} else {
		// テキストを消去
		switch (Name) {
			case "me":
				document.getElementById("me_0_" + idNum).value = "";
				break;
			case "se":
				document.getElementById("se_1_" + idNum).value = "";
				document.getElementById("se_2_" + idNum).value = "";
				break;
			case "cr":
				document.getElementById("cr_1_" + idNum).value = "";
				document.getElementById("cr_2_" + idNum).value = "";
				break;
			case "aaa":
				document.getElementById("aaa_1_" + idNum).value = "";
				document.getElementById("aaa_2_" + idNum).value = "";
				break;
			default:
				break;
		}
	}

}
function delFormulaOver(obj) {
	obj.style.color = "#666666";
}
function delFormulaOut(obj) {
	obj.style.color = "#cccccc";
}
function sortXF(event) {
	var i, j;
	var key_event = event || window.event; //Firefox IE用
	var key_ctrl = (key_event.ctrlKey);

	if (key_ctrl) {
		var outputText = "";
		var orgText = event.target.value;

		orgText = orgText.replace(/\s+/g, "");
		orgText = orgText.replace(/\+\+*/g, "+");
		if (orgText.slice(0, 1) == "+") {
			orgText = orgText.slice(1);
		}
		dd = orgText.split("+");

		var count = document.getElementById("EV_number").value;
		var regexp;
		// f
		for (j = 1; j < count + 1; j++) {
			str = "f" + j;
			regexp = new RegExp(str + "$"); //$は末尾指定 f1 は f11 にマッチしない
			for (i = 0; i < dd.length; i++) {
				if (dd[i].match(regexp)) {
					outputText += "+" + dd[i];
					dd[i] = "";
				}
			}
		}
		// x
		for (j = 1; j < count + 1; j++) {
			str = "x" + j;
			regexp = new RegExp(str + "$"); //$は末尾指定 x1 は x11 にマッチしない
			for (i = 0; i < dd.length; i++) {
				if (dd[i].match(regexp)) {
					outputText += "+" + dd[i];
					dd[i] = "";
				}
			}
		}
		// x，f 以外
		for (i = 0; i < dd.length; i++) {
			if (dd[i] !== "") {
				outputText += "+" + dd[i];
			}
		}

		//複数の＋を１つに
		outputText = outputText.replace(/\+\+*/g, "+");
		//先頭の＋を削除
		if (outputText.slice(0, 1) == "+") {
			outputText = outputText.slice(1);
		}
		//末尾の＋を削除
		if (outputText.slice(outputText.length - 1, outputText.length) == "+") {
			outputText = outputText.slice(0, outputText.length - 1);
		}
		outputText = outputText.replace(/\+/g, " + ");
		event.target.value = outputText;
	}

}
function saveFormula() {
	var i, j;
	var strArray = [];

	strArray.push("SEM" + "\n");

	var NN = parseInt(document.getElementById("subjNum").value);
	strArray.push("#" + "\n");
	strArray.push(NN + "\n");

	var LA = parseInt(document.getElementById("EV_number").value);  // EV_numver  Explanatory Variable 説明変数
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");

	var formulaLength = document.getElementsByName("formula").length;
	strArray.push("#" + "\n");
	strArray.push(formulaLength + "\n");
	strArray.push("#" + "\n");
	var me_text = "";
	for (i = 0; i < formulaLength; i++) {
		me_text = document.getElementById("me_0_" + (i + 1)).value;
		strArray.push(me_text + "\n");
	}

	var seLength = document.getElementsByName("se").length;
	strArray.push("#" + "\n");
	strArray.push(seLength + "\n");
	strArray.push("#" + "\n");
	var se_text = "";
	for (i = 0; i < seLength; i++) {
		se_text = document.getElementById("se_1_" + (i + 1)).value;
		strArray.push(se_text + ",");
		se_text = document.getElementById("se_2_" + (i + 1)).value;
		strArray.push(se_text + "\n");
	}

	var crLength = document.getElementsByName("cr").length;
	strArray.push("#" + "\n");
	strArray.push(crLength + "\n");
	strArray.push("#" + "\n");
	var cr_text = "";
	for (i = 0; i < crLength; i++) {
		cr_text = document.getElementById("cr_1_" + (i + 1)).value;
		strArray.push(cr_text + ",");
		cr_text = document.getElementById("cr_2_" + (i + 1)).value;
		strArray.push(cr_text + "\n");
	}

	var aaaLength = document.getElementsByName("aaa").length;
	strArray.push("#" + "\n");
	strArray.push(aaaLength + "\n");
	strArray.push("#" + "\n");
	var aaa_text = "";
	for (i = 0; i < aaaLength; i++) {
		aaa_text = document.getElementById("aaa_1_" + (i + 1)).value;
		strArray.push(aaa_text + ",");
		aaa_text = document.getElementById("eButton_" + (i + 1)).innerHTML;
		strArray.push(aaa_text + ",");
		aaa_text = document.getElementById("aaa_2_" + (i + 1)).value;
		strArray.push(aaa_text + "\n");
	}

	var Stream = strArray.join("");
	var fineName = "SEM-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function readFormula(ele) {
	var i, j;

	if (window.FileReader) {
		if (!ele.files.length) return;

		var file = ele.files[0];

		var fr = new FileReader();
		var FormulaData = "";
		var F_dd = [];
		fr.onload = function () {
			try {
				FormulaData = fr.result;  // 読み込み結果
				F_dd = FormulaData.split("#");

				if (crDel(F_dd[0]) === "SEM") {
					document.getElementById("subjNum").value = parseInt(F_dd[1]);
					changeSemTableBranch();
					formulaLength_save_init();
					removeAllSemME();
					removeAllSemSE();
					removeAllSemCR();
					removeAllSemAAA();
					changeSem_se_X();
					changeSem_se_F();
					changeSem_cr_X();
					changeSem_cr_F();

					document.getElementById("EV_number").value = parseInt(F_dd[2]);
					changeSemTableBranch();
					changeSem_me_X();
					changeSem_cr_F();

					var formulaLength = parseInt(F_dd[3]);
					for (i = 0; i < formulaLength - 1; i++) {
						makeSemME2();
						changeSem_se_F();
						changeSem_cr_F();
					}
					var me_text = F_dd[4];
					me_text = delTopCR(me_text);
					var _me_data = [];
					_me_data = me_text.split("\n");
					for (i = 0; i < formulaLength; i++) {
						document.getElementById("me_0_" + (i + 1)).value = _me_data[i];
					}

					var seLength = parseInt(F_dd[5]);
					for (i = 0; i < seLength; i++) {
						makeSemSE();
					}
					var se_text = F_dd[6];
					se_text = delTopCR(se_text);
					var se_data = [];
					se_data = se_text.split("\n");
					var _se_data = [];
					for (i = 0; i < seLength; i++) {
						_se_data = se_data[i].split(",");
						document.getElementById("se_1_" + (i + 1)).value = _se_data[0];
						document.getElementById("se_2_" + (i + 1)).value = _se_data[1];
					}

					var crLength = parseInt(F_dd[7]);
					for (i = 0; i < crLength; i++) {
						makeSemCR();
					}
					var cr_text = F_dd[8];
					cr_text = delTopCR(cr_text);
					var cr_data = [];
					cr_data = cr_text.split("\n");
					var _cr_data = [];
					for (i = 0; i < crLength; i++) {
						_cr_data = cr_data[i].split(",");
						document.getElementById("cr_1_" + (i + 1)).value = _cr_data[0];
						document.getElementById("cr_2_" + (i + 1)).value = _cr_data[1];
					}

					var aaaLength = parseInt(F_dd[9]);
					for (i = 0; i < aaaLength; i++) {
						makeSemAAA();
					}
					var aaa_text = F_dd[10];
					aaa_text = delTopCR(aaa_text);
					var aaa_data = [];
					aaa_data = aaa_text.split("\n");
					var _aaa_data = [];
					for (i = 0; i < aaaLength; i++) {
						_aaa_data = aaa_data[i].split(",");
						document.getElementById("aaa_1_" + (i + 1)).value = _aaa_data[0];
						document.getElementById("eButton_" + (i + 1)).innerHTML = _aaa_data[1];
						document.getElementById("aaa_2_" + (i + 1)).value = _aaa_data[2];
					}
				} else {
					alert("データ形式が違います");
				}
			} catch (error) {
				ele.value = ""; // value にはファイル名が入る この値を空にしておかないと同じファイル名のデータが読み込めない（onchangeは変わったかどうかをチェックするため）
				formulaLength_save_init();
				removeAllSemME();
				document.getElementById("me_0_1").value = ""
				removeAllSemSE();
				removeAllSemCR();
				removeAllSemAAA();
				changeSem_se_X();
				changeSem_se_F();
				changeSem_cr_X();
				changeSem_cr_F();
				alert("データを読み込めません");
			}
		};
		fr.readAsText(file);  // ファイルをテキストとして読み込む
	}
}
