/**
 * 分散分析
 * AsB(２要因混合計画)
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeAsbSetting();
	// デフォルトのタブを選択
	ChangeTab(1, 4);

	//コピペエリアにドラッグ＆ドロップを設定
	setDragAndDrop();

	document.getElementById("cell_1").focus();
};
// セルデータの消去
function clearCellData() {
	var i = 0;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);

	}
	var LB = parseInt(document.getElementById("factorB_number").value);

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		elmCount += NN[i] * LB;
	}

	var result = confirm("データを消去します");
	if (result === true) {
		document.getElementById("factorA_name").value = "A";
		document.getElementById("factorB_name").value = "B";
		for (i = 0; i < elmCount; i++) {
			document.getElementById("cell_" + (i + 1)).value = "";
		}
		errorClearCell(elmCount, "");
	}
	document.getElementById("cell_1").focus();
}
function checkCellData() {
	var i = 0;
	var j = 0;

	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}
	var LB = parseInt(document.getElementById("factorB_number").value);

	var elmCount = 0;
	for (i = 0; i < LA; i++) {
		elmCount += NN[i] * LB;
	}

	var errorCellNum = 0;

	if (document.getElementById("CandPArea").value === '') {
		errorClearCell(elmCount, "");
		errorCell(elmCount, "");

		for (i = 0; i < elmCount; i++) {
			if (document.getElementById("cell_" + (i + 1)).value === '') {
				errorCellNum = i + 1;
			}
		}
		if (errorCellNum === 0) {
			errorClearCell(elmCount, "");
			mainCalc_AsB();
		} else {
			alert("すべての数値が入力されていません (^_^)ゞ");
			document.getElementById("cell_" + errorCellNum).focus();
		}
	} else {
		var DData = dataremake5("CandPArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");
		if (elmCount != dd.length) {
			alert("データ数が一致しません");
		} else {
			copipe("CandPArea", "text");
			inputTextArea(document.getElementById("CandPArea"), 0);
			inputBtnTextClear(document.getElementById("inputBtn1"));
			checkCellData();
		}
	}
}
// メイン計算
function mainCalc_AsB() {
	var i = 0;
	var j = 0;
	var k = 0;
	var ii = 0;
	var jj = 0;

	var NN = [];

	AA = document.getElementById("factorA_name").value;
	LA = parseInt(document.getElementById("factorA_number").value, 10);

	var NX = 0;
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
		if (NX < NN[i]) NX = NN[i];
	}

	BB = document.getElementById("factorB_name").value;
	LB = parseInt(document.getElementById("factorB_number").value, 10);

	AA = AA.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (AA === '') AA = "A";
	BB = BB.replace(/\s/g, "_"); //半角スペースを＿に変換する
	if (BB === '') BB = "B";

	var NA = new Array(LA);
	for (i = 0; i < LA; i++) {
		NA[i] = 0;
		for (j = 0; j < LB; j++) {
			NA[i] += NN[i];
		}
	}

	var NB = 0;
	for (i = 0; i < LA; i++) {
		NB += NN[i];
	}

	var NAB = [];
	for (i = 0; i < LA; i++) {
		NAB[i] = NN[i];
	}

	var xx = new Array(LA);
	for (i = 0; i < LA; i++) {
		xx[i] = new Array(LB);
		for (j = 0; j < LB; j++) {
			xx[i][j] = new Array(NX);
		}
	}

	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (k = 0; k < NN[i]; k++) {
			for (j = 0; j < LB; j++) {
				xx[i][j][k] = parseFloat(document.getElementById("cell_" + cellId).value);
				cellId++;
			}
		}
	}

	var M = new Array(LA);
	for (i = 0; i < LA; i++) {
		M[i] = new Array(LB);
	}
	var mm;

	var SD = new Array(LA);
	for (i = 0; i < LA; i++) {
		SD[i] = new Array(LB);
	}
	var sd;

	var AAA = [];
	var BBB = [];
	var FFA$ = [];
	var ADA = [];
	var FFB$ = [];
	var BDB = [];
	var AS = [];

	var MC$;
	var EQ$;

	var strArray = [];
	var bar = "-----------------------------------------------------\n";

	// 平均・標準偏差
	strArray.push("[ AsB-Type Design ]\n\n");
	strArray.push(" == Mean & S.D. ( SD=sqrt(Vtotal/N) ) ==\n\n");
	strArray.push("  A= " + AA + "\n");
	strArray.push("  B= " + BB + "\n");
	strArray.push(bar);
	strArray.push("A\tB\tN\t\tMean\t\tS.D.\n");
	strArray.push(bar);

	var S = 0;
	var SS = 0;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			S = 0;
			SS = 0;
			for (k = 0; k < NN[i]; k++) {
				S += xx[i][j][k];
				SS += Math.pow(xx[i][j][k], 2);
			}
			M[i][j] = S / NN[i];
			mm = using(M[i][j], 5, 4);
			SD[i][j] = Math.sqrt(SS / NN[i] - Math.pow(M[i][j], 2));
			sd = using(SD[i][j], 5, 4);
			strArray.push((i + 1) + "\t" + (j + 1) + "\t" + NN[i] + "\t" + mm + "\t" + sd + "\t\n");
		}
		if (i < LA - 1) {
			strArray.push("\n");
		} else {
			strArray.push(bar);
		}
	}

	S = 0;
	SS = 0;
	var DS = 0;
	var OB = 0;
	var E = 0;
	for (i = 0; i < LA; i++) {
		DS += NN[i] - 1;
		for (j = 0; j < LB; j++) {
			S = S + 1 / NN[i];
			OB = OB + NN[i];
			SS = SS + M[i][j];
			E = E + Math.pow(SD[i][j], 2) * NN[i];
		}
	}

	// var N = LA*LB/S;
	var N = NN[0];
	var DH = SS / LA / LB;

	var NhFgag = false;
	var NhCheck = NN[0];
	for (i = 0; i < LA; i++) {
		if (NhCheck != NN[i]) {
			NhFgag = true;
		}
	}

	if (NhFgag === true) {
		strArray.push("\nNが不揃いです。\n");
		strArray.push("Unweighted-Mean ANOVAを行います。\n");
		N = LA * LB / S;
		n = using(N, 4, 2);
		strArray.push("Nh=" + n + "(調和平均)と仮定します。\n\n");
	}

	//分散分析
	// S.V    SS    df    MS   F
	// -----------------------------------
	//  A      A    DA    MA    FA    FA$
	// subj   SSUB  DS    MS
	// -----------------------------------
	//  B      B    DB    MB    FB    FB$
	// AxB     AB   DI    MI    FI    FI$
	// sxB     E    DE    ME
	// -----------------------------------
	// Total   T    DT

	// S.V    SS    df    MS    F     p
	// -----------------------------------
	//  A     SSa   DFa   MSa   Fa    Pa
	// subj   SSe   DFe   MSe
	// -----------------------------------
	//  B     SSb   DFb   MSb   Fb    Pb
	// AxB    SSab  DFab  MSab  Fab   Pab
	// sxB    SSsb  DFsb  MSsb
	// -----------------------------------
	// Total  SSt   DFt

	//主効果検定
	strArray.push("\n == Analysis of Variance ==\n\n");
	strArray.push(" A(" + LA + ") = " + AA + "\n");
	strArray.push(" B(" + LB + ") = " + BB + "\n");
	strArray.push(bar);
	strArray.push(" S.V          SS        df       MS        F\n");
	strArray.push(bar);

	var A = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		for (j = 0; j < LB; j++) {
			S = S + M[i][j];
		}
		A = A + Math.pow((S / LB - DH), 2) * N * LB;
	}
	var SSUB = 0;
	var xxx = 0;
	for (i = 0; i < LA; i++) {
		S = 0;
		SS = 0;
		for (k = 0; k < NN[i]; k++) {
			xxx = 0;
			for (j = 0; j < LB; j++) {
				xxx = xxx + xx[i][j][k];
			}
			S = S + xxx;
			SS = SS + Math.pow(xxx, 2);
		}
		SSUB = SSUB + SS / LB - Math.pow(S, 2) / NN[i] / LB;
	}

	var B = 0;
	for (j = 0; j < LB; j++) {
		S = 0;
		for (i = 0; i < LA; i++) {
			S = S + M[i][j];
		}
		B = B + Math.pow((S / LA - DH), 2) * N * LA;
	}

	var AB = 0;
	for (i = 0; i < LA; i++) {
		for (j = 0; j < LB; j++) {
			AB = AB + Math.pow((M[i][j] - DH), 2) * N;
		}
	}

	AB = AB - A - B;
	E = E - SSUB;
	var T = A + SSUB + B + AB + E;
	var DA = LA - 1;
	var MA = A / DA;
	var MS = SSUB / DS;
	var DB = LB - 1;
	var MB = B / DB;
	var DI = DA * DB;
	var MI = AB / DI;
	var DE = DS * DB;
	var ME = E / DE;
	var FA = MA / MS;
	var FB = MB / ME;
	var FI = MI / ME;

	var D1 = DA;
	var D2 = DS;
	var Fdata = FA;
	var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var a = using(A,12,4);
	// var da = using(DA,4,0);
	// var ma = using(MA,8,4);
	// var fa = using(FA,3,2);
	// var ssub = using(SSUB,10,4);
	// var ds = using(DS,4,0);
	// var ms = using(MS,8,4);

	strArray.push("  A" + using(A, 12, 4) + " " + using(DA, 4, 0) + " " + using(MA, 8, 4) + " " + using(FA, 3, 2) + " " + FA$ + "\n");
	strArray.push(" subj" + using(SSUB, 10, 4) + " " + using(DS, 4, 0) + " " + using(MS, 8, 4) + "\n");
	strArray.push(bar);
	// strArray.push("  A"+a+" "+da+" "+ma+" "+fa+" "+FA$+"\n");
	// strArray.push(" subj"+ssub+" "+ds+" "+ms+"\n");
	// strArray.push(bar);

	D1 = DB;
	D2 = DE;
	Fdata = FB;
	var FB$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var b = using(B,12,4);
	// var db = using(DB,4,0);
	// var mb = using(MB,8,4);
	// var fb = using(FB,3,2);

	strArray.push("  B" + using(B, 12, 4) + " " + using(DB, 4, 0) + " " + using(MB, 8, 4) + " " + using(FB, 3, 2) + " " + FB$ + "\n");
	// strArray.push("  B"+b+" "+db+" "+mb+" "+fb+" "+FB$+"\n");

	D1 = DI;
	Fdata = FI;
	var FI$ = pValue_Match_fRatio(D1, D2, Fdata);

	// var ab = using(AB,11,4);
	// var di = using(DI,4,0);
	// var mi = using(MI,8,4);
	// var fi = using(FI,3,2);
	// var e = using(E,11,4);
	// var de = using(DE,4,0);
	// var me = using(ME,8,4);

	strArray.push(" AxB" + using(AB, 11, 4) + " " + using(DI, 4, 0) + " " + using(MI, 8, 4) + " " + using(FI, 3, 2) + " " + FI$ + "\n");
	strArray.push(" sxB" + using(E, 11, 4) + " " + using(DE, 4, 0) + " " + using(ME, 8, 4) + "\n");
	strArray.push(bar);
	// strArray.push(" AxB"+ab+" "+di+" "+mi+" "+fi+" "+FI$+"\n");
	// strArray.push(" sxB"+e+" "+de+" "+me+"\n");
	// strArray.push(bar);

	// var t = using(T,10,4);
	var DT = OB - 1;
	// var dt = using(DT,4,0);

	strArray.push("Total" + using(T, 10, 4) + " " + using(DT, 4, 0));
	strArray.push("   +p<.10 *p<.05 **p<.01\n\n");
	// strArray.push("Total"+t+" "+dt);
	// strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

	//効果量
	var eta2 = 0;
	var effectSizeF = 0;

	strArray.push("\n == EffectSize ==\n\n");
	strArray.push("\tpartial η2\teffectsize f\n");
	strArray.push(bar);

	eta2 = DA * FA / (DA * FA + DS);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push("  A\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	eta2 = DB * FB / (DB * FB + DE);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push("  B\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	eta2 = DI * FI / (DI * FI + DE);
	effectSizeF = Math.sqrt(eta2 / (1 - eta2));
	strArray.push(" AxB\t" + eta2.toFixed(4) + "\t\t" + effectSizeF.toFixed(4) + "\n");

	strArray.push(bar);
	strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

	//単純主効果検定
	if (FI$ != "ns") {
		strArray.push("\n == Analysis of AxB Interaction ==\n\n");
		strArray.push("     S.V          SS        df       MS          F\n");
		strArray.push(bar);

		for (j = 0; j < LB; j++) {
			S = 0;
			SS = 0;
			AS[j] = 0;
			for (i = 0; i < LA; i++) {
				S += M[i][j];
				SS += Math.pow(M[i][j], 2);
				var S1 = 0, S2 = 0;
				for (k = 0; k < NN[i]; k++) {
					S1 = S1 + xx[i][j][k];
					S2 = S2 + Math.pow(xx[i][j][k], 2);
				}
				AS[j] = AS[j] + S2 - Math.pow(S1, 2) / NN[i];
			}
			A = (SS - Math.pow(S, 2) / LA) * N;
			FF = A / DA / AS[j] * DS;
			D1 = DA;
			D2 = DS;
			Fdata = FF;
			FFA$[j] = pValue_Match_fRatio(D1, D2, Fdata);
			ADA[j] = A / DA;

			// var ss = using(A,6,4);
			// var df = using(DA,4,0);
			// var ms = using(ADA[j],6,4);
			// var ff = using(FF,6,2);

			strArray.push(" A  at B" + (j + 1) + ":\t" + using(A, 6, 4) + " " + using(DA, 4, 0) + " " + using(ADA[j], 6, 4) + " " + using(FF, 6, 2) + " " + FFA$[j] + "\n");
			// strArray.push(" A  at B"+(j+1)+":\t"+ss+" "+df+" "+ms+" "+ff+" "+FFA$[j]+"\n");

			// var as = using(AS[j],6,4);
			// var df = using(DS,4,0);
			ASDF = AS[j] / DS;
			// var asdf = using(ASDF,6,4);

			strArray.push("(subj at B" + (j + 1) + ":\t" + using(AS[j], 6, 4) + " " + using(DS, 4, 0) + " " + using(ASDF, 6, 4) + " )\n");
			// strArray.push("(subj at B"+(j+1)+":\t"+as+" "+df+" "+asdf+" )\n");
			strArray.push(bar);
		}

		for (i = 0; i < LA; i++) {
			S = 0;
			SS = 0;
			for (j = 0; j < LB; j++) {
				S += M[i][j];
				SS += Math.pow(M[i][j], 2);
			}
			B = (SS - Math.pow(S, 2) / LB) * N;
			FF = B / DB / ME;
			D1 = DB;
			D2 = DE;
			Fdata = FF;
			FFB$[i] = pValue_Match_fRatio(D1, D2, Fdata);
			BDB[i] = B / DB;

			// ss = using(B,6,4);
			// df = using(DB,4,0);
			// ms = using(BDB[i],6,4);
			// f = using(FF,6,2);

			strArray.push(" B  at A" + (i + 1) + ":\t" + using(B, 6, 4) + " " + using(DB, 4, 0) + " " + using(BDB[i], 6, 4) + " " + using(FF, 6, 2) + " " + FFB$[i] + "\n");
			// strArray.push(" B  at A"+(i+1)+":\t"+ss+" "+df+" "+ms+" "+f+" "+FFB$[i]+"\n");
		}
		// var e = using(E,9,4);
		// var de = using(DE,4,0);
		// var me = using(ME,6,4);

		strArray.push("(   sxB  " + using(E, 9, 4) + " " + using(DE, 4, 0) + " " + using(ME, 6, 4) + "\n");
		// strArray.push("(   sxB  "+e+" "+de+" "+me+"\n");
		strArray.push(bar);
	}

	//多重比較
	// 多重比較の出力メモ（すべての方法で）
	//  交互作用の有意性に関わらず,
	//  AとBの水準数が２より大きく,主効果が有意だった場合は出力する
	//  2013.1.15 改訂

	var checkedLsd = false;
	var checkedHsd = false;
	var checkedBonf = false;
	var checkedHolm = false;

	checkedLsd = document.getElementById("LSD").checked;
	checkedHsd = document.getElementById("HSD").checked;
	checkedBonf = document.getElementById("BONF").checked;
	checkedHolm = document.getElementById("HOLM").checked;

	//多重比較 LSD法
	if (checkedLsd) {
		var T2;
		var LSD;
		var lsdd;
		if (FI$ != "ns") {
			if (LA > 2) {
				D2 = DS;
				T2 = tvalue(D2);
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {

						ASDF = AS[j] / DS;
						asdf = using(ASDF, 6, 4);
						LSD = T2 * Math.sqrt(2 * AS[j] / DS / N);
						lsdd = using(LSD, 8, 4);

						strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + asdf + ", * p<.05)\n");
						strArray.push(" (LSD=" + lsdd + ")\n");
						strArray.push(bar);

						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								if (Math.abs(M[i][j] - M[ii][j]) > LSD) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
							}
						}
					}
				}
				strArray.push(bar);
			}
			if (LB > 2) {
				D2 = DE;
				T2 = tvalue(D2);
				LSD = T2 * Math.sqrt(2 * ME / N);
				me = using(ME, 6, 4);
				lsdd = using(LSD, 8, 4);
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(" (LSD=" + lsdd + ")\n");
						strArray.push(bar);
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (Math.abs(M[i][j] - M[i][jj]) > LSD) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
							}
						}
					}
				}
				strArray.push(bar);
			}
		}
		if ((LA > 2) && (FA$ != "ns")) {
			MS = SSUB / DS;
			ms = using(MS, 6, 4);
			D2 = DS;
			T2 = tvalue(D2);
			LSD = T2 * Math.sqrt(2 * MS / N / LB);
			lsdd = using(LSD, 8, 4);

			strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
			strArray.push(" (MSe=" + ms + ", * p<.05)\n");
			strArray.push(" (LSD=" + lsdd + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N(Nu)       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				NLB = N * LB;
				// var aaa = using(AAA[i],6,4);
				// var nlb = using(NLB,6,2);
				strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					if (Math.abs(AAA[i] - AAA[ii]) > LSD) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
		if ((LB > 2) && (FB$ != "ns")) {
			ME = E / DE;
			me = using(ME, 6, 4);
			D2 = DE;
			T2 = tvalue(D2);
			LSD = T2 * Math.sqrt(2 * ME / N / LA);
			lsdd = using(LSD, 8, 4);

			strArray.push("\n == Multiple Comparisons by LSD ==\n\n");
			strArray.push(" (MSe=" + me + ", * p<.05)\n");
			strArray.push(" (LSD=" + lsdd + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N           Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				// var bbb = using(BBB[j],6,4);
				// var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (Math.abs(BBB[j] - BBB[jj]) > LSD) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
				}
			}
			strArray.push(bar);
		}
	}

	//多重比較 HSD(Tukey-kramer)
	// HSD法は分析に用いない

	//多重比較 Bonferroni法
	if (checkedBonf) {
		var kumi = 0;
		var TB = 0;
		var alpha_d = 0;


		var BONF;
		var bonf;

		if (FI$ != "ns") {
			if (LA > 2) {
				D2 = DS;
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {

						ASDF = AS[j] / DS;
						asdf = using(ASDF, 6, 4);

						kumi = kumiawase(LA, 2);
						TB = bonf_tValue(kumi, D2);
						alpha_d = using(0.05 / kumi, 2, 4);

						strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + asdf + ", * p<.05 , alpha'=" + alpha_d + ")\n");
						strArray.push(bar);

						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								BONF = TB * Math.sqrt(AS[j] / DS * (1 / NAB[i] + 1 / NAB[ii]));
								bonf = using(BONF, 7, 4);

								if (Math.abs(M[i][j] - M[ii][j]) > BONF) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
			if (LB > 2) {
				D2 = DE;
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						kumi = kumiawase(LB, 2);
						TB = bonf_tValue(kumi, D2);
						alpha_d = using(0.05 / kumi, 2, 4);
						me = using(ME, 6, 4);

						BONF = TB * Math.sqrt(2 * ME / NAB[i]);
						bonf = using(BONF, 7, 4);

						strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
						strArray.push(" (BONF=" + bonf + ")\n");
						strArray.push(bar);

						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (Math.abs(M[i][j] - M[i][jj]) > BONF) {
									MC$ = " *  ";
								} else {
									MC$ = "n.s.";
									EQ$ = "=";
								}
								if (MC$ == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								}
								strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "\n");
							}
						}
						strArray.push(bar);
					}
				}
			}
		}
		if ((LA > 2) && (FA$ != "ns")) {

			MS = SSUB / DS;
			ms = using(MS, 6, 4);

			D2 = DS;
			kumi = kumiawase(LA, 2);
			TB = bonf_tValue(kumi, D2);
			alpha_d = using(0.05 / kumi, 2, 4);

			strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
			strArray.push(" (MSe=" + ms + ", * p<.05 , alpha'=" + alpha_d + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N(Nu)       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				NLB = N * LB;
				// var nlb = using(NLB,6,2);
				// var aaa = using(AAA[i],6,4);
				// var na = using(NA,6,2);
				strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					BONF = TB * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
					bonf = using(BONF, 7, 4);

					if (Math.abs(AAA[i] - AAA[ii]) > BONF) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
				}
			}
			strArray.push(bar);
		}
		if ((LB > 2) && (FB$ != "ns")) {
			ME = E / DE;
			me = using(ME, 6, 4);

			D2 = DE;
			kumi = kumiawase(LB, 2);
			TB = bonf_tValue(kumi, D2);
			alpha_d = using(0.05 / kumi, 2, 4);

			BONF = TB * Math.sqrt(2 * ME / NB);
			bonf = using(BONF, 7, 4);

			strArray.push("\n == Multiple Comparisons by Bonferroni ==\n\n");
			strArray.push(" (MSe=" + me + ", * p<.05 , alpha'=" + alpha_d + ")\n");
			strArray.push(" (BONF=" + bonf + ")\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N           Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				// var bbb = using(BBB[j],6,4);
				// var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (Math.abs(BBB[j] - BBB[jj]) > BONF) {
						MC$ = " *  ";
					} else {
						MC$ = "n.s.";
						EQ$ = "=";
					}
					if (MC$ == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					}
					strArray.push("   B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + MC$ + "   (BONF=" + bonf + ")\n");
				}
			}
			strArray.push(bar);
		}
	}

	//多重比較 Holm
	if (checkedHolm) {
		var TL = [];
		var TLN = []; //順番を保存
		var HMC$ = [];
		var alpha_d = [];

		var tlcount = 0;

		var kumi = 0;

		var temp, temp2, temp3, temp4;

		var kflag = 1; //１のとき棄却する 0だと検定終了

		if (FI$ != "ns") {
			if (LA > 2) {
				D2 = DS;
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {

						ASDF = AS[j] / DS;
						asdf = using(ASDF, 6, 4);

						kumi = kumiawase(LA, 2);
						tlcount = 0;
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								TL[tlcount] = Math.abs(M[i][j] - M[ii][j]) / Math.sqrt(AS[j] / DS * (1 / NAB[i] + 1 / NAB[ii]));
								TLN[tlcount] = tlcount;
								tlcount++;
							}
						}

						//TL値の小さい順に並び替え（同時にTLN値も）
						// var temp;
						// var temp2;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TL[jk] < TL[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
								}
							}
						}

						//TL値を計算
						kflag = 1; //１のとき棄却する 0だと検定終了
						for (ik = kumi; ik > 0; ik--) {
							if (kflag) {
								if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
									HMC$[ik - 1] = " *  ";
								} else {
									HMC$[ik - 1] = "n.s.";
									kflag = 0; //検定終了 以降はすべて保留
								}
							} else {
								HMC$[ik - 1] = "n.s.";
							}
							alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
						}

						//TLN値の小さい順に並び替え
						// var temp3;
						// var temp4;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TLN[jk] < TLN[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									temp3 = HMC$[jk];
									temp4 = alpha_d[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									HMC$[jk] = HMC$[jk - 1];
									alpha_d[jk] = alpha_d[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
									HMC$[jk - 1] = temp3;
									alpha_d[jk - 1] = temp4;
								}
							}
						}

						strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
						strArray.push(" A at B" + (j + 1) + " Level\n");
						strArray.push(" (MSe=" + asdf + ", * p<.05)\n");
						strArray.push(bar);

						tlcount = 0;
						for (i = 0; i < LA - 1; i++) {
							for (ii = i + 1; ii < LA; ii++) {
								if (HMC$[tlcount] == " *  ") {
									if (M[i][j] > M[ii][j]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									EQ$ = "=";
								}
								strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
								tlcount++;
							}
						}
						strArray.push(bar);
					}
				}
			}
			if (LB > 2) {
				D2 = DE;
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						kumi = kumiawase(LB, 2);
						tlcount = 0;
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								TL[tlcount] = Math.abs(M[i][j] - M[i][jj]) / Math.sqrt(2 * ME / NAB[i]);
								TLN[tlcount] = tlcount;
								tlcount++;
							}
						}

						//TL値の小さい順に並び替え（同時にTLN値も）
						// var temp;
						// var temp2;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TL[jk] < TL[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
								}
							}
						}

						//TL値を計算
						kflag = 1; //１のとき棄却する 0だと検定終了
						for (ik = kumi; ik > 0; ik--) {
							if (kflag) {
								if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
									HMC$[ik - 1] = " *  ";
								} else {
									HMC$[ik - 1] = "n.s.";
									kflag = 0; //検定終了 以降はすべて保留
								}
							} else {
								HMC$[ik - 1] = "n.s.";
							}
							alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
						}

						//TLN値の小さい順に並び替え
						// var temp3;
						// var temp4;
						for (ik = 0; ik < kumi; ik++) {
							for (jk = kumi - 1; jk > 0; jk--) {
								if (TLN[jk] < TLN[jk - 1]) {
									temp = TL[jk];
									temp2 = TLN[jk];
									temp3 = HMC$[jk];
									temp4 = alpha_d[jk];
									TL[jk] = TL[jk - 1];
									TLN[jk] = TLN[jk - 1];
									HMC$[jk] = HMC$[jk - 1];
									alpha_d[jk] = alpha_d[jk - 1];
									TL[jk - 1] = temp;
									TLN[jk - 1] = temp2;
									HMC$[jk - 1] = temp3;
									alpha_d[jk - 1] = temp4;
								}
							}
						}

						me = using(ME, 6, 4);

						strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
						strArray.push(" B at A" + (i + 1) + " Level\n");
						strArray.push(" (MSe=" + me + ", * p<.05)\n");
						strArray.push(bar);

						tlcount = 0;
						for (j = 0; j < LB - 1; j++) {
							for (jj = j + 1; jj < LB; jj++) {
								if (HMC$[tlcount] == " *  ") {
									if (M[i][j] > M[i][jj]) {
										EQ$ = ">";
									} else {
										EQ$ = "<";
									}
								} else {
									EQ$ = "=";
								}
								strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
								tlcount++;
							}
						}
						strArray.push(bar);
					}
				}
			}
		}
		if ((LA > 2) && (FA$ != "ns")) {

			MS = SSUB / DS;
			ms = using(MS, 6, 4);

			D2 = DS;
			// var kumi = 0;
			kumi = kumiawase(LA, 2);
			tlcount = 0;

			strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
			strArray.push(" (MSe=" + ms + ", * p<.05)\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor A]\n");
			strArray.push(" A     N(Nu)       Mean\n");
			strArray.push(bar);
			for (i = 0; i < LA; i++) {
				S = 0;
				for (j = 0; j < LB; j++) {
					S = S + M[i][j];
				}
				AAA[i] = S / LB;
				NLB = N * LB;
				// var nlb = using(NLB,6,2);
				// var aaa = using(AAA[i],6,4);
				// var na = using(NA,6,2);
				strArray.push(" " + (i + 1) + "\t" + using(NA[i], 4, 0) + "(" + NLB.toFixed(2) + ")\t" + using(AAA[i], 6, 4) + "\n");
			}
			strArray.push(bar);
			tlcount = 0;
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					TL[tlcount] = Math.abs(AAA[i] - AAA[ii]) / Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii]));
					TLN[tlcount] = tlcount;
					tlcount++;
				}
			}

			//TL値の小さい順に並び替え（同時にTLN値も）
			// var temp;
			// var temp2;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TL[jk] < TL[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
					}
				}
			}

			//TL値を計算
			kflag = 1; //１のとき棄却する 0だと検定終了
			for (ik = kumi; ik > 0; ik--) {
				if (kflag) {
					if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
						HMC$[ik - 1] = " *  ";
					} else {
						HMC$[ik - 1] = "n.s.";
						kflag = 0; //検定終了 以降はすべて保留
					}
				} else {
					HMC$[ik - 1] = "n.s.";
				}
				alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
			}

			//TLN値の小さい順に並び替え
			// var temp3;
			// var temp4;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TLN[jk] < TLN[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						temp3 = HMC$[jk];
						temp4 = alpha_d[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						HMC$[jk] = HMC$[jk - 1];
						alpha_d[jk] = alpha_d[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
						HMC$[jk - 1] = temp3;
						alpha_d[jk - 1] = temp4;
					}
				}
			}

			tlcount = 0;
			for (i = 0; i < LA - 1; i++) {
				for (ii = i + 1; ii < LA; ii++) {
					if (HMC$[tlcount] == " *  ") {
						if (AAA[i] > AAA[ii]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					} else {
						EQ$ = "=";
					}
					strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
					tlcount++;
				}
			}
			strArray.push(bar);
		}
		if ((LB > 2) && (FB$ != "ns")) {
			ME = E / DE;
			me = using(ME, 6, 4);

			D2 = DE;
			// var kumi = 0;
			kumi = kumiawase(LB, 2);
			tlcount = 0;

			strArray.push("\n == Multiple Comparisons by Holm ==\n\n");
			strArray.push(" (MSe=" + me + ", * p<.05)\n");
			strArray.push(bar);

			strArray.push("[Main Effect of Factor B]\n");
			strArray.push(" B     N           Mean\n");
			strArray.push(bar);
			for (j = 0; j < LB; j++) {
				S = 0;
				for (i = 0; i < LA; i++) {
					S = S + M[i][j];
				}
				BBB[j] = S / LA;
				// var bbb = using(BBB[j],6,4);
				// var nb = using(NB,4,0);
				strArray.push(" " + (j + 1) + "\t" + using(NB, 4, 0) + "\t" + using(BBB[j], 6, 4) + "\n");
			}
			strArray.push(bar);
			tlcount = 0;
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					TL[tlcount] = Math.abs(BBB[j] - BBB[jj]) / Math.sqrt(2 * ME / NB);
					TLN[tlcount] = tlcount;
					tlcount++;
				}
			}

			//TL値の小さい順に並び替え（同時にTLN値も）
			// var temp;
			// var temp2;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TL[jk] < TL[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
					}
				}
			}

			//TL値を計算
			kflag = 1; //１のとき棄却する 0だと検定終了
			for (ik = kumi; ik > 0; ik--) {
				if (kflag) {
					if (TL[ik - 1] >= bonf_tValue(ik, D2)) {
						HMC$[ik - 1] = " *  ";
					} else {
						HMC$[ik - 1] = "n.s.";
						kflag = 0; //検定終了 以降はすべて保留
					}
				} else {
					HMC$[ik - 1] = "n.s.";
				}
				alpha_d[ik - 1] = using(0.05 / ik, 2, 4);
			}

			//TLN値の小さい順に並び替え
			// var temp3;
			// var temp4;
			for (ik = 0; ik < kumi; ik++) {
				for (jk = kumi - 1; jk > 0; jk--) {
					if (TLN[jk] < TLN[jk - 1]) {
						temp = TL[jk];
						temp2 = TLN[jk];
						temp3 = HMC$[jk];
						temp4 = alpha_d[jk];
						TL[jk] = TL[jk - 1];
						TLN[jk] = TLN[jk - 1];
						HMC$[jk] = HMC$[jk - 1];
						alpha_d[jk] = alpha_d[jk - 1];
						TL[jk - 1] = temp;
						TLN[jk - 1] = temp2;
						HMC$[jk - 1] = temp3;
						alpha_d[jk - 1] = temp4;
					}
				}
			}

			tlcount = 0;
			for (j = 0; j < LB - 1; j++) {
				for (jj = j + 1; jj < LB; jj++) {
					if (HMC$[tlcount] == " *  ") {
						if (BBB[j] > BBB[jj]) {
							EQ$ = ">";
						} else {
							EQ$ = "<";
						}
					} else {
						EQ$ = "=";
					}
					strArray.push("  B" + (j + 1) + "  " + EQ$ + "  B" + (jj + 1) + "  " + HMC$[tlcount] + "  (alpha'=" + alpha_d[tlcount] + ")\n");
					tlcount++;
				}
			}
			strArray.push(bar);
		}
	}

	strArray.push("\n _/_/_/ Analyzed by js-STAR _/_/_/\n");

	//グラフの設定
	var gCheck = document.getElementById("RltArea").value;
	gCheck = gCheck.replace(/\s+/g, ""); //空白文字を全削除

	//出力
	document.getElementById("RltArea").value = strArray.join("");
	strArray = null;

	//Ｒプログラム出力
	(function () {
		var rcmArray = [];
		var spc = "          ";

		rcmArray.push("####### 分散分析ＡｓＢ(２要因混合) #######\n");
		rcmArray.push("\n");
		rcmArray.push("# パッケージ car が必要：LeveneTest\n");
		rcmArray.push("\n");
		rcmArray.push("## js-STARの入力: AsB\n");
		rcmArray.push("levA <- " + LA + spc + "# level of A\n");
		rcmArray.push("levB <- " + LB + spc + "# level of B\n");
		rcmArray.push("n  <- c(  # データ数\n");
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				rcmArray.push(" " + NN[i]);
				if ((i != LA - 1) || (j != LB - 1)) rcmArray.push(",");
			}
			rcmArray.push("\n");
		}
		rcmArray.push(")\n");
		rcmArray.push("data <- c(\n");
		for (i = 0; i < LA; i++) {
			for (k = 0; k < NN[i]; k++) {
				for (j = 0; j < LB; j++) {
					rcmArray.push(" " + xx[i][j][k]);
					if ((i != LA - 1) || (j != LB - 1) || (k != NN[i] - 1)) rcmArray.push(",");
				}
				if ((i != LA - 1) || (k != NN[i] - 1)) {
					rcmArray.push("\n");
				}
			}
			if (i != LA - 1) {
				rcmArray.push("\n");
			}
		}
		rcmArray.push("\n )\n");
		rcmArray.push("## js-STARの入力おわり\n");

		rcmArray.push("\n");
		rcmArray.push("## スタック形式のデータセット\n");
		rcmArray.push("A <- c()\n");
		rcmArray.push("for( i in 1:levA ){\n");
		rcmArray.push("  for( j in 1:levB ){\n");
		rcmArray.push("    suji <- rep( i, n[j+levB*(i-1)] )\n");
		rcmArray.push("    A    <- c( A, suji )\n");
		rcmArray.push("  }\n");
		rcmArray.push("}\n");

		rcmArray.push("\n");
		rcmArray.push("s <- c()\n");
		rcmArray.push("s <- rep(1:(sum(n)/levB), each=levB )\n");
		rcmArray.push("\n");
		rcmArray.push("B <- c()\n");
		rcmArray.push("B <- rep(1:levB, sum(n)/levB )\n");
		rcmArray.push("AsB <- data.frame(A, s, B, data)\n");
		rcmArray.push("AsB$A <- factor(AsB$A )\n");
		rcmArray.push("AsB$s <- factor(AsB$s )\n");
		rcmArray.push("AsB$B <- factor(AsB$B )\n");

		rcmArray.push("\n");
		rcmArray.push("## 基本統計量\n");
		rcmArray.push("tmp <- tapply(AsB$data, list(AsB$A,AsB$B), mean)\n");
		rcmArray.push("hk  <- as.numeric( t(tmp) )\n");
		rcmArray.push("tmp <- tapply(AsB$data, list(AsB$A,AsB$B), sd)\n");
		rcmArray.push("sd  <- as.numeric( t(tmp) )\n");
		rcmArray.push("tmp <- tapply(AsB$data, list(AsB$A,AsB$B), min)\n");
		rcmArray.push("mi  <- as.numeric( t(tmp) )\n");
		rcmArray.push("tmp <- tapply(AsB$data, list(AsB$A,AsB$B), max)\n");
		rcmArray.push("ma  <- as.numeric( t(tmp) )\n");
		rcmArray.push("\n");
		rcmArray.push("suji <- round(c(n,hk,sd,mi,ma), 4)\n");
		rcmArray.push("hyoj <- c()\n");
		rcmArray.push("for(L in 1:5){\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("  if (i>1) hyoj <- c(hyoj, NA)\n");
		rcmArray.push("for(j in 1:levB){\n");
		rcmArray.push("  hyoj <- c(hyoj,\n");
		rcmArray.push("    suji[(L-1)*levA*levB+(i-1)*levB+j] )\n");
		rcmArray.push("  } } }\n");
		rcmArray.push("tx0 <- matrix(hyoj,\n");
		rcmArray.push("              nr=levA*levB+levA-1)\n");
		rcmArray.push("colnames(tx0) <- c(\n");
		rcmArray.push("  \"   ｎ\",\n");
		rcmArray.push("  \"     Mean\",\n");
		rcmArray.push("  \"       SD\",\n");
		rcmArray.push("  \"   Min\",\n");
		rcmArray.push("  \"   Max\" )\n");
		rcmArray.push("tmp <- c()\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("  if (i>1) tmp <- c(tmp, \"\")\n");
		rcmArray.push("for(j in 1:levB){\n");
		rcmArray.push("  tmp <- c(tmp,\n");
		rcmArray.push("    paste(\n");
		rcmArray.push("      paste(\"A.\", i, sep=\"\"),\n");
		rcmArray.push("      paste(\"B.\", j, sep=\"\"),\n");
		rcmArray.push("      sep=\"_\" ) )\n");
		rcmArray.push("  }\n");
		rcmArray.push("  }\n");
		rcmArray.push("rownames(tx0) <- tmp\n");

		rcmArray.push("\n");
		rcmArray.push("# 作図：線グラフ（ｘ軸に被験者内要因をとる）\n");
		rcmArray.push("pointc <- c(21,22,23,24,25,21,22,23,24,25)\n");
		rcmArray.push("backgr <- c( 8, 8, 8, 8, 8, 1, 1, 1, 1, 1)\n");
		rcmArray.push("\n");
		rcmArray.push("if(levA>10){pointc <- c(pointc,\n");
		rcmArray.push("              rep(21, levA-10) )\n");
		rcmArray.push("            backgr <- c(backgr,\n");
		rcmArray.push("              (1+1):( 1+(levA-10) )\n");
		rcmArray.push("              ) }\n");
		rcmArray.push("\n");
		rcmArray.push("xjik <- c(0.8, levB+0.2)   # 要因Ｂ\n");
		rcmArray.push("yjik <- c(\n");
		rcmArray.push("  min(hk-sd),              # ｙ軸下限点\n");
		rcmArray.push("  max(hk+sd) )             # ｙ軸上限点\n");
		rcmArray.push("\n");
		rcmArray.push("plot(1:levB, hk[1:levB],   # ダミー\n");
		rcmArray.push("  typ=\"n\",               # 非表示で枠設定\n");
		rcmArray.push("  bty=\"l\",\n");
		rcmArray.push("  xli=xjik, yli=yjik,\n");
		rcmArray.push("  xlab=\"\",               # ｘ軸のラベル名\n");
		rcmArray.push("  ylab=\"\",               # ｙ軸のラベル名\n");
		rcmArray.push("  xaxt=\"n\",\n");
		rcmArray.push("  tck=0.03, las=1,         # 目盛り突起\n");
		rcmArray.push("  main=c(\"SD= 不偏分散の平方根\")\n");
		rcmArray.push("    )\n");
		rcmArray.push("\n");
		for (i = 0; i < LA; i++) {
			rcmArray.push("# グラフ A" + (i + 1) + "\n");
			rcmArray.push("# x の値を増減するとアンテナが水平にずれる（重なり対策）\n");
			rcmArray.push("# 表示したい行は,行頭の# を削除する\n");
			for (j = 0; j < LB; j++) {
				var num = (j + 1) + i * LB;
				rcmArray.push("# x=0; arrows(" + (j + 1) + "+x,hk[" + num + "], " + (j + 1) + "+x,hk[" + num + "]+sd[" + num + "], lwd=1,ang=90,len=0.13) # A" + (i + 1) + "_B" + (j + 1) + " SD上\n");
				rcmArray.push("# x=0; arrows(" + (j + 1) + "+x,hk[" + num + "], " + (j + 1) + "+x,hk[" + num + "]-sd[" + num + "], lwd=1,ang=90,len=0.13) # A" + (i + 1) + "_B" + (j + 1) + " SD下\n");
			}
			rcmArray.push("\n");
		}
		rcmArray.push("\n");
		rcmArray.push("lab <- c()\n");
		rcmArray.push("for(i in 1:levB){\n");
		rcmArray.push("  lab <- c(lab, paste(\"B\",i,sep=\"\"))\n");
		rcmArray.push("}\n");
		rcmArray.push("axis(side=1,\n");
		rcmArray.push("     at = 1:levB,\n");
		rcmArray.push("     labels = lab,\n");
		rcmArray.push("     tck=0.03, las=1,\n");
		rcmArray.push("     )\n");
		rcmArray.push("\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("for(j in 2:levB){\n");
		rcmArray.push("  lines( (j-1):j,\n");
		rcmArray.push("    hk[((j-1)+(i-1)*levB):\n");
		rcmArray.push("       ( j   +(i-1)*levB) ]\n");
		rcmArray.push("    )\n");
		rcmArray.push("  } }\n");
		rcmArray.push("\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("for(j in 1:levB){\n");
		rcmArray.push("  points(j, hk[j+(i-1)*levB],\n");
		rcmArray.push("    pc=pointc[i], # ポイントキャラ\n");
		rcmArray.push("    bg=backgr[i], # バックグランド\n");
		rcmArray.push("    cex=3 )       # キャラ倍率\n");
		rcmArray.push("  } }\n");
		rcmArray.push("\n");
		rcmArray.push("## 描図おわり→注記\n");
		rcmArray.push("chuki <- paste(\n");
		rcmArray.push("  \"要因Ａ_水準\",\n");
		rcmArray.push("  1:levA,\n");
		rcmArray.push("  sep=\"\")\n");
		rcmArray.push("legend(\n");
		rcmArray.push("  \"topright\", # top/bottom+left/right,center\n");
		rcmArray.push("  chuki,\n");
		rcmArray.push("  pc=pointc[1:levA],\n");
		rcmArray.push("  col=1,\n");
		rcmArray.push("  cex=1.2 )\n");

		rcmArray.push("\n");
		rcmArray.push("## 分散分析\n");
		rcmArray.push("library( car )\n");
		rcmArray.push("ty1 <- anova(  # 誤差項\n");
		rcmArray.push("  lm(data~A+s+B+A:B, data=AsB,\n");
		rcmArray.push("    contrasts=list(\n");
		rcmArray.push("    A=\"contr.sum\",\n");
		rcmArray.push("    B=\"contr.sum\" ) )\n");
		rcmArray.push("  )\n");
		rcmArray.push("SSs   <- ty1$Sum[2]\n");
		rcmArray.push("SSsxb <- ty1$Sum[5]\n");
		rcmArray.push("DFs   <- ty1$Df[2]\n");
		rcmArray.push("DFsxb <- ty1$Df[5]\n");
		rcmArray.push("\n");
		rcmArray.push("ty2 <- Anova(  # TypeII_SS→オプ用\n");
		rcmArray.push("  lm(data~A*B, data=AsB,\n");
		rcmArray.push("    contrasts=list(\n");
		rcmArray.push("    A=\"contr.sum\",\n");
		rcmArray.push("    B=\"contr.sum\" ) ),\n");
		rcmArray.push("  type=2 )\n");
		rcmArray.push("\n");
		rcmArray.push("ty3 <- Anova(  # TypeIII_SS\n");
		rcmArray.push("  lm(data~A*B, data=AsB,\n");
		rcmArray.push("    contrasts=list(\n");
		rcmArray.push("    A=\"contr.sum\",\n");
		rcmArray.push("    B=\"contr.sum\" ) ),\n");
		rcmArray.push("  type=3 )\n");
		rcmArray.push("\n");
		rcmArray.push("SSa   <- ty3$Sum[2]\n");
		rcmArray.push("SSs   <- ty1$Sum[2]\n");
		rcmArray.push("SSb   <- ty3$Sum[3]\n");
		rcmArray.push("SSaxb <- ty3$Sum[4]\n");
		rcmArray.push("SSsxb <- ty1$Sum[5]\n");
		rcmArray.push("\n");
		rcmArray.push("DFa   <- ty3$Df[2]\n");
		rcmArray.push("DFs   <- ty1$Df[2]\n");
		rcmArray.push("DFb   <- ty3$Df[3]\n");
		rcmArray.push("DFaxb <- ty3$Df[4]\n");
		rcmArray.push("DFsxb <- ty1$Df[5]\n");
		rcmArray.push("\n");
		rcmArray.push("MSa   <- SSa  /DFa\n");
		rcmArray.push("MSs   <- SSs  /DFs\n");
		rcmArray.push("MSb   <- SSb  /DFb\n");
		rcmArray.push("MSaxb <- SSaxb/DFaxb\n");
		rcmArray.push("MSsxb <- SSsxb/DFsxb\n");
		rcmArray.push("\n");
		rcmArray.push("Fa   <- MSa  /MSs\n");
		rcmArray.push("Fb   <- MSb  /MSsxb\n");
		rcmArray.push("Faxb <- MSaxb/MSsxb\n");
		rcmArray.push("Pa   <- pf(Fa,df1=DFa,df2=DFs,low=0)\n");
		rcmArray.push("Pb   <- pf(Fb,df1=DFb,df2=DFsxb,low=0)\n");
		rcmArray.push("Paxb <- pf(Faxb,df1=DFaxb,df2=DFsxb,low=0)\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 <- c()\n");
		rcmArray.push("tx1 <- matrix(round( c(\n");
		rcmArray.push("  SSa,   DFa,   MSa,   Fa,   Pa,\n");
		rcmArray.push("  SSs,   DFs,   MSs,   NA,   NA,\n");
		rcmArray.push("  SSb,   DFb,   MSb,   Fb,   Pb,\n");
		rcmArray.push("  SSaxb, DFaxb, MSaxb, Faxb, Paxb,\n");
		rcmArray.push("  SSsxb, DFsxb, MSsxb, NA,   NA\n");
		rcmArray.push("  ), 4), nr=5, by=1)\n");
		rcmArray.push("colnames(tx1) <- c(\n");
		rcmArray.push("  \"TypeIII_SS\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"       MS\",\n");
		rcmArray.push("  \"      Ｆ\",\n");
		rcmArray.push("  \"     ｐ\" )\n");
		rcmArray.push("rownames(tx1) <- c(\n");
		rcmArray.push("  \"要因Ａ\",\n");
		rcmArray.push("  \" ｓ \",\n");
		rcmArray.push("  \"要因Ｂ\",\n");
		rcmArray.push("  \"Ａ×Ｂ\",\n");
		rcmArray.push("  \"ｓ×Ｂ\" )\n");

		rcmArray.push("\n");
		rcmArray.push("# 分散の均一性検定\n");
		rcmArray.push("kxf <- c()\n");
		rcmArray.push("kxp <- c()\n");
		rcmArray.push("for(j in 1:levB){\n");
		rcmArray.push("  kx <- leveneTest( # レーベン検定\n");
		rcmArray.push("    data[as.numeric(B)==j]~A[as.numeric(B)==j],\n");
		rcmArray.push("    data=AsB )\n");
		rcmArray.push("  kxf <- c(kxf, kx$F[1])\n");
		rcmArray.push("  kxp <- c(kxp, kx$P[1])\n");
		rcmArray.push("  }\n");
		rcmArray.push("N   <- sum(n)/levB\n");
		rcmArray.push("tx6 <- c()\n");
		rcmArray.push("tx6 <- matrix(round(c(\n");
		rcmArray.push("  kxf,\n");
		rcmArray.push("  rep(DFa, levB),\n");
		rcmArray.push("  rep(N-levA, levB),\n");
		rcmArray.push("  kxp\n");
		rcmArray.push("  ), 4), nc=4 )\n");
		rcmArray.push("colnames(tx6) <- c(\n");
		rcmArray.push("  \"      Ｆ\",\n");
		rcmArray.push("  \" df1\",\n");
		rcmArray.push("  \"  df2\",\n");
		rcmArray.push("  \"      ｐ\" )\n");
		rcmArray.push("rownames(tx6) <- paste(\n");
		rcmArray.push("  \"A at_B\", 1:levB,\n");
		rcmArray.push("  sep=\"\")\n");
		rcmArray.push("\n");
		rcmArray.push("kxk <- c()\n");
		rcmArray.push("kxp <- c()\n");
		rcmArray.push("for(j in 1:levB){\n");
		rcmArray.push("  kx <- bartlett.test( # バートレット検定\n");
		rcmArray.push("    data[as.numeric(B)==j]~A[as.numeric(B)==j],\n");
		rcmArray.push("    data=AsB )\n");
		rcmArray.push("  kxk <- c(kxk, kx$stat)\n");
		rcmArray.push("  kxp <- c(kxp, kx$p.va)\n");
		rcmArray.push("  }\n");
		rcmArray.push("tx7 <- c()\n");
		rcmArray.push("tx7 <- matrix(round(c(\n");
		rcmArray.push("  kxk,\n");
		rcmArray.push("  rep(DFa, levB),\n");
		rcmArray.push("  kxp\n");
		rcmArray.push("  ), 4), nc=3 )\n");
		rcmArray.push("colnames(tx7) <- c(\n");
		rcmArray.push("  \"      χ2\",\n");
		rcmArray.push("  \"  df\",\n");
		rcmArray.push("  \"      ｐ\" )\n");
		rcmArray.push("rownames(tx7) <- paste(\n");
		rcmArray.push("  \"A at_B\", 1:levB,\n");
		rcmArray.push("  sep=\"\")\n");

		rcmArray.push("\n");
		rcmArray.push("# 球面性検定\n");
		rcmArray.push("vsum <- c() # 平均相関corr\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("  dmat <- matrix(\n");
		rcmArray.push("    AsB$data[as.numeric(AsB$A)==i],\n");
		rcmArray.push("    nc=levB, by=1)\n");
		rcmArray.push("  fugo <- sign(cor(dmat))\n");
		rcmArray.push("  vsum <- c(vsum,\n");
		rcmArray.push("    sum(cor(dmat)^2*fugo)-levB\n");
		rcmArray.push("    )\n");
		rcmArray.push("  }\n");
		rcmArray.push("vsum <- vsum/(levB^2-levB)\n");
		rcmArray.push("corr <- sqrt(abs(mean(vsum)))*sign(mean(vsum))\n");
		rcmArray.push("corr <- abs(sum(cor(dmat))-levB)/(levB^2-levB) # 単純平均\n");
		rcmArray.push("\n");
		rcmArray.push("As <- c()  # Ａ水準コード\n");
		rcmArray.push("for(i in 1:levA){\n");
		rcmArray.push("  As <- c(As,\n");
		rcmArray.push("   rep(i, n[(i-1)*levB+1])\n");
		rcmArray.push("     )\n");
		rcmArray.push("  }\n");
		rcmArray.push("As     <- matrix(As, nc=1)\n");
		rcmArray.push("As[,1] <- factor(As[,1])\n");
		rcmArray.push("dmat <- matrix(\n");
		rcmArray.push("    AsB$data,\n");
		rcmArray.push("    nc=levB, by=1)\n");
		rcmArray.push("kx8  <- mauchly.test(\n");
		rcmArray.push("  lm(dmat~As), X=~1 )\n");
		rcmArray.push("\n");
		rcmArray.push("tx8 <- c()\n");
		rcmArray.push("tx8 <- matrix(round(c(\n");
		rcmArray.push("  kx8$stat,\n");
		rcmArray.push("  kx8$p.val,\n");
		rcmArray.push("  corr\n");
		rcmArray.push("  ), 3), nr=1 )\n");
		rcmArray.push("rownames(tx8) <- c(\"要因Ｂ\")\n");
		rcmArray.push("colnames(tx8) <- c(\n");
		rcmArray.push("  \"Mauchly's W\",\n");
		rcmArray.push("  \"    ｐ値\",\n");
		rcmArray.push("  \" 水準間相関\" )\n");
		rcmArray.push("\n");
		rcmArray.push("kx9 <- c()\n");
		rcmArray.push("kx9 <- anova( # 修正Ｆ検定\n");
		rcmArray.push("  lm(dmat~As), X=~1,\n");
		rcmArray.push("  test=\"Spherical\")\n");
		rcmArray.push("rownames(kx9) <- c(\"b\",\"sxa\",\"red\")\n");
		rcmArray.push("\n");
		rcmArray.push("tx9 <- c()\n");
		rcmArray.push("tx9 <- matrix(round(c(\n");
		rcmArray.push("  kx9$F[1:2],\n");
		rcmArray.push("  kx9$Pr[1:2],\n");
		rcmArray.push("  kx9$G[1:2],\n");
		rcmArray.push("  kx9$H[1:2]\n");
		rcmArray.push("  ), 4), nr=2)\n");
		rcmArray.push("colnames(tx9) <- c(\n");
		rcmArray.push("  \"   Ｆ値\",\n");
		rcmArray.push("  \"   ｐ値\",\n");
		rcmArray.push("  \"  G-G_ｐ\",\n");
		rcmArray.push("  \"  H-F_ｐ\" )\n");
		rcmArray.push("rownames(tx9) <- c(\n");
		rcmArray.push("  \"要因Ｂ\",\n");
		rcmArray.push("  \"Ａ×Ｂ\" )\n");

		rcmArray.push("\n");
		rcmArray.push("# パワー\n");
		rcmArray.push("ESa   <- sqrt(SSa/SSs) # ES.f\n");
		rcmArray.push("ESb   <- sqrt(SSb/SSsxb)\n");
		rcmArray.push("ESaxb <- sqrt(SSaxb/SSsxb)\n");
		rcmArray.push("\n");
		rcmArray.push("# yoinA\n");
		rcmArray.push("corr1=corr; corr2=1-corr\n");
		rcmArray.push("NCP <- ESa^2*N*levB*( 1/((levB*corr1)+corr2) )\n");
		rcmArray.push("crF <- qf(0.05,df1=DFa,df2=DFs,low=0)\n");
		rcmArray.push("PWa <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFa, df2=DFs, ncp=NCP)\n");
		rcmArray.push("\n");
		rcmArray.push("ncp0 <- ESa^2*N*levB # corr=0\n");
		rcmArray.push("PWa0 <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFa, df2=DFs, ncp=ncp0)\n");
		rcmArray.push("\n");
		rcmArray.push("ncpSPSS <- ESa^2*DFs\n");
		rcmArray.push("powA    <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFa,df2=DFs,ncp=ncpSPSS)\n");
		rcmArray.push("\n");
		rcmArray.push("crF <- qf(0.20,df1=DFa,df2=DFs,ncp=NCP)\n");
		rcmArray.push("ALa <- pf(crF, df1=DFa,df2=DFs,low=0)\n");
		rcmArray.push("\n");
		rcmArray.push("DFv <- NA\n");
		rcmArray.push("kos <- 0   # 出力個数\n");
		rcmArray.push("if (PWa<0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2 <- DFs+(i*0.01)\n");
		rcmArray.push("      DF2 <- min(DF2, 1000)\n");
		rcmArray.push("ncp <- ESa^2*(DF2+levA)*levB*( 1/((levB*corr1)+corr2) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFa,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFa,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta<0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("if (PWa>0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2  <- DFs-(i*0.01)\n");
		rcmArray.push("      DF2  <- max(DF2, 2)\n");
		rcmArray.push("ncp <- ESa^2*(DF2+levA)*levB*( 1/((levB*corr1)+corr2) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFa,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFa,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta>0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("NNa <- ceiling(DFv[1]+levA)\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# yoinB\n");
		rcmArray.push("NCP <- ESb^2*N*levB*( 1/(1-corr) )\n");
		rcmArray.push("crF <- qf(0.05,df1=DFb,df2=DFsxb,low=0)\n");
		rcmArray.push("PWb <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFb, df2=DFsxb, ncp=NCP)\n");
		rcmArray.push("\n");
		rcmArray.push("ncp0 <- ESb^2*N*levB # corr=0\n");
		rcmArray.push("PWb0 <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFb, df2=DFsxb, ncp=ncp0)\n");
		rcmArray.push("\n");
		rcmArray.push("ncpSPSS <- ESb^2*DFsxb\n");
		rcmArray.push("powB    <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFb,df2=DFsxb,ncp=ncpSPSS)\n");
		rcmArray.push("\n");
		rcmArray.push("crF <- qf(0.20,df1=DFb,df2=DFsxb,ncp=NCP)\n");
		rcmArray.push("ALb <- pf(crF, df1=DFb,df2=DFsxb,low=0)\n");
		rcmArray.push("\n");
		rcmArray.push("DFv <- NA\n");
		rcmArray.push("kos <- 0\n");
		rcmArray.push("if (PWb<0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2 <- DFsxb+(i*0.01)\n");
		rcmArray.push("      DF2 <- min(DF2, 1000)\n");
		rcmArray.push("ncp <- ESb^2*(DF2/DFb+levA)*levB*( 1/(1-corr) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFb,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFb,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta<0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("if (PWb>0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2  <- DFsxb-(i*0.01)\n");
		rcmArray.push("      DF2  <- max(DF2, 2)\n");
		rcmArray.push("ncp <- ESb^2*(DF2/DFb+levA)*levB*( 1/(1-corr) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFb,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFb,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta>0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("NNb <- ceiling(DFv[1]/DFb)+levA\n");
		rcmArray.push("\n");
		rcmArray.push("\n");
		rcmArray.push("# AxB\n");
		rcmArray.push("NCP <- ESaxb^2*N*levB*( 1/(1-corr) )\n");
		rcmArray.push("crF   <- qf(0.05,df1=DFaxb,df2=DFsxb,low=0)\n");
		rcmArray.push("PWaxb <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFaxb,df2=DFsxb,ncp=NCP)\n");
		rcmArray.push("\n");
		rcmArray.push("ncp0   <- ESaxb^2*N*levB # corr=0\n");
		rcmArray.push("PWaxb0 <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFaxb, df2=DFsxb, ncp=ncp0)\n");
		rcmArray.push("\n");
		rcmArray.push("ncpSPSS <- ESaxb^2*DFsxb\n");
		rcmArray.push("powAxB  <- 1-pf(crF,\n");
		rcmArray.push("  df1=DFaxb,df2=DFsxb,ncp=ncpSPSS)\n");
		rcmArray.push("\n");
		rcmArray.push("crF   <- qf(0.20,df1=DFaxb,df2=DFsxb,ncp=NCP)\n");
		rcmArray.push("ALaxb <- pf(crF, df1=DFaxb,df2=DFsxb,low=0)\n");
		rcmArray.push("\n");
		rcmArray.push("DFv <- NA\n");
		rcmArray.push("kos <- 0\n");
		rcmArray.push("if (PWaxb<0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2 <- DFsxb+(i*0.01)\n");
		rcmArray.push("      DF2 <- min(DF2, 1000)\n");
		rcmArray.push("ncp <- ESaxb^2*(DF2/DFb+levA)*levB*( 1/(1-corr) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFaxb,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFaxb,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta<0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("if (PWaxb>0.80)\n");
		rcmArray.push("  for(i in 1:100000){\n");
		rcmArray.push("    if (kos>1) i=99999\n");
		rcmArray.push("    else {\n");
		rcmArray.push("      DF2  <- DFsxb-(i*0.01)\n");
		rcmArray.push("      DF2  <- max(DF2, 2)\n");
		rcmArray.push("ncp <- ESaxb^2*(DF2/DFb+levA)*levB*( 1/(1-corr) )\n");
		rcmArray.push("      crF  <- qf(0.95,df1=DFaxb,df2=DF2)\n");
		rcmArray.push("      beta <- pf(crF, df1=DFaxb,df2=DF2,ncp=ncp)\n");
		rcmArray.push("\n");
		rcmArray.push("      if (beta>0.20) kos=kos+1\n");
		rcmArray.push("      if (kos==1)    DFv <- c(DF2, DFv) }\n");
		rcmArray.push("  }\n");
		rcmArray.push("NNaxb <- ceiling(DFv[1]/DFb)+levA\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 <- c()\n");
		rcmArray.push("tx2 <- matrix(round( c(\n");
		rcmArray.push("  ESa^2/(ESa^2+1),    ESa,  PWa,  PWa0,  powA,\n");
		rcmArray.push("  ESb^2/(ESb^2+1),    ESb,  PWb,  PWb0,  powB,\n");
		rcmArray.push("  ESaxb^2/(ESaxb^2+1),ESaxb,PWaxb,PWaxb0,powAxB\n");
		rcmArray.push("  ), 4), nr=3, by=1 )\n");
		rcmArray.push("rownames(tx2) <- c(\n");
		rcmArray.push("  \"要因Ａ\",\n");
		rcmArray.push("  \"要因Ｂ\",\n");
		rcmArray.push("  \"Ａ×Ｂ\" )\n");
		rcmArray.push("colnames(tx2) <- c(\n");
		rcmArray.push("  \"  偏η2\",\n");
		rcmArray.push("  \" 効果量ｆ\",\n");
		rcmArray.push("  \" 検出力1\",\n");
		rcmArray.push("  \" 検出力0\",\n");
		rcmArray.push("  \" 検出力2\"  )\n");
		rcmArray.push("\n");
		rcmArray.push("tx4 <- c()\n");
		rcmArray.push("tx4 <- matrix(round(c(\n");
		rcmArray.push("  ESa,  ALa,  0.80,DFa,  DFs,\n");
		rcmArray.push("  ESb,  ALb,  0.80,DFb,  DFsxb,\n");
		rcmArray.push("  ESaxb,ALaxb,0.80,DFaxb,DFsxb\n");
		rcmArray.push("  ), 4), nr=3, by=1 )\n");
		rcmArray.push("rownames(tx4) <- c(\n");
		rcmArray.push("  \"要因Ａ\",\"要因Ｂ\",\"Ａ×Ｂ\")\n");
		rcmArray.push("colnames(tx4) <- c(\n");
		rcmArray.push("  \"効果量ｆ\",\n");
		rcmArray.push("  \"      α\",\n");
		rcmArray.push("  \"  1-β\",\n");
		rcmArray.push("  \"  df1\",\n");
		rcmArray.push("  \"  df2\" )\n");
		rcmArray.push("\n");
		rcmArray.push("tx5 <- c()\n");
		rcmArray.push("tx5 <- matrix(round(c(\n");
		rcmArray.push("  ESa,  NNa,  N,\n");
		rcmArray.push("  ESb,  NNb,  N,\n");
		rcmArray.push("  ESaxb,NNaxb,N\n");
		rcmArray.push("  ), 4), nr=3, by=1 )\n");
		rcmArray.push("rownames(tx5) <- c(\n");
		rcmArray.push("  \"要因Ａ\",\"要因Ｂ\",\"Ａ×Ｂ\")\n");
		rcmArray.push("colnames(tx5) <- c(\n");
		rcmArray.push("  \"効果量ｆ\",\n");
		rcmArray.push("  \" 次回総数\",\n");
		rcmArray.push("  \" 今回のＮ\" )\n");

		if (FI$ != "ns") {
			rcmArray.push("\n");
			rcmArray.push("## 交互作用が有意のとき\n");
			rcmArray.push("## 単純主効果検定（多重検定）\n");
			rcmArray.push("Nhar <- levA*levB/sum(1/n)\n");
			rcmArray.push("SSsimp <- c()\n");
			rcmArray.push("SSerr  <- c()\n");
			rcmArray.push("for(j in 1:levB){\n");
			rcmArray.push("  kx <- anova(lm(\n");
			rcmArray.push("    data~A,\n");
			rcmArray.push("    data=subset(AsB,\n");
			rcmArray.push("      as.numeric(AsB$B)==j)\n");
			rcmArray.push("    ))\n");
			rcmArray.push("  SSsimp <- c(SSsimp,\n");
			rcmArray.push("    kx$Sum[1] )\n");
			rcmArray.push("  SSerr  <- c(SSerr,\n");
			rcmArray.push("    kx$Sum[2] )\n");
			rcmArray.push("  }\n");
			rcmArray.push("\n");
			rcmArray.push("for(i in 1:levA){\n");
			rcmArray.push("  heik <- c()\n");
			rcmArray.push("    for(j in 1:levB){\n");
			rcmArray.push("      heik <- c(heik,\n");
			rcmArray.push("        hk[j+levB*(i-1)] )\n");
			rcmArray.push("      }\n");
			rcmArray.push("  SSsimp <- c(SSsimp,sum(\n");
			rcmArray.push("    (heik-mean(heik))^2*Nhar\n");
			rcmArray.push("     ) )\n");
			rcmArray.push("  }\n");
			rcmArray.push("SSerr <- c(SSerr,\n");
			rcmArray.push("  rep(SSsxb, levA) )\n");
			rcmArray.push("\n");
			rcmArray.push("DF1 <- c(rep(DFa,levB), rep(DFb,  levA))\n");
			rcmArray.push("DF2 <- c(rep(DFs,levB), rep(DFsxb,levA))\n");
			rcmArray.push("Fsimp <- SSsimp/DF1/ (SSerr/DF2)\n");
			rcmArray.push("Psimp <- pf(Fsimp,df1=DF1,df2=DF2,low=0)\n");
			rcmArray.push("Psadj <- p.adjust(Psimp, me=\"BH\")\n");
			rcmArray.push("\n");
			rcmArray.push("suji <- round(c(\n");
			rcmArray.push("  SSsimp, DF1, DF2,Fsimp,\n");
			rcmArray.push("  Psimp, Psadj\n");
			rcmArray.push("  ), 4)\n");
			rcmArray.push("hyoj <- c()\n");
			rcmArray.push("for(L in 1:6){  # ６列表示\n");
			rcmArray.push("for(i in 1:(levB+levA)){\n");
			rcmArray.push("  if (i==levB+1) hyoj <- c(hyoj, NA)\n");
			rcmArray.push("  hyoj <- c(hyoj,\n");
			rcmArray.push("    suji[(L-1)*(levB+levA)+i] )\n");
			rcmArray.push("  } }\n");
			rcmArray.push("tx3 <- c()\n");
			rcmArray.push("tx3 <- matrix(hyoj,\n");
			rcmArray.push("              nr=levB+levA+1)\n");
			rcmArray.push("colnames(tx3) <- c(\n");
			rcmArray.push("  \"SS\",\n");
			rcmArray.push("  \" df1\",\n");
			rcmArray.push("  \" df2\",\n");
			rcmArray.push("  \"   Ｆ値\",\n");
			rcmArray.push("  \"   ｐ値\",\n");
			rcmArray.push("  \" 調整後\" )\n");
			rcmArray.push("tmp <- c()\n");
			rcmArray.push("for(j in 1:levB){\n");
			rcmArray.push("  tmp <- c(tmp,\n");
			rcmArray.push("    paste(\"A at_B\",\n");
			rcmArray.push("          j, sep=\"\") )\n");
			rcmArray.push("  }\n");
			rcmArray.push("tmp <- c(tmp, \"\")\n");
			rcmArray.push("for(i in 1:levA){\n");
			rcmArray.push("  tmp <- c(tmp,\n");
			rcmArray.push("    paste(\"B at_A\",\n");
			rcmArray.push("          i, sep=\"\") )\n");
			rcmArray.push("  }\n");
			rcmArray.push("rownames(tx3) <- tmp\n");

			if (LA != 2) {
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {
						rcmArray.push("\n");
						rcmArray.push("## A at B" + (j + 1) + " の多重比較\n");
						rcmArray.push("AatB" + (j + 1) + " <- round(pairwise.t.test(\n");
						rcmArray.push("  subset(AsB,as.numeric(AsB$B)==" + (j + 1) + ")$data,\n");
						rcmArray.push("  subset(AsB,as.numeric(AsB$B)==" + (j + 1) + ")$A,\n");
						rcmArray.push("    p.ad=\"BH\")$p.va, 4)\n");
						rcmArray.push("dimnames(AatB" + (j + 1) + ") <- list( \n");
						rcmArray.push("  paste(\"A\",      2:levA,   sep=\"\"),\n");
						rcmArray.push("  paste(\"   A\", 2:levA-1, sep=\"\") )\n");
					}
				}
			}
			if (LB != 2) {
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						rcmArray.push("\n");
						rcmArray.push("## B at A" + (i + 1) + " の多重比較（pair=1 を指定）\n");
						rcmArray.push("BatA" + (i + 1) + " <- round(pairwise.t.test(\n");
						rcmArray.push("  subset(AsB,as.numeric(AsB$A)==" + (i + 1) + ")$data,\n");
						rcmArray.push("  subset(AsB,as.numeric(AsB$A)==" + (i + 1) + ")$B,\n");
						rcmArray.push("    pair=1,\n");
						rcmArray.push("    p.ad=\"BH\")$p.va, 4)\n");
						rcmArray.push("dimnames(BatA" + (i + 1) + ") <- list( \n");
						rcmArray.push("  paste(\"B\",      2:levB,   sep=\"\"),\n");
						rcmArray.push("  paste(\"   B\", 2:levB-1, sep=\"\") )\n");
					}
				}
			}
		} else {
			if (LA != 2) {
				if (FA$ != "ns") {
					rcmArray.push("\n");
					rcmArray.push("## 交互作用が有意でないとき主効果の多重比較\n");
					rcmArray.push("## （要因Ａ）\n");
					rcmArray.push("tmp <- c()\n");
					rcmArray.push("for(i in 1:levA){\n");
					rcmArray.push("  tmp <- c(tmp,\n");
					rcmArray.push("    round(mean(\n");
					rcmArray.push("    subset(AsB,as.numeric(AsB$A)==i)$data\n");
					rcmArray.push("    ), 4)\n");
					rcmArray.push("  ) }\n");
					rcmArray.push("mainA <- matrix(tmp,nr=1)\n");
					rcmArray.push("rownames(mainA) <- \"Mean\"\n");
					rcmArray.push("colnames(mainA) <- paste(\n");
					rcmArray.push("  \"   A\", 1:levA, sep=\"\")\n");
					rcmArray.push("\n");
					rcmArray.push("testA <- round(\n");
					rcmArray.push("  pairwise.t.test(\n");
					rcmArray.push("    AsB$data, AsB$A,\n");
					rcmArray.push("    p.ad=\"BH\")$p.va,\n");
					rcmArray.push("    4)\n");
					rcmArray.push("dimnames(testA) <- list(\n");
					rcmArray.push("  paste(\"A\",      2:levA,   sep=\"\"),\n");
					rcmArray.push("  paste(\"   A\", 2:levA-1, sep=\"\") )\n");
				}
			}
			if (LB != 2) {
				if (FB$ != "ns") {
					rcmArray.push("\n");
					rcmArray.push("## 交互作用が有意でないとき主効果の多重比較（pair=1 を指定）\n");
					rcmArray.push("## （要因Ｂ）\n");
					rcmArray.push("tmp <- c()\n");
					rcmArray.push("for(j in 1:levB){\n");
					rcmArray.push("  tmp <- c(tmp,\n");
					rcmArray.push("    round(mean(\n");
					rcmArray.push("    subset(AsB,as.numeric(AsB$B)==j)$data\n");
					rcmArray.push("    ), 4)\n");
					rcmArray.push("  ) }\n");
					rcmArray.push("mainB <- matrix(tmp,nr=1)\n");
					rcmArray.push("rownames(mainB) <- \"Mean\"\n");
					rcmArray.push("colnames(mainB) <- paste(\n");
					rcmArray.push("  \"   B\", 1:levB, sep=\"\")\n");
					rcmArray.push("\n");
					rcmArray.push("testB <- round(\n");
					rcmArray.push("  pairwise.t.test(\n");
					rcmArray.push("    AsB$data, AsB$B,\n");
					rcmArray.push("    pair=1, p.ad=\"BH\")$p.va,\n");
					rcmArray.push("    4)\n");
					rcmArray.push("dimnames(testB) <- list(\n");
					rcmArray.push("  paste(\"B\",      2:levB,   sep=\"\"),\n");
					rcmArray.push("  paste(\"   B\", 2:levB-1, sep=\"\") )\n");
				}
			}
		}

		rcmArray.push("\n");
		rcmArray.push("options(digits=5)\n");
		rcmArray.push("options(scipen=5)\n");
		rcmArray.push("############################\n");
		rcmArray.push("#  分散分析 ＡsＢ-design： #\n");
		rcmArray.push("#    ２要因 混合計画     #\n");
		rcmArray.push("############################\n");
		rcmArray.push("tx0 # 基本統計量（SD=不偏分散の平方根）\n");
		rcmArray.push("\n");
		rcmArray.push("tx1 # 分散分析ＡｓＢ\n");
		rcmArray.push("\n");
		rcmArray.push("tx2 # 効果量と検出力(1-β)\n");
		rcmArray.push("# 効果量ｆ= sqrt( 偏η2/(1-偏η2) )\n");
		rcmArray.push("# 検出力1 は非心度推定= f^2*DataSize, r=r\n");
		rcmArray.push("# 検出力0 は非心度推定= f^2*DataSize, r=0\n");
		rcmArray.push("# 検出力2 は非心度推定= f^2*DFerror\n");

		if (FI$ != "ns") {
			rcmArray.push("\n");
			rcmArray.push("tx3 # 交互作用Ａ×Ｂの単純主効果検定\n");
			rcmArray.push("# 単純主効果Ａの検定は水準別誤差項による\n");
			rcmArray.push("# 単純主効果Ｂの検定はプールドｓ×Ｂによる\n");
			rcmArray.push("# 調整後ｐ値の検定は有意水準α=0.15 推奨\n");
			rcmArray.push("# ｐ値の調整は Benjamini & Hochberg(1995) による\n");
			rcmArray.push("# Part.η2(偏イータ２乗)= Ｆ*df1/(Ｆ*df1+df2)\n");

			if (LA > 2) {
				for (j = 0; j < LB; j++) {
					if (FFA$[j] != "ns") {
						rcmArray.push("\n");
						rcmArray.push("AatB" + (j + 1) + " # A at B" + (j + 1) + " の多重比較\n");
						rcmArray.push("    # 数値は参加者間ｔ検定の調整後ｐ値(両側確率)\n");
						rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995)\n");
					}
				}
			}
			if (LB > 2) {
				for (i = 0; i < LA; i++) {
					if (FFB$[i] != "ns") {
						rcmArray.push("\n");
						rcmArray.push("BatA" + (i + 1) + " # B at A" + (i + 1) + " の多重比較\n");
						rcmArray.push("    # 数値は参加者内ｔ検定の調整後ｐ値(両側確率)\n");
						rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995)\n");
					}
				}
			}
		} else {
			if (LA > 2) {
				if (FA$ != "ns") {
					rcmArray.push("\n");
					rcmArray.push("mainA # 主効果Ａの多重比較\n");
					rcmArray.push("testA\n");
					rcmArray.push("    # 数値は参加者間ｔ検定の調整後ｐ値(両側確率)\n");
					rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995)\n");
				}
			}
			if (LB > 2) {
				if (FB$ != "ns") {
					rcmArray.push("\n");
					rcmArray.push("mainB # 主効果Ｂの多重比較\n");
					rcmArray.push("testB\n");
					rcmArray.push("    # 数値は参加者内ｔ検定の調整後ｐ値(両側確率)\n");
					rcmArray.push("    # ｐ値の調整は Benjamini & Hochberg(1995)\n");
				}
			}
		}

		rcmArray.push("\n");
		rcmArray.push("tx5 # パワーアナリシス：Ｎの計算\n");
		rcmArray.push("# α=0.05, (1-β)=0.80 に設定\n");
		rcmArray.push("# ■ NA が表示されたら計算不能\n");

		rcmArray.push("\n");
		rcmArray.push("tx8 # 球面性検定（要因Ｂ=２水準なら不要）\n");
		rcmArray.push("    # p<αなら球面性不成立！\n");
		rcmArray.push("tx9 # 球面性不成立時の修正Ｆ検定(ｎ=同数に限る)\n");
		rcmArray.push("    # G-G_p は Greenhouse-Geisser の調整後ｐ値\n");
		rcmArray.push("    # H-F_p は Huynh-Feldt の調整後ｐ値\n");
		rcmArray.push("\n");
		rcmArray.push("tx7 # 分散の均一性検定（バートレット検定）\n");
		rcmArray.push("\n");
		rcmArray.push("# ○オプション：［↑］⇒行頭の♯を消す⇒［Enter］\n");
		rcmArray.push("# windows();boxplot(data~A*B,d=AsB,las=1) # 箱ひげ図\n");
		rcmArray.push("# tx4     # パワーアナリシス：αの計算\n");
		rcmArray.push("# tx6     # Levene Test(center=median)\n");
		rcmArray.push("# kx9[0,] # 調整係数ε(epsilon)\n");
		rcmArray.push("# sqrt(Fsimp*DF1/DF2)       # 単純主効果の効果量ｆ\n");
		rcmArray.push("# Fsimp*DF1/(Fsimp*DF1+DF2) # 単純主効果の偏η2\n");
		rcmArray.push("# print(ty2,d=8) # TypeII_SSの分散分析\n");

		rcmArray.push("\n");
		rcmArray.push("# _/_/_/ Powered by js-STAR _/_/_/");
		rcmArray.push("\n");

		document.getElementById("RcmArea").value = rcmArray.join("");
		rcmArray = null;
	}());	//Ｒプログラムここまで

	//グラフ描画
	(function () {
		chartClear();

		var i, j;
		var g;

		var chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg0";
		var ctx = document.getElementById("chart").appendChild(chartImg);

		var graphType = document.getElementById("graphSelect").value;
		var legendName = document.getElementById("legendSelect").value;

		var data;
		var datasetKey = [];
		if (legendName === 'A') {
			data = new Array(LA);
			for (i = 0; i < LA; i++) {
				data[i] = new Array(LB);
			}
			for (i = 0; i < LA; i++) {
				for (j = 0; j < LB; j++) {
					data[i][j] = Math.round(M[i][j] * 10) / 10;
				}
			}

			for (i = 0; i < LA + 1; i++) {
				datasetKey[i] = [];
			}
		}
		if (legendName === 'B') {
			data = new Array(LB);
			for (j = 0; j < LB; j++) {
				data[j] = new Array(LA);
			}
			for (j = 0; j < LB; j++) {
				for (i = 0; i < LA; i++) {
					data[j][i] = Math.round(M[i][j] * 10) / 10;
				}
			}

			for (j = 0; j < LB + 1; j++) {
				datasetKey[j] = [];
			}
		}

		var max_y = M[0][0];
		var min_y = 0;
		for (i = 0; i < LA; i++) {
			for (j = 0; j < LB; j++) {
				if (max_y < M[i][j]) max_y = Math.round(M[i][j] * 10) / 10;
				if (min_y > M[i][j]) min_y = Math.round(M[i][j] * 10) / 10;
			}
		}
		var _myMax = gCheck.match(/max:\d+/);
		if (_myMax !== null) {
			var myMax = _myMax[0].match(/\d+/);
			max_y = parseFloat(myMax, 10);
		}
		var _myMin = gCheck.match(/min:\d+/);
		if (_myMin !== null) {
			var myMin = _myMin[0].match(/\d+/);
			min_y = parseFloat(myMin, 10);
		}

		//カラーユニバーサルデザイン推奨配色セット制作委員会
		//https://jfly.uni-koeln.de/colorset/CUD_color_set_GuideBook_2018_for_print_cs4.pdf
		var chartClrAry = ["#ff4b00", "#f6aa00", "#990099", "#005aff", "#4dc4ff", "#03af7a", "#fff100", "#ff8082", "#804000"];

		// 複合グラフを作成する
		datasetKey[0].label = ''; //ラベルを空白にする

		var start;
		var end;
		// 折れ線グラフ
		if (graphType === 'line') {
			if (legendName === 'A') {
				start = 1;
				end = LA + 1;
			}
			if (legendName === 'B') {
				start = 1;
				end = LB + 1;
			}
			for (g = start; g < end; g++) {
				datasetKey[g].label = legendName + g;
				datasetKey[g].data = data[g - 1];
				datasetKey[g].backgroundColor = chartClrAry[(g - 1) % chartClrAry.length];
				datasetKey[g].borderColor = chartClrAry[(g - 1) % chartClrAry.length];
				datasetKey[g].pointBorderWidth = 3;
				datasetKey[g].borderWidth = 1;
				datasetKey[g].lineTension = 0;
				datasetKey[g].type = graphType; //折れ線グラフを指定				// datasetKey[i].type = 'line'; //折れ線グラフを指定
			}
		}

		// 棒グラフ
		if (graphType === 'bar') {
			if (legendName === 'A') {
				start = 0;
				end = LA;
			}
			if (legendName === 'B') {
				start = 0;
				end = LB;
			}
			for (g = start; g < end; g++) {
				datasetKey[g].label = legendName + (g + 1);
				datasetKey[g].data = data[g];
				datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length];
				datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
				datasetKey[g].pointBorderWidth = 3;
				datasetKey[g].borderWidth = 1;
				datasetKey[g].lineTension = 0;
				datasetKey[g].type = graphType; //折れ線グラフを指定
			}
		}

		var labelData = [];
		if (legendName === 'A') {
			for (j = 0; j < LB; j++) {
				labelData.push('B' + (j + 1));
			}
		}
		if (legendName === 'B') {
			for (i = 0; i < LA; i++) {
				labelData.push('A' + (i + 1));
			}
		}

		var datasetData = [];
		for (g = 0; g < end; g++) {
			datasetData[g] = datasetKey[g];
		}

		var myChart = new Chart(ctx, {
			type: 'bar', //最初に棒グラフを指定
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				scales: {
					xAxes: [{
						maxBarThickness: 30,
						ticks: {
						}
					}],
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
					display: true,
					labels: { //空白ラベルだったら表示しない
						filter: function (items, chart) {
							return items.text != '';
						},
					}
				},
				title: {
					display: true,
					text: 'Mean'
				}
			}
		});

		//箱ひげ図
		var addData = [];
		var myData = [];
		var arrayCol = [];

		if (legendName === 'A') {
			for (i = 0; i < LA; i++) {
				myData[i] = [];
			}

			for (j = 0; j < LB; j++) {
				for (i = 0; i < LA; i++) {
					arrayCol = [];
					for (k = 0; k < NN[i]; k++) {
						arrayCol.push(xx[i][j][k]);
					}
					myData[i].push(arrayCol);
				}
			}
		}
		if (legendName === 'B') {
			for (j = 0; j < LB; j++) {
				myData[j] = [];
			}

			for (i = 0; i < LA; i++) {
				for (j = 0; j < LB; j++) {
					arrayCol = [];
					for (k = 0; k < NN[i]; k++) {
						arrayCol.push(xx[i][j][k]);
					}
					myData[j].push(arrayCol);
				}
			}
		}

		chartImg = document.createElement('canvas');
		chartImg.id = "ChartImg1";
		ctx = document.getElementById("chart").appendChild(chartImg);

		if (legendName === 'A') {
			start = 0;
			end = LA;
		} else {
			start = 0;
			end = LB;
		}

		datasetKey = [];
		for (g = 0; g < end; g++) {
			datasetKey[g] = [];
		}

		for (g = 0; g < end; g++) {
			datasetKey[g].label = legendName + (g + 1);
			datasetKey[g].data = myData[g];
			datasetKey[g].backgroundColor = chartClrAry[g % chartClrAry.length] + '33';
			datasetKey[g].borderColor = chartClrAry[g % chartClrAry.length];
			datasetKey[g].borderWidth = 1;
			datasetKey[g].outlierRadius = 3;
			datasetKey[g].itemRadius = 3;
			datasetKey[g].outlierColor = '#999999';
		}

		labelData = [];
		if (legendName === 'A') {
			for (j = 0; j < LB; j++) {
				labelData.push('B' + (j + 1));
			}
		}
		if (legendName === 'B') {
			for (i = 0; i < LA; i++) {
				labelData.push('A' + (i + 1));
			}
		}

		datasetData = [];
		for (g = 0; g < end; g++) {
			datasetData[g] = datasetKey[g];
		}

		var myChart2 = new Chart(ctx, {
			type: 'boxplot',
			data: {
				labels: labelData,
				datasets: datasetData
			},
			options: {
				responsive: true,
				scales: {
					yAxes: [{
						ticks: {
							suggestedMin: min_y,
							suggestedMax: max_y
						}
					}]
				},
				legend: {
					position: 'right',
				},
				title: {
					display: true,
					text: 'Boxplot'
				}
			}
		});
	}());	//グラフ描画ここまで

	document.getElementById("RltArea").focus();
}
/**
 * [changeAsbSetting id="asb_setting"の書き換え]
 *
 * 要因Aの名前 1行テキストボックスのid factorA_name
 * 要因Aの水準数1行テキストボックスのid factorA_number
 * 要因Bの名前 1行テキストボックスのid factorB_name
 * 要因Bの水準数1行テキストボックスのid factorB_number
 *
 */
function changeAsbSetting() {
	var htmArray = [];

	// freqdata2を使うか要検討 todo
	// htmArray.push("<div class=\"freqdata2\">");
	htmArray.push("<div class=\"tateyoko\">");

	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因A 名＿前：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorA_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"A\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorA_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因A 水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorA_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAsbSetting2();\">");
	} else {
		htmArray.push("<select id=\"factorA_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 水準数');changeAsbSetting2();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	htmArray.push("</div>");

	document.getElementById("asb_setting").innerHTML = htmArray.join("");
	htmArray = null;

	changeAsbSetting2();
}
function changeAsbSetting2() {
	var i = 0;
	var h = 3;
	var LA = parseInt(document.getElementById("factorA_number").value);

	var htmArray = [];

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<table border=\"0\" class=\"codetb2\">");
		for (i = 0; i < LA; i++) {
			htmArray.push("<tr>");
			htmArray.push("<td class=\"codetbL2\">要因A 水準" + (i + 1) + " 参加者数：</td>");
			htmArray.push("<td class=\"codetbR2\">");
			htmArray.push("<input type=\"number\" class=\"text9\" id=\"A" + (i + 1) + "_subjNum\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAsbTable();\">");
			htmArray.push("</td>");
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	} else {
		htmArray.push("<table border=\"0\" class=\"codetb2\">");
		for (i = 0; i < LA; i++) {
			htmArray.push("<tr>");
			htmArray.push("<td class=\"codetbL2\">要因A 水準" + (i + 1) + " 参加者数：</td>");
			htmArray.push("<td class=\"codetbR2\">");
			htmArray.push("<select id=\"A" + (i + 1) + "_subjNum\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因A 水準" + (i + 1) + " 参加者数');changeAsbTable();\">");
			htmArray.push("<option value=\"2\" selected>2</option>");
			for (h = 3; h < 31; h++) {
				htmArray.push("<option value=\"" + h + "\">" + h + "</option>");
			}
			htmArray.push("<option value=\"-1\">他</option>");
			htmArray.push("</select>");

			htmArray.push("</td>");
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");
	}

	htmArray.push("<table border=\"0\" class=\"codetb\">");
	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因B 名＿前：</td>");
	htmArray.push("<td class=\"codetbR\"><input type=\"text\" class=\"text6\" id=\"factorB_name\" size=\"20\" maxlength=\"20\" name=\"s1\" value=\"B\" onfocus=\"onBgColor(this);cellClearButton(this,'cellClrBtn1');\" onblur=\"offBgColor(this)\" onKeyUp=\"cellClearButton(this,'cellClrBtn1');\"><span id=\"cellClrBtn1\" class=\"cellClrBtnOn\" onclick=\"cellClr('factorB_name','cellClrBtn1');\" >×</span></td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	htmArray.push("<td class=\"codetbL\">要因B 水準数：</td>");
	htmArray.push("<td class=\"codetbR\">");

	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("<input type=\"number\" class=\"text9\" id=\"factorB_number\" size=\"10\" min=\"2\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\" oninput=\"changeAsbTable();\">");
	} else {
		htmArray.push("<select id=\"factorB_number\" name=\"i\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'要因B 水準数');changeAsbTable();\">");
		htmArray.push("<option value=\"2\" selected>2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"-1\">他</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</td>");
	htmArray.push("</tr>");
	htmArray.push("</table>");

	document.getElementById("asb_setting2").innerHTML = htmArray.join("");
	htmArray = null;

	changeAsbTable();
}
function changeAsbTable() {
	var i = 0;
	var j = 0;
	var k = 0;
	var LA = parseInt(document.getElementById("factorA_number").value);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}
	var LB = parseInt(document.getElementById("factorB_number").value);

	var htmArray = [];
	var cellId = 1;
	var sCount = 1;

	var cellCount = 0;
	for (i = 0; i < LA; i++) {
		cellCount += NN[i] * LB;
	}

	// htmArray.push("<div class=\"freqdata3\">");
	htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
	htmArray.push("<tr>");
	htmArray.push("<td ROWSPAN=\"2\" class=\"hyou_midashi_3d_title2\">");
	htmArray.push("要因A");
	htmArray.push("</td>");
	htmArray.push("<td ROWSPAN=\"2\" class=\"hyou_midashi_3d_title2\">");
	htmArray.push("参加者");
	htmArray.push("</td>");

	htmArray.push("<td COLSPAN=\"" + LB + "\" class=\"hyou_midashi_3d_title2\">");
	htmArray.push("要因B");
	htmArray.push("</td>");
	htmArray.push("</tr>");

	htmArray.push("<tr>");
	for (j = 0; j < LB; j++) {
		htmArray.push("<td class=\"hyou_midashi_3d_title2\">");
		htmArray.push("B" + (j + 1));
		htmArray.push("</td>");
	}
	htmArray.push("</tr>");

	for (i = 0; i < LA; i++) {
		htmArray.push("<tr>");
		htmArray.push("<td ROWSPAN=\"" + NN[i] + "\" class=\"hyou_midashi_3d_title\">");
		htmArray.push("A" + (i + 1));
		htmArray.push("</td>");

		for (k = 0; k < NN[i]; k++) {
			if (k === 0) {
				htmArray.push("<td class=\"hyou_midashi_3d_top\">");
			} else {
				htmArray.push("<td class=\"hyou_midashi_3d\">");
			}
			htmArray.push(sCount);
			htmArray.push("</td>");

			for (j = 0; j < LB; j++) {
				htmArray.push("<td class=\"hyou_nyuryoku\">");
				htmArray.push("<input type=\"number\" class=\"text\" id=\"cell_" + cellId + "\" size=\"3\" max=\"999\" name=\"\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\" onKeypress=\"checkNum();\">");
				htmArray.push("</td>");
				cellId++;
			}
			sCount++;
			htmArray.push("</tr>");
		}
	}
	htmArray.push("</table>");

	document.getElementById("asb_table").innerHTML = htmArray.join("");
	htmArray = null;
}
function saveData_AsB() {
	var i, j, k;

	var strArray = [];

	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}
	var BB = document.getElementById("factorB_name").value;
	var LB = parseInt(document.getElementById("factorB_number").value, 10);

	//#0
	strArray.push("AsB" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#3
	strArray.push("#" + "\n");
	for (i = 0; i < LA; i++) {
		if (i !== LA - 1) {
			strArray.push(NN[i] + ",");
		} else {
			strArray.push(NN[i]);
		}
	}
	//#4
	strArray.push("#" + "\n");
	strArray.push(BB + "\n");
	//#5
	strArray.push("#" + "\n");
	strArray.push(LB + "\n");
	//#6
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (k = 0; k < NN[i]; k++) {
			for (j = 0; j < LB; j++) {
				x = document.getElementById("cell_" + cellId).value;
				if (j !== LB - 1) {
					strArray.push(x + "\t");
				} else {
					strArray.push(x);
				}
				cellId++;
			}
			strArray.push("\n");
		}
	}

	var Stream = strArray.join("");
	var fineName = "AsB_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function saveData_AsB() {
	var i, j, k;

	var strArray = [];

	var AA = document.getElementById("factorA_name").value;
	var LA = parseInt(document.getElementById("factorA_number").value, 10);
	var NN = [];
	for (i = 0; i < LA; i++) {
		NN[i] = parseInt(document.getElementById("A" + (i + 1) + "_subjNum").value, 10);
	}
	var BB = document.getElementById("factorB_name").value;
	var LB = parseInt(document.getElementById("factorB_number").value, 10);

	//#0
	strArray.push("AsB" + "\n");
	//#1
	strArray.push("#" + "\n");
	strArray.push(AA + "\n");
	//#2
	strArray.push("#" + "\n");
	strArray.push(LA + "\n");
	//#3
	strArray.push("#" + "\n");
	for (i = 0; i < LA; i++) {
		if (i !== LA - 1) {
			strArray.push(NN[i] + ",");
		} else {
			strArray.push(NN[i]);
		}
	}
	strArray.push("\n");
	//#4
	strArray.push("#" + "\n");
	strArray.push(BB + "\n");
	//#5
	strArray.push("#" + "\n");
	strArray.push(LB + "\n");
	//#6
	strArray.push("#" + "\n");
	var x;
	var cellId = 1;
	for (i = 0; i < LA; i++) {
		for (k = 0; k < NN[i]; k++) {
			for (j = 0; j < LB; j++) {
				x = parseInt(document.getElementById("cell_" + cellId).value);
				if (j != LB - 1) {
					strArray.push(x + "\t");
				} else {
					strArray.push(x + "\n");
				}
				cellId++;
			}
		}
	}
	var Stream = strArray.join("");
	var fineName = "AsB_Data-" + getDate() + ".txt";

	SaveToFile(fineName, Stream);
}
function dataHeaderProcess_AsB() {
	var readText = document.getElementById("CandPArea").value;
	var dd = [];
	dd = readText.split("#");

	if (crDel(dd[0]) === "AsB") {
		var AA = crDel(dd[1]);
		var LA = crDel(dd[2]);

		var nn_text = crDel(dd[3]);
		var NN = [];
		NN = nn_text.split(",");

		var BB = crDel(dd[4]);
		var LB = crDel(dd[5]);

		document.getElementById("factorA_name").value = AA;
		document.getElementById("factorA_number").value = parseInt(LA, 10);
		changeAsbSetting2();
		for (i = 0; i < LA; i++) {
			document.getElementById("A" + (i + 1) + "_subjNum").value = parseInt(NN[i], 10);
		}
		document.getElementById("factorB_name").value = BB;
		document.getElementById("factorB_number").value = parseInt(LB, 10);

		changeAsbTable();
		document.getElementById("CandPArea").value = delTopCR(dd[6]);
	}
}
