
window.onload = function () {
    setTitle(1); //0:index.htm  1:それ以外
    setMenu(1);  //0:index.htm  1:それ以外
    setFooter();
};
//canvasサイズ
var cw = 550; //幅
var ch = 320; //高さ

var a = 28; //座標の幅
// 原点の位置
var ox = (cw - a * 10) / 2;
var oy = a * 10 + (ch - a * 10) / 2;

var PN = 3; //群（点）の数

var images = []; //点の画像配列
var _rnd = Math.floor(Math.random() * (10000));
for (i = 0; i < PN; i++) {
    images[i] = new Image();
    var str = '?var=' + _rnd;
    images[i].src = '../image/point_puma.png' + str;
}
var w = 14; //点の幅
var h = 14; //点の高さ

//点の値
var x = [];
var y = [];

//分散分析のための設定
var AA = 'A';
var LA = 3;

var NN = new Array(LA);
var NA = new Array(LA);

var M = new Array(LA);

var SD = new Array(LA);

function setData() {
    x = [ox + a * 2, ox + a * 5, ox + a * 8];
    y = [oy - a * 4, oy - a * 5, oy - a * 6];

    var wN = parseInt(document.getElementById('A1_N').value);
    NN[0] = wN;
    NN[1] = wN;
    NN[2] = wN;

    M[0] = parseInt((oy - y[0]) / a).toFixed(1);
    M[1] = parseInt((oy - y[1]) / a).toFixed(1);
    M[2] = parseInt((oy - y[2]) / a).toFixed(1);

    var wSD = parseFloat(document.getElementById('A1_SD').value);
    SD[0] = wSD;
    SD[1] = wSD;
    SD[2] = wSD;
}
function DrawAxis() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    ctx.clearRect(0, 0, canvas.width, canvas.height);

    ctx.lineWidth = 1;
    ctx.strokeStyle = 'rgb(128,128,128)';

    ctx.setLineDash([3, 3]);
    ctx.beginPath();
    ctx.moveTo(ox + a * 2, oy);
    ctx.lineTo(ox + a * 2, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 5, oy);
    ctx.lineTo(ox + a * 5, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 8, oy);
    ctx.lineTo(ox + a * 8, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox + a * 10, oy);
    ctx.lineTo(ox + a * 10, oy - a * 10);
    ctx.stroke();

    for (j = 1; j < 11; j++) {
        ctx.beginPath();
        ctx.moveTo(ox, oy - a * j);
        ctx.lineTo(ox + a * 10, oy - a * j);
        ctx.stroke();
    }

    ctx.strokeStyle = 'rgb(0,0,0)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox, oy - a * 10);
    ctx.stroke();
    ctx.beginPath();
    ctx.moveTo(ox, oy);
    ctx.lineTo(ox + a * 10, oy);
    ctx.stroke();

    ctx.font = "16px Arial";
    ctx.textAlign = "right";
    ctx.fillText("0", ox - 5, oy + 20);
    ctx.fillText("10", ox - 5, oy - a * 10);
    ctx.fillText("A1", ox + a * 2 + 10, oy + 20);
    ctx.fillText("A2", ox + a * 5 + 10, oy + 20);
    ctx.fillText("A3", ox + a * 8 + 10, oy + 20);
}
function DrawLine() {
    var i;
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');

    var wSD = parseFloat(document.getElementById('A1_SD').value);
    SD[0] = wSD;
    SD[1] = wSD;
    SD[2] = wSD;

    //線グラフを描画
    ctx.lineWidth = 3;
    ctx.strokeStyle = 'rgb(0,175,45)';
    ctx.setLineDash([]);
    ctx.beginPath();
    ctx.moveTo(x[0], y[0]);
    ctx.lineTo(x[1], y[1]);
    // if(document.getElementById('hsd').checked){
    if (document.getElementById('hsd').value == 3) {
        ctx.lineTo(x[2], y[2]);
    }
    ctx.stroke();

    //標準偏差を描画
    ctx.lineWidth = 2;
    var temp = 1; //アンテナの上下
    for (i = 0; i < 2; i++) {
        temp = temp - i * 2; //1 or -1
        ctx.beginPath();
        ctx.moveTo(x[0], y[0]);
        ctx.lineTo(x[0], y[0] + temp * SD[0] * a);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(x[0] - 10, y[0] + temp * SD[0] * a);
        ctx.lineTo(x[0] + 10, y[0] + temp * SD[0] * a);
        ctx.stroke();
    }

    temp = 1; //アンテナの上下
    for (i = 0; i < 2; i++) {
        temp = temp - i * 2; //1 or -1
        ctx.beginPath();
        ctx.moveTo(x[1], y[1]);
        ctx.lineTo(x[1], y[1] + temp * SD[1] * a);
        ctx.stroke();
        ctx.beginPath();
        ctx.moveTo(x[1] - 10, y[1] + temp * SD[1] * a);
        ctx.lineTo(x[1] + 10, y[1] + temp * SD[1] * a);
        ctx.stroke();
    }

    // if(document.getElementById('hsd').checked){
    if (document.getElementById('hsd').value == 3) {
        temp = 1; //アンテナの上下
        for (i = 0; i < 2; i++) {
            temp = temp - i * 2; //1 or -1
            ctx.beginPath();
            ctx.moveTo(x[2], y[2]);
            ctx.lineTo(x[2], y[2] + temp * SD[2] * a);
            ctx.stroke();
            ctx.beginPath();
            ctx.moveTo(x[2] - 10, y[2] + temp * SD[2] * a);
            ctx.lineTo(x[2] + 10, y[2] + temp * SD[2] * a);
            ctx.stroke();
        }
    }
}
function DrawPoint() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    for (var i in images) {
        // 画像を描画した時の情報を記憶
        images[i].drawOffsetX = x[i];
        images[i].drawOffsetY = y[i];
        images[i].drawWidth = w;
        images[i].drawHeight = h;

        // 画像を描画
        if (i < 2) {
            ctx.drawImage(images[i], x[i] - w / 2, y[i] - h / 2, w, h);
        }

        if (document.getElementById('hsd').value == 3) {
            ctx.drawImage(images[2], x[2] - w / 2, y[2] - h / 2, w, h);
        }

    }
}
function printData() {
    var wN = parseInt(document.getElementById('A1_N').value);
    document.getElementById('A2_N').innerHTML = wN;

    document.getElementById('A1_mean').innerHTML = parseFloat(M[0]).toFixed(1);
    document.getElementById('A2_mean').innerHTML = parseFloat(M[1]).toFixed(1);

    var wSD = parseFloat(document.getElementById('A1_SD').value);
    document.getElementById('A2_SD').innerHTML = wSD.toFixed(1);

    // if(document.getElementById('hsd').checked){
    if (document.getElementById('hsd').value == 3) {
        document.getElementById('A3_N').innerHTML = wN;
        document.getElementById('A3_mean').innerHTML = parseFloat(M[2]).toFixed(1);
        document.getElementById('A3_SD').innerHTML = wSD.toFixed(1);
    } else {
        document.getElementById('A3_N').innerHTML = '';
        document.getElementById('A3_mean').innerHTML = '';
        document.getElementById('A3_SD').innerHTML = '';
    }
}
function mainAs() {
    var canvas = document.getElementById('canvas');
    var ctx = canvas.getContext('2d');
    var dragTarget = null;
    var isDragging = false;

    setData();
    DrawAxis();
    DrawLine();

    images[PN - 1].addEventListener('load', function () {
        DrawPoint();
    }, false);


    printData();
    s_calc_as();

    // ドラッグ開始
    var mouseDown = function (e) {
        // ドラッグ開始位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;

        for (var i = images.length - 1; i >= 0; i--) {
            // 当たり判定（ドラッグした位置が画像の範囲内に収まっているか）
            if (posX >= images[i].drawOffsetX &&
                posX <= (images[i].drawOffsetX + images[i].drawWidth) &&
                posY >= images[i].drawOffsetY &&
                posY <= (images[i].drawOffsetY + images[i].drawHeight)
            ) {
                dragTarget = i;
                isDragging = true;
                break;
            }
        }
    };

    // ドラッグ終了
    var mouseUp = function (e) {
        isDragging = false;
    };

    // canvasの枠から外れた
    var mouseOut = function (e) {
        // canvas外にマウスカーソルが移動した場合に、ドラッグ終了としたい場合はコメントインする
        // mouseUp(e);
    };

    // ドラッグ中
    var mouseMove = function (e) {
        // ドラッグ終了位置
        var posX = parseInt(e.clientX - canvas.getBoundingClientRect().left) + w / 2;
        var posY = parseInt(e.clientY - canvas.getBoundingClientRect().top) + h / 2;


        if ((posX < ox) || (posX > ox + a * 10) || (posY < oy - a * 10 + h / 2) || (posY > oy + h / 2)) {
            isDragging = false;
        }

        if (isDragging) {
            var mx = 0;
            var my = 0;
            for (var i in images) {
                if (i == dragTarget) {
                    mx = images[i].drawOffsetX;
                    my = posY - images[i].drawHeight / 2;

                    // ドラッグが終了した時の情報を記憶
                    images[i].drawOffsetX = mx;
                    images[i].drawOffsetY = my;
                } else {
                    mx = images[i].drawOffsetX;
                    my = images[i].drawOffsetY;
                }
                w = images[i].drawWidth;
                h = images[i].drawHeight;

                x[i] = mx;
                y[i] = my;
            }

            M[0] = ((oy - y[0]) / a).toFixed(1);
            M[1] = ((oy - y[1]) / a).toFixed(1);
            M[2] = ((oy - y[2]) / a).toFixed(1);

            DrawAxis();
            DrawLine();
            DrawPoint();
            printData();

            s_calc_as();
        }
    };

    // canvasにイベント登録
    canvas.addEventListener('mousedown', function (e) { mouseDown(e); }, false);
    canvas.addEventListener('mousemove', function (e) { mouseMove(e); }, false);
    canvas.addEventListener('mouseup', function (e) { mouseUp(e); }, false);
    canvas.addEventListener('mouseout', function (e) { mouseOut(e); }, false);

}
function s_calc_as() {
    var MC$;
    var EQ$;

    var strArray = [];
    var bar = "-----------------------------------------------------\n";

    var wN = parseInt(document.getElementById('A1_N').value);
    NN[0] = wN;
    NN[1] = wN;
    NN[2] = wN;

    NA[0] = NN[0];
    NA[1] = NN[1];
    NA[2] = NN[2];

    M[0] = parseFloat(M[0]);
    M[1] = parseFloat(M[1]);
    M[2] = parseFloat(M[2]);

    var wSD = parseFloat(document.getElementById('A1_SD').value);
    SD[0] = wSD;
    SD[1] = wSD;
    SD[2] = wSD;

    for (i = 0; i < LA; i++) {
        NA[i] = NN[i];
    }

    // if(document.getElementById('hsd').checked){
    if (document.getElementById('hsd').value == 3) {
        LA = 3;
    } else {
        LA = 2;
    }
    //主効果検定
    strArray.push(" == Analysis of Variance ==\n\n");
    strArray.push(" S.V        SS        df        MS        F\n");

    var S = 0;
    var OB = 0;
    for (i = 0; i < LA; i++) {
        S = S + M[i] * NN[i];
        OB = OB + NN[i]; //度数の合計
    }
    var DH = S / OB; //大平均
    var A = 0;
    var E = 0;
    for (i = 0; i < LA; i++) {
        var MD = Math.pow(M[i] - DH, 2);
        A = A + MD * NN[i];
        E = E + Math.pow(SD[i], 2) * NN[i];
    }
    var T = A + E;
    var DA = LA - 1;
    var MA = A / DA;
    var DE = OB - LA;
    var ME = E / DE;
    var FA = MA / ME;
    var DAE = DA + DE;

    var D1 = DA;
    var D2 = DE;
    var Fdata = FA;
    var FA$ = pValue_Match_fRatio(D1, D2, Fdata);

    var a = using(A, 11, 4);
    var da = using(DA, 4, 0);
    var ma = using(MA, 8, 4);
    var fa = using(FA, 3, 2);
    var e = using(E, 9, 4);
    var de = using(DE, 4, 0);
    var me = using(ME, 8, 4);
    var t = using(T, 9, 4);
    var dae = using(DAE, 4, 0);

    strArray.push(bar);
    strArray.push("  A" + a + " " + da + " " + ma + " " + fa + " " + FA$ + "\n");
    strArray.push(" subj" + e + " " + de + " " + me + "\n");
    strArray.push(bar);
    strArray.push("Total" + t + " " + dae);
    strArray.push("   +p<.10 *p<.05 **p<.01\n\n");

    var effectSizeF = Math.sqrt(DA / DE * FA);
    strArray.push("\n == EffectSize ==\n\n");
    strArray.push("\teffectsize f\n");
    strArray.push(bar);
    strArray.push("  A\t" + effectSizeF.toFixed(4) + "\n");
    strArray.push(bar);
    strArray.push("\t\tLarge=0.4 , Medium=0.25 , Small=0.1\n");

    //多重比較 HSD(Tukey-kramer)
    // if(checkedHsd){
    if (FA$ != "ns") {
        if (LA > 2) {
            var Q2 = 0;
            Q2 = st_qValue(LA, DE);

            strArray.push("\n == Multiple Comparisons by HSD ==\n\n");
            strArray.push(" (MSe=" + me + ", * p<.05)\n");
            strArray.push(bar);
            for (i = 0; i < LA - 1; i++) {
                for (ii = i + 1; ii < LA; ii++) {
                    var HSD = Q2 * Math.sqrt(ME * (1 / NA[i] + 1 / NA[ii])) / Math.SQRT2;
                    var hsd = using(HSD, 8, 4);

                    if (Math.abs(M[i] - M[ii]) > HSD) {
                        MC$ = " *  ";
                    } else {
                        MC$ = "n.s.";
                        EQ$ = "=";
                    }
                    if (MC$ == " *  ") {
                        if (M[i] > M[ii]) {
                            EQ$ = ">";
                        } else {
                            EQ$ = "<";
                        }
                    }
                    strArray.push("  A" + (i + 1) + "  " + EQ$ + "  A" + (ii + 1) + "  " + MC$ + "   (HSD=" + hsd + ")\n");
                }
            }
            strArray.push(bar);
        }
    }
    // }

    document.getElementById("asDataArea").value = strArray.join("");
    strArray = null;
}