/**
 * ユーティリティ
 * 基本統計量
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function clearData() {
	result = confirm("データを消去します");
	if (result == true) {
		document.getElementById("DataArea").value = "";
		document.getElementById("kmin").value = "";
		document.getElementById("kmax").value = "";
		document.getElementById("khaba").value = "";
		document.getElementById("knum").value = "";
	}
}
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		if (document.getElementById("kmin").value == "") {
			err = true;
			alert("階級の最小値が入力されてません");
		}
		if (document.getElementById("khaba").value == "") {
			err = true;
			alert("階級幅が入力されてません");
		}
		if (document.getElementById("knum").value == "") {
			err = true;
			alert("階級数が入力されてません");
		}

		if (err == false) {
			mainCalc_Basic();
		}
	}
}
// メイン計算
function mainCalc_Basic() {
	var i = 0;
	var j = 0;

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var xx = [];
	for (i = 0; i < dd.length; i++) {
		xx[i] = parseFloat(dd[i]);
	}

	var kaikyu = [];
	var dosu = [];
	var ruidosu = [];
	var soutaidosu = [];

	var kmin = parseInt(document.getElementById("kmin").value);
	var khaba = parseInt(document.getElementById("khaba").value);
	var knum = parseInt(document.getElementById("knum").value) + 1;
	var kmax = kmin + khaba * (knum - 1);
	document.getElementById("kmax").value = kmax;

	for (i = 0; i < knum + 1; i++) {
		kaikyu[i] = kmin + i * khaba;
	}

	var str = '===基本統計量===\n\n';

	//個数
	var N = xx.length;
	str += '個数：' + N + '\n';

	//平均,標準偏差,分散
	var S = 0;
	var SS = 0;
	for (i = 0; i < xx.length; i++) {
		S += xx[i];
		SS += Math.pow(xx[i], 2);
	}
	var M = S / N;
	var V = SS / N - Math.pow(M, 2);
	var SD = Math.sqrt(V);
	str += '総和：' + S + '\n';
	str += '平均値：' + using(M, 5, 4) + '\n';
	str += '標準偏差：' + using(SD, 5, 4) + '\n';
	str += '分散：' + using(V, 5, 4) + '\n';

	//最大値,最小値
	var min = xx[0];
	var max = xx[0];
	for (i = 0; i < xx.length; i++) {
		if (xx[i] < min) min = xx[i];
		if (xx[i] > max) max = xx[i];
	}
	str += '最小値：' + min + '\n';
	str += '最大値：' + max + '\n';

	// sortData(0,data.length-1);

	xx.sort(function (a, b) { return a - b; });

	//レンジ
	var percent = 100;
	i = 0;
	while (percent >= 70) {
		percent = (N - i * 2) / N * 100;
		i = i + 1;
	}
	i = i - 2;
	percent = (N - i * 2) / N * 100;
	// var RangeMin = data[i];
	// var RangeMax = data[N-1-i];
	var RangeMin = xx[i];
	var RangeMax = xx[N - 1 - i];

	str += 'レンジ(' + using(percent, 3, 1) + '%)：' + RangeMin + '-' + RangeMax + '\n';
	percent = 100;
	i = 0;
	while (percent >= 50) {
		percent = (N - i * 2) / N * 100;
		i = i + 1;
	}
	i = i - 2;
	percent = (N - i * 2) / N * 100;
	// RangeMin = data[i];
	// RangeMax = data[N-1-i];
	RangeMin = xx[i];
	RangeMax = xx[N - 1 - i];
	str += 'レンジ(' + using(percent, 3, 1) + '%)：' + RangeMin + '-' + RangeMax + '\n';

	//メジアン
	if (N % 2 == 1) {
		Me = xx[Math.ceil(N / 2 - 1)];
		// Me = data[Math.ceil(N/2-1)];
		str += 'メジアン：' + Me + '\n';
	} else {
		// Me1 = data[N/2-1];
		// Me2 = data[N/2];
		Me1 = xx[N / 2 - 1];
		Me2 = xx[N / 2];
		Me = (Me1 + Me2) / 2;
		str += 'メジアン：' + Me + '(' + Me1 + ',' + Me2 + ')' + '\n';
	}

	str += '\n\n';
	//度数分布
	for (i = 0; i < knum + 1; i++) {
		dosu[i] = 0;
		ruidosu[i] = 0;
		soutaidosu[i] = 0;
	}

	n = 0;
	for (i = 0; i < xx.length; i++) {
		for (j = 0; j < knum; j++) {
			if (xx[i] < kaikyu[j]) break;
		}
		n = n + 1;
		dosu[j] = dosu[j] + 1;
	}

	for (i = 0; i < knum + 1; i++) {
		for (j = 0; j < i + 1; j++) {
			ruidosu[i] = ruidosu[i] + dosu[j];
		}
		soutaidosu[i] = using(Math.floor(dosu[i] / n * 1000) / 1000, 1, 3);
	}

	dosu[knum] = n - ruidosu[knum - 1];

	str += '===度数分布===\n\n';
	str += '以上\t未満\t度数\t累積度数\t相対度数\n';
	str += '-----------------------------------------------\n';
	str += '   - ' + kaikyu[0] + '\t\t' + dosu[0] + '\t' + ruidosu[0] + '\t' + soutaidosu[0] + '\n';
	for (i = 1; i < knum; i++) {
		str = str + kaikyu[i - 1] + ' - ' + kaikyu[i] + '\t\t' + dosu[i] + '\t' + ruidosu[i] + '\t' + soutaidosu[i] + '\n';
	}
	str += kaikyu[knum - 1] + ' -  \t\t' + dosu[knum] + '\t' + ruidosu[knum] + '\t' + soutaidosu[knum] + '\n';
	str += '-----------------------------------------------\n';
	str += ' 合計\t\t' + n + '\t' + n + '\t' + '1.000' + '\n';
	str += "\n _/_/_/ Analyzed by js-STAR _/_/_/\n";

	document.getElementById("RltArea").value = str;

}
