/**
 * ユーティリティ
 * 乱数発生
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeRandomSetting();
	// ChangeAsInput(0);

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
/**
 * [checkData 相関係数の値をチェック]
 */
function checkData() {
	var rand_output = parseInt(document.getElementById("rand_output").value); //出力選択
	var corrCoefficient;
	switch (rand_output) {
		case 1:
			corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
			break;
		case 2:
			corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
			break;
		case 3:
			corrCoefficient = 0; //エラー処理のために相関係数を０にしておく
			break;
	}
	if (Math.abs(corrCoefficient) <= 1) {
		mainCalc_Random();
	} else {
		alert("相関係数は－１以上１以下です");
	}

}
function mainCalc_Random() {
	var i = 0;
	var j = 0;
	var ii = 0;
	var jj = 0;

	var NN = 0;
	var LA = 0;

	var DData = dataremake5("RltArea");
	var dd = [];
	dd = DData.split(" ");

	//値追加の場合の行数と列数の計算
	NN = countRowCol("RltArea")[0]; // 行数を取得
	LA = countRowCol("RltArea")[1]; // 列数を取得

	if (LA == -1) { //列数エラー -1
		alert("データが行列形式ではありません");
	} else {
		var rand_output = parseInt(document.getElementById("rand_output").value); //出力選択

		//出力別の値取得
		var tate, yoko;
		var min, max;
		var decimal;
		var corrCoefficient;
		var avg, sd;
		var start, end, dist;
		switch (rand_output) {
			case 1:
				tate = parseInt(document.getElementById("tate").value); //列数
				yoko = parseInt(document.getElementById("yoko").value); //行数

				min = parseInt(document.getElementById("min").value);
				max = parseInt(document.getElementById("max").value);
				decimal = parseInt(document.getElementById("decimal").value); //小数点以下

				corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
				break;
			case 2:
				tate = parseInt(document.getElementById("tate").value); //列数
				yoko = parseInt(document.getElementById("yoko").value); //行数

				avg = parseFloat(document.getElementById("avg").value); //平均
				sd = parseFloat(document.getElementById("sd").value); //標準偏差
				decimal = parseInt(document.getElementById("decimal").value); //小数点以下

				corrCoefficient = parseFloat(document.getElementById("corrCoefficient").value); //相関係数
				break;
			case 3:
				start = parseInt(document.getElementById("start").value); //開始値
				end = parseInt(document.getElementById("end").value); //終了値
				dist = parseInt(document.getElementById("dist").value); //間隔
				break;
		}

		//最小値（開始値）と最大値（終了値）の処理
		var dummy = 0;
		if (min > max) {
			dummy = max;
			max = min;
			min = dummy;
		}
		if (start > end) {
			dummy = end;
			end = start;
			start = dummy;
		}

		//乱数の出力
		var count = 0;
		var rand = 0;
		var randX = 0;
		var randY = 0;
		var randZ = 0;
		var r1 = 0;
		var r2 = 0;
		var z = 0;
		var num = 0;

		var strArray = [];

		if (document.getElementById("RltAdd").checked) {
			// if(dd[0] == ""){
			if (NN == 0) { //行数が 0 の場合は結果を追加しない
				document.getElementById("RltAdd").checked = false;
			}
		}
		if (document.getElementById("RltAdd").checked) {
			switch (rand_output) {
				case 1:
					count = 0;
					for (ii = 0; ii < NN; ii++) {
						for (jj = 0; jj < LA; jj++) {
							strArray.push(crDel(dd[count]));
							strArray.push("\t");
							count++;
						}
						if (corrCoefficient == 0) {
							for (j = 0; j < yoko; j++) {
								// rand = Math.floor(Math.random()*(max-min+1)+min);
								// rand = (Math.random()*(max-min+1)+min).toFixed(decimal);
								rand = (Math.random() * (max - min) + min).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						} else {
							// randX = Math.floor(Math.random()*(max-min+1)+min);
							// randX = (Math.random()*(max-min+1)+min).toFixed(decimal);
							randX = (Math.random() * (max - min) + min).toFixed(decimal);
							strArray.push(randX);
							strArray.push("\t");
							for (j = 0; j < yoko - 1; j++) {
								// randZ = Math.floor(Math.random()*(max-min+1)+min);
								// randY = Math.floor(corrCoefficient*randX+Math.sqrt(1-Math.pow(corrCoefficient,2))*randZ);
								// randZ = (Math.random()*(max-min+1)+min).toFixed(decimal);
								randZ = (Math.random() * (max - min) + min).toFixed(decimal);
								randY = (corrCoefficient * randX + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZ).toFixed(decimal);
								if (randY > max) {
									randY = max.toFixed(decimal);
								}
								strArray.push(randY);
								if (j != yoko - 2) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 2:
					count = 0;
					for (ii = 0; ii < NN; ii++) {
						for (jj = 0; jj < LA; jj++) {
							strArray.push(crDel(dd[count]));
							strArray.push("\t");
							count++;
						}
						for (j = 0; j < yoko; j++) {
							r1 = Math.random();
							r2 = Math.random();
							z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
							rand = (z * sd + avg).toFixed(decimal);
							strArray.push(rand);
							if (j != yoko - 1) {
								strArray.push("\t");
							}
						}
						strArray.push("\n");
					}
					break;
				case 3:
					count = 0;
					num = start;
					for (ii = 0; ii < NN; ii++) {
						for (jj = 0; jj < LA; jj++) {
							strArray.push(crDel(dd[count]));
							strArray.push("\t");
							count++;
						}
						strArray.push(num);
						strArray.push("\n");
						num = num + dist;
					}
					break;
			}
		} else {
			switch (rand_output) {
				case 1:
					if (corrCoefficient == 0) {
						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								// rand = Math.floor(Math.random()*(max-min+1)+min);
								// rand = (Math.random()*(max-min+1)+min).toFixed(decimal);
								rand = (Math.random() * (max - min) + min).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						for (i = 0; i < tate; i++) {
							// randX = Math.floor(Math.random()*(max-min+1)+min);
							// randX = (Math.random()*(max-min+1)+min).toFixed(decimal);
							randX = (Math.random() * (max - min) + min).toFixed(decimal);
							strArray.push(randX);
							strArray.push("\t");
							for (j = 0; j < yoko - 1; j++) {
								// randZ = Math.floor(Math.random()*(max-min+1)+min);
								// randY = Math.floor(corrCoefficient*randX+Math.sqrt(1-Math.pow(corrCoefficient,2))*randZ);
								// randZ = (Math.random()*(max-min+1)+min).toFixed(decimal);
								randZ = (Math.random() * (max - min) + min).toFixed(decimal);
								randY = (corrCoefficient * randX + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZ).toFixed(decimal);
								if (randY > max) {
									randY = max.toFixed(decimal);
								}
								strArray.push(randY);
								if (j != yoko - 2) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 2:
					if (corrCoefficient == 0) {
						for (i = 0; i < tate; i++) {
							for (j = 0; j < yoko; j++) {
								r1 = Math.random();
								r2 = Math.random();
								z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
								rand = (z * sd + avg).toFixed(decimal);
								strArray.push(rand);
								if (j != yoko - 1) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					} else {
						for (i = 0; i < tate; i++) {
							r1 = Math.random();
							r2 = Math.random();
							z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
							randX = z * sd + avg;
							strArray.push(randX.toFixed(decimal));
							strArray.push("\t");
							for (j = 0; j < yoko - 1; j++) {
								r1 = Math.random();
								r2 = Math.random();
								z = Math.sqrt(-2 * Math.log(r1)) * Math.cos(2 * Math.PI * r2);
								randZ = z * sd + avg;
								randY = corrCoefficient * randX + Math.sqrt(1 - Math.pow(corrCoefficient, 2)) * randZ;
								strArray.push(randY.toFixed(decimal));
								if (j != yoko - 2) {
									strArray.push("\t");
								}
							}
							strArray.push("\n");
						}
					}
					break;
				case 3:
					for (i = start; i <= end; i = i + dist) {
						strArray.push(i);
						strArray.push("\n");
					}
					break;
			}
		}

		document.getElementById("RltArea").value = strArray.join("");
		strArray = null;
	}
}

function changeRandomSetting() {
	var rand_output = parseInt(document.getElementById("rand_output").value);
	var htmArray = [];

	var thisBrowser = getBrowser();
	if (rand_output == 1) {
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("縦(行)：<input type=\"number\" class=\"text9\" id=\"tate\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("縦(行)：<select id=\"tate\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'縦(行)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("×横(列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("×横(列)：<select id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'横(列)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("最小値：<input type=\"number\" class=\"text9\" id=\"min\" size=\"10\" min=\"0\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("最小値：<select id=\"min\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'最小値')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\"selected>1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"20\">20</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　最大値：<input type=\"number\" class=\"text9\" id=\"max\" size=\"10\" min=\"0\" value=\"10\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("最大値：<select id=\"max\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'最大値')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\" selected>10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"20\">20</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　小数点以下：<input type=\"number\" class=\"text9\" id=\"decimal\" size=\"10\" min=\"0\" value=\"3\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 小数点以下：<select id=\"decimal\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'小数点以下')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\" selected>3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("相関係数：<input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"corrCoefficient\" value=\"0\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("</div>\n");
	}
	if (rand_output == 2) {
		htmArray.push("<div class=\"tateyoko\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("縦(行)：<input type=\"number\" class=\"text9\" id=\"tate\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("縦(行)：<select id=\"tate\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'縦(行)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("×横(列)：<input type=\"number\" class=\"text9\" id=\"yoko\" size=\"10\" min=\"1\" value=\"2\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push("×横(列)：<select id=\"yoko\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'横(列)')\">\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\"selected>2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"6\">6</option>\n");
			htmArray.push("<option value=\"7\">7</option>\n");
			htmArray.push("<option value=\"8\">8</option>\n");
			htmArray.push("<option value=\"9\">9</option>\n");
			htmArray.push("<option value=\"10\">10</option>\n");
			htmArray.push("<option value=\"11\">11</option>\n");
			htmArray.push("<option value=\"12\">12</option>\n");
			htmArray.push("<option value=\"13\">13</option>\n");
			htmArray.push("<option value=\"14\">14</option>\n");
			htmArray.push("<option value=\"15\">15</option>\n");
			htmArray.push("<option value=\"16\">16</option>\n");
			htmArray.push("<option value=\"17\">17</option>\n");
			htmArray.push("<option value=\"18\">18</option>\n");
			htmArray.push("<option value=\"19\">19</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");

		htmArray.push("平均：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"avg\" value=\"0\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("　標準偏差：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"sd\" value=\"1\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　小数点以下：<input type=\"number\" class=\"text9\" id=\"decimal\" size=\"10\" min=\"0\" value=\"3\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 小数点以下：<select id=\"decimal\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'小数点以下')\">\n");
			htmArray.push("<option value=\"0\">0</option>\n");
			htmArray.push("<option value=\"1\">1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\" selected>3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}

		htmArray.push("</div>\n");

		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("相関係数：<input type=\"text\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"corrCoefficient\" value=\"0\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("</div>\n");
	}
	if (rand_output == 3) {
		htmArray.push("<div class=\"tateyoko\">\n");
		htmArray.push("開始：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"start\" value=\"1\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");
		htmArray.push("　終了：<input type=\"number\" class=\"text9\" size=\"6\" maxlength=\"6\" id=\"end\" value=\"10\" onfocus=\"onBgColor(this)\" onblur=\"offBgColor(this)\">\n");

		if (thisBrowser.indexOf('ie') == -1) {
			htmArray.push("　間隔：<input type=\"number\" class=\"text9\" id=\"dist\" size=\"10\" min=\"1\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this);\">");
		} else {
			htmArray.push(" 間隔：<select id=\"dist\" class=\"tySelect\" size=\"1\" onchange=\"addSelectItem5(this,'間隔')\">\n");
			htmArray.push("<option value=\"1\" selected>1</option>\n");
			htmArray.push("<option value=\"2\">2</option>\n");
			htmArray.push("<option value=\"3\">3</option>\n");
			htmArray.push("<option value=\"4\">4</option>\n");
			htmArray.push("<option value=\"5\">5</option>\n");
			htmArray.push("<option value=\"-1\">他</option>\n");
			htmArray.push("</select>\n");
		}
		htmArray.push("</div>\n");
	}

	document.getElementById("rand_setting").innerHTML = htmArray.join("");
	htmArray = null;
}