/**
 * ユーティリティ
 * 逆転項目処理
 *
 *
 *
 */
window.onload = function () {
	setTitle(1); //0:index.htm  1:それ以外
	setMenu(1);  //0:index.htm  1:それ以外
	setFooter();

	//フォームを作成
	changeReverseSetting();

	// デフォルトのタブを選択
	ChangeTab(1, 4);
};
function checkData() {
	var err = false;

	// DataAreaが空でない
	if (document.getElementById("DataArea").value != "") {
		var DData = dataremake5("DataArea");
		DData = crDel(DData);
		var dd = [];
		dd = DData.split(" ");

		// minとmaxが空である
		var min, max;
		if ((document.getElementById("x_min").value != "") && (document.getElementById("x_max").value != "")) {
			min = parseInt(document.getElementById("x_min").value, 10);
			max = parseInt(document.getElementById("x_max").value, 10);

			if (min < 0) {
				err = true;
				alert("最小値は0以上です");
			} else {
				// min<maxである
				if (min >= max) {
					err = true;
					alert("最小値＜最大値ではありません");
				}
			}

		} else {
			err = true;
			alert("最小値・最大値が入力されていません");
		}

		// データが行列形式である
		var NN = countRowCol("DataArea")[0]; // 行数を取得
		var KK = countRowCol("DataArea")[1]; // 列数を取得
		if (KK == -1) {
			err = true;
			alert("データが行列形式ではありません");
		}

		// データがmin以上max以下である
		for (i = 0; i < dd.length; i++) {
			if (isNaN(dd[i]) == false) {
				if ((parseInt(dd[i], 10) < min) || (parseInt(dd[i], 10) > max)) {
					err = true;
					alert("最小値～最大値でないデータがあります");
					break;
				}
			} else {
				err = true;
				alert("数値ではないデータがあります");
				break;
			}
		}

		if (err == false) {
			mainCalc_reverse();
		}
	}
}
function mainCalc_reverse() {
	var i = 0;
	var result = "";

	var wMin = parseInt(document.getElementById("x_min").value, 10);
	var wMax = parseInt(document.getElementById("x_max").value, 10);

	var NN = countRowCol("DataArea")[0]; // 行数を取得
	var KK = countRowCol("DataArea")[1]; // 列数を取得

	var xx = new Array(NN);
	for (i = 0; i < NN; i++) {
		xx[i] = new Array(KK);
	}

	var DData = dataremake5("DataArea");
	DData = crDel(DData);
	var dd = [];
	dd = DData.split(" ");

	var ddCount = 0;
	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			xx[i][j] = parseInt(dd[ddCount], 10);
			ddCount++;
		}
	}

	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			if (document.getElementById("x" + (j + 1)).checked) {
				xx[i][j] = (wMax + wMin) - xx[i][j];
			}
		}
	}

	for (i = 0; i < NN; i++) {
		for (j = 0; j < KK; j++) {
			result += xx[i][j] + "\t";
		}
		result += "\n";
	}

	document.getElementById("RltArea").value = result;
	document.getElementById("RltArea").focus();
}
function changeReverseSetting() {
	var htmArray = [];

	htmArray.push("<div class=\"tateyoko\">");

	var thisBrowser = getBrowser();
	if (thisBrowser.indexOf('ie') == -1) {
		htmArray.push("最小値：<input type=\"number\" class=\"text9\" id=\"x_min\" size=\"10\" maxlength=\"10\" min=\"0\"  max=\"100\" value=\"1\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
		htmArray.push("　最大値：<input type=\"number\" class=\"text9\" id=\"x_max\" size=\"10\" maxlength=\"10\" min=\"1\"  max=\"100\" value=\"5\" onfocus=\"onBgColor(this);\" onblur=\"offBgColor(this)\">");
	} else {
		htmArray.push("最小値：<select name=\"tate\" id=\"x_min\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
		htmArray.push("<option value=\"0\">1</option>");
		htmArray.push("<option value=\"1\" selected>1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\">5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\">10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\">12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("<option value=\"14\">14</option>");
		htmArray.push("<option value=\"15\">15</option>");
		htmArray.push("<option value=\"16\">16</option>");
		htmArray.push("<option value=\"17\">17</option>");
		htmArray.push("<option value=\"18\">18</option>");
		htmArray.push("<option value=\"19\">19</option>");
		htmArray.push("</select>");
		htmArray.push("　最大値：<select name=\"yoko\" id=\"x_max\" class=\"tySelect\" size=\"1\" onchange=\"checkMinMaxValue();\">");
		htmArray.push("<option value=\"1\">1</option>");
		htmArray.push("<option value=\"2\">2</option>");
		htmArray.push("<option value=\"3\">3</option>");
		htmArray.push("<option value=\"4\">4</option>");
		htmArray.push("<option value=\"5\" selected>5</option>");
		htmArray.push("<option value=\"6\">6</option>");
		htmArray.push("<option value=\"7\">7</option>");
		htmArray.push("<option value=\"8\">8</option>");
		htmArray.push("<option value=\"9\">9</option>");
		htmArray.push("<option value=\"10\">10</option>");
		htmArray.push("<option value=\"11\">11</option>");
		htmArray.push("<option value=\"12\">12</option>");
		htmArray.push("<option value=\"13\">13</option>");
		htmArray.push("<option value=\"14\">14</option>");
		htmArray.push("<option value=\"15\">15</option>");
		htmArray.push("<option value=\"16\">16</option>");
		htmArray.push("<option value=\"17\">17</option>");
		htmArray.push("<option value=\"18\">18</option>");
		htmArray.push("<option value=\"19\">19</option>");
		htmArray.push("<option value=\"20\">20</option>");
		htmArray.push("</select>");
	}

	htmArray.push("</div>");

	document.getElementById("reverse_setting").innerHTML = htmArray.join("");
	htmArray = null;

}
g_saveDataTextarea = ""; //Textareaの文字列の保持
function ChangeTextarea(wArea) {
	g_saveDataTextarea = document.getElementById(wArea).value;
}
function changeReverseTable() {
	var i, j, k;

	var htmArray = [];
	var beStr = document.getElementById("DataArea").value;
	var wStr = "";

	if (g_saveDataTextarea != beStr) {
		wStr = beStr.replace(/,/g, " ");
		wStr = wStr.replace(/\t/g, " ");
		wStr = wStr.replace(/\r\n/g, "\n");
		wStr = wStr + "\n";

		var count = 0;
		for (i = 0; i < wStr.length; i++) {
			if (wStr.charAt(i) == "\n") break;
			if (wStr.charAt(i) == " ") {
				count++;
			}
			if (wStr.charAt(i) == " " && wStr.charAt(i + 1) == "\n") {
				count = count - 1;
			}
		}

		if (beStr != "") {
			LA = count + 1;
		} else {
			LA = 0;
		}

		var trCount = parseInt(LA / 10) + 1;
		if (LA % 10 == 0) trCount = trCount - 1;

		var LACount = 0;
		htmArray.push("<table border=\"1\" cellpadding=\"4\" class=\"hyou_waku\">");
		for (j = 0; j < trCount; j++) {
			htmArray.push("<tr>");
			for (i = 0; i < 10; i++) {
				htmArray.push("<td class=\"hyou_midashi_NF_title\">");
				if (LACount < LA) {
					htmArray.push("<input type=\"checkbox\" id=\"x" + (LACount + 1) + "\" name=\"x" + (LACount + 1) + "\" value=\"" + (LACount + 1) + "\" onclick=\"rv_keyClick(event," + (LACount + 1) + ");\"><label for=\"x" + (LACount + 1) + "\">x" + (LACount + 1) + "</label>");
				} else {
					htmArray.push(" ");
				}
				htmArray.push("</td>");
				LACount++;
			}
			htmArray.push("</tr>");
		}
		htmArray.push("</table>");

		document.getElementById("reverse_table").innerHTML = htmArray.join("");
		htmArray = null;
	}
}
/**
 * [rv_keyClick shiftキーを押しながらチェックボックスをクリックすると全てのチェックを反転する]
 * @param  {event} event [Firefox IE用]
 * @param  {int} num   [クリックしたチェックボックスidの番号]
 */
function rv_keyClick(event, num) {
	//イベント処理
	var key_event = event || window.event; //Firefox IE用
	// var key_ctrl = (key_event.ctrlKey);
	var key_shift = (key_event.shiftKey);

	//キーに対応した処理
	if (key_shift) {
		var KK = countRowCol("DataArea")[1]; // 列数を取得

		for (var k = 0; k < KK; k++) {
			document.getElementById("x" + (k + 1)).checked = !document.getElementById("x" + (k + 1)).checked;
		}
		document.getElementById("x" + num).checked = !document.getElementById("x" + num).checked;
	}
}